/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var e=[],i=0,R=re.length;i<R;i++)e[i]=me[re[i]];return e};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ht,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ct,construct:Rt}=typeof Reflect<"u"&&Reflect;Ct||(Ct=function(e,i,R){return e.apply(i,R)}),ot||(ot=function(e){return e}),ft||(ft=function(e){return e}),Rt||(Rt=function(e,i){return new e(...i)});const oi=ut(Array.prototype.forEach),jt=ut(Array.prototype.pop),wt=ut(Array.prototype.push),Et=ut(String.prototype.toLowerCase),Nt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),vt=ui(TypeError);function ut(re){return function(e){for(var i=arguments.length,R=new Array(i>1?i-1:0),j=1;j<i;j++)R[j-1]=arguments[j];return Ct(re,e,R)}}function ui(re){return function(){for(var e=arguments.length,i=new Array(e),R=0;R<e;R++)i[R]=arguments[R];return Rt(re,i)}}function We(re,e,i){var R;i=(R=i)!==null&&R!==void 0?R:Et,Ht&&Ht(re,null);let j=e.length;for(;j--;){let W=e[j];if(typeof W=="string"){const D=i(W);D!==W&&(ii(e)||(e[j]=D),W=D)}re[W]=!0}return re}function bt(re){const e=ri(null);for(const[i,R]of zt(re))e[i]=R;return e}function At(re,e){for(;re!==null;){const R=si(re,e);if(R){if(R.get)return ut(R.get);if(typeof R.value=="function")return ut(R.value)}re=ni(re)}function i(R){return console.warn("fallback value for",R),null}return i}const Wt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Pt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),$i=ft(/^data-[\-\w.\u00B7-\uFFFF]/),bi=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),ki=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),xt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:$i,ARIA_ATTR:bi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:ki,DOCTYPE_NAME:xt});const wi=()=>typeof window>"u"?null:window,vi=function(e,i){if(typeof e!="object"||typeof e.createPolicy!="function")return null;let R=null;const j="data-tt-policy-suffix";i&&i.hasAttribute(j)&&(R=i.getAttribute(j));const W="dompurify"+(R?"#"+R:"");try{return e.createPolicy(W,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Yt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:wi();const e=ze=>Yt(ze);if(e.version="3.0.5",e.removed=[],!re||!re.document||re.document.nodeType!==9)return e.isSupported=!1,e;const i=re.document,R=i.currentScript;let{document:j}=re;const{DocumentFragment:W,HTMLTemplateElement:D,Node:y,Element:$,NodeFilter:b,NamedNodeMap:k=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:B,DOMParser:c,trustedTypes:d}=re,t=$.prototype,s=At(t,"cloneNode"),a=At(t,"nextSibling"),m=At(t,"childNodes"),p=At(t,"parentNode");if(typeof D=="function"){const ze=j.createElement("template");ze.content&&ze.content.ownerDocument&&(j=ze.content.ownerDocument)}let w,o="";const{implementation:g,createNodeIterator:r,createDocumentFragment:E,getElementsByTagName:N}=j,{importNode:M}=i;let P={};e.isSupported=typeof zt=="function"&&typeof p=="function"&&g&&g.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:v,TMPLIT_EXPR:H,DATA_ATTR:V,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:I}=Gt;let{IS_ALLOWED_URI:X}=Gt,U=null;const de=We({},[...Wt,...Lt,...It,...Mt,...Vt]);let he=null;const ne=We({},[...qt,...Pt,...Qt,...St]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ce=null,Re=null,Be=!0,le=!0,_=!1,ae=!0,oe=!1,J=!1,G=!1,ie=!1,fe=!1,De=!1,Fe=!1,ye=!0,K=!1;const f="user-content-";let A=!0,F=!1,l={},u=null;const n=We({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let h=null;const C=We({},["audio","video","img","source","image","track"]);let S=null;const O=We({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),q="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",te="http://www.w3.org/1999/xhtml";let be=te,we=!1,ke=null;const Pe=We({},[q,Z,te],Nt);let Ee;const Ae=["application/xhtml+xml","text/html"],Ne="text/html";let Ie,Ge=null;const nt=j.createElement("form"),Ye=function(ue){return ue instanceof RegExp||ue instanceof Function},Ue=function(ue){if(!(Ge&&Ge===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),Ee=Ae.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Ee=Ne:Ee=ue.PARSER_MEDIA_TYPE,Ie=Ee==="application/xhtml+xml"?Nt:Et,U="ALLOWED_TAGS"in ue?We({},ue.ALLOWED_TAGS,Ie):de,he="ALLOWED_ATTR"in ue?We({},ue.ALLOWED_ATTR,Ie):ne,ke="ALLOWED_NAMESPACES"in ue?We({},ue.ALLOWED_NAMESPACES,Nt):Pe,S="ADD_URI_SAFE_ATTR"in ue?We(bt(O),ue.ADD_URI_SAFE_ATTR,Ie):O,h="ADD_DATA_URI_TAGS"in ue?We(bt(C),ue.ADD_DATA_URI_TAGS,Ie):C,u="FORBID_CONTENTS"in ue?We({},ue.FORBID_CONTENTS,Ie):n,Ce="FORBID_TAGS"in ue?We({},ue.FORBID_TAGS,Ie):{},Re="FORBID_ATTR"in ue?We({},ue.FORBID_ATTR,Ie):{},l="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Be=ue.ALLOW_ARIA_ATTR!==!1,le=ue.ALLOW_DATA_ATTR!==!1,_=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,oe=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,fe=ue.RETURN_DOM||!1,De=ue.RETURN_DOM_FRAGMENT||!1,Fe=ue.RETURN_TRUSTED_TYPE||!1,ie=ue.FORCE_BODY||!1,ye=ue.SANITIZE_DOM!==!1,K=ue.SANITIZE_NAMED_PROPS||!1,A=ue.KEEP_CONTENT!==!1,F=ue.IN_PLACE||!1,X=ue.ALLOWED_URI_REGEXP||Kt,be=ue.NAMESPACE||te,ge=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),oe&&(le=!1),De&&(fe=!0),l&&(U=We({},[...Vt]),he=[],l.html===!0&&(We(U,Wt),We(he,qt)),l.svg===!0&&(We(U,Lt),We(he,Pt),We(he,St)),l.svgFilters===!0&&(We(U,It),We(he,Pt),We(he,St)),l.mathMl===!0&&(We(U,Mt),We(he,Qt),We(he,St))),ue.ADD_TAGS&&(U===de&&(U=bt(U)),We(U,ue.ADD_TAGS,Ie)),ue.ADD_ATTR&&(he===ne&&(he=bt(he)),We(he,ue.ADD_ATTR,Ie)),ue.ADD_URI_SAFE_ATTR&&We(S,ue.ADD_URI_SAFE_ATTR,Ie),ue.FORBID_CONTENTS&&(u===n&&(u=bt(u)),We(u,ue.FORBID_CONTENTS,Ie)),A&&(U["#text"]=!0),J&&We(U,["html","head","body"]),U.table&&(We(U,["tbody"]),delete Ce.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');w=ue.TRUSTED_TYPES_POLICY,o=w.createHTML("")}else w===void 0&&(w=vi(d,R)),w!==null&&typeof o=="string"&&(o=w.createHTML(""));ot&&ot(ue),Ge=ue}},Y=We({},["mi","mo","mn","ms","mtext"]),se=We({},["foreignobject","desc","title","annotation-xml"]),pe=We({},["title","style","font","a","script"]),ve=We({},Lt);We(ve,It),We(ve,ci);const Le=We({},Mt);We(Le,fi);const je=function(ue){let Te=p(ue);(!Te||!Te.tagName)&&(Te={namespaceURI:be,tagName:"template"});const Me=Et(ue.tagName),Qe=Et(Te.tagName);return ke[ue.namespaceURI]?ue.namespaceURI===Z?Te.namespaceURI===te?Me==="svg":Te.namespaceURI===q?Me==="svg"&&(Qe==="annotation-xml"||Y[Qe]):!!ve[Me]:ue.namespaceURI===q?Te.namespaceURI===te?Me==="math":Te.namespaceURI===Z?Me==="math"&&se[Qe]:!!Le[Me]:ue.namespaceURI===te?Te.namespaceURI===Z&&!se[Qe]||Te.namespaceURI===q&&!Y[Qe]?!1:!Le[Me]&&(pe[Me]||!ve[Me]):!!(Ee==="application/xhtml+xml"&&ke[ue.namespaceURI]):!1},qe=function(ue){wt(e.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},_e=function(ue,Te){try{wt(e.removed,{attribute:Te.getAttributeNode(ue),from:Te})}catch{wt(e.removed,{attribute:null,from:Te})}if(Te.removeAttribute(ue),ue==="is"&&!he[ue])if(fe||De)try{qe(Te)}catch{}else try{Te.setAttribute(ue,"")}catch{}},tt=function(ue){let Te,Me;if(ie)ue="<remove></remove>"+ue;else{const lt=li(ue,/^[\r\n\t ]+/);Me=lt&&lt[0]}Ee==="application/xhtml+xml"&&be===te&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Qe=w?w.createHTML(ue):ue;if(be===te)try{Te=new c().parseFromString(Qe,Ee)}catch{}if(!Te||!Te.documentElement){Te=g.createDocument(be,"template",null);try{Te.documentElement.innerHTML=we?o:Qe}catch{}}const it=Te.body||Te.documentElement;return ue&&Me&&it.insertBefore(j.createTextNode(Me),it.childNodes[0]||null),be===te?N.call(Te,J?"html":"body")[0]:J?Te.documentElement:it},st=function(ue){return r.call(ue.ownerDocument||ue,ue,b.SHOW_ELEMENT|b.SHOW_COMMENT|b.SHOW_TEXT,null,!1)},Ze=function(ue){return ue instanceof B&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof k)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof y=="object"?ue instanceof y:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},et=function(ue,Te,Me){P[ue]&&oi(P[ue],Qe=>{Qe.call(e,Te,Me,Ge)})},gt=function(ue){let Te;if(et("beforeSanitizeElements",ue,null),Ze(ue))return qe(ue),!0;const Me=Ie(ue.nodeName);if(et("uponSanitizeElement",ue,{tagName:Me,allowedTags:U}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return qe(ue),!0;if(!U[Me]||Ce[Me]){if(!Ce[Me]&&$t(Me)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me)))return!1;if(A&&!u[Me]){const Qe=p(ue)||ue.parentNode,it=m(ue)||ue.childNodes;if(it&&Qe){const lt=it.length;for(let Xe=lt-1;Xe>=0;--Xe)Qe.insertBefore(s(it[Xe],!0),a(ue))}}return qe(ue),!0}return ue instanceof $&&!je(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(qe(ue),!0):(oe&&ue.nodeType===3&&(Te=ue.textContent,Te=dt(Te,z," "),Te=dt(Te,v," "),Te=dt(Te,H," "),ue.textContent!==Te&&(wt(e.removed,{element:ue.cloneNode()}),ue.textContent=Te)),et("afterSanitizeElements",ue,null),!1)},mt=function(ue,Te,Me){if(ye&&(Te==="id"||Te==="name")&&(Me in j||Me in nt))return!1;if(!(le&&!Re[Te]&&ht(V,Te))){if(!(Be&&ht(T,Te))){if(!he[Te]||Re[Te]){if(!($t(ue)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,ue)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ue))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Te)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Te))||Te==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me))))return!1}else if(!S[Te]){if(!ht(X,dt(Me,I,""))){if(!((Te==="src"||Te==="xlink:href"||Te==="href")&&ue!=="script"&&ai(Me,"data:")===0&&h[ue])){if(!(_&&!ht(L,dt(Me,I,"")))){if(Me)return!1}}}}}}return!0},$t=function(ue){return ue.indexOf("-")>0},Tt=function(ue){let Te,Me,Qe,it;et("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(it=lt.length;it--;){Te=lt[it];const{name:ct,namespaceURI:pt}=Te;if(Me=ct==="value"?Te.value:hi(Te.value),Qe=Ie(ct),Xe.attrName=Qe,Xe.attrValue=Me,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,et("uponSanitizeAttribute",ue,Xe),Me=Xe.attrValue,Xe.forceKeepAttr||(_e(ct,ue),!Xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Me)){_e(ct,ue);continue}oe&&(Me=dt(Me,z," "),Me=dt(Me,v," "),Me=dt(Me,H," "));const Dt=Ie(ue.nodeName);if(mt(Dt,Qe,Me)){if(K&&(Qe==="id"||Qe==="name")&&(_e(ct,ue),Me=f+Me),w&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!pt)switch(d.getAttributeType(Dt,Qe)){case"TrustedHTML":{Me=w.createHTML(Me);break}case"TrustedScriptURL":{Me=w.createScriptURL(Me);break}}try{pt?ue.setAttributeNS(pt,ct,Me):ue.setAttribute(ct,Me),jt(e.removed)}catch{}}}et("afterSanitizeAttributes",ue,null)},Ot=function ze(ue){let Te;const Me=st(ue);for(et("beforeSanitizeShadowDOM",ue,null);Te=Me.nextNode();)et("uponSanitizeShadowNode",Te,null),!gt(Te)&&(Te.content instanceof W&&ze(Te.content),Tt(Te));et("afterSanitizeShadowDOM",ue,null)};return e.sanitize=function(ze){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Te,Me,Qe,it;if(we=!ze,we&&(ze="<!-->"),typeof ze!="string"&&!rt(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!e.isSupported)return ze;if(G||Ue(ue),e.removed=[],typeof ze=="string"&&(F=!1),F){if(ze.nodeName){const ct=Ie(ze.nodeName);if(!U[ct]||Ce[ct])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof y)Te=tt("<!---->"),Me=Te.ownerDocument.importNode(ze,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Te=Me:Te.appendChild(Me);else{if(!fe&&!oe&&!J&&ze.indexOf("<")===-1)return w&&Fe?w.createHTML(ze):ze;if(Te=tt(ze),!Te)return fe?null:Fe?o:""}Te&&ie&&qe(Te.firstChild);const lt=st(F?ze:Te);for(;Qe=lt.nextNode();)gt(Qe)||(Qe.content instanceof W&&Ot(Qe.content),Tt(Qe));if(F)return ze;if(fe){if(De)for(it=E.call(Te.ownerDocument);Te.firstChild;)it.appendChild(Te.firstChild);else it=Te;return(he.shadowroot||he.shadowrootmode)&&(it=M.call(i,it,!0)),it}let Xe=J?Te.outerHTML:Te.innerHTML;return J&&U["!doctype"]&&Te.ownerDocument&&Te.ownerDocument.doctype&&Te.ownerDocument.doctype.name&&ht(xt,Te.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Te.ownerDocument.doctype.name+`>
`+Xe),oe&&(Xe=dt(Xe,z," "),Xe=dt(Xe,v," "),Xe=dt(Xe,H," ")),w&&Fe?w.createHTML(Xe):Xe},e.setConfig=function(ze){Ue(ze),G=!0},e.clearConfig=function(){Ge=null,G=!1},e.isValidAttribute=function(ze,ue,Te){Ge||Ue({});const Me=Ie(ze),Qe=Ie(ue);return mt(Me,Qe,Te)},e.addHook=function(ze,ue){typeof ue=="function"&&(P[ze]=P[ze]||[],wt(P[ze],ue))},e.removeHook=function(ze){if(P[ze])return jt(P[ze])},e.removeHooks=function(ze){P[ze]&&(P[ze]=[])},e.removeAllHooks=function(){P={}},e}var Di=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(me[45],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=e.$uS=void 0;class i{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const y=R(D);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(D){const y=R(D);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(D){const y=R(D);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(D){const y=R(D);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(D){const y=R(D);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(D){const y=R(D);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(D){const y=R(D);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(D){const y=R(D);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const y=R(D);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const y=R(D);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const y=R(D);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const y=R(D);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const y=R(D);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const y=R(D);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,y){this.domNode.classList.toggle(D,y),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,y){this.domNode.setAttribute(D,y)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}e.$uS=i;function R(W){return typeof W=="number"?`${W}px`:W}function j(W){return new i(W)}e.$vS=j}),define(me[72],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0;const i=new WeakMap;function R(y){if(!y.parent||y.parent===y)return null;try{const $=y.location,b=y.parent.location;if($.origin!=="null"&&b.origin!=="null"&&$.origin!==b.origin)return null}catch{return null}return y.parent}class j{static a($){let b=i.get($);if(!b){b=[],i.set($,b);let k=$,B;do B=R(k),B?b.push({window:new WeakRef(k),iframeElement:k.frameElement||null}):b.push({window:new WeakRef(k),iframeElement:null}),k=B;while(k)}return b.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow($,b){if(!b||$===b)return{top:0,left:0};let k=0,B=0;const c=this.a($);for(const d of c){const t=d.window.deref();if(k+=t?.scrollY??0,B+=t?.scrollX??0,t===b||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();k+=s.top,B+=s.left}return{top:k,left:B}}}e.$LQ=j;async function W(y,$){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const b=JSON.stringify({parentOrigin:y,salt:$}),B=new TextEncoder().encode(b),c=await crypto.subtle.digest("sha-256",B);return D(c)}e.$MQ=W;function D(y){const b=Array.from(new Uint8Array(y)).map(k=>k.toString(16).padStart(2,"0")).join("");return BigInt(`0x${b}`).toString(32).padStart(52,"0")}}),define(me[73],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=e.$dT=e.$cT=e.ListDragOverEffectPosition=e.ListDragOverEffectType=void 0;var i;(function(D){D[D.Copy=0]="Copy",D[D.Move=1]="Move"})(i||(e.ListDragOverEffectType=i={}));var R;(function(D){D.Over="drop-target",D.Before="drop-target-before",D.After="drop-target-after"})(R||(e.ListDragOverEffectPosition=R={})),e.$cT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class j extends Error{constructor(y,$){super(`ListError [${y}] ${$}`)}}e.$dT=j;class W{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,$){$>0&&this.c.set(y,$)}}e.$eT=W}),define(me[74],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5S=void 0;class i{constructor(j){this.a=j}splice(j,W,D){this.a.forEach(y=>y.splice(j,W,D))}}e.$5S=i}),define(me[46],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=void 0;const i=20;class R{constructor(W,D,y,$,b,k){this.a=Math.round(D),this.b=Math.round(y),this.c=Math.round(W),this.d=$,this.e=b,this.f=k,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new R(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const D=Math.round(W);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(W){const D=Math.round(W);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(W){const D=Math.round(W);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,D,y,$,b){const k=Math.max(0,y-W),B=Math.max(0,k-2*D),c=$>0&&$>y;if(!c)return{computedAvailableSize:Math.round(k),computedIsNeeded:c,computedSliderSize:Math.round(B),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(i,Math.floor(y*B/$))),t=(B-d)/($-y),s=b*t;return{computedAvailableSize:Math.round(k),computedIsNeeded:c,computedSliderSize:Math.round(d),computedSliderRatio:t,computedSliderPosition:Math.round(s)}}m(){const W=R.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const D=W-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const D=W-this.c;let y=this.f;return D<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const D=this.k+W;return Math.round(D/this.j)}}e.$AS=R}),define(me[27],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9U=e.$8U=e.$7U=e.TreeDragOverBubble=e.TreeMouseEventTarget=e.ObjectTreeElementCollapseState=e.TreeVisibility=void 0;var i;(function($){$[$.Hidden=0]="Hidden",$[$.Visible=1]="Visible",$[$.Recurse=2]="Recurse"})(i||(e.TreeVisibility=i={}));var R;(function($){$[$.Expanded=0]="Expanded",$[$.Collapsed=1]="Collapsed",$[$.PreserveOrExpanded=2]="PreserveOrExpanded",$[$.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(R||(e.ObjectTreeElementCollapseState=R={}));var j;(function($){$[$.Unknown=0]="Unknown",$[$.Twistie=1]="Twistie",$[$.Element=2]="Element",$[$.Filter=3]="Filter"})(j||(e.TreeMouseEventTarget=j={}));var W;(function($){$[$.Down=0]="Down",$[$.Up=1]="Up"})(W||(e.TreeDragOverBubble=W={})),e.$7U={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown($=!1){return{accept:!0,bubble:0,autoExpand:$}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown($=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:$}}};class D extends Error{constructor(b,k){super(`TreeError [${b}] ${k}`)}}e.$8U=D;class y{constructor(b){this.a=b,this.b=new WeakMap}map(b){let k=this.b.get(b);return k||(k=this.a(b),this.b.set(b,k)),k}}e.$9U=y}),define(me[22],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$window=e.$oQ=e.$nQ=void 0;function i(j,W){const D=j;typeof D.vscodeWindowId!="number"&&Object.defineProperty(D,"vscodeWindowId",{get:()=>W})}e.$nQ=i,e.$oQ=window,e.$window=e.$oQ;function R(j){return j===e.$oQ?!1:typeof j?.vscodeWindowId=="number"}e.$qQ=R}),define(me[75],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function i(s,a,m){const p=R(s,a);if(p!==-1)return s[p]}e.$fb=i;function R(s,a,m=s.length-1){for(let p=m;p>=0;p--){const w=s[p];if(a(w))return p}return-1}e.$gb=R;function j(s,a){const m=W(s,a);return m===-1?void 0:s[m]}e.$hb=j;function W(s,a,m=0,p=s.length){let w=m,o=p;for(;w<o;){const g=Math.floor((w+o)/2);a(s[g])?w=g+1:o=g}return w-1}e.$ib=W;function D(s,a){const m=y(s,a);return m===s.length?void 0:s[m]}e.$jb=D;function y(s,a,m=0,p=s.length){let w=m,o=p;for(;w<o;){const g=Math.floor((w+o)/2);a(s[g])?o=g:w=g+1}return w}e.$kb=y;function $(s,a,m=0,p=s.length){const w=y(s,a,m,p);return w===s.length?-1:w}e.$lb=$;class b{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(b.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!a(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const m=W(this.e,a,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=b;function k(s,a){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const w=s[p];a(w,m)>0&&(m=w)}return m}e.$nb=k;function B(s,a){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const w=s[p];a(w,m)>=0&&(m=w)}return m}e.$ob=B;function c(s,a){return k(s,(m,p)=>-a(m,p))}e.$pb=c;function d(s,a){if(s.length===0)return-1;let m=0;for(let p=1;p<s.length;p++){const w=s[p];a(w,s[m])>0&&(m=p)}return m}e.$qb=d;function t(s,a){for(const m of s){const p=a(m);if(p!==void 0)return p}}e.$rb=t}),define(me[76],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function i(D,y){const $=Object.create(null);for(const b of D){const k=y(b);let B=$[k];B||(B=$[k]=[]),B.push(b)}return $}e.$K=i;function R(D,y){const $=[],b=[];for(const k of D)y.has(k)||$.push(k);for(const k of y)D.has(k)||b.push(k);return{removed:$,added:b}}e.$L=R;function j(D,y){const $=[],b=[];for(const[k,B]of D)y.has(k)||$.push(B);for(const[k,B]of y)D.has(k)||b.push(B);return{removed:$,added:b}}e.$M=j;function W(D,y){const $=new Set;for(const b of y)D.has(b)&&$.add(b);return $}e.$N=W}),define(me[77],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.$zt=e.$yt=void 0;function i(y,$){const b=Math.pow(10,$);return Math.round(y*b)/b}class R{constructor($,b,k,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,$))|0,this.g=Math.min(255,Math.max(0,b))|0,this.b=Math.min(255,Math.max(0,k))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,b){return $.r===b.r&&$.g===b.g&&$.b===b.b&&$.a===b.a}}e.$yt=R;class j{constructor($,b,k,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.l=i(Math.max(Math.min(1,k),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,b){return $.h===b.h&&$.s===b.s&&$.l===b.l&&$.a===b.a}static fromRGBA($){const b=$.r/255,k=$.g/255,B=$.b/255,c=$.a,d=Math.max(b,k,B),t=Math.min(b,k,B);let s=0,a=0;const m=(t+d)/2,p=d-t;if(p>0){switch(a=Math.min(m<=.5?p/(2*m):p/(2-2*m),1),d){case b:s=(k-B)/p+(k<B?6:0);break;case k:s=(B-b)/p+2;break;case B:s=(b-k)/p+4;break}s*=60,s=Math.round(s)}return new j(s,a,m,c)}static i($,b,k){return k<0&&(k+=1),k>1&&(k-=1),k<1/6?$+(b-$)*6*k:k<1/2?b:k<2/3?$+(b-$)*(2/3-k)*6:$}static toRGBA($){const b=$.h/360,{s:k,l:B,a:c}=$;let d,t,s;if(k===0)d=t=s=B;else{const a=B<.5?B*(1+k):B+k-B*k,m=2*B-a;d=j.i(m,a,b+1/3),t=j.i(m,a,b),s=j.i(m,a,b-1/3)}return new R(Math.round(d*255),Math.round(t*255),Math.round(s*255),c)}}e.$zt=j;class W{constructor($,b,k,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=i(Math.max(Math.min(1,b),0),3),this.v=i(Math.max(Math.min(1,k),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,b){return $.h===b.h&&$.s===b.s&&$.v===b.v&&$.a===b.a}static fromRGBA($){const b=$.r/255,k=$.g/255,B=$.b/255,c=Math.max(b,k,B),d=Math.min(b,k,B),t=c-d,s=c===0?0:t/c;let a;return t===0?a=0:c===b?a=((k-B)/t%6+6)%6:c===k?a=(B-b)/t+2:a=(b-k)/t+4,new W(Math.round(a*60),s,c,$.a)}static toRGBA($){const{h:b,s:k,v:B,a:c}=$,d=B*k,t=d*(1-Math.abs(b/60%2-1)),s=B-d;let[a,m,p]=[0,0,0];return b<60?(a=d,m=t):b<120?(a=t,m=d):b<180?(m=d,p=t):b<240?(m=t,p=d):b<300?(a=t,p=d):b<=360&&(a=d,p=t),a=Math.round((a+s)*255),m=Math.round((m+s)*255),p=Math.round((p+s)*255),new R(a,m,p,c)}}e.$At=W;class D{static fromHex($){return D.Format.CSS.parseHex($)||D.red}static equals($,b){return!$&&!b?!0:!$||!b?!1:$.equals(b)}get hsla(){return this.i?this.i:j.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor($){if($)if($ instanceof R)this.rgba=$;else if($ instanceof j)this.i=$,this.rgba=j.toRGBA($);else if($ instanceof W)this.j=$,this.rgba=W.toRGBA($);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals($){return!!$&&R.equals(this.rgba,$.rgba)&&j.equals(this.hsla,$.hsla)&&W.equals(this.hsva,$.hsva)}getRelativeLuminance(){const $=D.k(this.rgba.r),b=D.k(this.rgba.g),k=D.k(this.rgba.b),B=.2126*$+.7152*b+.0722*k;return i(B,4)}static k($){const b=$/255;return b<=.03928?b/12.92:Math.pow((b+.055)/1.055,2.4)}getContrastRatio($){const b=this.getRelativeLuminance(),k=$.getRelativeLuminance();return b>k?(b+.05)/(k+.05):(k+.05)/(b+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan($){const b=this.getRelativeLuminance(),k=$.getRelativeLuminance();return b>k}isDarkerThan($){const b=this.getRelativeLuminance(),k=$.getRelativeLuminance();return b<k}lighten($){return new D(new j(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*$,this.hsla.a))}darken($){return new D(new j(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*$,this.hsla.a))}transparent($){const{r:b,g:k,b:B,a:c}=this.rgba;return new D(new R(b,k,B,c*$))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend($){const b=$.rgba,k=this.rgba.a,B=b.a,c=k+B*(1-k);if(c<1e-6)return D.transparent;const d=this.rgba.r*k/c+b.r*B*(1-k)/c,t=this.rgba.g*k/c+b.g*B*(1-k)/c,s=this.rgba.b*k/c+b.b*B*(1-k)/c;return new D(new R(d,t,s,c))}makeOpaque($){if(this.isOpaque()||$.rgba.a!==1)return this;const{r:b,g:k,b:B,a:c}=this.rgba;return new D(new R($.rgba.r-c*($.rgba.r-b),$.rgba.g-c*($.rgba.g-k),$.rgba.b-c*($.rgba.b-B),1))}flatten(...$){const b=$.reduceRight((k,B)=>D.o(B,k));return D.o(this,b)}static o($,b){const k=1-$.rgba.a;return new D(new R(k*b.rgba.r+$.rgba.a*$.rgba.r,k*b.rgba.g+$.rgba.a*$.rgba.g,k*b.rgba.b+$.rgba.a*$.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor($,b,k){if($.isLighterThan(b))return $;k=k||.5;const B=$.getRelativeLuminance(),c=b.getRelativeLuminance();return k=k*(c-B)/c,$.lighten(k)}static getDarkerColor($,b,k){if($.isDarkerThan(b))return $;k=k||.5;const B=$.getRelativeLuminance(),c=b.getRelativeLuminance();return k=k*(B-c)/B,$.darken(k)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$Bt=D,function(y){let $;(function(b){let k;(function(B){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:y.Format.CSS.formatRGBA(r)}B.formatRGB=c;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}B.formatRGBA=d;function t(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(r)}B.formatHSL=t;function s(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}B.formatHSLA=s;function a(r){const E=r.toString(16);return E.length!==2?"0"+E:E}function m(r){return`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}`}B.formatHex=m;function p(r,E=!1){return E&&r.rgba.a===1?y.Format.CSS.formatHex(r):`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}${a(Math.round(r.rgba.a*255))}`}B.formatHexA=p;function w(r){return r.isOpaque()?y.Format.CSS.formatHex(r):y.Format.CSS.formatRGBA(r)}B.format=w;function o(r){const E=r.length;if(E===0||r.charCodeAt(0)!==35)return null;if(E===7){const N=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),M=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),P=16*g(r.charCodeAt(5))+g(r.charCodeAt(6));return new y(new R(N,M,P,1))}if(E===9){const N=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),M=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),P=16*g(r.charCodeAt(5))+g(r.charCodeAt(6)),z=16*g(r.charCodeAt(7))+g(r.charCodeAt(8));return new y(new R(N,M,P,z/255))}if(E===4){const N=g(r.charCodeAt(1)),M=g(r.charCodeAt(2)),P=g(r.charCodeAt(3));return new y(new R(16*N+N,16*M+M,16*P+P))}if(E===5){const N=g(r.charCodeAt(1)),M=g(r.charCodeAt(2)),P=g(r.charCodeAt(3)),z=g(r.charCodeAt(4));return new y(new R(16*N+N,16*M+M,16*P+P,(16*z+z)/255))}return null}B.parseHex=o;function g(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(k=b.CSS||(b.CSS={}))})($=y.Format||(y.Format={}))}(D||(e.$Bt=D={}))}),define(me[28],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function i(D){return(y,$,b)=>{let k=null,B=null;if(typeof b.value=="function"?(k="value",B=b.value):typeof b.get=="function"&&(k="get",B=b.get),!B)throw new Error("not supported");b[k]=D(B,$)}}function R(D,y,$){let b=null,k=null;if(typeof $.value=="function"?(b="value",k=$.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(b="get",k=$.get),!k)throw new Error("not supported");const B=`$memoize$${y}`;$[b]=function(...c){return this.hasOwnProperty(B)||Object.defineProperty(this,B,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,c)}),this[B]}}e.$Kh=R;function j(D,y,$){return i((b,k)=>{const B=`$debounce$${k}`,c=`$debounce$result$${k}`;return function(...d){this[c]||(this[c]=$?$():void 0),clearTimeout(this[B]),y&&(this[c]=y(this[c],...d),d=[this[c]]),this[B]=setTimeout(()=>{b.apply(this,d),this[c]=$?$():void 0},D)}})}e.$Lh=j;function W(D,y,$){return i((b,k)=>{const B=`$throttle$timer$${k}`,c=`$throttle$result$${k}`,d=`$throttle$lastRun$${k}`,t=`$throttle$pending$${k}`;return function(...s){if(this[c]||(this[c]=$?$():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[c]=y(this[c],...s)),this[t])return;const a=this[d]+D;a<=Date.now()?(this[d]=Date.now(),b.apply(this,[this[c]]),this[c]=$?$():void 0):(this[t]=!0,this[B]=setTimeout(()=>{this[t]=!1,this[d]=Date.now(),b.apply(this,[this[c]]),this[c]=$?$():void 0},a-Date.now()))}})}e.$Mh=W}),define(me[78],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class i{constructor(j,W,D,y){this.originalStart=j,this.originalLength=W,this.modifiedStart=D,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}e.$at=i}),define(me[6],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?w.isErrorNoTelemetry(r)?new w(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(E=>{E(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$W=i,e.$X=new i;function R(g){e.$X.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function j(g){if(!g||typeof g!="object")return!1;const r=g;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.$Z=j;function W(g){b(g)||e.$X.onUnexpectedError(g)}e.$1=W;function D(g){b(g)||e.$X.onUnexpectedExternalError(g)}e.$2=D;function y(g){if(g instanceof Error){const{name:r,message:E}=g,N=g.stacktrace||g.stack;return{$isError:!0,name:r,message:E,stack:N,noTelemetry:w.isErrorNoTelemetry(g)}}return g}e.$3=y;const $="Canceled";function b(g){return g instanceof k?!0:g instanceof Error&&g.name===$&&g.message===$}e.$4=b;class k extends Error{constructor(){super($),this.name=this.message}}e.$5=k;function B(){const g=new Error($);return g.name=g.message,g}e.$6=B;function c(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.$7=c;function d(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.$8=d;class t extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=t;function s(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.$0=s;class a extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$$=a;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$_=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class w extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof w)return r;const E=new w;return E.message=r.message,E.stack=r.stack,E}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$bb=w;class o extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(me[12],$e([1,0,6,75]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function j(K,f=0){return K[K.length-(1+f)]}e.$sb=j;function W(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.$tb=W;function D(K,f,A=(F,l)=>F===l){if(K===f)return!0;if(!K||!f||K.length!==f.length)return!1;for(let F=0,l=K.length;F<l;F++)if(!A(K[F],f[F]))return!1;return!0}e.$ub=D;function y(K,f){const A=K.length-1;f<A&&(K[f]=K[A]),K.pop()}e.$vb=y;function $(K,f,A){return b(K.length,F=>A(K[F],f))}e.$wb=$;function b(K,f){let A=0,F=K-1;for(;A<=F;){const l=(A+F)/2|0,u=f(l);if(u<0)A=l+1;else if(u>0)F=l-1;else return l}return-(A+1)}e.$xb=b;function k(K,f,A){if(K=K|0,K>=f.length)throw new TypeError("invalid index");const F=f[Math.floor(f.length*Math.random())],l=[],u=[],n=[];for(const h of f){const C=A(h,F);C<0?l.push(h):C>0?u.push(h):n.push(h)}return K<l.length?k(K,l,A):K<l.length+n.length?n[0]:k(K-(l.length+n.length),u,A)}e.$yb=k;function B(K,f){const A=[];let F;for(const l of K.slice(0).sort(f))!F||f(F[0],l)!==0?(F=[l],A.push(F)):F.push(l);return A}e.$zb=B;function*c(K,f){let A,F;for(const l of K)F!==void 0&&f(F,l)?A.push(l):(A&&(yield A),A=[l]),F=l;A&&(yield A)}e.$Ab=c;function d(K,f){for(let A=0;A<=K.length;A++)f(A===0?void 0:K[A-1],A===K.length?void 0:K[A])}e.$Bb=d;function t(K,f){for(let A=0;A<K.length;A++)f(A===0?void 0:K[A-1],K[A],A+1===K.length?void 0:K[A+1])}e.$Cb=t;function s(K,f,A){const F=[];function l(h,C,S){if(C===0&&S.length===0)return;const O=F[F.length-1];O&&O.start+O.deleteCount===h?(O.deleteCount+=C,O.toInsert.push(...S)):F.push({start:h,deleteCount:C,toInsert:S})}let u=0,n=0;for(;;){if(u===K.length){l(u,0,f.slice(n));break}if(n===f.length){l(u,K.length-u,[]);break}const h=K[u],C=f[n],S=A(h,C);S===0?(u+=1,n+=1):S<0?(l(u,1,[]),u+=1):S>0&&(l(u,0,[C]),n+=1)}return F}e.$Db=s;function a(K,f,A){const F=s(K,f,A),l=[],u=[];for(const n of F)l.push(...K.slice(n.start,n.start+n.deleteCount)),u.push(...n.toInsert);return{removed:l,added:u}}e.$Eb=a;function m(K,f,A){if(A===0)return[];const F=K.slice(0,A).sort(f);return w(K,f,F,A,K.length),F}e.top=m;function p(K,f,A,F,l){return A===0?Promise.resolve([]):new Promise((u,n)=>{(async()=>{const h=K.length,C=K.slice(0,A).sort(f);for(let S=A,O=Math.min(A+F,h);S<h;S=O,O=Math.min(O+F,h)){if(S>A&&await new Promise(q=>setTimeout(q)),l&&l.isCancellationRequested)throw new i.$5;w(K,f,C,S,O)}return C})().then(u,n)})}e.$Gb=p;function w(K,f,A,F,l){for(const u=A.length;F<l;F++){const n=K[F];if(f(n,A[u-1])<0){A.pop();const h=(0,R.$kb)(A,C=>f(n,C)<0);A.splice(h,0,n)}}}function o(K){return K.filter(f=>!!f)}e.$Hb=o;function g(K){let f=0;for(let A=0;A<K.length;A++)K[A]&&(K[f]=K[A],f+=1);K.length=f}e.$Ib=g;function r(K,f,A){K.splice(A,0,K.splice(f,1)[0])}e.$Jb=r;function E(K){return!Array.isArray(K)||K.length===0}e.$Kb=E;function N(K){return Array.isArray(K)&&K.length>0}e.$Lb=N;function M(K,f=A=>A){const A=new Set;return K.filter(F=>{const l=f(F);return A.has(l)?!1:(A.add(l),!0)})}e.$Mb=M;function P(K){const f=new Set;return A=>{const F=K(A);return f.has(F)?!1:(f.add(F),!0)}}e.$Nb=P;function z(K,f){return K.length>0?K[0]:f}e.$Ob=z;function v(K,f){return K.length>0?K[K.length-1]:f}e.$Pb=v;function H(K,f,A=(F,l)=>F===l){let F=0;for(let l=0,u=Math.min(K.length,f.length);l<u&&A(K[l],f[l]);l++)F++;return F}e.$Qb=H;function V(K){return[].concat(...K)}e.$Rb=V;function T(K,f){let A=typeof f=="number"?K:0;typeof f=="number"?A=K:(A=0,f=K);const F=[];if(A<=f)for(let l=A;l<f;l++)F.push(l);else for(let l=A;l>f;l--)F.push(l);return F}e.$Sb=T;function L(K,f,A){return K.reduce((F,l)=>(F[f(l)]=A?A(l):l,F),Object.create(null))}e.$Tb=L;function I(K,f){return K.push(f),()=>X(K,f)}e.$Ub=I;function X(K,f){const A=K.indexOf(f);if(A>-1)return K.splice(A,1),f}e.$Vb=X;function U(K,f,A){const F=K.slice(0,f),l=K.slice(f);return F.concat(A,l)}e.$Wb=U;function de(K,f){let A;if(typeof f=="number"){let F=f;A=()=>{const l=Math.sin(F++)*179426549;return l-Math.floor(l)}}else A=Math.random;for(let F=K.length-1;F>0;F-=1){const l=Math.floor(A()*(F+1)),u=K[F];K[F]=K[l],K[l]=u}}e.$Xb=de;function he(K,f){const A=K.indexOf(f);A>-1&&(K.splice(A,1),K.unshift(f))}e.$Yb=he;function ne(K,f){const A=K.indexOf(f);A>-1&&(K.splice(A,1),K.push(f))}e.$Zb=ne;function ge(K,f){for(const A of f)K.push(A)}e.$1b=ge;function Ce(K,f){return Array.isArray(K)?K.map(f):f(K)}e.$2b=Ce;function Re(K){return Array.isArray(K)?K:[K]}e.$3b=Re;function Be(K){return K[Math.floor(Math.random()*K.length)]}e.$4b=Be;function le(K,f,A){const F=ae(K,f),l=K.length,u=A.length;K.length=l+u;for(let n=l-1;n>=F;n--)K[n+u]=K[n];for(let n=0;n<u;n++)K[n+F]=A[n]}e.$5b=le;function _(K,f,A,F){const l=ae(K,f);let u=K.splice(l,A);return u===void 0&&(u=[]),le(K,l,F),u}e.$6b=_;function ae(K,f){return f<0?Math.max(f+K.length,0):Math.min(f,K.length)}var oe;(function(K){function f(u){return u<0}K.isLessThan=f;function A(u){return u<=0}K.isLessThanOrEqual=A;function F(u){return u>0}K.isGreaterThan=F;function l(u){return u===0}K.isNeitherLessOrGreaterThan=l,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function J(K,f){return(A,F)=>f(K(A),K(F))}e.$7b=J;function G(...K){return(f,A)=>{for(const F of K){const l=F(f,A);if(!oe.isNeitherLessOrGreaterThan(l))return l}return oe.neitherLessOrGreaterThan}}e.$8b=G;const ie=(K,f)=>K-f;e.$9b=ie;const fe=(K,f)=>(0,e.$9b)(K?1:0,f?1:0);e.$0b=fe;function De(K){return(f,A)=>-K(f,A)}e.$$b=De;class Fe{constructor(f){this.g=f,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(f){let A=this.c;for(;A<this.g.length&&f(this.g[A]);)A++;const F=A===this.c?null:this.g.slice(this.c,A);return this.c=A,F}takeFromEndWhile(f){let A=this.d;for(;A>=0&&f(this.g[A]);)A--;const F=A===this.d?null:this.g.slice(A+1,this.d+1);return this.d=A,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const f=this.g[this.c];return this.c++,f}removeLast(){const f=this.g[this.d];return this.d--,f}takeCount(f){const A=this.g.slice(this.c,this.c+f);return this.c+=f,A}}e.$_b=Fe;class ye{static{this.empty=new ye(f=>{})}constructor(f){this.iterate=f}forEach(f){this.iterate(A=>(f(A),!0))}toArray(){const f=[];return this.iterate(A=>(f.push(A),!0)),f}filter(f){return new ye(A=>this.iterate(F=>f(F)?A(F):!0))}map(f){return new ye(A=>this.iterate(F=>A(f(F))))}some(f){let A=!1;return this.iterate(F=>(A=f(F),!A)),A}findFirst(f){let A;return this.iterate(F=>f(F)?(A=F,!1):!0),A}findLast(f){let A;return this.iterate(F=>(f(F)&&(A=F),!0)),A}findLastMaxBy(f){let A,F=!0;return this.iterate(l=>((F||oe.isGreaterThan(f(l,A)))&&(F=!1,A=l),!0)),A}}e.$ac=ye}),define(me[79],$e([1,0,6]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function R(b,k){if(!b)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=R;function j(b,k="Unreachable"){throw new Error(k)}e.$9c=j;function W(b){if(!b)throw new i.$cb("Assertion Failed")}e.$0c=W;function D(b){b||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}e.$$c=D;function y(b){if(!b()){debugger;b(),(0,i.$1)(new i.$cb("Assertion Failed"))}}e.$_c=y;function $(b,k){let B=0;for(;B<b.length-1;){const c=b[B],d=b[B+1];if(!k(c,d))return!1;B++}return!0}e.$ad=$}),define(me[47],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function i(R,j){const W=this;let D=!1,y;return function(){if(D)return y;if(D=!0,j)try{y=R.apply(W,arguments)}finally{j()}else y=R.apply(W,arguments);return y}}e.$db=i}),define(me[80],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=e.$wO=void 0;class i{constructor(j){this.a=j,this.b=0}nextId(){return this.a+ ++this.b}}e.$wO=i,e.$xO=new i("id#")}),define(me[29],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(R){function j(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}R.is=j;const W=Object.freeze([]);function D(){return W}R.empty=D;function*y(r){yield r}R.single=y;function $(r){return j(r)?r:y(r)}R.wrap=$;function b(r){return r||W}R.from=b;function*k(r){for(let E=r.length-1;E>=0;E--)yield r[E]}R.reverse=k;function B(r){return!r||r[Symbol.iterator]().next().done===!0}R.isEmpty=B;function c(r){return r[Symbol.iterator]().next().value}R.first=c;function d(r,E){for(const N of r)if(E(N))return!0;return!1}R.some=d;function t(r,E){for(const N of r)if(E(N))return N}R.find=t;function*s(r,E){for(const N of r)E(N)&&(yield N)}R.filter=s;function*a(r,E){let N=0;for(const M of r)yield E(M,N++)}R.map=a;function*m(...r){for(const E of r)yield*E}R.concat=m;function p(r,E,N){let M=N;for(const P of r)M=E(M,P);return M}R.reduce=p;function*w(r,E,N=r.length){for(E<0&&(E+=r.length),N<0?N+=r.length:N>r.length&&(N=r.length);E<N;E++)yield r[E]}R.slice=w;function o(r,E=Number.POSITIVE_INFINITY){const N=[];if(E===0)return[N,r];const M=r[Symbol.iterator]();for(let P=0;P<E;P++){const z=M.next();if(z.done)return[N,R.empty()];N.push(z.value)}return[N,{[Symbol.iterator](){return M}}]}R.consume=o;async function g(r){const E=[];for await(const N of r)E.push(N);return Promise.resolve(E)}R.asyncToArray=g})(i||(e.Iterable=i={}))}),define(me[48],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.KeyMod=e.KeyCodeUtils=e.$ir=e.$hr=e.$gr=e.$fr=e.$er=e.ScanCode=e.KeyCode=void 0;var i;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(i||(e.KeyCode=i={}));var R;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(R||(e.ScanCode=R={}));class j{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,a){this._keyCodeToStr[s]=a,this._strToKeyCode[a.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const W=new j,D=new j,y=new j;e.$er=new Array(230),e.$fr={};const $=[],b=Object.create(null),k=Object.create(null);e.$gr={lowerCaseToEnum:t=>k[t]||0,toEnum:t=>b[t]||0,toString:t=>$[t]||"None"},e.$hr=[],e.$ir=[];for(let t=0;t<=193;t++)e.$hr[t]=-1;for(let t=0;t<=132;t++)e.$ir[t]=-1;(function(){const t="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],a=[],m=[];for(const p of s){const[w,o,g,r,E,N,M,P,z]=p;if(m[o]||(m[o]=!0,$[o]=g,b[g]=o,k[g.toLowerCase()]=o,w&&(e.$hr[o]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(e.$ir[r]=o))),!a[r]){if(a[r]=!0,!E)throw new Error(`String representation missing for key code ${r} around scan code ${g}`);W.define(r,E),D.define(r,P||E),y.define(r,z||P||E)}N&&(e.$er[N]=r),M&&(e.$fr[M]=r)}e.$ir[3]=46})();var B;(function(t){function s(g){return W.keyCodeToStr(g)}t.toString=s;function a(g){return W.strToKeyCode(g)}t.fromString=a;function m(g){return D.keyCodeToStr(g)}t.toUserSettingsUS=m;function p(g){return y.keyCodeToStr(g)}t.toUserSettingsGeneral=p;function w(g){return D.strToKeyCode(g)||y.strToKeyCode(g)}t.fromUserSettings=w;function o(g){if(g>=98&&g<=113)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(g)}t.toElectronAccelerator=o})(B||(e.KeyCodeUtils=B={}));var c;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(c||(e.KeyMod=c={}));function d(t,s){const a=(s&65535)<<16>>>0;return(t|a)>>>0}e.$jr=d}),define(me[81],$e([1,0,6]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;var R;(function(B){B[B.CtrlCmd=2048]="CtrlCmd",B[B.Shift=1024]="Shift",B[B.Alt=512]="Alt",B[B.WinCtrl=256]="WinCtrl",B[B.KeyCode=255]="KeyCode"})(R||(R={}));function j(B,c){if(typeof B=="number"){if(B===0)return null;const d=(B&65535)>>>0,t=(B&4294901760)>>>16;return t!==0?new $([W(d,c),W(t,c)]):new $([W(d,c)])}else{const d=[];for(let t=0;t<B.length;t++)d.push(W(B[t],c));return new $(d)}}e.$kr=j;function W(B,c){const d=!!(B&2048),t=!!(B&256),s=c===2?t:d,a=!!(B&1024),m=!!(B&512),p=c===2?d:t,w=B&255;return new D(s,a,m,p,w)}e.$lr=W;class D{constructor(c,d,t,s,a){this.ctrlKey=c,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyCode=a}equals(c){return c instanceof D&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${c}${d}${t}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new $([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.$mr=D;class y{constructor(c,d,t,s,a){this.ctrlKey=c,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.scanCode=a}equals(c){return c instanceof y&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${c}${d}${t}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.$nr=y;class ${constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let d=0,t=this.chords.length;d<t;d++)d!==0&&(c+=";"),c+=this.chords[d].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(c.chords[d]))return!1;return!0}}e.$or=$;class b{constructor(c,d,t,s,a,m){this.ctrlKey=c,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyLabel=a,this.keyAriaLabel=m}}e.$pr=b;class k{}e.$qr=k}),define(me[23],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(me[14],$e([1,0,23]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RS=e.$QS=e.$PS=void 0;let j=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new i.$V(()=>j("mouse",!1)),D=new i.$V(()=>j("element",!1));function y(k){j=k}e.$PS=y;function $(k){return k==="element"?D.value:W.value}e.$QS=$;function b(){return j("element",!0)}e.$RS=b}),define(me[49],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(W){this.element=W,this.next=i.Undefined,this.prev=i.Undefined}}class R{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let W=this.a;for(;W!==i.Undefined;){const D=W.next;W.prev=i.Undefined,W.next=i.Undefined,W=D}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,D){const y=new i(W);if(this.a===i.Undefined)this.a=y,this.b=y;else if(D){const b=this.b;this.b=y,y.prev=b,b.next=y}else{const b=this.a;this.a=y,y.next=b,b.prev=y}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(y))}}shift(){if(this.a!==i.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==i.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==i.Undefined&&W.next!==i.Undefined){const D=W.prev;D.next=W.next,W.next.prev=D}else W.prev===i.Undefined&&W.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):W.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):W.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==i.Undefined;)yield W.element,W=W.next}}e.$4c=R}),define(me[34],$e([1,0]),function(re,e){"use strict";var i,R,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function W(w,o,g){let r=w.get(o);return r===void 0&&(r=g,w.set(o,r)),r}e.$xc=W;function D(w){const o=[];return w.forEach((g,r)=>{o.push(`${r} => ${g}`)}),`Map(${w.size}) {${o.join(", ")}}`}e.$yc=D;function y(w){const o=[];return w.forEach(g=>{o.push(g)}),`Set(${w.size}) {${o.join(", ")}}`}e.$zc=y;class ${constructor(o,g){this.uri=o,this.value=g}}function b(w){return Array.isArray(w)}class k{static{this.c=o=>o.toString()}constructor(o,g){if(this[i]="ResourceMap",o instanceof k)this.d=new Map(o.d),this.e=g??k.c;else if(b(o)){this.d=new Map,this.e=g??k.c;for(const[r,E]of o)this.set(r,E)}else this.d=new Map,this.e=o??k.c}set(o,g){return this.d.set(this.e(o),new $(o,g)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[r,E]of this.d)o(E.value,E.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Ac=k;class B{constructor(o,g){this[R]="ResourceSet",!o||typeof o=="function"?this.c=new k(o):(this.c=new k(g),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,g){this.c.forEach((r,E)=>o.call(g,E,E,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=B;var c;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(c||(e.Touch=c={}));class d{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,g=0){const r=this.c.get(o);if(r)return g!==0&&this.l(r,g),r.value}set(o,g,r=0){let E=this.c.get(o);if(E)E.value=g,r!==0&&this.l(E,r);else{switch(E={key:o,value:g,next:void 0,previous:void 0},r){case 0:this.j(E);break;case 1:this.i(E);break;case 2:this.j(E);break;default:this.j(E);break}this.c.set(o,E),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.c.get(o);if(g)return this.c.delete(o),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.k(o),this.f--,o.value}forEach(o,g){const r=this.g;let E=this.d;for(;E;){if(g?o.bind(g)(E.value,E.key,this):o(E.value,E.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:r.key,done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return E}values(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:r.value,done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return E}entries(){const o=this,g=this.g;let r=this.d;const E={[Symbol.iterator](){return E},next(){if(o.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:[r.key,r.value],done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return E}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.d,r=this.size;for(;g&&r>o;)this.c.delete(g.key),g=g.next,r--;this.d=g,this.f=r,g&&(g.previous=void 0),this.g++}i(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}j(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}k(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const g=o.next,r=o.previous;if(!g||!r)throw new Error("Invalid list");g.previous=r,r.next=g}o.next=void 0,o.previous=void 0,this.g++}l(o,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.d)return;const r=o.next,E=o.previous;o===this.e?(E.next=void 0,this.e=E):(r.previous=E,E.next=r),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(g===2){if(o===this.e)return;const r=o.next,E=o.previous;o===this.d?(r.previous=void 0,this.d=r):(r.previous=E,E.next=r),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((g,r)=>{o.push([r,g])}),o}fromJSON(o){this.clear();for(const[g,r]of o)this.set(g,r)}}e.$Cc=d;class t extends d{constructor(o,g=1){super(),this.m=o,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(o){this.m=o,this.o()}get ratio(){return this.n}set ratio(o){this.n=Math.min(Math.max(0,o),1),this.o()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=t;class s{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let g=this.c.get(o)||0;return g===0?!1:(g--,g===0?this.c.delete(o):this.c.set(o,g),!0)}has(o){return this.c.has(o)}}e.$Ec=s;class a{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[g,r]of o)this.set(g,r)}clear(){this.c.clear(),this.d.clear()}set(o,g){this.c.set(o,g),this.d.set(g,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const g=this.c.get(o);return g===void 0?!1:(this.c.delete(o),this.d.delete(g),!0)}forEach(o,g){this.c.forEach((r,E)=>{o.call(g,r,E,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=a;class m{constructor(){this.c=new Map}add(o,g){let r=this.c.get(o);r||(r=new Set,this.c.set(o,r)),r.add(g)}delete(o,g){const r=this.c.get(o);r&&(r.delete(g),r.size===0&&this.c.delete(o))}forEach(o,g){const r=this.c.get(o);r&&r.forEach(g)}get(o){const g=this.c.get(o);return g||new Set}}e.$Gc=m;function p(w,o){if(w===o)return!0;if(w.size!==o.size)return!1;for(const[g,r]of w)if(!o.has(g)||o.get(g)!==r)return!1;for(const[g]of o)if(!w.has(g))return!1;return!0}e.$Hc=p}),define(me[3],$e([1,0,12,76,34,47,29]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const y=!1;let $=null;class b{constructor(){this.b=new Map}static{this.a=0}c(I){let X=this.b.get(I);return X||(X={parent:null,source:null,isSingleton:!1,value:I,idx:b.a++},this.b.set(I,X)),X}trackDisposable(I){const X=this.c(I);X.source||(X.source=new Error().stack)}setParent(I,X){const U=this.c(I);U.parent=X}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,X){const U=X.get(I);if(U)return U;const de=I.parent?this.f(this.c(I.parent),X):I;return X.set(I,de),de}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,X){let U;if(X)U=X;else{const Ce=new Map,Re=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Ce).isSingleton);if(Re.length===0)return;const Be=new Set(Re.map(le=>le.value));if(U=Re.filter(le=>!(le.parent&&Be.has(le.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function de(Ce){function Re(le,_){for(;le.length>0&&_.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Be=Ce.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Re(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const he=new j.$Gc;for(const Ce of U){const Re=de(Ce);for(let Be=0;Be<=Re.length;Be++)he.add(Re.slice(0,Be).join(`
`),Ce)}U.sort((0,i.$7b)(Ce=>Ce.idx,i.$9b));let ne="",ge=0;for(const Ce of U.slice(0,I)){ge++;const Re=de(Ce),Be=[];for(let le=0;le<Re.length;le++){let _=Re[le];_=`(shared with ${he.get(Re.slice(0,le+1).join(`
`)).size}/${U.length} leaks) at ${_}`;const oe=he.get(Re.slice(0,le).join(`
`)),J=(0,R.$K)([...oe].map(G=>de(G)[le]),G=>G);delete J[Re[le]];for(const[G,ie]of Object.entries(J))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${G}`);Be.unshift(_)}ne+=`


==================== Leaking disposable ${ge}/${U.length}: ${Ce.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return U.length>I&&(ne+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:ne}}}e.$Ic=b;function k(L){$=L}if(e.$Jc=k,y){const L="__is_disposable_tracked__";k(new class{trackDisposable(I){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[L]||console.log(X)},3e3)}setParent(I,X){if(I&&I!==r.None)try{I[L]=!0}catch{}}markAsDisposed(I){if(I&&I!==r.None)try{I[L]=!0}catch{}}markAsSingleton(I){}})}function B(L){return $?.trackDisposable(L),L}e.$Kc=B;function c(L){$?.markAsDisposed(L)}e.$Lc=c;function d(L,I){$?.setParent(L,I)}function t(L,I){if($)for(const X of L)$.setParent(X,I)}function s(L){return $?.markAsSingleton(L),L}e.$Mc=s;function a(L){return typeof L.dispose=="function"&&L.dispose.length===0}e.$Nc=a;function m(L){if(D.Iterable.is(L)){const I=[];for(const X of L)if(X)try{X.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}e.$Oc=m;function p(L){for(const I of L)a(I)&&I.dispose();return[]}e.$Pc=p;function w(...L){const I=o(()=>m(L));return t(L,I),I}e.$Qc=w;function o(L){const I=B({dispose:(0,W.$db)(()=>{c(I),L()})});return I}e.$Rc=o;class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Sc=g;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,B(this),d(this.q,this)}dispose(){c(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Tc=r;class E{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Uc=E;class N{constructor(I){this.a=new E,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=N;class M{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=M;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(I){let X=I;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,c(this))},this}}e.$Xc=P;class z{constructor(){this.a=new Map}acquire(I,...X){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...X)},this.a.set(I,U));const{object:de}=U,he=(0,W.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:de,dispose:he}}}e.$Yc=z;class v{constructor(I){this.a=I}async acquire(I,...X){const U=this.a.acquire(I,...X);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(de){throw U.dispose(),de}}}e.$Zc=v;class H{constructor(I){this.object=I}dispose(){}}e.$1c=H;function V(L){const I=new g;try{L(I)}finally{I.dispose()}}e.$2c=V;class T{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,X,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,X)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=T}),function(re,e){typeof define=="function"&&define.amd?define(me[82],$e([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(f,A){for(var F=0;F<A.length;F++){var l=A[F];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(f,l.key,l)}}function i(f,A,F){return A&&e(f.prototype,A),F&&e(f,F),Object.defineProperty(f,"prototype",{writable:!1}),f}function R(f,A){if(f){if(typeof f=="string")return j(f,A);var F=Object.prototype.toString.call(f).slice(8,-1);if(F==="Object"&&f.constructor&&(F=f.constructor.name),F==="Map"||F==="Set")return Array.from(f);if(F==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(F))return j(f,A)}}function j(f,A){(A==null||A>f.length)&&(A=f.length);for(var F=0,l=new Array(A);F<A;F++)l[F]=f[F];return l}function W(f,A){var F=typeof Symbol<"u"&&f[Symbol.iterator]||f["@@iterator"];if(F)return(F=F.call(f)).next.bind(F);if(Array.isArray(f)||(F=R(f))||A&&f&&typeof f.length=="number"){F&&(f=F);var l=0;return function(){return l>=f.length?{done:!0}:{done:!1,value:f[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=D();function y(f){re.defaults=f}var $=/[&<>"']/,b=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,B=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(A){return c[A]};function t(f,A){if(A){if($.test(f))return f.replace(b,d)}else if(k.test(f))return f.replace(B,d);return f}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(f){return f.replace(s,function(A,F){return F=F.toLowerCase(),F==="colon"?":":F.charAt(0)==="#"?F.charAt(1)==="x"?String.fromCharCode(parseInt(F.substring(2),16)):String.fromCharCode(+F.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(f,A){f=typeof f=="string"?f:f.source,A=A||"";var F={replace:function(u,n){return n=n.source||n,n=n.replace(m,"$1"),f=f.replace(u,n),F},getRegex:function(){return new RegExp(f,A)}};return F}var w=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(f,A,F){if(f){var l;try{l=decodeURIComponent(a(F)).replace(w,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}A&&!o.test(F)&&(F=P(A,F));try{F=encodeURI(F).replace(/%25/g,"%")}catch{return null}return F}var r={},E=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,M=/^([^:]+:\/*[^/]*)[\s\S]*$/;function P(f,A){r[" "+f]||(E.test(f)?r[" "+f]=f+"/":r[" "+f]=V(f,"/",!0)),f=r[" "+f];var F=f.indexOf(":")===-1;return A.substring(0,2)==="//"?F?A:f.replace(N,"$1")+A:A.charAt(0)==="/"?F?A:f.replace(M,"$1")+A:f+A}var z={exec:function(){}};function v(f){for(var A=1,F,l;A<arguments.length;A++){F=arguments[A];for(l in F)Object.prototype.hasOwnProperty.call(F,l)&&(f[l]=F[l])}return f}function H(f,A){var F=f.replace(/\|/g,function(n,h,C){for(var S=!1,O=h;--O>=0&&C[O]==="\\";)S=!S;return S?"|":" |"}),l=F.split(/ \|/),u=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>A)l.splice(A);else for(;l.length<A;)l.push("");for(;u<l.length;u++)l[u]=l[u].trim().replace(/\\\|/g,"|");return l}function V(f,A,F){var l=f.length;if(l===0)return"";for(var u=0;u<l;){var n=f.charAt(l-u-1);if(n===A&&!F)u++;else if(n!==A&&F)u++;else break}return f.slice(0,l-u)}function T(f,A){if(f.indexOf(A[1])===-1)return-1;for(var F=f.length,l=0,u=0;u<F;u++)if(f[u]==="\\")u++;else if(f[u]===A[0])l++;else if(f[u]===A[1]&&(l--,l<0))return u;return-1}function L(f){f&&f.sanitize&&!f.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(f,A){if(A<1)return"";for(var F="";A>1;)A&1&&(F+=f),A>>=1,f+=f;return F+f}function X(f,A,F,l){var u=A.href,n=A.title?t(A.title):null,h=f[1].replace(/\\([\[\]])/g,"$1");if(f[0].charAt(0)!=="!"){l.state.inLink=!0;var C={type:"link",raw:F,href:u,title:n,text:h,tokens:l.inlineTokens(h)};return l.state.inLink=!1,C}return{type:"image",raw:F,href:u,title:n,text:t(h)}}function U(f,A){var F=f.match(/^(\s+)(?:```)/);if(F===null)return A;var l=F[1];return A.split(`
`).map(function(u){var n=u.match(/^\s+/);if(n===null)return u;var h=n[0];return h.length>=l.length?u.slice(l.length):u}).join(`
`)}var de=function(){function f(F){this.options=F||re.defaults}var A=f.prototype;return A.space=function(l){var u=this.rules.block.newline.exec(l);if(u&&u[0].length>0)return{type:"space",raw:u[0]}},A.code=function(l){var u=this.rules.block.code.exec(l);if(u){var n=u[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:u[0],codeBlockStyle:"indented",text:this.options.pedantic?n:V(n,`
`)}}},A.fences=function(l){var u=this.rules.block.fences.exec(l);if(u){var n=u[0],h=U(n,u[3]||"");return{type:"code",raw:n,lang:u[2]?u[2].trim():u[2],text:h}}},A.heading=function(l){var u=this.rules.block.heading.exec(l);if(u){var n=u[2].trim();if(/#$/.test(n)){var h=V(n,"#");(this.options.pedantic||!h||/ $/.test(h))&&(n=h.trim())}return{type:"heading",raw:u[0],depth:u[1].length,text:n,tokens:this.lexer.inline(n)}}},A.hr=function(l){var u=this.rules.block.hr.exec(l);if(u)return{type:"hr",raw:u[0]}},A.blockquote=function(l){var u=this.rules.block.blockquote.exec(l);if(u){var n=u[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:u[0],tokens:this.lexer.blockTokens(n,[]),text:n}}},A.list=function(l){var u=this.rules.block.list.exec(l);if(u){var n,h,C,S,O,q,Z,te,be,we,ke,Pe,Ee=u[1].trim(),Ae=Ee.length>1,Ne={type:"list",raw:"",ordered:Ae,start:Ae?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Ae?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Ae?Ee:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Pe=!1,!(!(u=Ie.exec(l))||this.rules.block.hr.test(l)));){if(n=u[0],l=l.substring(n.length),te=u[2].split(`
`,1)[0],be=l.split(`
`,1)[0],this.options.pedantic?(S=2,ke=te.trimLeft()):(S=u[2].search(/[^ ]/),S=S>4?1:S,ke=te.slice(S),S+=u[1].length),q=!1,!te&&/^ *$/.test(be)&&(n+=be+`
`,l=l.substring(be.length+1),Pe=!0),!Pe)for(var Ge=new RegExp("^ {0,"+Math.min(3,S-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,S-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,S-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,S-1)+"}#");l&&(we=l.split(`
`,1)[0],te=we,this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(te)||Ue.test(te)||Ge.test(te)||nt.test(l)));){if(te.search(/[^ ]/)>=S||!te.trim())ke+=`
`+te.slice(S);else if(!q)ke+=`
`+te;else break;!q&&!te.trim()&&(q=!0),n+=we+`
`,l=l.substring(we.length+1)}Ne.loose||(Z?Ne.loose=!0:/\n *\n *$/.test(n)&&(Z=!0)),this.options.gfm&&(h=/^\[[ xX]\] /.exec(ke),h&&(C=h[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Ne.items.push({type:"list_item",raw:n,task:!!h,checked:C,loose:!1,text:ke}),Ne.raw+=n}Ne.items[Ne.items.length-1].raw=n.trimRight(),Ne.items[Ne.items.length-1].text=ke.trimRight(),Ne.raw=Ne.raw.trimRight();var Y=Ne.items.length;for(O=0;O<Y;O++){this.lexer.state.top=!1,Ne.items[O].tokens=this.lexer.blockTokens(Ne.items[O].text,[]);var se=Ne.items[O].tokens.filter(function(ve){return ve.type==="space"}),pe=se.every(function(ve){for(var Le=ve.raw.split(""),je=0,qe=W(Le),_e;!(_e=qe()).done;){var tt=_e.value;if(tt===`
`&&(je+=1),je>1)return!0}return!1});!Ne.loose&&se.length&&pe&&(Ne.loose=!0,Ne.items[O].loose=!0)}return Ne}},A.html=function(l){var u=this.rules.block.html.exec(l);if(u){var n={type:"html",raw:u[0],pre:!this.options.sanitizer&&(u[1]==="pre"||u[1]==="script"||u[1]==="style"),text:u[0]};if(this.options.sanitize){var h=this.options.sanitizer?this.options.sanitizer(u[0]):t(u[0]);n.type="paragraph",n.text=h,n.tokens=this.lexer.inline(h)}return n}},A.def=function(l){var u=this.rules.block.def.exec(l);if(u){u[3]&&(u[3]=u[3].substring(1,u[3].length-1));var n=u[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:n,raw:u[0],href:u[2],title:u[3]}}},A.table=function(l){var u=this.rules.block.table.exec(l);if(u){var n={type:"table",header:H(u[1]).map(function(Z){return{text:Z}}),align:u[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:u[3]&&u[3].trim()?u[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(n.header.length===n.align.length){n.raw=u[0];var h=n.align.length,C,S,O,q;for(C=0;C<h;C++)/^ *-+: *$/.test(n.align[C])?n.align[C]="right":/^ *:-+: *$/.test(n.align[C])?n.align[C]="center":/^ *:-+ *$/.test(n.align[C])?n.align[C]="left":n.align[C]=null;for(h=n.rows.length,C=0;C<h;C++)n.rows[C]=H(n.rows[C],n.header.length).map(function(Z){return{text:Z}});for(h=n.header.length,S=0;S<h;S++)n.header[S].tokens=this.lexer.inline(n.header[S].text);for(h=n.rows.length,S=0;S<h;S++)for(q=n.rows[S],O=0;O<q.length;O++)q[O].tokens=this.lexer.inline(q[O].text);return n}}},A.lheading=function(l){var u=this.rules.block.lheading.exec(l);if(u)return{type:"heading",raw:u[0],depth:u[2].charAt(0)==="="?1:2,text:u[1],tokens:this.lexer.inline(u[1])}},A.paragraph=function(l){var u=this.rules.block.paragraph.exec(l);if(u){var n=u[1].charAt(u[1].length-1)===`
`?u[1].slice(0,-1):u[1];return{type:"paragraph",raw:u[0],text:n,tokens:this.lexer.inline(n)}}},A.text=function(l){var u=this.rules.block.text.exec(l);if(u)return{type:"text",raw:u[0],text:u[0],tokens:this.lexer.inline(u[0])}},A.escape=function(l){var u=this.rules.inline.escape.exec(l);if(u)return{type:"escape",raw:u[0],text:t(u[1])}},A.tag=function(l){var u=this.rules.inline.tag.exec(l);if(u)return!this.lexer.state.inLink&&/^<a /i.test(u[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(u[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(u[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(u[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:u[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(u[0]):t(u[0]):u[0]}},A.link=function(l){var u=this.rules.inline.link.exec(l);if(u){var n=u[2].trim();if(!this.options.pedantic&&/^</.test(n)){if(!/>$/.test(n))return;var h=V(n.slice(0,-1),"\\");if((n.length-h.length)%2===0)return}else{var C=T(u[2],"()");if(C>-1){var S=u[0].indexOf("!")===0?5:4,O=S+u[1].length+C;u[2]=u[2].substring(0,C),u[0]=u[0].substring(0,O).trim(),u[3]=""}}var q=u[2],Z="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);te&&(q=te[1],Z=te[3])}else Z=u[3]?u[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(n)?q=q.slice(1):q=q.slice(1,-1)),X(u,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},u[0],this.lexer)}},A.reflink=function(l,u){var n;if((n=this.rules.inline.reflink.exec(l))||(n=this.rules.inline.nolink.exec(l))){var h=(n[2]||n[1]).replace(/\s+/g," ");if(h=u[h.toLowerCase()],!h||!h.href){var C=n[0].charAt(0);return{type:"text",raw:C,text:C}}return X(n,h,n[0],this.lexer)}},A.emStrong=function(l,u,n){n===void 0&&(n="");var h=this.rules.inline.emStrong.lDelim.exec(l);if(h&&!(h[3]&&n.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=h[1]||h[2]||"";if(!C||C&&(n===""||this.rules.inline.punctuation.exec(n))){var S=h[0].length-1,O,q,Z=S,te=0,be=h[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,u=u.slice(-1*l.length+S);(h=be.exec(u))!=null;)if(O=h[1]||h[2]||h[3]||h[4]||h[5]||h[6],!!O){if(q=O.length,h[3]||h[4]){Z+=q;continue}else if((h[5]||h[6])&&S%3&&!((S+q)%3)){te+=q;continue}if(Z-=q,!(Z>0)){if(q=Math.min(q,q+Z+te),Math.min(S,q)%2){var we=l.slice(1,S+h.index+q);return{type:"em",raw:l.slice(0,S+h.index+q+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ke=l.slice(2,S+h.index+q-1);return{type:"strong",raw:l.slice(0,S+h.index+q+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},A.codespan=function(l){var u=this.rules.inline.code.exec(l);if(u){var n=u[2].replace(/\n/g," "),h=/[^ ]/.test(n),C=/^ /.test(n)&&/ $/.test(n);return h&&C&&(n=n.substring(1,n.length-1)),n=t(n,!0),{type:"codespan",raw:u[0],text:n}}},A.br=function(l){var u=this.rules.inline.br.exec(l);if(u)return{type:"br",raw:u[0]}},A.del=function(l){var u=this.rules.inline.del.exec(l);if(u)return{type:"del",raw:u[0],text:u[2],tokens:this.lexer.inlineTokens(u[2])}},A.autolink=function(l,u){var n=this.rules.inline.autolink.exec(l);if(n){var h,C;return n[2]==="@"?(h=t(this.options.mangle?u(n[1]):n[1]),C="mailto:"+h):(h=t(n[1]),C=h),{type:"link",raw:n[0],text:h,href:C,tokens:[{type:"text",raw:h,text:h}]}}},A.url=function(l,u){var n;if(n=this.rules.inline.url.exec(l)){var h,C;if(n[2]==="@")h=t(this.options.mangle?u(n[0]):n[0]),C="mailto:"+h;else{var S;do S=n[0],n[0]=this.rules.inline._backpedal.exec(n[0])[0];while(S!==n[0]);h=t(n[0]),n[1]==="www."?C="http://"+h:C=h}return{type:"link",raw:n[0],text:h,href:C,tokens:[{type:"text",raw:h,text:h}]}}},A.inlineText=function(l,u){var n=this.rules.inline.text.exec(l);if(n){var h;return this.lexer.state.inRawBlock?h=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(n[0]):t(n[0]):n[0]:h=t(this.options.smartypants?u(n[0]):n[0]),{type:"text",raw:n[0],text:h}}},f}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=p(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=p(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=p(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=p(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=p(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=p(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=v({},he),he.gfm=v({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=p(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=p(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=v({},he.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:p(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=p(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=p(he._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=p(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=p(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=p(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=p(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=p(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=p(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=p(ne.reflink).replace("label",ne._label).replace("ref",he._label).getRegex(),ne.nolink=p(ne.nolink).replace("ref",he._label).getRegex(),ne.reflinkSearch=p(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=v({},ne),ne.pedantic=v({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=v({},ne.normal,{escape:p(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=p(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=v({},ne.gfm,{br:p(ne.br).replace("{2,}","*").getRegex(),text:p(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(f){return f.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(f){var A="",F,l,u=f.length;for(F=0;F<u;F++)l=f.charCodeAt(F),Math.random()>.5&&(l="x"+l.toString(16)),A+="&#"+l+";";return A}var Re=function(){function f(F){this.tokens=[],this.tokens.links=Object.create(null),this.options=F||re.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:he.normal,inline:ne.normal};this.options.pedantic?(l.block=he.pedantic,l.inline=ne.pedantic):this.options.gfm&&(l.block=he.gfm,this.options.breaks?l.inline=ne.breaks:l.inline=ne.gfm),this.tokenizer.rules=l}f.lex=function(l,u){var n=new f(u);return n.lex(l)},f.lexInline=function(l,u){var n=new f(u);return n.inlineTokens(l)};var A=f.prototype;return A.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var u;u=this.inlineQueue.shift();)this.inlineTokens(u.src,u.tokens);return this.tokens},A.blockTokens=function(l,u){var n=this;u===void 0&&(u=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(Z,te,be){return te+"    ".repeat(be.length)});for(var h,C,S,O;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(h=Z.call({lexer:n},l,u))?(l=l.substring(h.raw.length),u.push(h),!0):!1}))){if(h=this.tokenizer.space(l)){l=l.substring(h.raw.length),h.raw.length===1&&u.length>0?u[u.length-1].raw+=`
`:u.push(h);continue}if(h=this.tokenizer.code(l)){l=l.substring(h.raw.length),C=u[u.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+h.raw,C.text+=`
`+h.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):u.push(h);continue}if(h=this.tokenizer.fences(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.heading(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.hr(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.blockquote(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.list(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.html(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.def(l)){l=l.substring(h.raw.length),C=u[u.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+h.raw,C.text+=`
`+h.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[h.tag]||(this.tokens.links[h.tag]={href:h.href,title:h.title});continue}if(h=this.tokenizer.table(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.lheading(l)){l=l.substring(h.raw.length),u.push(h);continue}if(S=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,te=l.slice(1),be=void 0;n.options.extensions.startBlock.forEach(function(we){be=we.call({lexer:this},te),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(S=l.substring(0,Z+1))}(),this.state.top&&(h=this.tokenizer.paragraph(S))){C=u[u.length-1],O&&C.type==="paragraph"?(C.raw+=`
`+h.raw,C.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):u.push(h),O=S.length!==l.length,l=l.substring(h.raw.length);continue}if(h=this.tokenizer.text(l)){l=l.substring(h.raw.length),C=u[u.length-1],C&&C.type==="text"?(C.raw+=`
`+h.raw,C.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):u.push(h);continue}if(l){var q="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,u},A.inline=function(l,u){return u===void 0&&(u=[]),this.inlineQueue.push({src:l,tokens:u}),u},A.inlineTokens=function(l,u){var n=this;u===void 0&&(u=[]);var h,C,S,O=l,q,Z,te;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)be.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,q.index)+"["+I("a",q[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,q.index)+"["+I("a",q[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,q.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(Z||(te=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(h=ke.call({lexer:n},l,u))?(l=l.substring(h.raw.length),u.push(h),!0):!1}))){if(h=this.tokenizer.escape(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.tag(l)){l=l.substring(h.raw.length),C=u[u.length-1],C&&h.type==="text"&&C.type==="text"?(C.raw+=h.raw,C.text+=h.text):u.push(h);continue}if(h=this.tokenizer.link(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(h.raw.length),C=u[u.length-1],C&&h.type==="text"&&C.type==="text"?(C.raw+=h.raw,C.text+=h.text):u.push(h);continue}if(h=this.tokenizer.emStrong(l,O,te)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.codespan(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.br(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.del(l)){l=l.substring(h.raw.length),u.push(h);continue}if(h=this.tokenizer.autolink(l,Ce)){l=l.substring(h.raw.length),u.push(h);continue}if(!this.state.inLink&&(h=this.tokenizer.url(l,Ce))){l=l.substring(h.raw.length),u.push(h);continue}if(S=l,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Pe=l.slice(1),Ee=void 0;n.options.extensions.startInline.forEach(function(Ae){Ee=Ae.call({lexer:this},Pe),typeof Ee=="number"&&Ee>=0&&(ke=Math.min(ke,Ee))}),ke<1/0&&ke>=0&&(S=l.substring(0,ke+1))}(),h=this.tokenizer.inlineText(S,ge)){l=l.substring(h.raw.length),h.raw.slice(-1)!=="_"&&(te=h.raw.slice(-1)),Z=!0,C=u[u.length-1],C&&C.type==="text"?(C.raw+=h.raw,C.text+=h.text):u.push(h);continue}if(l){var we="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return u},i(f,null,[{key:"rules",get:function(){return{block:he,inline:ne}}}]),f}(),Be=function(){function f(F){this.options=F||re.defaults}var A=f.prototype;return A.code=function(l,u,n){var h=(u||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(l,h);C!=null&&C!==l&&(n=!0,l=C)}return l=l.replace(/\n$/,"")+`
`,h?'<pre><code class="'+this.options.langPrefix+t(h,!0)+'">'+(n?l:t(l,!0))+`</code></pre>
`:"<pre><code>"+(n?l:t(l,!0))+`</code></pre>
`},A.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},A.html=function(l){return l},A.heading=function(l,u,n,h){if(this.options.headerIds){var C=this.options.headerPrefix+h.slug(n);return"<h"+u+' id="'+C+'">'+l+"</h"+u+`>
`}return"<h"+u+">"+l+"</h"+u+`>
`},A.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},A.list=function(l,u,n){var h=u?"ol":"ul",C=u&&n!==1?' start="'+n+'"':"";return"<"+h+C+`>
`+l+"</"+h+`>
`},A.listitem=function(l){return"<li>"+l+`</li>
`},A.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},A.paragraph=function(l){return"<p>"+l+`</p>
`},A.table=function(l,u){return u&&(u="<tbody>"+u+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+u+`</table>
`},A.tablerow=function(l){return`<tr>
`+l+`</tr>
`},A.tablecell=function(l,u){var n=u.header?"th":"td",h=u.align?"<"+n+' align="'+u.align+'">':"<"+n+">";return h+l+("</"+n+`>
`)},A.strong=function(l){return"<strong>"+l+"</strong>"},A.em=function(l){return"<em>"+l+"</em>"},A.codespan=function(l){return"<code>"+l+"</code>"},A.br=function(){return this.options.xhtml?"<br/>":"<br>"},A.del=function(l){return"<del>"+l+"</del>"},A.link=function(l,u,n){if(l=g(this.options.sanitize,this.options.baseUrl,l),l===null)return n;var h='<a href="'+t(l)+'"';return u&&(h+=' title="'+u+'"'),h+=">"+n+"</a>",h},A.image=function(l,u,n){if(l=g(this.options.sanitize,this.options.baseUrl,l),l===null)return n;var h='<img src="'+l+'" alt="'+n+'"';return u&&(h+=' title="'+u+'"'),h+=this.options.xhtml?"/>":">",h},A.text=function(l){return l},f}(),le=function(){function f(){}var A=f.prototype;return A.strong=function(l){return l},A.em=function(l){return l},A.codespan=function(l){return l},A.del=function(l){return l},A.html=function(l){return l},A.text=function(l){return l},A.link=function(l,u,n){return""+n},A.image=function(l,u,n){return""+n},A.br=function(){return""},f}(),_=function(){function f(){this.seen={}}var A=f.prototype;return A.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},A.getNextSafeSlug=function(l,u){var n=l,h=0;if(this.seen.hasOwnProperty(n)){h=this.seen[l];do h++,n=l+"-"+h;while(this.seen.hasOwnProperty(n))}return u||(this.seen[l]=h,this.seen[n]=0),n},A.slug=function(l,u){u===void 0&&(u={});var n=this.serialize(l);return this.getNextSafeSlug(n,u.dryrun)},f}(),ae=function(){function f(F){this.options=F||re.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}f.parse=function(l,u){var n=new f(u);return n.parse(l)},f.parseInline=function(l,u){var n=new f(u);return n.parseInline(l)};var A=f.prototype;return A.parse=function(l,u){u===void 0&&(u=!0);var n="",h,C,S,O,q,Z,te,be,we,ke,Pe,Ee,Ae,Ne,Ie,Ge,nt,Ye,Ue,Y=l.length;for(h=0;h<Y;h++){if(ke=l[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ue=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){n+=Ue||"";continue}switch(ke.type){case"space":continue;case"hr":{n+=this.renderer.hr();continue}case"heading":{n+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,a(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{n+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(be="",te="",O=ke.header.length,C=0;C<O;C++)te+=this.renderer.tablecell(this.parseInline(ke.header[C].tokens),{header:!0,align:ke.align[C]});for(be+=this.renderer.tablerow(te),we="",O=ke.rows.length,C=0;C<O;C++){for(Z=ke.rows[C],te="",q=Z.length,S=0;S<q;S++)te+=this.renderer.tablecell(this.parseInline(Z[S].tokens),{header:!1,align:ke.align[S]});we+=this.renderer.tablerow(te)}n+=this.renderer.table(be,we);continue}case"blockquote":{we=this.parse(ke.tokens),n+=this.renderer.blockquote(we);continue}case"list":{for(Pe=ke.ordered,Ee=ke.start,Ae=ke.loose,O=ke.items.length,we="",C=0;C<O;C++)Ie=ke.items[C],Ge=Ie.checked,nt=Ie.task,Ne="",Ie.task&&(Ye=this.renderer.checkbox(Ge),Ae?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=Ye+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=Ye+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:Ye}):Ne+=Ye),Ne+=this.parse(Ie.tokens,Ae),we+=this.renderer.listitem(Ne,nt,Ge);n+=this.renderer.list(we,Pe,Ee);continue}case"html":{n+=this.renderer.html(ke.text);continue}case"paragraph":{n+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(we=ke.tokens?this.parseInline(ke.tokens):ke.text;h+1<Y&&l[h+1].type==="text";)ke=l[++h],we+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);n+=u?this.renderer.paragraph(we):we;continue}default:{var se='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return n},A.parseInline=function(l,u){u=u||this.renderer;var n="",h,C,S,O=l.length;for(h=0;h<O;h++){if(C=l[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(S=this.options.extensions.renderers[C.type].call({parser:this},C),S!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){n+=S||"";continue}switch(C.type){case"escape":{n+=u.text(C.text);break}case"html":{n+=u.html(C.text);break}case"link":{n+=u.link(C.href,C.title,this.parseInline(C.tokens,u));break}case"image":{n+=u.image(C.href,C.title,C.text);break}case"strong":{n+=u.strong(this.parseInline(C.tokens,u));break}case"em":{n+=u.em(this.parseInline(C.tokens,u));break}case"codespan":{n+=u.codespan(C.text);break}case"br":{n+=u.br();break}case"del":{n+=u.del(this.parseInline(C.tokens,u));break}case"text":{n+=u.text(C.text);break}default:{var q='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return n},f}();function oe(f,A,F){if(typeof f>"u"||f===null)throw new Error("marked(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");if(typeof A=="function"&&(F=A,A=null),A=v({},oe.defaults,A||{}),L(A),F){var l=A.highlight,u;try{u=Re.lex(f,A)}catch(O){return F(O)}var n=function(q){var Z;if(!q)try{A.walkTokens&&oe.walkTokens(u,A.walkTokens),Z=ae.parse(u,A)}catch(te){q=te}return A.highlight=l,q?F(q):F(null,Z)};if(!l||l.length<3||(delete A.highlight,!u.length))return n();var h=0;oe.walkTokens(u,function(O){O.type==="code"&&(h++,setTimeout(function(){l(O.text,O.lang,function(q,Z){if(q)return n(q);Z!=null&&Z!==O.text&&(O.text=Z,O.escaped=!0),h--,h===0&&n()})},0))}),h===0&&n();return}function C(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,A.silent)return"<p>An error occurred:</p><pre>"+t(O.message+"",!0)+"</pre>";throw O}try{var S=Re.lex(f,A);if(A.walkTokens){if(A.async)return Promise.all(oe.walkTokens(S,A.walkTokens)).then(function(){return ae.parse(S,A)}).catch(C);oe.walkTokens(S,A.walkTokens)}return ae.parse(S,A)}catch(O){C(O)}}oe.options=oe.setOptions=function(f){return v(oe.defaults,f),y(oe.defaults),oe},oe.getDefaults=D,oe.defaults=re.defaults,oe.use=function(){for(var f=arguments.length,A=new Array(f),F=0;F<f;F++)A[F]=arguments[F];var l=v.apply(void 0,[{}].concat(A)),u=oe.defaults.extensions||{renderers:{},childTokens:{}},n;A.forEach(function(h){if(h.extensions&&(n=!0,h.extensions.forEach(function(S){if(!S.name)throw new Error("extension name required");if(S.renderer){var O=u.renderers?u.renderers[S.name]:null;O?u.renderers[S.name]=function(){for(var q=arguments.length,Z=new Array(q),te=0;te<q;te++)Z[te]=arguments[te];var be=S.renderer.apply(this,Z);return be===!1&&(be=O.apply(this,Z)),be}:u.renderers[S.name]=S.renderer}if(S.tokenizer){if(!S.level||S.level!=="block"&&S.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");u[S.level]?u[S.level].unshift(S.tokenizer):u[S.level]=[S.tokenizer],S.start&&(S.level==="block"?u.startBlock?u.startBlock.push(S.start):u.startBlock=[S.start]:S.level==="inline"&&(u.startInline?u.startInline.push(S.start):u.startInline=[S.start]))}S.childTokens&&(u.childTokens[S.name]=S.childTokens)})),h.renderer&&function(){var S=oe.defaults.renderer||new Be,O=function(te){var be=S[te];S[te]=function(){for(var we=arguments.length,ke=new Array(we),Pe=0;Pe<we;Pe++)ke[Pe]=arguments[Pe];var Ee=h.renderer[te].apply(S,ke);return Ee===!1&&(Ee=be.apply(S,ke)),Ee}};for(var q in h.renderer)O(q);l.renderer=S}(),h.tokenizer&&function(){var S=oe.defaults.tokenizer||new de,O=function(te){var be=S[te];S[te]=function(){for(var we=arguments.length,ke=new Array(we),Pe=0;Pe<we;Pe++)ke[Pe]=arguments[Pe];var Ee=h.tokenizer[te].apply(S,ke);return Ee===!1&&(Ee=be.apply(S,ke)),Ee}};for(var q in h.tokenizer)O(q);l.tokenizer=S}(),h.walkTokens){var C=oe.defaults.walkTokens;l.walkTokens=function(S){var O=[];return O.push(h.walkTokens.call(this,S)),C&&(O=O.concat(C.call(this,S))),O}}n&&(l.extensions=u),oe.setOptions(l)})},oe.walkTokens=function(f,A){for(var F=[],l=function(){var C=n.value;switch(F=F.concat(A.call(oe,C)),C.type){case"table":{for(var S=W(C.header),O;!(O=S()).done;){var q=O.value;F=F.concat(oe.walkTokens(q.tokens,A))}for(var Z=W(C.rows),te;!(te=Z()).done;)for(var be=te.value,we=W(be),ke;!(ke=we()).done;){var Pe=ke.value;F=F.concat(oe.walkTokens(Pe.tokens,A))}break}case"list":{F=F.concat(oe.walkTokens(C.items,A));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[C.type]?oe.defaults.extensions.childTokens[C.type].forEach(function(Ee){F=F.concat(oe.walkTokens(C[Ee],A))}):C.tokens&&(F=F.concat(oe.walkTokens(C.tokens,A)))}},u=W(f),n;!(n=u()).done;)l();return F},oe.parseInline=function(f,A){if(typeof f>"u"||f===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof f!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(f)+", string expected");A=v({},oe.defaults,A||{}),L(A);try{var F=Re.lexInline(f,A);return A.walkTokens&&oe.walkTokens(F,A.walkTokens),ae.parseInline(F,A)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,A.silent)return"<p>An error occurred:</p><pre>"+t(l.message+"",!0)+"</pre>";throw l}},oe.Parser=ae,oe.parser=ae.parse,oe.Renderer=Be,oe.TextRenderer=le,oe.Lexer=Re,oe.lexer=Re.lex,oe.Tokenizer=de,oe.Slugger=_,oe.parse=oe;var J=oe.options,G=oe.setOptions,ie=oe.use,fe=oe.walkTokens,De=oe.parseInline,Fe=oe,ye=ae.parse,K=Re.lex;re.Lexer=Re,re.Parser=ae,re.Renderer=Be,re.Slugger=_,re.TextRenderer=le,re.Tokenizer=de,re.getDefaults=D,re.lexer=K,re.marked=oe,re.options=J,re.parse=Fe,re.parseInline=De,re.parser=ye,re.setOptions=G,re.use=ie,re.walkTokens=fe,Object.defineProperty(re,"__esModule",{value:!0})}),define(me[83],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0;function i(s){const a=W(s);if(a&&a.length>0)return new Uint32Array(a)}e.$5j=i;let R=0;const j=new Uint32Array(10);function W(s){if(R=0,D(s,B,4352),R>0||(D(s,c,4449),R>0)||(D(s,d,4520),R>0)||(D(s,t,12593),R))return j.subarray(0,R);if(s>=44032&&s<=55203){const a=s-44032,m=a%588,p=Math.floor(a/588),w=Math.floor(m/28),o=m%28-1;if(p<B.length?D(p,B,0):4352+p-12593<t.length&&D(4352+p,t,12593),w<c.length?D(w,c,0):4449+w-12593<t.length&&D(4449+w-12593,t,12593),o>=0&&(o<d.length?D(o,d,0):4520+o-12593<t.length&&D(4520+o-12593,t,12593)),R>0)return j.subarray(0,R)}}function D(s,a,m){s>=m&&s<m+a.length&&y(a[s-m])}function y(s){s!==0&&(j[R++]=s&255,s>>8&&(j[R++]=s>>8&255),s>>16&&(j[R++]=s>>16&255))}var $;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var b;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(b||(b={}));var k;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(k||(k={}));const B=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),t=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[84],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=void 0;class i{constructor(j,W=0,D=j.length,y=W-1){this.a=j,this.b=W,this.c=D,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}e.$nU=i}),define(me[85],$e([1,0,84]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pU=e.$oU=void 0;class R{constructor(D=[],y=10){this.h(D),this.b=y,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new i.$nU(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const y of D)this.a.add(y)}get j(){const D=[];return this.a.forEach(y=>D.push(y)),D}}e.$oU=R;class j{get size(){return this.f}constructor(D,y=10){if(this.g=y,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let $=1;$<D.length;$++)this.add(D[$])}add(D){const y={value:D,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const y=this.c.value;return this.a.delete(y),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),y}prepend(D){if(this.f===this.g||this.a.has(D))return;const y={value:D,previous:void 0,next:this.b};this.b.previous=y,this.b=y,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let y=this.b;for(;y!==this.c;)y.value===D&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}e.$pU=j}),define(me[35],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function i(y,$,b){return Math.min(Math.max(y,$),b)}e.$fm=i;function R(y,$){return($+y%$)%$}e.rot=R;class j{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=j;class W{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=W;class D{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const b=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=D}),define(me[50],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var i;(function(R){function j($,b){if($.start>=b.end||b.start>=$.end)return{start:0,end:0};const k=Math.max($.start,b.start),B=Math.min($.end,b.end);return B-k<=0?{start:0,end:0}:{start:k,end:B}}R.intersect=j;function W($){return $.end-$.start<=0}R.isEmpty=W;function D($,b){return!W(j($,b))}R.intersects=D;function y($,b){const k=[],B={start:$.start,end:Math.min(b.start,$.end)},c={start:Math.max(b.end,$.start),end:$.end};return W(B)||k.push(B),W(c)||k.push(c),k}R.relativeComplement=y})(i||(e.Range=i={}))}),define(me[86],$e([1,0,50]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9S=e.$8S=e.$7S=e.$6S=void 0;function R($,b){const k=[];for(const B of b){if($.start>=B.range.end)continue;if($.end<B.range.start)break;const c=i.Range.intersect($,B.range);i.Range.isEmpty(c)||k.push({range:c,size:B.size})}return k}e.$6S=R;function j({start:$,end:b},k){return{start:$+k,end:b+k}}e.$7S=j;function W($){const b=[];let k=null;for(const B of $){const c=B.range.start,d=B.range.end,t=B.size;if(k&&t===k.size){k.range.end=d;continue}k={range:{start:c,end:d},size:t},b.push(k)}return b}e.$8S=W;function D(...$){return W($.reduce((b,k)=>b.concat(k),[]))}class y{get paddingTop(){return this.c}set paddingTop(b){this.b=this.b+b-this.c,this.c=b}constructor(b){this.a=[],this.b=0,this.c=0,this.c=b??0,this.b=this.c}splice(b,k,B=[]){const c=B.length-k,d=R({start:0,end:b},this.a),t=R({start:b+k,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:j(a.range,c),size:a.size})),s=B.map((a,m)=>({range:{start:b+m,end:b+m+1},size:a.size}));this.a=D(d,s,t),this.b=this.c+this.a.reduce((a,m)=>a+m.size*(m.range.end-m.range.start),0)}get count(){const b=this.a.length;return b?this.a[b-1].range.end:0}get size(){return this.b}indexAt(b){if(b<0)return-1;if(b<this.c)return 0;let k=0,B=this.c;for(const c of this.a){const d=c.range.end-c.range.start,t=B+d*c.size;if(b<t)return k+Math.floor((b-B)/c.size);k+=d,B=t}return k}indexAfter(b){return Math.min(this.indexAt(b)+1,this.count)}positionAt(b){if(b<0)return-1;let k=0,B=0;for(const c of this.a){const d=c.range.end-c.range.start,t=B+d;if(b<t)return this.c+k+(b-B)*c.size;k+=d*c.size,B=t}return-1}}e.$9S=y}),define(me[87],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(W){return new R(W)}constructor(W){this.c=i&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=R}),define(me[4],$e([1,0,6,47,3,49,87]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.Event=void 0;const y=!1,$=!1;var b;(function(V){V.None=()=>j.$Tc.None;function T(l){if($){const{onDidAddListener:u}=l,n=t.create();let h=0;l.onDidAddListener=()=>{++h===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),n.print()),u?.()}}}function L(l,u){return Be(l,()=>{},0,void 0,!0,void 0,u)}V.defer=L;function I(l){return(u,n=null,h)=>{let C=!1,S;return S=l(O=>{if(!C)return S?S.dispose():C=!0,u.call(n,O)},null,h),C&&S.dispose(),S}}V.once=I;function X(l,u,n){return Ce((h,C=null,S)=>l(O=>h.call(C,u(O)),null,S),n)}V.map=X;function U(l,u,n){return Ce((h,C=null,S)=>l(O=>{u(O),h.call(C,O)},null,S),n)}V.forEach=U;function de(l,u,n){return Ce((h,C=null,S)=>l(O=>u(O)&&h.call(C,O),null,S),n)}V.filter=de;function he(l){return l}V.signal=he;function ne(...l){return(u,n=null,h)=>{const C=(0,j.$Qc)(...l.map(S=>S(O=>u.call(n,O))));return Re(C,h)}}V.any=ne;function ge(l,u,n,h){let C=n;return X(l,S=>(C=u(C,S),C),h)}V.reduce=ge;function Ce(l,u){let n;const h={onWillAddFirstListener(){n=l(C.fire,C)},onDidRemoveLastListener(){n?.dispose()}};u||T(h);const C=new w(h);return u?.add(C),C.event}function Re(l,u){return u instanceof Array?u.push(l):u&&u.add(l),l}function Be(l,u,n=100,h=!1,C=!1,S,O){let q,Z,te,be=0,we;const ke={leakWarningThreshold:S,onWillAddFirstListener(){q=l(Ee=>{be++,Z=u(Z,Ee),h&&!te&&(Pe.fire(Z),Z=void 0),we=()=>{const Ae=Z;Z=void 0,te=void 0,(!h||be>1)&&Pe.fire(Ae),be=0},typeof n=="number"?(clearTimeout(te),te=setTimeout(we,n)):te===void 0&&(te=0,queueMicrotask(we))})},onWillRemoveListener(){C&&be>0&&we?.()},onDidRemoveLastListener(){we=void 0,q.dispose()}};O||T(ke);const Pe=new w(ke);return O?.add(Pe),Pe.event}V.debounce=Be;function le(l,u=0,n){return V.debounce(l,(h,C)=>h?(h.push(C),h):[C],u,void 0,!0,void 0,n)}V.accumulate=le;function _(l,u=(h,C)=>h===C,n){let h=!0,C;return de(l,S=>{const O=h||!u(S,C);return h=!1,C=S,O},n)}V.latch=_;function ae(l,u,n){return[V.filter(l,u,n),V.filter(l,h=>!u(h),n)]}V.split=ae;function oe(l,u=!1,n=[],h){let C=n.slice(),S=l(Z=>{C?C.push(Z):q.fire(Z)});h&&h.add(S);const O=()=>{C?.forEach(Z=>q.fire(Z)),C=null},q=new w({onWillAddFirstListener(){S||(S=l(Z=>q.fire(Z)),h&&h.add(S))},onDidAddFirstListener(){C&&(u?setTimeout(O):O())},onDidRemoveLastListener(){S&&S.dispose(),S=null}});return h&&h.add(q),q.event}V.buffer=oe;function J(l,u){return(h,C,S)=>{const O=u(new ie);return l(function(q){const Z=O.evaluate(q);Z!==G&&h.call(C,Z)},void 0,S)}}V.chain=J;const G=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(u){return this.f.push(u),this}forEach(u){return this.f.push(n=>(u(n),n)),this}filter(u){return this.f.push(n=>u(n)?n:G),this}reduce(u,n){let h=n;return this.f.push(C=>(h=u(h,C),h)),this}latch(u=(n,h)=>n===h){let n=!0,h;return this.f.push(C=>{const S=n||!u(C,h);return n=!1,h=C,S?C:G}),this}evaluate(u){for(const n of this.f)if(u=n(u),u===G)break;return u}}function fe(l,u,n=h=>h){const h=(...q)=>O.fire(n(...q)),C=()=>l.on(u,h),S=()=>l.removeListener(u,h),O=new w({onWillAddFirstListener:C,onDidRemoveLastListener:S});return O.event}V.fromNodeEventEmitter=fe;function De(l,u,n=h=>h){const h=(...q)=>O.fire(n(...q)),C=()=>l.addEventListener(u,h),S=()=>l.removeEventListener(u,h),O=new w({onWillAddFirstListener:C,onDidRemoveLastListener:S});return O.event}V.fromDOMEventEmitter=De;function Fe(l){return new Promise(u=>I(l)(u))}V.toPromise=Fe;function ye(l){const u=new w;return l.then(n=>{u.fire(n)},()=>{u.fire(void 0)}).finally(()=>{u.dispose()}),u.event}V.fromPromise=ye;function K(l,u,n){return u(n),l(h=>u(h))}V.runAndSubscribe=K;class f{constructor(u,n){this._observable=u,this.f=0,this.g=!1;const h={onWillAddFirstListener:()=>{u.addObserver(this)},onDidRemoveLastListener:()=>{u.removeObserver(this)}};n||T(h),this.emitter=new w(h),n&&n.add(this.emitter)}beginUpdate(u){this.f++}handlePossibleChange(u){}handleChange(u,n){this.g=!0}endUpdate(u){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function A(l,u){return new f(l,u).emitter.event}V.fromObservable=A;function F(l){return(u,n,h)=>{let C=0,S=!1;const O={beginUpdate(){C++},endUpdate(){C--,C===0&&(l.reportChanges(),S&&(S=!1,u.call(n)))},handlePossibleChange(){},handleChange(){S=!0}};l.addObserver(O),l.reportChanges();const q={dispose(){l.removeObserver(O)}};return h instanceof j.$Sc?h.add(q):Array.isArray(h)&&h.push(q),q}}V.fromObservableLight=F})(b||(e.Event=b={}));class k{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${k.f++}`,k.all.add(this)}start(T){this.g=new D.$2d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$4d=k;let B=-1;function c(V){const T=B;return B=V,{dispose(){B=T}}}e.$5d=c;class d{constructor(T,L=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=L,this.g=0}dispose(){this.f?.clear()}check(T,L){const I=this.threshold;if(I<=0||L<I)return;this.f||(this.f=new Map);const X=this.f.get(T.value)||0;if(this.f.set(T.value,X+1),this.g-=1,this.g<=0){this.g=I*.5;let U,de=0;for(const[he,ne]of this.f)(!U||de<ne)&&(U=he,de=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${de}):`),console.warn(U)}return()=>{const U=this.f.get(T.value)||0;this.f.set(T.value,U-1)}}}class t{static create(){return new t(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class a{constructor(T){this.value=T,this.id=s++}}const m=2,p=(V,T)=>{if(V instanceof a)T(V);else for(let L=0;L<V.length;L++){const I=V[L];I&&T(I)}};class w{constructor(T){this.w=0,this.f=T,this.g=B>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??B):void 0,this.j=this.f?._profName?new k(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(y){const T=this.t;queueMicrotask(()=>{p(T,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,L,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Tc.None;if(this.m)return j.$Tc.None;L&&(T=T.bind(L));const X=new a(T);let U,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=t.create(),U=this.g.check(X.stack,this.w+1)),y&&(X.stack=de??t.create()),this.t?this.t instanceof a?(this.u??=new g,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,j.$Rc)(()=>{U?.(),this.x(X)});return I instanceof j.$Sc?I.add(he):Array.isArray(I)&&I.push(he),he},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,I=L.indexOf(T);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[I]=void 0;const X=this.u.current===this;if(this.w*m<=L.length){let U=0;for(let de=0;de<L.length;de++)L[de]?L[U++]=L[de]:X&&(this.u.end--,U<this.u.i&&this.u.i--);L.length=U}}y(T,L){if(!T)return;const I=this.f?.onListenerError||i.$1;if(!I){T.value(L);return}try{T.value(L)}catch(X){I(X)}}z(T){const L=T.current.t;for(;T.i<T.end;)this.y(L[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,T);else{const L=this.u;L.enqueue(this,T,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=w;const o=()=>new g;e.$7d=o;class g{constructor(){this.i=-1,this.end=0}enqueue(T,L,I){this.i=0,this.end=I,this.current=T,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends w{async fireAsync(T,L,I){if(this.t)for(this.h||(this.h=new W.$4c),p(this.t,X=>this.h.push([X.value,T]));this.h.size>0&&!L.isCancellationRequested;){const[X,U]=this.h.shift(),de=[],he={...U,token:L,waitUntil:ne=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");I&&(ne=I(ne,X)),de.push(ne)}};try{X(he)}catch(ne){(0,i.$1)(ne);continue}Object.freeze(de),await Promise.allSettled(de).then(ne=>{for(const ge of ne)ge.status==="rejected"&&(0,i.$1)(ge.reason)})}}}e.$8d=r;class E extends w{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new W.$4c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$9d=E;class N extends E{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$0d=N;class M extends w{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$$d=M;class P{constructor(){this.g=!1,this.h=[],this.f=new w({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const L={event:T,listener:null};this.h.push(L),this.g&&this.m(L);const I=()=>{this.g&&this.o(L);const X=this.h.indexOf(L);this.h.splice(X,1)};return(0,j.$Rc)((0,R.$db)(I))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(L=>this.f.fire(L))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$_d=P;class z{constructor(T,L,I,X){this.f=new j.$Sc;const U=this.f.add(new P),de=this.f.add(new j.$3c);function he(ne){de.set(ne,U.add(X(ne)))}for(const ne of T)he(ne);this.f.add(L(ne=>{he(ne)})),this.f.add(I(ne=>{de.deleteAndDispose(ne)})),this.event=U.event}dispose(){this.f.dispose()}}e.$ae=z;class v{constructor(){this.f=[]}wrapEvent(T){return(L,I,X)=>T(U=>{const de=this.f[this.f.length-1];de?de.push(()=>L.call(I,U)):L.call(I,U)},void 0,X)}bufferEvents(T){const L=[];this.f.push(L);const I=T();return this.f.pop(),L.forEach(X=>X()),I}}e.$be=v;class H{constructor(){this.f=!1,this.g=b.None,this.h=j.$Tc.None,this.j=new w({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=H}),define(me[17],$e([1,0,22,4]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.$sQ=void 0;class j{constructor(){this.a=new Map,this.b=new R.$6d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new R.$6d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new j}getZoomLevel(m){return this.a.get(this.f(m))??0}setZoomLevel(m,p){if(this.getZoomLevel(p)===m)return;const w=this.f(p);this.a.set(w,m),this.b.fire(w)}getZoomFactor(m){return this.c.get(this.f(m))??1}setZoomFactor(m,p){this.c.set(this.f(p),m)}setFullscreen(m,p){if(this.isFullscreen(p)===m)return;const w=this.f(p);this.e.set(w,m),this.d.fire(w)}isFullscreen(m){return!!this.e.get(this.f(m))}f(m){return m.vscodeWindowId}}function W(a,m,p){typeof m=="string"&&(m=a.matchMedia(m)),m.addEventListener("change",p)}e.$sQ=W;function D(a,m){j.INSTANCE.setZoomLevel(a,m)}e.$tQ=D;function y(a){return j.INSTANCE.getZoomLevel(a)}e.$uQ=y,e.$vQ=j.INSTANCE.onDidChangeZoomLevel;function $(a){return j.INSTANCE.getZoomFactor(a)}e.$wQ=$;function b(a,m){j.INSTANCE.setZoomFactor(a,m)}e.$xQ=b;function k(a,m){j.INSTANCE.setFullscreen(a,m)}e.$yQ=k;function B(a){return j.INSTANCE.isFullscreen(a)}e.$zQ=B,e.$AQ=j.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;e.$BQ=c.indexOf("Firefox")>=0,e.$CQ=c.indexOf("AppleWebKit")>=0,e.$DQ=c.indexOf("Chrome")>=0,e.$EQ=!e.$DQ&&c.indexOf("Safari")>=0,e.$FQ=!e.$DQ&&!e.$EQ&&e.$CQ,e.$GQ=c.indexOf("Electron/")>=0,e.$HQ=c.indexOf("Android")>=0;let d=!1;if(typeof i.$oQ.matchMedia=="function"){const a=i.$oQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=i.$oQ.matchMedia("(display-mode: fullscreen)");d=a.matches,W(i.$oQ,a,({matches:p})=>{d&&m.matches||(d=p)})}function t(){return d}e.$IQ=t;function s(){return navigator?.windowControlsOverlay?.visible}e.$JQ=s}),define(me[24],$e([1,0,4]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=void 0;class R{get event(){return this.a.event}constructor(W,D,y){const $=b=>this.a.fire(b);this.a=new i.$6d({onWillAddFirstListener:()=>W.addEventListener(D,$,y),onDidRemoveLastListener:()=>W.removeEventListener(D,$,y)})}dispose(){this.a.dispose()}}e.$1S=R}),define(me[30],$e([1,0,4]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const R=Object.freeze(function(y,$){const b=setTimeout(y.bind($),0);return{dispose(){clearTimeout(b)}}});var j;(function(y){function $(b){return b===y.None||b===y.Cancelled||b instanceof W?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}y.isCancellationToken=$,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(j||(e.CancellationToken=j={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new i.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=j.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=j.None}}e.$de=D}),define(me[88],$e([1,0,30]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class R{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$de,$=this.b(y.token);return this.a={promise:$,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$Oe=R;class j{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const $=JSON.stringify(y);return this.b!==$&&(this.b=$,this.a=this.c(y)),this.a}}e.$Pe=j;class W{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const $=this.b(y);return this.a.set(y,$),$}}e.$Qe=W}),define(me[51],$e([1,0,4,3]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.$zs=e.ScrollbarVisibility=void 0;var j;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(j||(e.ScrollbarVisibility=j={}));class W{constructor(t,s,a,m,p,w,o){this.c=t,this._scrollStateBrand=void 0,this.c&&(s=s|0,a=a|0,m=m|0,p=p|0,w=w|0,o=o|0),this.rawScrollLeft=m,this.rawScrollTop=o,s<0&&(s=0),m+s>a&&(m=a-s),m<0&&(m=0),p<0&&(p=0),o+p>w&&(o=w-p),o<0&&(o=0),this.width=s,this.scrollWidth=a,this.scrollLeft=m,this.height=p,this.scrollHeight=w,this.scrollTop=o}equals(t){return this.rawScrollLeft===t.rawScrollLeft&&this.rawScrollTop===t.rawScrollTop&&this.width===t.width&&this.scrollWidth===t.scrollWidth&&this.scrollLeft===t.scrollLeft&&this.height===t.height&&this.scrollHeight===t.scrollHeight&&this.scrollTop===t.scrollTop}withScrollDimensions(t,s){return new W(this.c,typeof t.width<"u"?t.width:this.width,typeof t.scrollWidth<"u"?t.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof t.height<"u"?t.height:this.height,typeof t.scrollHeight<"u"?t.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(t){return new W(this.c,this.width,this.scrollWidth,typeof t.scrollLeft<"u"?t.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof t.scrollTop<"u"?t.scrollTop:this.rawScrollTop)}createScrollEvent(t,s){const a=this.width!==t.width,m=this.scrollWidth!==t.scrollWidth,p=this.scrollLeft!==t.scrollLeft,w=this.height!==t.height,o=this.scrollHeight!==t.scrollHeight,g=this.scrollTop!==t.scrollTop;return{inSmoothScrolling:s,oldWidth:t.width,oldScrollWidth:t.scrollWidth,oldScrollLeft:t.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:t.height,oldScrollHeight:t.scrollHeight,oldScrollTop:t.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:m,scrollLeftChanged:p,heightChanged:w,scrollHeightChanged:o,scrollTopChanged:g}}}e.$zs=W;class D extends R.$Tc{constructor(t){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$6d),this.onScroll=this.j.event,this.c=t.smoothScrollDuration,this.f=t.scheduleAtNextAnimationFrame,this.g=new W(t.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(t){this.c=t}validateScrollPosition(t){return this.g.withScrollPosition(t)}getScrollDimensions(){return this.g}setScrollDimensions(t,s){const a=this.g.withScrollDimensions(t,s);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(t){const s=this.g.withScrollPosition(t);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(t,s){if(this.c===0)return this.setScrollPositionNow(t);if(this.h){t={scrollLeft:typeof t.scrollLeft>"u"?this.h.to.scrollLeft:t.scrollLeft,scrollTop:typeof t.scrollTop>"u"?this.h.to.scrollTop:t.scrollTop};const a=this.g.withScrollPosition(t);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let m;s?m=new k(this.h.from,a,this.h.startTime,this.h.duration):m=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=m}else{const a=this.g.withScrollPosition(t);this.h=k.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const t=this.h.tick(),s=this.g.withScrollPosition(t);if(this.n(s,!0),!!this.h){if(t.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(t,s){const a=this.g;a.equals(t)||(this.g=t,this.j.fire(this.g.createScrollEvent(a,s)))}}e.$As=D;class y{constructor(t,s,a){this.scrollLeft=t,this.scrollTop=s,this.isDone=a}}e.$Bs=y;function $(d,t){const s=t-d;return function(a){return d+s*c(a)}}function b(d,t,s){return function(a){return a<s?d(a/s):t((a-s)/(1-s))}}class k{constructor(t,s,a,m){this.from=t,this.to=s,this.duration=m,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(t,s,a){if(Math.abs(t-s)>2.5*a){let p,w;return t<s?(p=t+.75*a,w=s-.75*a):(p=t-.75*a,w=s+.75*a),b($(t,p),$(w,s),.33)}return $(t,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(t){this.to=t.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(t){const s=(t-this.startTime)/this.duration;if(s<1){const a=this.c(s),m=this.d(s);return new y(a,m,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(t,s,a){return k.start(t,s,a)}static start(t,s,a){a=a+10;const m=Date.now()-10;return new k(t,s,m,a)}}e.$Cs=k;function B(d){return Math.pow(d,3)}function c(d){return 1-B(1-d)}}),define(me[89],$e([1,0,6,3]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function j(o){const g=o;return g?typeof g.read=="function":!1}e.$ee=j;function W(o){const g=o;return g?[g.on,g.pause,g.resume,g.destroy].every(r=>typeof r=="function"):!1}e.$fe=W;function D(o){const g=o;return g?W(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$ge=D;function y(o,g){return new $(o,g)}e.$he=y;class ${constructor(g,r){this.e=g,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(r=>r(g))}h(g){this.c.error.length===0?(0,i.$1)(g):this.c.error.slice(0).forEach(r=>r(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,r){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(g,r){if(this.a.destroyed)return;let E;switch(g){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const N=E.indexOf(r);N>=0&&E.splice(N,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(o,g){const r=[];let E;for(;(E=o.read())!==null;)r.push(E);return g(r)}e.$ie=b;function k(o,g,r){const E=[];let N;for(;(N=o.read())!==null&&E.length<r;)E.push(N);return N===null&&E.length>0?g(E):{read:()=>{if(E.length>0)return E.shift();if(typeof N<"u"){const M=N;return N=void 0,M}return o.read()}}}e.$je=k;function B(o,g){return new Promise((r,E)=>{const N=[];c(o,{onData:M=>{g&&N.push(M)},onError:M=>{g?E(M):r(void 0)},onEnd:()=>{r(g?g(N):void 0)}})})}e.$ke=B;function c(o,g,r){o.on("error",E=>{r?.isCancellationRequested||g.onError(E)}),o.on("end",()=>{r?.isCancellationRequested||g.onEnd()}),o.on("data",E=>{r?.isCancellationRequested||g.onData(E)})}e.$le=c;function d(o,g){return new Promise((r,E)=>{const N=new R.$Sc,M=[],P=H=>{if(M.push(H),M.length>g)return N.dispose(),o.pause(),r({stream:o,buffer:M,ended:!1})},z=H=>(N.dispose(),E(H)),v=()=>(N.dispose(),r({stream:o,buffer:M,ended:!0}));N.add((0,R.$Rc)(()=>o.removeListener("error",z))),o.on("error",z),N.add((0,R.$Rc)(()=>o.removeListener("end",v))),o.on("end",v),N.add((0,R.$Rc)(()=>o.removeListener("data",P))),o.on("data",P)})}e.$me=d;function t(o,g){const r=y(g);return r.end(o),r}e.$ne=t;function s(){const o=y(()=>{throw new Error("not supported")});return o.end(),o}e.$oe=s;function a(o){let g=!1;return{read:()=>g?null:(g=!0,o)}}e.$pe=a;function m(o,g,r){const E=y(r);return c(o,{onData:N=>E.write(g.data(N)),onError:N=>E.error(g.error?g.error(N):N),onEnd:()=>E.end()}),E}e.$qe=m;function p(o,g,r){let E=!1;return{read:()=>{const N=g.read();return E?N:(E=!0,N!==null?r([o,N]):o)}}}e.$re=p;function w(o,g,r){let E=!1;const N=y(r);return c(g,{onData:M=>E?N.write(M):(E=!0,N.write(r([o,M]))),onError:M=>N.error(M),onEnd:()=>{E||(E=!0,N.write(o)),N.end()}}),N}e.$se=w}),define(me[36],$e([1,0,23,89]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const j=typeof Buffer<"u",W=new i.$V(()=>new Uint8Array(256));let D,y;class ${static alloc(L){return j?new $(Buffer.allocUnsafe(L)):new $(new Uint8Array(L))}static wrap(L){return j&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new $(L)}static fromString(L,I){return!(I?.dontUseNodeBuffer||!1)&&j?new $(Buffer.from(L)):(D||(D=new TextEncoder),new $(D.encode(L)))}static fromByteArray(L){const I=$.alloc(L.length);for(let X=0,U=L.length;X<U;X++)I.buffer[X]=L[X];return I}static concat(L,I){if(typeof I>"u"){I=0;for(let de=0,he=L.length;de<he;de++)I+=L[de].byteLength}const X=$.alloc(I);let U=0;for(let de=0,he=L.length;de<he;de++){const ne=L[de];X.set(ne,U),U+=ne.byteLength}return X}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=$.alloc(this.byteLength);return L.set(this),L}toString(){return j?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(L,I){return new $(this.buffer.subarray(L,I))}set(L,I){if(L instanceof $)this.buffer.set(L.buffer,I);else if(L instanceof Uint8Array)this.buffer.set(L,I);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),I);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return c(this.buffer,L)}writeUInt32BE(L,I){d(this.buffer,L,I)}readUInt32LE(L){return t(this.buffer,L)}writeUInt32LE(L,I){s(this.buffer,L,I)}readUInt8(L){return a(this.buffer,L)}writeUInt8(L,I){m(this.buffer,L,I)}indexOf(L,I=0){return b(this.buffer,L instanceof $?L.buffer:L,I)}}e.$te=$;function b(T,L,I=0){const X=L.byteLength,U=T.byteLength;if(X===0)return 0;if(X===1)return T.indexOf(L[0]);if(X>U-I)return-1;const de=W.value;de.fill(L.length);for(let Ce=0;Ce<L.length;Ce++)de[L[Ce]]=L.length-Ce-1;let he=I+L.length-1,ne=he,ge=-1;for(;he<U;)if(T[he]===L[ne]){if(ne===0){ge=he;break}he--,ne--}else he+=Math.max(L.length-ne,de[T[he]]),ne=L.length-1;return ge}e.$ue=b;function k(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}e.$ve=k;function B(T,L,I){T[I+0]=L&255,L=L>>>8,T[I+1]=L&255}e.$we=B;function c(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}e.$xe=c;function d(T,L,I){T[I+3]=L,L=L>>>8,T[I+2]=L,L=L>>>8,T[I+1]=L,L=L>>>8,T[I]=L}e.$ye=d;function t(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}e.$ze=t;function s(T,L,I){T[I+0]=L&255,L=L>>>8,T[I+1]=L&255,L=L>>>8,T[I+2]=L&255,L=L>>>8,T[I+3]=L&255}e.$Ae=s;function a(T,L){return T[L]}e.$Be=a;function m(T,L,I){T[I]=L}e.$Ce=m;function p(T){return R.$ie(T,L=>$.concat(L))}e.$De=p;function w(T){return R.$pe(T)}e.$Ee=w;function o(T){return R.$ke(T,L=>$.concat(L))}e.$Fe=o;async function g(T){return T.ended?$.concat(T.buffer):$.concat([...T.buffer,await o(T.stream)])}e.$Ge=g;function r(T){return R.$ne(T,L=>$.concat(L))}e.$He=r;function E(T){return R.$qe(T,{data:L=>typeof L=="string"?$.fromString(L):$.wrap(L)},L=>$.concat(L))}e.$Ie=E;function N(T){return R.$he(L=>$.concat(L),T)}e.$Je=N;function M(T,L){return R.$re(T,L,I=>$.concat(I))}e.$Ke=M;function P(T,L){return R.$se(T,L,I=>$.concat(I))}e.$Le=P;function z(T){let L=0,I=0,X=0;const U=new Uint8Array(Math.floor(T.length/4*3)),de=ne=>{switch(I){case 3:U[X++]=L|ne,I=0;break;case 2:U[X++]=L|ne>>>2,L=ne<<6,I=3;break;case 1:U[X++]=L|ne>>>4,L=ne<<4,I=2;break;default:L=ne<<2,I=1}};for(let ne=0;ne<T.length;ne++){const ge=T.charCodeAt(ne);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ne]}`)}}const he=X;for(;I>0;)de(0);return $.wrap(U).slice(0,he)}e.$Me=z;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:T},L=!0,I=!1){const X=I?H:v;let U="";const de=T.byteLength%3;let he=0;for(;he<T.byteLength-de;he+=3){const ne=T[he+0],ge=T[he+1],Ce=T[he+2];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[(ge<<2|Ce>>>6)&63],U+=X[Ce&63]}if(de===1){const ne=T[he+0];U+=X[ne>>>2],U+=X[ne<<4&63],L&&(U+="==")}else if(de===2){const ne=T[he+0],ge=T[he+1];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[ge<<2&63],L&&(U+="=")}return U}e.$Ne=V}),define(me[10],$e([1,0,88,23]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.GraphemeBreakType=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=void 0;function j(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.$Te=j;const W=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(W,function(pe,ve){const Le=parseInt(ve,10);return isNaN(Le)||Le<0||Le>=se.length?pe:se[Le]})}e.$Ue=D;const y=/{([^}]+)}/g;function $(Y,se){return Object.keys(se).length===0?Y:Y.replace(y,(pe,ve)=>se[ve]??pe)}e.$Ve=$;function b(Y){return Y.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}e.$We=b;function k(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.$Xe=k;function B(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ye=B;function c(Y,se){let pe=0;const ve=se.charCodeAt(0);for(let Le=Y.length-1;Le>=0;Le--)Y.charCodeAt(Le)===ve&&pe++;return pe}e.$Ze=c;function d(Y,se,pe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${pe}`}e.$1e=d;function t(Y,se,pe="\u2026"){if(Y.length<=se)return Y;const ve=Math.ceil(se/2)-pe.length/2,Le=Math.floor(se/2)-pe.length/2;return`${Y.substr(0,ve)}${pe}${Y.substr(Y.length-Le)}`}e.$2e=t;function s(Y,se=" "){const pe=a(Y,se);return m(pe,se)}e.$3e=s;function a(Y,se){if(!Y||!se)return Y;const pe=se.length;if(pe===0||Y.length===0)return Y;let ve=0;for(;Y.indexOf(se,ve)===ve;)ve=ve+pe;return Y.substring(ve)}e.$4e=a;function m(Y,se){if(!Y||!se)return Y;const pe=se.length,ve=Y.length;if(pe===0||ve===0)return Y;let Le=ve,je=-1;for(;je=Y.lastIndexOf(se,Le-1),!(je===-1||je+pe!==Le);){if(je===0)return"";Le=je}return Y.substring(0,Le)}e.$5e=m;function p(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$6e=p;function w(Y){return Y.replace(/\*/g,"")}e.$7e=w;function o(Y,se,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=B(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(Y,ve)}e.$8e=o;function g(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.$9e=g;function r(Y){return Y.split(/\r\n|\r|\n/)}e.$0e=r;function E(Y){const se=[],pe=Y.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)se.push(pe[2*ve]+(pe[2*ve+1]??""));return se}e.$$e=E;function N(Y){for(let se=0,pe=Y.length;se<pe;se++){const ve=Y.charCodeAt(se);if(ve!==32&&ve!==9)return se}return-1}e.$_e=N;function M(Y,se=0,pe=Y.length){for(let ve=se;ve<pe;ve++){const Le=Y.charCodeAt(ve);if(Le!==32&&Le!==9)return Y.substring(se,ve)}return Y.substring(se,pe)}e.$af=M;function P(Y,se=Y.length-1){for(let pe=se;pe>=0;pe--){const ve=Y.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}e.$bf=P;function z(Y,se,pe){const ve=[];let Le=0;for(const je of Y.matchAll(se)){if(ve.push(Y.slice(Le,je.index)),je.index===void 0)throw new Error("match.index should be defined");Le=je.index+je[0].length,ve.push(pe(je[0],...je.slice(1),je.index,Y,je.groups))}return ve.push(Y.slice(Le)),Promise.all(ve).then(je=>je.join(""))}e.$cf=z;function v(Y,se){return Y<se?-1:Y>se?1:0}e.$df=v;function H(Y,se,pe=0,ve=Y.length,Le=0,je=se.length){for(;pe<ve&&Le<je;pe++,Le++){const tt=Y.charCodeAt(pe),st=se.charCodeAt(Le);if(tt<st)return-1;if(tt>st)return 1}const qe=ve-pe,_e=je-Le;return qe<_e?-1:qe>_e?1:0}e.$ef=H;function V(Y,se){return T(Y,se,0,Y.length,0,se.length)}e.$ff=V;function T(Y,se,pe=0,ve=Y.length,Le=0,je=se.length){for(;pe<ve&&Le<je;pe++,Le++){let tt=Y.charCodeAt(pe),st=se.charCodeAt(Le);if(tt===st)continue;if(tt>=128||st>=128)return H(Y.toLowerCase(),se.toLowerCase(),pe,ve,Le,je);I(tt)&&(tt-=32),I(st)&&(st-=32);const Ze=tt-st;if(Ze!==0)return Ze}const qe=ve-pe,_e=je-Le;return qe<_e?-1:qe>_e?1:0}e.$gf=T;function L(Y){return Y>=48&&Y<=57}e.$hf=L;function I(Y){return Y>=97&&Y<=122}e.$if=I;function X(Y){return Y>=65&&Y<=90}e.$jf=X;function U(Y,se){return Y.length===se.length&&T(Y,se)===0}e.$kf=U;function de(Y,se){const pe=se.length;return se.length>Y.length?!1:T(Y,se,0,pe)===0}e.$lf=de;function he(Y,se){const pe=Math.min(Y.length,se.length);let ve;for(ve=0;ve<pe;ve++)if(Y.charCodeAt(ve)!==se.charCodeAt(ve))return ve;return pe}e.$mf=he;function ne(Y,se){const pe=Math.min(Y.length,se.length);let ve;const Le=Y.length-1,je=se.length-1;for(ve=0;ve<pe;ve++)if(Y.charCodeAt(Le-ve)!==se.charCodeAt(je-ve))return ve;return pe}e.$nf=ne;function ge(Y){return 55296<=Y&&Y<=56319}e.$of=ge;function Ce(Y){return 56320<=Y&&Y<=57343}e.$pf=Ce;function Re(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.$qf=Re;function Be(Y,se,pe){const ve=Y.charCodeAt(pe);if(ge(ve)&&pe+1<se){const Le=Y.charCodeAt(pe+1);if(Ce(Le))return Re(ve,Le)}return ve}e.$rf=Be;function le(Y,se){const pe=Y.charCodeAt(se-1);if(Ce(pe)&&se>1){const ve=Y.charCodeAt(se-2);if(ge(ve))return Re(ve,pe)}return pe}class _{get offset(){return this.e}constructor(se,pe=0){this.c=se,this.d=se.length,this.e=pe}setOffset(se){this.e=se}prevCodePoint(){const se=le(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Be(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}e.$sf=_;class ae{get offset(){return this.c.offset}constructor(se,pe=0){this.c=new _(se,pe)}nextGraphemeLength(){const se=Ee.getInstance(),pe=this.c,ve=pe.offset;let Le=se.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const je=pe.offset,qe=se.getGraphemeBreakType(pe.nextCodePoint());if(ke(Le,qe)){pe.setOffset(je);break}Le=qe}return pe.offset-ve}prevGraphemeLength(){const se=Ee.getInstance(),pe=this.c,ve=pe.offset;let Le=se.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const je=pe.offset,qe=se.getGraphemeBreakType(pe.prevCodePoint());if(ke(qe,Le)){pe.setOffset(je);break}Le=qe}return ve-pe.offset}eol(){return this.c.eol()}}e.$tf=ae;function oe(Y,se){return new ae(Y,se).nextGraphemeLength()}e.$uf=oe;function J(Y,se){return new ae(Y,se).prevGraphemeLength()}e.$vf=J;function G(Y,se){se>0&&Ce(Y.charCodeAt(se))&&se--;const pe=se+oe(Y,se);return[pe-J(Y,pe),pe]}e.$wf=G;function ie(Y){const se=new ae(Y);let pe=0;for(;!se.eol();)pe++,se.nextGraphemeLength();return pe}e.$xf=ie;let fe;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(Y){return fe||(fe=De()),fe.test(Y)}e.$yf=Fe;const ye=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return ye.test(Y)}e.$zf=K,e.$Af=/[\u2028\u2029]/;function f(Y){return e.$Af.test(Y)}e.$Bf=f;function A(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.$Cf=A;function F(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.$Df=F;function l(Y,se,pe=""){const ve=Y.trimStart();if(ve.length<se)return ve;const Le=/\b/g;let je=0;for(;Le.test(ve)&&!(ve.length-Le.lastIndex<se);)je=Le.lastIndex,Le.lastIndex+=1;return je===0?ve:pe+ve.substring(je).trimStart()}e.$Ef=l;const u=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,n=/\x1b\].*?\x07/g;function h(Y){return Y&&(Y=Y.replace(u,"").replace(n,"")),Y}e.$Ff=h,e.$Gf="\uFEFF";function C(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.$Hf=C;function S(Y){return C(Y)?Y.substr(1):Y}e.$If=S;function O(Y,se){if(!Y||!se||Y.length<se.length)return!1;const pe=se.length,ve=Y.toLowerCase();let Le=0,je=-1;for(;Le<pe;){const qe=ve.indexOf(se[Le],je+1);if(qe<0)return!1;je=qe,Le++}return!0}e.$Jf=O;function q(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.$Kf=q;function Z(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.$Lf=Z;function te(Y,se=1){if(se===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),se--;while(se>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}e.$Mf=te;function be(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.$Nf=be;function we(Y){return Ee.getInstance().getGraphemeBreakType(Y)}e.$Of=we;function ke(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var Pe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Ae()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const pe=this.d,ve=pe.length/3;let Le=1;for(;Le<=ve;)if(se<pe[3*Le])Le=2*Le;else if(se>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return 0}}function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(Y,se){if(Y===0)return 0;const pe=Ie(Y,se);if(pe!==void 0)return pe;const ve=new _(se,Y);return ve.prevCodePoint(),ve.offset}e.$Pf=Ne;function Ie(Y,se){const pe=new _(se,Y);let ve=pe.prevCodePoint();for(;Ge(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!F(ve))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===8205&&(Le=pe.offset),Le}function Ge(Y){return 127995<=Y&&Y<=127999}var nt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Qf="\xA0";class Ye{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Pe(se=>{function pe(Ze){const rt=new Map;for(let et=0;et<Ze.length;et+=2)rt.set(Ze[et],Ze[et+1]);return rt}function ve(Ze,rt){const et=new Map(Ze);for(const[gt,mt]of rt)et.set(gt,mt);return et}function Le(Ze,rt){if(!Ze)return rt;const et=new Map;for(const[gt,mt]of Ze)rt.has(gt)&&et.set(gt,mt);return et}const je=this.c.value;let qe=se.filter(Ze=>!Ze.startsWith("_")&&Ze in je);qe.length===0&&(qe=["_default"]);let _e;for(const Ze of qe){const rt=pe(je[Ze]);_e=Le(_e,rt)}const tt=pe(je._common),st=ve(tt,_e);return new Ye(st)})}static getInstance(se){return Ye.d.get(Array.from(se))}static{this.e=new R.$V(()=>Object.keys(Ye.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=Ye;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(se){return Ue.e().has(se)}static get codePoints(){return Ue.e()}}e.$Sf=Ue}),define(me[37],$e([1,0,34,83,10]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.FuzzyScore=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.or=void 0;function W(...S){return function(O,q){for(let Z=0,te=S.length;Z<te;Z++){const be=S[Z](O,q);if(be)return be}return null}}e.or=W,e.$7j=D.bind(void 0,!1),e.$8j=D.bind(void 0,!0);function D(S,O,q){if(!q||q.length<O.length)return null;let Z;return S?Z=j.$lf(q,O):Z=q.indexOf(O)===0,Z?O.length>0?[{start:0,end:O.length}]:[]:null}function y(S,O){const q=O.toLowerCase().indexOf(S.toLowerCase());return q===-1?null:[{start:q,end:q+S.length}]}e.$9j=y;function $(S,O){return b(S.toLowerCase(),O.toLowerCase(),0,0)}e.$0j=$;function b(S,O,q,Z){if(q===S.length)return[];if(Z===O.length)return null;if(S[q]===O[Z]){let te=null;return(te=b(S,O,q+1,Z+1))?o({start:Z,end:Z+1},te):null}return b(S,O,q,Z+1)}function k(S){return 97<=S&&S<=122}function B(S){return 65<=S&&S<=90}e.$$j=B;function c(S){return 48<=S&&S<=57}function d(S){return S===32||S===9||S===10||S===13}const t=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>t.add(S.charCodeAt(0)));function s(S){return d(S)||t.has(S)}function a(S,O){return S===O||s(S)&&s(O)}const m=new Map;function p(S){if(m.has(S))return m.get(S);let O;const q=(0,R.$5j)(S);return q&&(O=q),m.set(S,O),O}function w(S){return k(S)||B(S)||c(S)}function o(S,O){return O.length===0?O=[S]:S.end===O[0].start?O[0].start=S.start:O.unshift(S),O}function g(S,O){for(let q=O;q<S.length;q++){const Z=S.charCodeAt(q);if(B(Z)||c(Z)||q>0&&!w(S.charCodeAt(q-1)))return q}return S.length}function r(S,O,q,Z){if(q===S.length)return[];if(Z===O.length)return null;if(S[q]!==O[Z].toLowerCase())return null;{let te=null,be=Z+1;for(te=r(S,O,q+1,Z+1);!te&&(be=g(O,be))<O.length;)te=r(S,O,q+1,be),be++;return te===null?null:o({start:Z,end:Z+1},te)}}function E(S){let O=0,q=0,Z=0,te=0,be=0;for(let Ae=0;Ae<S.length;Ae++)be=S.charCodeAt(Ae),B(be)&&O++,k(be)&&q++,w(be)&&Z++,c(be)&&te++;const we=O/S.length,ke=q/S.length,Pe=Z/S.length,Ee=te/S.length;return{upperPercent:we,lowerPercent:ke,alphaPercent:Pe,numericPercent:Ee}}function N(S){const{upperPercent:O,lowerPercent:q}=S;return q===0&&O>.6}function M(S){const{upperPercent:O,lowerPercent:q,alphaPercent:Z,numericPercent:te}=S;return q>.2&&O<.8&&Z>.6&&te<.2}function P(S){let O=0,q=0,Z=0,te=0;for(let be=0;be<S.length;be++)Z=S.charCodeAt(be),B(Z)&&O++,k(Z)&&q++,d(Z)&&te++;return(O===0||q===0)&&te===0?S.length<=30:O<=5}function z(S,O){if(!O||(O=O.trim(),O.length===0)||!P(S))return null;O.length>60&&(O=O.substring(0,60));const q=E(O);if(!M(q)){if(!N(q))return null;O=O.toLowerCase()}let Z=null,te=0;for(S=S.toLowerCase();te<O.length&&(Z=r(S,O,0,te))===null;)te=g(O,te+1);return Z}e.$_j=z;function v(S,O,q=!1){if(!O||O.length===0)return null;let Z=null,te=0;for(S=S.toLowerCase(),O=O.toLowerCase();te<O.length&&(Z=H(S,O,0,te,q),Z===null);)te=V(O,te+1);return Z}e.$ak=v;function H(S,O,q,Z,te){let be=0;if(q===S.length)return[];if(Z===O.length)return null;if(!a(S.charCodeAt(q),O.charCodeAt(Z))){const Pe=p(S.charCodeAt(q));if(!Pe)return null;for(let Ee=0;Ee<Pe.length;Ee++)if(!a(Pe[Ee],O.charCodeAt(Z+Ee)))return null;be+=Pe.length-1}let we=null,ke=Z+be+1;if(we=H(S,O,q+1,ke,te),!te)for(;!we&&(ke=V(O,ke))<O.length;)we=H(S,O,q+1,ke,te),ke++;if(!we)return null;if(S.charCodeAt(q)!==O.charCodeAt(Z)){const Pe=p(S.charCodeAt(q));if(!Pe)return we;for(let Ee=0;Ee<Pe.length;Ee++)if(Pe[Ee]!==O.charCodeAt(Z+Ee))return we}return o({start:Z,end:Z+be+1},we)}function V(S,O){for(let q=O;q<S.length;q++)if(s(S.charCodeAt(q))||q>0&&s(S.charCodeAt(q-1)))return q;return S.length}const T=W(e.$8j,z,y),L=W(e.$8j,z,$),I=new i.$Dc(1e4);function X(S,O,q=!1){if(typeof S!="string"||typeof O!="string")return null;let Z=I.get(S);Z||(Z=new RegExp(j.$6e(S),"i"),I.set(S,Z));const te=Z.exec(O);return te?[{start:te.index,end:te.index+te[0].length}]:q?L(S,O):T(S,O)}e.$bk=X;function U(S,O){const q=A(S,S.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?he(q):null}e.$ck=U;function de(S,O,q,Z,te,be){const we=Math.min(13,S.length);for(;q<we;q++){const ke=A(S,O,q,Z,te,be,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,be]}e.$dk=de;function he(S){if(typeof S>"u")return[];const O=[],q=S[1];for(let Z=S.length-1;Z>1;Z--){const te=S[Z]+q,be=O[O.length-1];be&&be.end===te?be.end=te+1:O.push({start:te,end:te+1})}return O}e.$ek=he;const ne=128;function ge(){const S=[],O=[];for(let q=0;q<=ne;q++)O[q]=0;for(let q=0;q<=ne;q++)S.push(O.slice(0));return S}function Ce(S){const O=[];for(let q=0;q<=S;q++)O[q]=0;return O}const Re=Ce(2*ne),Be=Ce(2*ne),le=ge(),_=ge(),ae=ge(),oe=!1;function J(S,O,q,Z,te){function be(ke,Pe,Ee=" "){for(;ke.length<Pe;)ke=Ee+ke;return ke}let we=` |   |${Z.split("").map(ke=>be(ke,3)).join("|")}
`;for(let ke=0;ke<=q;ke++)ke===0?we+=" |":we+=`${O[ke-1]}|`,we+=S[ke].slice(0,te+1).map(Pe=>be(Pe.toString(),3)).join("|")+`
`;return we}function G(S,O,q,Z){S=S.substr(O),q=q.substr(Z),console.log(J(_,S,S.length,q,q.length)),console.log(J(ae,S,S.length,q,q.length)),console.log(J(le,S,S.length,q,q.length))}function ie(S,O){if(O<0||O>=S.length)return!1;const q=S.codePointAt(O);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!j.$Df(q)}}function fe(S,O){if(O<0||O>=S.length)return!1;switch(S.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function De(S,O,q){return O[S]!==q[S]}function Fe(S,O,q,Z,te,be,we=!1){for(;O<q&&te<be;)S[O]===Z[te]&&(we&&(Re[O]=te),O+=1),te+=1;return O===q}e.$fk=Fe;var ye;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var K;(function(S){S.Default=[-100,0];function O(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}S.isDefault=O})(K||(e.FuzzyScore=K={}));class f{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(O,q){this.firstMatchCanBeWeak=O,this.boostFullMatch=q}}e.$gk=f;function A(S,O,q,Z,te,be,we=f.default){const ke=S.length>ne?ne:S.length,Pe=Z.length>ne?ne:Z.length;if(q>=ke||be>=Pe||ke-q>Pe-be||!Fe(O,q,ke,te,be,Pe,!0))return;F(ke,Pe,q,be,O,te);let Ee=1,Ae=1,Ne=q,Ie=be;const Ge=[!1];for(Ee=1,Ne=q;Ne<ke;Ee++,Ne++){const se=Re[Ne],pe=Be[Ne],ve=Ne+1<ke?Be[Ne+1]:Pe;for(Ae=se-be+1,Ie=se;Ie<ve;Ae++,Ie++){let Le=Number.MIN_SAFE_INTEGER,je=!1;Ie<=pe&&(Le=l(S,O,Ne,q,Z,te,Ie,Pe,be,le[Ee-1][Ae-1]===0,Ge));let qe=0;Le!==Number.MAX_SAFE_INTEGER&&(je=!0,qe=Le+_[Ee-1][Ae-1]);const _e=Ie>se,tt=_e?_[Ee][Ae-1]+(le[Ee][Ae-1]>0?-5:0):0,st=Ie>se+1&&le[Ee][Ae-1]>0,Ze=st?_[Ee][Ae-2]+(le[Ee][Ae-2]>0?-5:0):0;if(st&&(!_e||Ze>=tt)&&(!je||Ze>=qe))_[Ee][Ae]=Ze,ae[Ee][Ae]=3,le[Ee][Ae]=0;else if(_e&&(!je||tt>=qe))_[Ee][Ae]=tt,ae[Ee][Ae]=2,le[Ee][Ae]=0;else if(je)_[Ee][Ae]=qe,ae[Ee][Ae]=1,le[Ee][Ae]=le[Ee-1][Ae-1]+1;else throw new Error("not possible")}}if(oe&&G(S,q,Z,be),!Ge[0]&&!we.firstMatchCanBeWeak)return;Ee--,Ae--;const nt=[_[Ee][Ae],be];let Ye=0,Ue=0;for(;Ee>=1;){let se=Ae;do{const pe=ae[Ee][se];if(pe===3)se=se-2;else if(pe===2)se=se-1;else break}while(se>=1);Ye>1&&O[q+Ee-1]===te[be+Ae-1]&&!De(se+be-1,Z,te)&&Ye+1>le[Ee][se]&&(se=Ae),se===Ae?Ye++:Ye=1,Ue||(Ue=se),Ee--,Ae=se-1,nt.push(Ae)}Pe===ke&&we.boostFullMatch&&(nt[0]+=2);const Y=Ue-ke;return nt[0]-=Y,nt}e.$hk=A;function F(S,O,q,Z,te,be){let we=S-1,ke=O-1;for(;we>=q&&ke>=Z;)te[we]===be[ke]&&(Be[we]=ke,we--),ke--}function l(S,O,q,Z,te,be,we,ke,Pe,Ee,Ae){if(O[q]!==be[we])return Number.MIN_SAFE_INTEGER;let Ne=1,Ie=!1;return we===q-Z?Ne=S[q]===te[we]?7:5:De(we,te,be)&&(we===0||!De(we-1,te,be))?(Ne=S[q]===te[we]?7:5,Ie=!0):ie(be,we)&&(we===0||!ie(be,we-1))?Ne=5:(ie(be,we-1)||fe(be,we-1))&&(Ne=5,Ie=!0),Ne>1&&q===Z&&(Ae[0]=!0),Ie||(Ie=De(we,te,be)||ie(be,we-1)||fe(be,we-1)),q===Z?we>Pe&&(Ne-=Ie?3:5):Ee?Ne+=Ie?2:0:Ne+=Ie?0:1,we+1===ke&&(Ne-=Ie?3:5),Ne}function u(S,O,q,Z,te,be,we){return h(S,O,q,Z,te,be,!0,we)}e.$ik=u;function n(S,O,q,Z,te,be,we){return h(S,O,q,Z,te,be,!1,we)}e.$jk=n;function h(S,O,q,Z,te,be,we,ke){let Pe=A(S,O,q,Z,te,be,ke);if(Pe&&!we)return Pe;if(S.length>=3){const Ee=Math.min(7,S.length-1);for(let Ae=q+1;Ae<Ee;Ae++){const Ne=C(S,Ae);if(Ne){const Ie=A(Ne,Ne.toLowerCase(),q,Z,te,be,ke);Ie&&(Ie[0]-=3,(!Pe||Ie[0]>Pe[0])&&(Pe=Ie))}}}return Pe}function C(S,O){if(O+1>=S.length)return;const q=S[O],Z=S[O+1];if(q!==Z)return S.slice(0,O)+Z+q+S.slice(O+2)}}),define(me[52],$e([1,0,10]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function R(m){return j(m,0)}e.$7i=R;function j(m,p){switch(typeof m){case"object":return m===null?W(349,p):Array.isArray(m)?$(m,p):b(m,p);case"string":return y(m,p);case"boolean":return D(m,p);case"number":return W(m,p);case"undefined":return W(937,p);default:return W(617,p)}}e.$8i=j;function W(m,p){return(p<<5)-p+m|0}e.$9i=W;function D(m,p){return W(m?433:863,p)}function y(m,p){p=W(149417,p);for(let w=0,o=m.length;w<o;w++)p=W(m.charCodeAt(w),p);return p}e.$0i=y;function $(m,p){return p=W(104579,p),m.reduce((w,o)=>j(o,w),p)}function b(m,p){return p=W(181387,p),Object.keys(m).sort().reduce((w,o)=>(w=y(o,w),j(m[o],w)),p)}class k{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=j(p,this.g),this.g}}e.$$i=k;var B;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function c(m,p,w=32){const o=w-p,g=~((1<<o)-1);return(m<<p|(g&m)>>>o)>>>0}function d(m,p=0,w=m.byteLength,o=0){for(let g=0;g<w;g++)m[p+g]=o}function t(m,p,w="0"){for(;m.length<p;)m=w+m;return m}function s(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(w=>w.toString(16).padStart(2,"0")).join(""):t((m>>>0).toString(16),p/4)}e.$_i=s;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const w=p.length;if(w===0)return;const o=this.p;let g=this.r,r=this.u,E,N;for(r!==0?(E=r,N=-1,r=0):(E=p.charCodeAt(0),N=0);;){let M=E;if(i.$of(E))if(N+1<w){const P=p.charCodeAt(N+1);i.$pf(P)?(N++,M=i.$qf(E,P)):M=65533}else{r=E;break}else i.$pf(E)&&(M=65533);if(g=this.w(o,g,M),N++,N<w)E=p.charCodeAt(N);else break}this.r=g,this.u=r}w(p,w,o){return o<128?p[w++]=o:o<2048?(p[w++]=192|(o&1984)>>>6,p[w++]=128|(o&63)>>>0):o<65536?(p[w++]=224|(o&61440)>>>12,p[w++]=128|(o&4032)>>>6,p[w++]=128|(o&63)>>>0):(p[w++]=240|(o&1835008)>>>18,p[w++]=128|(o&258048)>>>12,p[w++]=128|(o&4032)>>>6,p[w++]=128|(o&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=a.g,w=this.q;for(let v=0;v<64;v+=4)p.setUint32(v,w.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)p.setUint32(v,c(p.getUint32(v-12,!1)^p.getUint32(v-32,!1)^p.getUint32(v-56,!1)^p.getUint32(v-64,!1),1),!1);let o=this.h,g=this.l,r=this.m,E=this.n,N=this.o,M,P,z;for(let v=0;v<80;v++)v<20?(M=g&r|~g&E,P=1518500249):v<40?(M=g^r^E,P=1859775393):v<60?(M=g&r|g&E|r&E,P=2400959708):(M=g^r^E,P=3395469782),z=c(o,5)+M+N+P+p.getUint32(v*4,!1)&4294967295,N=E,E=r,r=c(g,30),g=o,o=z;this.h=this.h+o&4294967295,this.l=this.l+g&4294967295,this.m=this.m+r&4294967295,this.n=this.n+E&4294967295,this.o=this.o+N&4294967295}}e.$aj=a}),define(me[90],$e([1,0,78,52]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=void 0;class j{constructor(c){this.a=c}getElements(){const c=this.a,d=new Int32Array(c.length);for(let t=0,s=c.length;t<s;t++)d[t]=c.charCodeAt(t);return d}}e.$bt=j;function W(B,c,d){return new k(new j(B),new j(c)).ComputeDiff(d).changes}e.$ct=W;class D{static Assert(c,d){if(!c)throw new Error(d)}}class y{static Copy(c,d,t,s,a){for(let m=0;m<a;m++)t[s+m]=c[d+m]}static Copy2(c,d,t,s,a){for(let m=0;m<a;m++)t[s+m]=c[d+m]}}var $;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})($||($={}));class b{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$at(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,d){this.b=Math.min(this.b,c),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(c,d){this.b=Math.min(this.b,c),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class k{constructor(c,d,t=null){this.a=t,this.b=c,this.c=d;const[s,a,m]=k.o(c),[p,w,o]=k.o(d);this.d=m&&o,this.e=s,this.f=a,this.g=p,this.h=w,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const d=c.getElements();if(k.n(d)){const t=new Int32Array(d.length);for(let s=0,a=d.length;s<a;s++)t[s]=(0,R.$0i)(d[s],0);return[d,t,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(c,d){return this.f[c]!==this.h[d]?!1:this.d?this.e[c]===this.g[d]:!0}q(c,d){if(!this.p(c,d))return!1;const t=k.r(this.b,c),s=k.r(this.c,d);return t===s}static r(c,d){return typeof c.getStrictElement=="function"?c.getStrictElement(d):null}s(c,d){return this.f[c]!==this.f[d]?!1:this.d?this.e[c]===this.e[d]:!0}u(c,d){return this.h[c]!==this.h[d]?!1:this.d?this.g[c]===this.g[d]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,d,t,s,a){const m=[!1];let p=this.w(c,d,t,s,m);return a&&(p=this.z(p)),{quitEarly:m[0],changes:p}}w(c,d,t,s,a){for(a[0]=!1;c<=d&&t<=s&&this.p(c,t);)c++,t++;for(;d>=c&&s>=t&&this.p(d,s);)d--,s--;if(c>d||t>s){let r;return t<=s?(D.Assert(c===d+1,"originalStart should only be one more than originalEnd"),r=[new i.$at(c,0,t,s-t+1)]):c<=d?(D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$at(c,d-c+1,t,0)]):(D.Assert(c===d+1,"originalStart should only be one more than originalEnd"),D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const m=[0],p=[0],w=this.y(c,d,t,s,m,p,a),o=m[0],g=p[0];if(w!==null)return w;if(!a[0]){const r=this.w(c,o,t,g,a);let E=[];return a[0]?E=[new i.$at(o+1,d-(o+1)+1,g+1,s-(g+1)+1)]:E=this.w(o+1,d,g+1,s,a),this.H(r,E)}return[new i.$at(c,d-c+1,t,s-t+1)]}x(c,d,t,s,a,m,p,w,o,g,r,E,N,M,P,z,v,H){let V=null,T=null,L=new b,I=d,X=t,U=N[0]-z[0]-s,de=-1073741824,he=this.k.length-1;do{const ne=U+c;ne===I||ne<X&&o[ne-1]<o[ne+1]?(r=o[ne+1],M=r-U-s,r<de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,M),U=ne+1-c):(r=o[ne-1]+1,M=r-U-s,r<de&&L.MarkNextChange(),de=r-1,L.AddOriginalElement(r,M+1),U=ne-1-c),he>=0&&(o=this.k[he],c=o[0],I=1,X=o.length-1)}while(--he>=-1);if(V=L.getReverseChanges(),H[0]){let ne=N[0]+1,ge=z[0]+1;if(V!==null&&V.length>0){const Ce=V[V.length-1];ne=Math.max(ne,Ce.getOriginalEnd()),ge=Math.max(ge,Ce.getModifiedEnd())}T=[new i.$at(ne,E-ne+1,ge,P-ge+1)]}else{L=new b,I=m,X=p,U=N[0]-z[0]-w,de=1073741824,he=v?this.m.length-1:this.m.length-2;do{const ne=U+a;ne===I||ne<X&&g[ne-1]>=g[ne+1]?(r=g[ne+1]-1,M=r-U-w,r>de&&L.MarkNextChange(),de=r+1,L.AddOriginalElement(r+1,M+1),U=ne+1-a):(r=g[ne-1],M=r-U-w,r>de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,M+1),U=ne-1-a),he>=0&&(g=this.m[he],a=g[0],I=1,X=g.length-1)}while(--he>=-1);T=L.getChanges()}return this.H(V,T)}y(c,d,t,s,a,m,p){let w=0,o=0,g=0,r=0,E=0,N=0;c--,t--,a[0]=0,m[0]=0,this.k=[],this.m=[];const M=d-c+(s-t),P=M+1,z=new Int32Array(P),v=new Int32Array(P),H=s-t,V=d-c,T=c-t,L=d-s,X=(V-H)%2===0;z[H]=c,v[V]=d,p[0]=!1;for(let U=1;U<=M/2+1;U++){let de=0,he=0;g=this.J(H-U,U,H,P),r=this.J(H+U,U,H,P);for(let ge=g;ge<=r;ge+=2){ge===g||ge<r&&z[ge-1]<z[ge+1]?w=z[ge+1]:w=z[ge-1]+1,o=w-(ge-H)-T;const Ce=w;for(;w<d&&o<s&&this.p(w+1,o+1);)w++,o++;if(z[ge]=w,w+o>de+he&&(de=w,he=o),!X&&Math.abs(ge-V)<=U-1&&w>=v[ge])return a[0]=w,m[0]=o,Ce<=v[ge]&&1447>0&&U<=1448?this.x(H,g,r,T,V,E,N,L,z,v,w,d,a,o,s,m,X,p):null}const ne=(de-c+(he-t)-U)/2;if(this.a!==null&&!this.a(de,ne))return p[0]=!0,a[0]=de,m[0]=he,ne>0&&1447>0&&U<=1448?this.x(H,g,r,T,V,E,N,L,z,v,w,d,a,o,s,m,X,p):(c++,t++,[new i.$at(c,d-c+1,t,s-t+1)]);E=this.J(V-U,U,V,P),N=this.J(V+U,U,V,P);for(let ge=E;ge<=N;ge+=2){ge===E||ge<N&&v[ge-1]>=v[ge+1]?w=v[ge+1]-1:w=v[ge-1],o=w-(ge-V)-L;const Ce=w;for(;w>c&&o>t&&this.p(w,o);)w--,o--;if(v[ge]=w,X&&Math.abs(ge-H)<=U&&w<=z[ge])return a[0]=w,m[0]=o,Ce>=z[ge]&&1447>0&&U<=1448?this.x(H,g,r,T,V,E,N,L,z,v,w,d,a,o,s,m,X,p):null}if(U<=1447){let ge=new Int32Array(r-g+2);ge[0]=H-g+1,y.Copy2(z,g,ge,1,r-g+1),this.k.push(ge),ge=new Int32Array(N-E+2),ge[0]=V-E+1,y.Copy2(v,E,ge,1,N-E+1),this.m.push(ge)}}return this.x(H,g,r,T,V,E,N,L,z,v,w,d,a,o,s,m,X,p)}z(c){for(let d=0;d<c.length;d++){const t=c[d],s=d<c.length-1?c[d+1].originalStart:this.f.length,a=d<c.length-1?c[d+1].modifiedStart:this.h.length,m=t.originalLength>0,p=t.modifiedLength>0;for(;t.originalStart+t.originalLength<s&&t.modifiedStart+t.modifiedLength<a&&(!m||this.s(t.originalStart,t.originalStart+t.originalLength))&&(!p||this.u(t.modifiedStart,t.modifiedStart+t.modifiedLength));){const o=this.q(t.originalStart,t.modifiedStart);if(this.q(t.originalStart+t.originalLength,t.modifiedStart+t.modifiedLength)&&!o)break;t.originalStart++,t.modifiedStart++}const w=[null];if(d<c.length-1&&this.I(c[d],c[d+1],w)){c[d]=w[0],c.splice(d+1,1),d--;continue}}for(let d=c.length-1;d>=0;d--){const t=c[d];let s=0,a=0;if(d>0){const r=c[d-1];s=r.originalStart+r.originalLength,a=r.modifiedStart+r.modifiedLength}const m=t.originalLength>0,p=t.modifiedLength>0;let w=0,o=this.G(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength);for(let r=1;;r++){const E=t.originalStart-r,N=t.modifiedStart-r;if(E<s||N<a||m&&!this.s(E,E+t.originalLength)||p&&!this.u(N,N+t.modifiedLength))break;const P=(E===s&&N===a?5:0)+this.G(E,t.originalLength,N,t.modifiedLength);P>o&&(o=P,w=r)}t.originalStart-=w,t.modifiedStart-=w;const g=[null];if(d>0&&this.I(c[d-1],c[d],g)){c[d-1]=g[0],c.splice(d,1),d++;continue}}if(this.d)for(let d=1,t=c.length;d<t;d++){const s=c[d-1],a=c[d],m=a.originalStart-s.originalStart-s.originalLength,p=s.originalStart,w=a.originalStart+a.originalLength,o=w-p,g=s.modifiedStart,r=a.modifiedStart+a.modifiedLength,E=r-g;if(m<5&&o<20&&E<20){const N=this.A(p,o,g,E,m);if(N){const[M,P]=N;(M!==s.originalStart+s.originalLength||P!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=M-s.originalStart,s.modifiedLength=P-s.modifiedStart,a.originalStart=M+m,a.modifiedStart=P+m,a.originalLength=w-a.originalStart,a.modifiedLength=r-a.modifiedStart)}}}return c}A(c,d,t,s,a){if(d<a||s<a)return null;const m=c+d-a+1,p=t+s-a+1;let w=0,o=0,g=0;for(let r=c;r<m;r++)for(let E=t;E<p;E++){const N=this.B(r,E,a);N>0&&N>w&&(w=N,o=r,g=E)}return w>0?[o,g]:null}B(c,d,t){let s=0;for(let a=0;a<t;a++){if(!this.p(c+a,d+a))return 0;s+=this.e[c+a].length}return s}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,d){if(this.C(c)||this.C(c-1))return!0;if(d>0){const t=c+d;if(this.C(t-1)||this.C(t))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,d){if(this.E(c)||this.E(c-1))return!0;if(d>0){const t=c+d;if(this.E(t-1)||this.E(t))return!0}return!1}G(c,d,t,s){const a=this.D(c,d)?1:0,m=this.F(t,s)?1:0;return a+m}H(c,d){const t=[];if(c.length===0||d.length===0)return d.length>0?d:c;if(this.I(c[c.length-1],d[0],t)){const s=new Array(c.length+d.length-1);return y.Copy(c,0,s,0,c.length-1),s[c.length-1]=t[0],y.Copy(d,1,s,c.length,d.length-1),s}else{const s=new Array(c.length+d.length);return y.Copy(c,0,s,0,c.length),y.Copy(d,0,s,c.length,d.length),s}}I(c,d,t){if(D.Assert(c.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),D.Assert(c.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=d.originalStart||c.modifiedStart+c.modifiedLength>=d.modifiedStart){const s=c.originalStart;let a=c.originalLength;const m=c.modifiedStart;let p=c.modifiedLength;return c.originalStart+c.originalLength>=d.originalStart&&(a=d.originalStart+d.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=d.modifiedStart&&(p=d.modifiedStart+d.modifiedLength-c.modifiedStart),t[0]=new i.$at(s,a,m,p),!0}else return t[0]=null,!1}J(c,d,t,s){if(c>=0&&c<s)return c;const a=t,m=s-t-1,p=d%2===0;if(c<0){const w=a%2===0;return p===w?0:1}else{const w=m%2===0;return p===w?s-1:s-2}}}e.$dt=k}),define(me[53],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(me[91],$e([1,0,12,10]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class j{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const t=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return t-s}value(){return this.b[this.c]}}e.$ii=j;class W{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$ef)(d,this.b,0,d.length,this.c,this.d):(0,R.$gf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=W;class D{constructor(d=!0,t=!0){this.f=d,this.g=t}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let t=d.length-1;t>=0;t--,this.c--){const s=this.b.charCodeAt(t);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const t=this.b.charCodeAt(this.e);if(t===47||this.f&&t===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$ef)(d,this.b,0,d.length,this.d,this.e):(0,R.$gf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=D;var y;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(y||(y={}));class ${constructor(d,t){this.f=d,this.g=t,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$ff)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$ff)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$df)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$df)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=$;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var k;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(k||(k={}));class B{static forUris(d=()=>!1,t=()=>!1){return new B(new $(d,t))}static forPaths(d=!1){return new B(new D(void 0,!d))}static forStrings(){return new B(new j)}static forConfigKeys(){return new B(new W)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,t){if(t){const s=t.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a,d)}else{const s=d.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(d,t){const s=this.b.reset(d);let a;this.c||(this.c=new b,this.c.segment=s.value());const m=[];for(a=this.c;;){const w=s.cmp(a.segment);if(w>0)a.left||(a.left=new b,a.left.segment=s.value()),m.push([-1,a]),a=a.left;else if(w<0)a.right||(a.right=new b,a.right.segment=s.value()),m.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new b,a.mid.segment=s.value()),m.push([0,a]),a=a.mid;else break}const p=a.value;a.value=t,a.key=d;for(let w=m.length-1;w>=0;w--){const o=m[w][1];o.updateHeight();const g=o.balanceFactor();if(g<-1||g>1){const r=m[w][0],E=m[w+1][0];if(r===1&&E===1)m[w][1]=o.rotateLeft();else if(r===-1&&E===-1)m[w][1]=o.rotateRight();else if(r===1&&E===-1)o.right=m[w+1][1]=m[w+1][1].rotateRight(),m[w][1]=o.rotateLeft();else if(r===-1&&E===1)o.left=m[w+1][1]=m[w+1][1].rotateLeft(),m[w][1]=o.rotateRight();else throw new Error;if(w>0)switch(m[w-1][0]){case-1:m[w-1][1].left=m[w][1];break;case 1:m[w-1][1].right=m[w][1];break;case 0:m[w-1][1].mid=m[w][1];break}else this.c=m[0][1]}}return p}get(d){return this.d(d)?.value}d(d){const t=this.b.reset(d);let s=this.c;for(;s;){const a=t.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(t.hasNext())t.next(),s=s.mid;else break}return s}has(d){const t=this.d(d);return!(t?.value===void 0&&t?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,t){const s=this.b.reset(d),a=[];let m=this.c;for(;m;){const p=s.cmp(m.segment);if(p>0)a.push([-1,m]),m=m.left;else if(p<0)a.push([1,m]),m=m.right;else if(s.hasNext())s.next(),a.push([0,m]),m=m.mid;else break}if(m){if(t?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this.f(m.right);if(p.key){const{key:w,value:o,segment:g}=p;this.e(p.key,!1),m.key=w,m.value=o,m.segment=g}}else{const p=m.left??m.right;if(a.length>0){const[w,o]=a[a.length-1];switch(w){case-1:o.left=p;break;case 0:o.mid=p;break;case 1:o.right=p;break}}else this.c=p}for(let p=a.length-1;p>=0;p--){const w=a[p][1];w.updateHeight();const o=w.balanceFactor();if(o>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),a[p][1]=w.rotateLeft()):o<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),a[p][1]=w.rotateRight()),p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const t=this.b.reset(d);let s=this.c,a;for(;s;){const m=t.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(t.hasNext())t.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(d){return this.g(d,!1)}g(d,t){const s=this.b.reset(d);let a=this.c;for(;a;){const m=s.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):t?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[t,s]of this)d(s,t)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const t=[];return this.j(d,t),t[Symbol.iterator]()}j(d,t){d&&(d.left&&this.j(d.left,t),d.value&&t.push([d.key,d.value]),d.mid&&this.j(d.mid,t),d.right&&this.j(d.right,t))}_isBalanced(){const d=t=>{if(!t)return!0;const s=t.balanceFactor();return s<-1||s>1?!1:d(t.left)&&d(t.right)};return d(this.c)}}e.$mi=B}),define(me[7],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function i(g){return typeof g=="string"}e.$Tf=i;function R(g){return Array.isArray(g)&&g.every(r=>i(r))}e.$Uf=R;function j(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.$Vf=j;function W(g){const r=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof r}e.$Wf=W;function D(g){return typeof g=="number"&&!isNaN(g)}e.$Xf=D;function y(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.$Yf=y;function $(g){return g===!0||g===!1}e.$Zf=$;function b(g){return typeof g>"u"}e.$1f=b;function k(g){return!B(g)}e.$2f=k;function B(g){return b(g)||g===null}e.$3f=B;function c(g,r){if(!g)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.$4f=c;function d(g){if(B(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.$5f=d;function t(...g){const r=[];for(let E=0;E<g.length;E++){const N=g[E];if(B(N))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);r.push(N)}return r}e.$6f=t;const s=Object.prototype.hasOwnProperty;function a(g){if(!j(g))return!1;for(const r in g)if(s.call(g,r))return!1;return!0}e.$7f=a;function m(g){return typeof g=="function"}e.$8f=m;function p(...g){return g.length>0&&g.every(m)}e.$9f=p;function w(g,r){const E=Math.min(g.length,r.length);for(let N=0;N<E;N++)o(g[N],r[N])}e.$0f=w;function o(g,r){if(i(r)){if(typeof g!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(m(r)){try{if(g instanceof r)return}catch{}if(!B(g)&&g.constructor===r||r.length===1&&r.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$$f=o}),define(me[38],$e([1,0,7]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=void 0;const R=Object.create(null);function j(D,y){if((0,i.$Tf)(y)){const $=R[y];if($===void 0)throw new Error(`${D} references an unknown codicon: ${y}`);y=$}return R[D]=y,{id:D}}e.$kk=j;function W(){return R}e.$lk=W}),define(me[92],$e([1,0,38]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=void 0,e.$mk={add:(0,i.$kk)("add",6e4),plus:(0,i.$kk)("plus",6e4),gistNew:(0,i.$kk)("gist-new",6e4),repoCreate:(0,i.$kk)("repo-create",6e4),lightbulb:(0,i.$kk)("lightbulb",60001),lightBulb:(0,i.$kk)("light-bulb",60001),repo:(0,i.$kk)("repo",60002),repoDelete:(0,i.$kk)("repo-delete",60002),gistFork:(0,i.$kk)("gist-fork",60003),repoForked:(0,i.$kk)("repo-forked",60003),gitPullRequest:(0,i.$kk)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$kk)("git-pull-request-abandoned",60004),recordKeys:(0,i.$kk)("record-keys",60005),keyboard:(0,i.$kk)("keyboard",60005),tag:(0,i.$kk)("tag",60006),gitPullRequestLabel:(0,i.$kk)("git-pull-request-label",60006),tagAdd:(0,i.$kk)("tag-add",60006),tagRemove:(0,i.$kk)("tag-remove",60006),person:(0,i.$kk)("person",60007),personFollow:(0,i.$kk)("person-follow",60007),personOutline:(0,i.$kk)("person-outline",60007),personFilled:(0,i.$kk)("person-filled",60007),gitBranch:(0,i.$kk)("git-branch",60008),gitBranchCreate:(0,i.$kk)("git-branch-create",60008),gitBranchDelete:(0,i.$kk)("git-branch-delete",60008),sourceControl:(0,i.$kk)("source-control",60008),mirror:(0,i.$kk)("mirror",60009),mirrorPublic:(0,i.$kk)("mirror-public",60009),star:(0,i.$kk)("star",60010),starAdd:(0,i.$kk)("star-add",60010),starDelete:(0,i.$kk)("star-delete",60010),starEmpty:(0,i.$kk)("star-empty",60010),comment:(0,i.$kk)("comment",60011),commentAdd:(0,i.$kk)("comment-add",60011),alert:(0,i.$kk)("alert",60012),warning:(0,i.$kk)("warning",60012),search:(0,i.$kk)("search",60013),searchSave:(0,i.$kk)("search-save",60013),logOut:(0,i.$kk)("log-out",60014),signOut:(0,i.$kk)("sign-out",60014),logIn:(0,i.$kk)("log-in",60015),signIn:(0,i.$kk)("sign-in",60015),eye:(0,i.$kk)("eye",60016),eyeUnwatch:(0,i.$kk)("eye-unwatch",60016),eyeWatch:(0,i.$kk)("eye-watch",60016),circleFilled:(0,i.$kk)("circle-filled",60017),primitiveDot:(0,i.$kk)("primitive-dot",60017),closeDirty:(0,i.$kk)("close-dirty",60017),debugBreakpoint:(0,i.$kk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$kk)("debug-breakpoint-disabled",60017),debugHint:(0,i.$kk)("debug-hint",60017),terminalDecorationSuccess:(0,i.$kk)("terminal-decoration-success",60017),primitiveSquare:(0,i.$kk)("primitive-square",60018),edit:(0,i.$kk)("edit",60019),pencil:(0,i.$kk)("pencil",60019),info:(0,i.$kk)("info",60020),issueOpened:(0,i.$kk)("issue-opened",60020),gistPrivate:(0,i.$kk)("gist-private",60021),gitForkPrivate:(0,i.$kk)("git-fork-private",60021),lock:(0,i.$kk)("lock",60021),mirrorPrivate:(0,i.$kk)("mirror-private",60021),close:(0,i.$kk)("close",60022),removeClose:(0,i.$kk)("remove-close",60022),x:(0,i.$kk)("x",60022),repoSync:(0,i.$kk)("repo-sync",60023),sync:(0,i.$kk)("sync",60023),clone:(0,i.$kk)("clone",60024),desktopDownload:(0,i.$kk)("desktop-download",60024),beaker:(0,i.$kk)("beaker",60025),microscope:(0,i.$kk)("microscope",60025),vm:(0,i.$kk)("vm",60026),deviceDesktop:(0,i.$kk)("device-desktop",60026),file:(0,i.$kk)("file",60027),fileText:(0,i.$kk)("file-text",60027),more:(0,i.$kk)("more",60028),ellipsis:(0,i.$kk)("ellipsis",60028),kebabHorizontal:(0,i.$kk)("kebab-horizontal",60028),mailReply:(0,i.$kk)("mail-reply",60029),reply:(0,i.$kk)("reply",60029),organization:(0,i.$kk)("organization",60030),organizationFilled:(0,i.$kk)("organization-filled",60030),organizationOutline:(0,i.$kk)("organization-outline",60030),newFile:(0,i.$kk)("new-file",60031),fileAdd:(0,i.$kk)("file-add",60031),newFolder:(0,i.$kk)("new-folder",60032),fileDirectoryCreate:(0,i.$kk)("file-directory-create",60032),trash:(0,i.$kk)("trash",60033),trashcan:(0,i.$kk)("trashcan",60033),history:(0,i.$kk)("history",60034),clock:(0,i.$kk)("clock",60034),folder:(0,i.$kk)("folder",60035),fileDirectory:(0,i.$kk)("file-directory",60035),symbolFolder:(0,i.$kk)("symbol-folder",60035),logoGithub:(0,i.$kk)("logo-github",60036),markGithub:(0,i.$kk)("mark-github",60036),github:(0,i.$kk)("github",60036),terminal:(0,i.$kk)("terminal",60037),console:(0,i.$kk)("console",60037),repl:(0,i.$kk)("repl",60037),zap:(0,i.$kk)("zap",60038),symbolEvent:(0,i.$kk)("symbol-event",60038),error:(0,i.$kk)("error",60039),stop:(0,i.$kk)("stop",60039),variable:(0,i.$kk)("variable",60040),symbolVariable:(0,i.$kk)("symbol-variable",60040),array:(0,i.$kk)("array",60042),symbolArray:(0,i.$kk)("symbol-array",60042),symbolModule:(0,i.$kk)("symbol-module",60043),symbolPackage:(0,i.$kk)("symbol-package",60043),symbolNamespace:(0,i.$kk)("symbol-namespace",60043),symbolObject:(0,i.$kk)("symbol-object",60043),symbolMethod:(0,i.$kk)("symbol-method",60044),symbolFunction:(0,i.$kk)("symbol-function",60044),symbolConstructor:(0,i.$kk)("symbol-constructor",60044),symbolBoolean:(0,i.$kk)("symbol-boolean",60047),symbolNull:(0,i.$kk)("symbol-null",60047),symbolNumeric:(0,i.$kk)("symbol-numeric",60048),symbolNumber:(0,i.$kk)("symbol-number",60048),symbolStructure:(0,i.$kk)("symbol-structure",60049),symbolStruct:(0,i.$kk)("symbol-struct",60049),symbolParameter:(0,i.$kk)("symbol-parameter",60050),symbolTypeParameter:(0,i.$kk)("symbol-type-parameter",60050),symbolKey:(0,i.$kk)("symbol-key",60051),symbolText:(0,i.$kk)("symbol-text",60051),symbolReference:(0,i.$kk)("symbol-reference",60052),goToFile:(0,i.$kk)("go-to-file",60052),symbolEnum:(0,i.$kk)("symbol-enum",60053),symbolValue:(0,i.$kk)("symbol-value",60053),symbolRuler:(0,i.$kk)("symbol-ruler",60054),symbolUnit:(0,i.$kk)("symbol-unit",60054),activateBreakpoints:(0,i.$kk)("activate-breakpoints",60055),archive:(0,i.$kk)("archive",60056),arrowBoth:(0,i.$kk)("arrow-both",60057),arrowDown:(0,i.$kk)("arrow-down",60058),arrowLeft:(0,i.$kk)("arrow-left",60059),arrowRight:(0,i.$kk)("arrow-right",60060),arrowSmallDown:(0,i.$kk)("arrow-small-down",60061),arrowSmallLeft:(0,i.$kk)("arrow-small-left",60062),arrowSmallRight:(0,i.$kk)("arrow-small-right",60063),arrowSmallUp:(0,i.$kk)("arrow-small-up",60064),arrowUp:(0,i.$kk)("arrow-up",60065),bell:(0,i.$kk)("bell",60066),bold:(0,i.$kk)("bold",60067),book:(0,i.$kk)("book",60068),bookmark:(0,i.$kk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$kk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$kk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$kk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$kk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$kk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$kk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$kk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$kk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$kk)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$kk)("briefcase",60076),broadcast:(0,i.$kk)("broadcast",60077),browser:(0,i.$kk)("browser",60078),bug:(0,i.$kk)("bug",60079),calendar:(0,i.$kk)("calendar",60080),caseSensitive:(0,i.$kk)("case-sensitive",60081),check:(0,i.$kk)("check",60082),checklist:(0,i.$kk)("checklist",60083),chevronDown:(0,i.$kk)("chevron-down",60084),chevronLeft:(0,i.$kk)("chevron-left",60085),chevronRight:(0,i.$kk)("chevron-right",60086),chevronUp:(0,i.$kk)("chevron-up",60087),chromeClose:(0,i.$kk)("chrome-close",60088),chromeMaximize:(0,i.$kk)("chrome-maximize",60089),chromeMinimize:(0,i.$kk)("chrome-minimize",60090),chromeRestore:(0,i.$kk)("chrome-restore",60091),circleOutline:(0,i.$kk)("circle-outline",60092),circle:(0,i.$kk)("circle",60092),debugBreakpointUnverified:(0,i.$kk)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$kk)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$kk)("circle-slash",60093),circuitBoard:(0,i.$kk)("circuit-board",60094),clearAll:(0,i.$kk)("clear-all",60095),clippy:(0,i.$kk)("clippy",60096),closeAll:(0,i.$kk)("close-all",60097),cloudDownload:(0,i.$kk)("cloud-download",60098),cloudUpload:(0,i.$kk)("cloud-upload",60099),code:(0,i.$kk)("code",60100),collapseAll:(0,i.$kk)("collapse-all",60101),colorMode:(0,i.$kk)("color-mode",60102),commentDiscussion:(0,i.$kk)("comment-discussion",60103),creditCard:(0,i.$kk)("credit-card",60105),dash:(0,i.$kk)("dash",60108),dashboard:(0,i.$kk)("dashboard",60109),database:(0,i.$kk)("database",60110),debugContinue:(0,i.$kk)("debug-continue",60111),debugDisconnect:(0,i.$kk)("debug-disconnect",60112),debugPause:(0,i.$kk)("debug-pause",60113),debugRestart:(0,i.$kk)("debug-restart",60114),debugStart:(0,i.$kk)("debug-start",60115),debugStepInto:(0,i.$kk)("debug-step-into",60116),debugStepOut:(0,i.$kk)("debug-step-out",60117),debugStepOver:(0,i.$kk)("debug-step-over",60118),debugStop:(0,i.$kk)("debug-stop",60119),debug:(0,i.$kk)("debug",60120),deviceCameraVideo:(0,i.$kk)("device-camera-video",60121),deviceCamera:(0,i.$kk)("device-camera",60122),deviceMobile:(0,i.$kk)("device-mobile",60123),diffAdded:(0,i.$kk)("diff-added",60124),diffIgnored:(0,i.$kk)("diff-ignored",60125),diffModified:(0,i.$kk)("diff-modified",60126),diffRemoved:(0,i.$kk)("diff-removed",60127),diffRenamed:(0,i.$kk)("diff-renamed",60128),diff:(0,i.$kk)("diff",60129),diffSidebyside:(0,i.$kk)("diff-sidebyside",60129),discard:(0,i.$kk)("discard",60130),editorLayout:(0,i.$kk)("editor-layout",60131),emptyWindow:(0,i.$kk)("empty-window",60132),exclude:(0,i.$kk)("exclude",60133),extensions:(0,i.$kk)("extensions",60134),eyeClosed:(0,i.$kk)("eye-closed",60135),fileBinary:(0,i.$kk)("file-binary",60136),fileCode:(0,i.$kk)("file-code",60137),fileMedia:(0,i.$kk)("file-media",60138),filePdf:(0,i.$kk)("file-pdf",60139),fileSubmodule:(0,i.$kk)("file-submodule",60140),fileSymlinkDirectory:(0,i.$kk)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$kk)("file-symlink-file",60142),fileZip:(0,i.$kk)("file-zip",60143),files:(0,i.$kk)("files",60144),filter:(0,i.$kk)("filter",60145),flame:(0,i.$kk)("flame",60146),foldDown:(0,i.$kk)("fold-down",60147),foldUp:(0,i.$kk)("fold-up",60148),fold:(0,i.$kk)("fold",60149),folderActive:(0,i.$kk)("folder-active",60150),folderOpened:(0,i.$kk)("folder-opened",60151),gear:(0,i.$kk)("gear",60152),gift:(0,i.$kk)("gift",60153),gistSecret:(0,i.$kk)("gist-secret",60154),gist:(0,i.$kk)("gist",60155),gitCommit:(0,i.$kk)("git-commit",60156),gitCompare:(0,i.$kk)("git-compare",60157),compareChanges:(0,i.$kk)("compare-changes",60157),gitMerge:(0,i.$kk)("git-merge",60158),githubAction:(0,i.$kk)("github-action",60159),githubAlt:(0,i.$kk)("github-alt",60160),globe:(0,i.$kk)("globe",60161),grabber:(0,i.$kk)("grabber",60162),graph:(0,i.$kk)("graph",60163),gripper:(0,i.$kk)("gripper",60164),heart:(0,i.$kk)("heart",60165),home:(0,i.$kk)("home",60166),horizontalRule:(0,i.$kk)("horizontal-rule",60167),hubot:(0,i.$kk)("hubot",60168),inbox:(0,i.$kk)("inbox",60169),issueReopened:(0,i.$kk)("issue-reopened",60171),issues:(0,i.$kk)("issues",60172),italic:(0,i.$kk)("italic",60173),jersey:(0,i.$kk)("jersey",60174),json:(0,i.$kk)("json",60175),kebabVertical:(0,i.$kk)("kebab-vertical",60176),key:(0,i.$kk)("key",60177),law:(0,i.$kk)("law",60178),lightbulbAutofix:(0,i.$kk)("lightbulb-autofix",60179),linkExternal:(0,i.$kk)("link-external",60180),link:(0,i.$kk)("link",60181),listOrdered:(0,i.$kk)("list-ordered",60182),listUnordered:(0,i.$kk)("list-unordered",60183),liveShare:(0,i.$kk)("live-share",60184),loading:(0,i.$kk)("loading",60185),location:(0,i.$kk)("location",60186),mailRead:(0,i.$kk)("mail-read",60187),mail:(0,i.$kk)("mail",60188),markdown:(0,i.$kk)("markdown",60189),megaphone:(0,i.$kk)("megaphone",60190),mention:(0,i.$kk)("mention",60191),milestone:(0,i.$kk)("milestone",60192),gitPullRequestMilestone:(0,i.$kk)("git-pull-request-milestone",60192),mortarBoard:(0,i.$kk)("mortar-board",60193),move:(0,i.$kk)("move",60194),multipleWindows:(0,i.$kk)("multiple-windows",60195),mute:(0,i.$kk)("mute",60196),noNewline:(0,i.$kk)("no-newline",60197),note:(0,i.$kk)("note",60198),octoface:(0,i.$kk)("octoface",60199),openPreview:(0,i.$kk)("open-preview",60200),package:(0,i.$kk)("package",60201),paintcan:(0,i.$kk)("paintcan",60202),pin:(0,i.$kk)("pin",60203),play:(0,i.$kk)("play",60204),run:(0,i.$kk)("run",60204),plug:(0,i.$kk)("plug",60205),preserveCase:(0,i.$kk)("preserve-case",60206),preview:(0,i.$kk)("preview",60207),project:(0,i.$kk)("project",60208),pulse:(0,i.$kk)("pulse",60209),question:(0,i.$kk)("question",60210),quote:(0,i.$kk)("quote",60211),radioTower:(0,i.$kk)("radio-tower",60212),reactions:(0,i.$kk)("reactions",60213),references:(0,i.$kk)("references",60214),refresh:(0,i.$kk)("refresh",60215),regex:(0,i.$kk)("regex",60216),remoteExplorer:(0,i.$kk)("remote-explorer",60217),remote:(0,i.$kk)("remote",60218),remove:(0,i.$kk)("remove",60219),replaceAll:(0,i.$kk)("replace-all",60220),replace:(0,i.$kk)("replace",60221),repoClone:(0,i.$kk)("repo-clone",60222),repoForcePush:(0,i.$kk)("repo-force-push",60223),repoPull:(0,i.$kk)("repo-pull",60224),repoPush:(0,i.$kk)("repo-push",60225),report:(0,i.$kk)("report",60226),requestChanges:(0,i.$kk)("request-changes",60227),rocket:(0,i.$kk)("rocket",60228),rootFolderOpened:(0,i.$kk)("root-folder-opened",60229),rootFolder:(0,i.$kk)("root-folder",60230),rss:(0,i.$kk)("rss",60231),ruby:(0,i.$kk)("ruby",60232),saveAll:(0,i.$kk)("save-all",60233),saveAs:(0,i.$kk)("save-as",60234),save:(0,i.$kk)("save",60235),screenFull:(0,i.$kk)("screen-full",60236),screenNormal:(0,i.$kk)("screen-normal",60237),searchStop:(0,i.$kk)("search-stop",60238),server:(0,i.$kk)("server",60240),settingsGear:(0,i.$kk)("settings-gear",60241),settings:(0,i.$kk)("settings",60242),shield:(0,i.$kk)("shield",60243),smiley:(0,i.$kk)("smiley",60244),sortPrecedence:(0,i.$kk)("sort-precedence",60245),splitHorizontal:(0,i.$kk)("split-horizontal",60246),splitVertical:(0,i.$kk)("split-vertical",60247),squirrel:(0,i.$kk)("squirrel",60248),starFull:(0,i.$kk)("star-full",60249),starHalf:(0,i.$kk)("star-half",60250),symbolClass:(0,i.$kk)("symbol-class",60251),symbolColor:(0,i.$kk)("symbol-color",60252),symbolConstant:(0,i.$kk)("symbol-constant",60253),symbolEnumMember:(0,i.$kk)("symbol-enum-member",60254),symbolField:(0,i.$kk)("symbol-field",60255),symbolFile:(0,i.$kk)("symbol-file",60256),symbolInterface:(0,i.$kk)("symbol-interface",60257),symbolKeyword:(0,i.$kk)("symbol-keyword",60258),symbolMisc:(0,i.$kk)("symbol-misc",60259),symbolOperator:(0,i.$kk)("symbol-operator",60260),symbolProperty:(0,i.$kk)("symbol-property",60261),wrench:(0,i.$kk)("wrench",60261),wrenchSubaction:(0,i.$kk)("wrench-subaction",60261),symbolSnippet:(0,i.$kk)("symbol-snippet",60262),tasklist:(0,i.$kk)("tasklist",60263),telescope:(0,i.$kk)("telescope",60264),textSize:(0,i.$kk)("text-size",60265),threeBars:(0,i.$kk)("three-bars",60266),thumbsdown:(0,i.$kk)("thumbsdown",60267),thumbsup:(0,i.$kk)("thumbsup",60268),tools:(0,i.$kk)("tools",60269),triangleDown:(0,i.$kk)("triangle-down",60270),triangleLeft:(0,i.$kk)("triangle-left",60271),triangleRight:(0,i.$kk)("triangle-right",60272),triangleUp:(0,i.$kk)("triangle-up",60273),twitter:(0,i.$kk)("twitter",60274),unfold:(0,i.$kk)("unfold",60275),unlock:(0,i.$kk)("unlock",60276),unmute:(0,i.$kk)("unmute",60277),unverified:(0,i.$kk)("unverified",60278),verified:(0,i.$kk)("verified",60279),versions:(0,i.$kk)("versions",60280),vmActive:(0,i.$kk)("vm-active",60281),vmOutline:(0,i.$kk)("vm-outline",60282),vmRunning:(0,i.$kk)("vm-running",60283),watch:(0,i.$kk)("watch",60284),whitespace:(0,i.$kk)("whitespace",60285),wholeWord:(0,i.$kk)("whole-word",60286),window:(0,i.$kk)("window",60287),wordWrap:(0,i.$kk)("word-wrap",60288),zoomIn:(0,i.$kk)("zoom-in",60289),zoomOut:(0,i.$kk)("zoom-out",60290),listFilter:(0,i.$kk)("list-filter",60291),listFlat:(0,i.$kk)("list-flat",60292),listSelection:(0,i.$kk)("list-selection",60293),selection:(0,i.$kk)("selection",60293),listTree:(0,i.$kk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$kk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$kk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$kk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$kk)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$kk)("circle-small-filled",60298),debugStackframeDot:(0,i.$kk)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$kk)("terminal-decoration-mark",60298),debugStackframe:(0,i.$kk)("debug-stackframe",60299),debugStackframeFocused:(0,i.$kk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$kk)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$kk)("symbol-string",60301),debugReverseContinue:(0,i.$kk)("debug-reverse-continue",60302),debugStepBack:(0,i.$kk)("debug-step-back",60303),debugRestartFrame:(0,i.$kk)("debug-restart-frame",60304),debugAlt:(0,i.$kk)("debug-alt",60305),callIncoming:(0,i.$kk)("call-incoming",60306),callOutgoing:(0,i.$kk)("call-outgoing",60307),menu:(0,i.$kk)("menu",60308),expandAll:(0,i.$kk)("expand-all",60309),feedback:(0,i.$kk)("feedback",60310),gitPullRequestReviewer:(0,i.$kk)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$kk)("group-by-ref-type",60311),ungroupByRefType:(0,i.$kk)("ungroup-by-ref-type",60312),account:(0,i.$kk)("account",60313),gitPullRequestAssignee:(0,i.$kk)("git-pull-request-assignee",60313),bellDot:(0,i.$kk)("bell-dot",60314),debugConsole:(0,i.$kk)("debug-console",60315),library:(0,i.$kk)("library",60316),output:(0,i.$kk)("output",60317),runAll:(0,i.$kk)("run-all",60318),syncIgnored:(0,i.$kk)("sync-ignored",60319),pinned:(0,i.$kk)("pinned",60320),githubInverted:(0,i.$kk)("github-inverted",60321),serverProcess:(0,i.$kk)("server-process",60322),serverEnvironment:(0,i.$kk)("server-environment",60323),pass:(0,i.$kk)("pass",60324),issueClosed:(0,i.$kk)("issue-closed",60324),stopCircle:(0,i.$kk)("stop-circle",60325),playCircle:(0,i.$kk)("play-circle",60326),record:(0,i.$kk)("record",60327),debugAltSmall:(0,i.$kk)("debug-alt-small",60328),vmConnect:(0,i.$kk)("vm-connect",60329),cloud:(0,i.$kk)("cloud",60330),merge:(0,i.$kk)("merge",60331),export:(0,i.$kk)("export",60332),graphLeft:(0,i.$kk)("graph-left",60333),magnet:(0,i.$kk)("magnet",60334),notebook:(0,i.$kk)("notebook",60335),redo:(0,i.$kk)("redo",60336),checkAll:(0,i.$kk)("check-all",60337),pinnedDirty:(0,i.$kk)("pinned-dirty",60338),passFilled:(0,i.$kk)("pass-filled",60339),circleLargeFilled:(0,i.$kk)("circle-large-filled",60340),circleLarge:(0,i.$kk)("circle-large",60341),circleLargeOutline:(0,i.$kk)("circle-large-outline",60341),combine:(0,i.$kk)("combine",60342),gather:(0,i.$kk)("gather",60342),table:(0,i.$kk)("table",60343),variableGroup:(0,i.$kk)("variable-group",60344),typeHierarchy:(0,i.$kk)("type-hierarchy",60345),typeHierarchySub:(0,i.$kk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$kk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$kk)("git-pull-request-create",60348),runAbove:(0,i.$kk)("run-above",60349),runBelow:(0,i.$kk)("run-below",60350),notebookTemplate:(0,i.$kk)("notebook-template",60351),debugRerun:(0,i.$kk)("debug-rerun",60352),workspaceTrusted:(0,i.$kk)("workspace-trusted",60353),workspaceUntrusted:(0,i.$kk)("workspace-untrusted",60354),workspaceUnknown:(0,i.$kk)("workspace-unknown",60355),terminalCmd:(0,i.$kk)("terminal-cmd",60356),terminalDebian:(0,i.$kk)("terminal-debian",60357),terminalLinux:(0,i.$kk)("terminal-linux",60358),terminalPowershell:(0,i.$kk)("terminal-powershell",60359),terminalTmux:(0,i.$kk)("terminal-tmux",60360),terminalUbuntu:(0,i.$kk)("terminal-ubuntu",60361),terminalBash:(0,i.$kk)("terminal-bash",60362),arrowSwap:(0,i.$kk)("arrow-swap",60363),copy:(0,i.$kk)("copy",60364),personAdd:(0,i.$kk)("person-add",60365),filterFilled:(0,i.$kk)("filter-filled",60366),wand:(0,i.$kk)("wand",60367),debugLineByLine:(0,i.$kk)("debug-line-by-line",60368),inspect:(0,i.$kk)("inspect",60369),layers:(0,i.$kk)("layers",60370),layersDot:(0,i.$kk)("layers-dot",60371),layersActive:(0,i.$kk)("layers-active",60372),compass:(0,i.$kk)("compass",60373),compassDot:(0,i.$kk)("compass-dot",60374),compassActive:(0,i.$kk)("compass-active",60375),azure:(0,i.$kk)("azure",60376),issueDraft:(0,i.$kk)("issue-draft",60377),gitPullRequestClosed:(0,i.$kk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$kk)("git-pull-request-draft",60379),debugAll:(0,i.$kk)("debug-all",60380),debugCoverage:(0,i.$kk)("debug-coverage",60381),runErrors:(0,i.$kk)("run-errors",60382),folderLibrary:(0,i.$kk)("folder-library",60383),debugContinueSmall:(0,i.$kk)("debug-continue-small",60384),beakerStop:(0,i.$kk)("beaker-stop",60385),graphLine:(0,i.$kk)("graph-line",60386),graphScatter:(0,i.$kk)("graph-scatter",60387),pieChart:(0,i.$kk)("pie-chart",60388),bracket:(0,i.$kk)("bracket",60175),bracketDot:(0,i.$kk)("bracket-dot",60389),bracketError:(0,i.$kk)("bracket-error",60390),lockSmall:(0,i.$kk)("lock-small",60391),azureDevops:(0,i.$kk)("azure-devops",60392),verifiedFilled:(0,i.$kk)("verified-filled",60393),newline:(0,i.$kk)("newline",60394),layout:(0,i.$kk)("layout",60395),layoutActivitybarLeft:(0,i.$kk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$kk)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$kk)("layout-panel-left",60398),layoutPanelCenter:(0,i.$kk)("layout-panel-center",60399),layoutPanelJustify:(0,i.$kk)("layout-panel-justify",60400),layoutPanelRight:(0,i.$kk)("layout-panel-right",60401),layoutPanel:(0,i.$kk)("layout-panel",60402),layoutSidebarLeft:(0,i.$kk)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$kk)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$kk)("layout-statusbar",60405),layoutMenubar:(0,i.$kk)("layout-menubar",60406),layoutCentered:(0,i.$kk)("layout-centered",60407),target:(0,i.$kk)("target",60408),indent:(0,i.$kk)("indent",60409),recordSmall:(0,i.$kk)("record-small",60410),errorSmall:(0,i.$kk)("error-small",60411),terminalDecorationError:(0,i.$kk)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$kk)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$kk)("arrow-circle-left",60413),arrowCircleRight:(0,i.$kk)("arrow-circle-right",60414),arrowCircleUp:(0,i.$kk)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$kk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$kk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$kk)("layout-sidebar-left-off",60418),blank:(0,i.$kk)("blank",60419),heartFilled:(0,i.$kk)("heart-filled",60420),map:(0,i.$kk)("map",60421),mapFilled:(0,i.$kk)("map-filled",60422),circleSmall:(0,i.$kk)("circle-small",60423),bellSlash:(0,i.$kk)("bell-slash",60424),bellSlashDot:(0,i.$kk)("bell-slash-dot",60425),commentUnresolved:(0,i.$kk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$kk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$kk)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$kk)("search-fuzzy",60429),commentDraft:(0,i.$kk)("comment-draft",60430),send:(0,i.$kk)("send",60431),sparkle:(0,i.$kk)("sparkle",60432),insert:(0,i.$kk)("insert",60433),mic:(0,i.$kk)("mic",60434),thumbsdownFilled:(0,i.$kk)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$kk)("thumbsup-filled",60436),coffee:(0,i.$kk)("coffee",60437),snake:(0,i.$kk)("snake",60438),game:(0,i.$kk)("game",60439),vr:(0,i.$kk)("vr",60440),chip:(0,i.$kk)("chip",60441),piano:(0,i.$kk)("piano",60442),music:(0,i.$kk)("music",60443),micFilled:(0,i.$kk)("mic-filled",60444),repoFetch:(0,i.$kk)("repo-fetch",60445),copilot:(0,i.$kk)("copilot",60446),lightbulbSparkle:(0,i.$kk)("lightbulb-sparkle",60447),robot:(0,i.$kk)("robot",60448),sparkleFilled:(0,i.$kk)("sparkle-filled",60449),diffSingle:(0,i.$kk)("diff-single",60450),diffMultiple:(0,i.$kk)("diff-multiple",60451),surroundWith:(0,i.$kk)("surround-with",60452),share:(0,i.$kk)("share",60453),gitStash:(0,i.$kk)("git-stash",60454),gitStashApply:(0,i.$kk)("git-stash-apply",60455),gitStashPop:(0,i.$kk)("git-stash-pop",60456),vscode:(0,i.$kk)("vscode",60457),vscodeInsiders:(0,i.$kk)("vscode-insiders",60458),codeOss:(0,i.$kk)("code-oss",60459),runCoverage:(0,i.$kk)("run-coverage",60460),runAllCoverage:(0,i.$kk)("run-all-coverage",60461),coverage:(0,i.$kk)("coverage",60462),githubProject:(0,i.$kk)("github-project",60463)}}),define(me[18],$e([1,0,38,92]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=void 0;function j(){return Object.values(e.$pk)}e.$nk=j,e.$ok={dialogError:(0,i.$kk)("dialog-error","error"),dialogWarning:(0,i.$kk)("dialog-warning","warning"),dialogInfo:(0,i.$kk)("dialog-info","info"),dialogClose:(0,i.$kk)("dialog-close","close"),treeItemExpanded:(0,i.$kk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$kk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$kk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$kk)("tree-filter-clear","close"),treeItemLoading:(0,i.$kk)("tree-item-loading","loading"),menuSelection:(0,i.$kk)("menu-selection","check"),menuSubmenu:(0,i.$kk)("menu-submenu","chevron-right"),menuBarMore:(0,i.$kk)("menubar-more","more"),scrollbarButtonLeft:(0,i.$kk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$kk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$kk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$kk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$kk)("toolbar-more","more"),quickInputBack:(0,i.$kk)("quick-input-back","arrow-left"),dropDownButton:(0,i.$kk)("drop-down-button",60084),symbolCustomColor:(0,i.$kk)("symbol-customcolor",60252),exportIcon:(0,i.$kk)("export",60332),workspaceUnspecified:(0,i.$kk)("workspace-unspecified",60355),newLine:(0,i.$kk)("newline",60394),thumbsDownFilled:(0,i.$kk)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$kk)("thumbsup-filled",60436),gitFetch:(0,i.$kk)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$kk)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$kk)("debug-breakpoint-pending",60377)},e.$pk={...R.$mk,...e.$ok}}),define(me[54],$e([1,0,7]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([w,o])=>{p[w]=o&&typeof o=="object"?R(o):o}),p}e.$Ln=R;function j(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const w=p.shift();Object.freeze(w);for(const o in w)if(W.call(w,o)){const g=w[o];typeof g=="object"&&!Object.isFrozen(g)&&!(0,i.$Wf)(g)&&p.push(g)}}return m}e.$Mn=j;const W=Object.prototype.hasOwnProperty;function D(m,p){return y(m,p,new Set)}e.$Nn=D;function y(m,p,w){if((0,i.$3f)(m))return m;const o=p(m);if(typeof o<"u")return o;if(Array.isArray(m)){const g=[];for(const r of m)g.push(y(r,p,w));return g}if((0,i.$Vf)(m)){if(w.has(m))throw new Error("Cannot clone recursive data-structure");w.add(m);const g={};for(const r in m)W.call(m,r)&&(g[r]=y(m[r],p,w));return w.delete(m),g}return m}function $(m,p,w=!0){return(0,i.$Vf)(m)?((0,i.$Vf)(p)&&Object.keys(p).forEach(o=>{o in m?w&&((0,i.$Vf)(m[o])&&(0,i.$Vf)(p[o])?$(m[o],p[o],w):m[o]=p[o]):m[o]=p[o]}),m):p}e.$On=$;function b(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let w,o;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(w=0;w<m.length;w++)if(!b(m[w],p[w]))return!1}else{const g=[];for(o in m)g.push(o);g.sort();const r=[];for(o in p)r.push(o);if(r.sort(),!b(g,r))return!1;for(w=0;w<g.length;w++)if(!b(m[g[w]],p[g[w]]))return!1}return!0}e.$Pn=b;function k(m){const p=new Set;return JSON.stringify(m,(w,o)=>{if((0,i.$Vf)(o)||Array.isArray(o)){if(p.has(o))return"[Circular]";p.add(o)}return o})}e.$Qn=k;function B(m,p){const w=Object.create(null);return!m||!p||Object.keys(p).forEach(g=>{const r=m[g],E=p[g];b(r,E)||(w[g]=E)}),w}e.$Rn=B;function c(m,p){const w=p.toLowerCase(),o=Object.keys(m).find(g=>g.toLowerCase()===w);return o?m[o]:m[p]}e.$Sn=c;function d(m,p){const w=Object.create(null);for(const[o,g]of Object.entries(m))p(o,g)&&(w[o]=g);return w}e.$Tn=d;function t(m){let p=[];for(;Object.prototype!==m;)p=p.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return p}e.$Un=t;function s(m){const p=[];for(const w of t(m))typeof m[w]=="function"&&p.push(w);return p}e.$Vn=s;function a(m,p){const w=g=>function(){const r=Array.prototype.slice.call(arguments,0);return p(g,r)},o={};for(const g of m)o[g]=w(g);return o}e.$Wn=a}),define(me[19],$e([1,0,18]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$qk=e.ThemeColor=void 0;var R;(function(D){function y($){return $&&typeof $=="object"&&typeof $.id=="string"}D.isThemeColor=y})(R||(e.ThemeColor=R={}));function j(D){return{id:D}}e.$qk=j;var W;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function $(p){const w=y.exec(p.id);if(!w)return $(i.$pk.error);const[,o,g]=w,r=["codicon","codicon-"+o];return g&&r.push("codicon-modifier-"+g.substring(1)),r}D.asClassNameArray=$;function b(p){return $(p).join(" ")}D.asClassName=b;function k(p){return"."+$(p).join(".")}D.asCSSSelector=k;function B(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||R.isThemeColor(p.color))}D.isThemeIcon=B;const c=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(p){const w=c.exec(p);if(!w)return;const[,o]=w;return{id:o}}D.fromString=d;function t(p){return{id:p}}D.fromId=t;function s(p,w){let o=p.id;const g=o.lastIndexOf("~");return g!==-1&&(o=o.substring(0,g)),w&&(o=`${o}~${w}`),{id:o}}D.modify=s;function a(p){const w=p.id.lastIndexOf("~");if(w!==-1)return p.id.substring(w+1)}D.getModifier=a;function m(p,w){return p.id===w.id&&p.color?.id===w.color?.id}D.isEqual=m})(W||(e.ThemeIcon=W={}))}),define(me[39],$e([1,0,37,10,19]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=void 0;const W="$(",D=new RegExp(`\\$\\(${j.ThemeIcon.iconNameExpression}(?:${j.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${D.source}`,"g");function $(m){return m.replace(y,(p,w)=>w?p:`\\${p}`)}e.$rk=$;const b=new RegExp(`\\\\${D.source}`,"g");function k(m){return m.replace(b,p=>`\\${p}`)}e.$sk=k;const B=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function c(m){return m.indexOf(W)===-1?m:m.replace(B,(p,w,o,g)=>o?p:w||g||"")}e.$tk=c;function d(m){return m?m.replace(/\$\((.*?)\)/g,(p,w)=>` ${w} `).trim():""}e.$uk=d;const t=new RegExp(`\\$\\(${j.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(m){t.lastIndex=0;let p="";const w=[];let o=0;for(;;){const g=t.lastIndex,r=t.exec(m),E=m.substring(g,r?.index);if(E.length>0){p+=E;for(let N=0;N<E.length;N++)w.push(o)}if(!r)break;o+=r[0].length}return{text:p,iconOffsets:w}}e.$vk=s;function a(m,p,w=!1){const{text:o,iconOffsets:g}=p;if(!g||g.length===0)return(0,i.$bk)(m,o,w);const r=(0,R.$4e)(o," "),E=o.length-r.length,N=(0,i.$bk)(m,r,w);if(N)for(const M of N){const P=g[M.start+E]+E;M.start+=P,M.end+=P}return N}e.$wk=a}),define(me[93],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QV=e.$PV=void 0,e.$PV="vscode:contextmenu",e.$QV="vscode:onCloseContextMenu"}),define(me[94],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XV=void 0;class i{constructor(j,W){this.a=j,this.onMessage=W}send(j){try{this.a.send("vscode:message",j.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$XV=i}),define(me[31],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=e.$Q=e.$P=e.$O=void 0;const i=globalThis.vscode;e.$O=i.ipcRenderer,e.$P=i.ipcMessagePort,e.$Q=i.webFrame,e.$R=i.process,e.$S=i.context}),define(me[95],$e([1,0,93,31]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TV=void 0;let j=0;function W(y,$,b){const k=[],B=j++,c=`vscode:onContextMenu${B}`,d=(t,s,a)=>{k[s].click?.(a)};R.$O.once(c,d),R.$O.once(i.$QV,(t,s)=>{s===B&&(R.$O.removeListener(c,d),b?.())}),R.$O.send(i.$PV,B,y.map(t=>D(t,k)),c,$)}e.$TV=W;function D(y,$){const b={id:$.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return $.push(y),Array.isArray(y.submenu)&&(b.submenu=y.submenu.map(k=>D(k,$))),b}}),define(me[55],$e([8]),{}),define(me[96],$e([8]),{}),define(me[97],$e([8]),{}),define(me[98],$e([8]),{}),define(me[99],$e([1,0,97,98]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0})}),define(me[100],$e([8]),{}),define(me[101],$e([8]),{}),define(me[102],$e([8]),{}),define(me[103],$e([8]),{}),define(me[104],$e([8]),{}),define(me[105],$e([8]),{}),define(me[106],$e([8]),{}),define(me[107],$e([8]),{}),define(me[108],$e([8]),{}),define(me[109],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/actionbar/actionViewItems",e)}),define(me[110],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/findinput/findInput",e)}),define(me[111],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/findinput/findInputToggles",e)}),define(me[112],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/hover/updatableHoverWidget",e)}),define(me[113],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/inputbox/inputBox",e)}),define(me[114],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",e)}),define(me[115],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/tree/abstractTree",e)}),define(me[116],$e([13,11]),function(re,e){return re.create("vs/base/common/actions",e)}),define(me[40],$e([1,0,4,3,116]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0;class W extends R.$Tc{constructor(c,d="",t="",s=!0,a){super(),this.h=this.B(new i.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=d,this.u=t,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,d){this.C&&await this.C(c)}}e.$Xi=W;class D extends R.$Tc{constructor(){super(...arguments),this.f=this.B(new i.$6d),this.onWillRun=this.f.event,this.m=this.B(new i.$6d),this.onDidRun=this.m.event}async run(c,d){if(!c.enabled)return;this.f.fire({action:c});let t;try{await this.u(c,d)}catch(s){t=s}this.m.fire({action:c,error:t})}async u(c,d){await c.run(d)}}e.$Yi=D;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let d=[];for(const t of c)t.length&&(d.length?d=[...d,new y,...t]:d=t);return d}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=y;class ${get actions(){return this.a}constructor(c,d,t,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=d,this.class=s,this.a=t}async run(){}}e.$1i=$;class b extends W{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,j.localize(0,null),void 0,!1)}}e.$2i=b;function k(B){return{id:B.id,label:B.label,class:B.class,enabled:B.enabled??!0,checked:B.checked,run:async(...c)=>B.run(...c),tooltip:B.label}}e.$3i=k}),define(me[117],$e([13,11]),function(re,e){return re.create("vs/base/common/platform",e)}),define(me[5],$e([1,0,117]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,j=!1,W=!1,D=!1,y=!1,$=!1,b=!1,k=!1,B=!1,c=!1,d,t=e.$g,s=e.$g,a,m;const p=globalThis;let w;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?w=p.vscode.process:typeof process<"u"&&(w=process);const o=typeof w?.versions?.electron=="string",g=o&&w?.type==="renderer";if(typeof w=="object"){R=w.platform==="win32",j=w.platform==="darwin",W=w.platform==="linux",D=W&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,b=o,B=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,t=e.$g;const T=w.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),I=L.availableLanguages["*"];d=L.locale,s=L.osLocale,t=I||e.$g,a=L._translationsConfigFile}catch{}y=!0}else typeof navigator=="object"&&!g?(m=navigator.userAgent,R=m.indexOf("Windows")>=0,j=m.indexOf("Macintosh")>=0,k=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=m.indexOf("Linux")>=0,c=m?.indexOf("Mobi")>=0,$=!0,d=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,t=d,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(r||(e.Platform=r={}));function E(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=E;let N=0;j?N=1:R?N=3:W&&(N=2),e.$i=R,e.$j=j,e.$k=W,e.$l=D,e.$m=y,e.$n=b,e.$o=$,e.$p=$&&typeof p.importScripts=="function",e.$q=e.$p?p.origin:void 0,e.$r=k,e.$s=c,e.$t=B,e.$u=N,e.$v=m,e.$w=t;var M;(function(T){function L(){return e.$w}T.value=L;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=I;function X(){return e.$w==="en"}T.isDefault=X})(M||(e.Language=M={})),e.$x=d,e.$y=s,e.$z=a,e.$A=typeof p.postMessage=="function"&&!p.importScripts,e.$B=(()=>{if(e.$A){const T=[];p.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let X=0,U=T.length;X<U;X++){const de=T[X];if(de.id===I.data.vscodeScheduleAsyncWork){T.splice(X,1),de.callback();return}}});let L=0;return I=>{const X=++L;T.push({id:X,callback:I}),p.postMessage({vscodeScheduleAsyncWork:X},"*")}}return T=>setTimeout(T)})();var P;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(P||(e.OperatingSystem=P={})),e.OS=j||k?2:R?1:3;let z=!0,v=!1;function H(){if(!v){v=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,z=new Uint16Array(T.buffer)[0]===513}return z}e.$D=H,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function V(T){return parseFloat(T)>=20}e.$J=V}),define(me[118],$e([1,0,17,22,5]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.KeyboardSupport=void 0;var W;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(W||(e.KeyboardSupport=W={})),e.$KQ={clipboard:{writeText:j.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:j.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:j.$m||i.$IQ()?0:navigator.keyboard||i.$EQ?1:2,touch:"ontouchstart"in R.$oQ||navigator.maxTouchPoints>0,pointerEvents:R.$oQ.PointerEvent&&("ontouchstart"in R.$oQ||navigator.maxTouchPoints>0)}}),define(me[15],$e([1,0,17,48,81,5]),function(re,e,i,R,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=void 0;function D(t){if(t.charCode){const a=String.fromCharCode(t.charCode).toUpperCase();return R.KeyCodeUtils.fromString(a)}const s=t.keyCode;if(s===3)return 7;if(i.$BQ)switch(s){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(i.$CQ){if(W.$j&&s===93)return 57;if(!W.$j&&s===92)return 57}return R.$er[s]||0}const y=W.$j?256:2048,$=512,b=1024,k=W.$j?2048:256;function B(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode}, key: ${t.key}`}e.$QQ=B;function c(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode} ('${R.KeyCodeUtils.toString(t.keyCode)}')`}e.$RQ=c;class d{constructor(s){this._standardKeyboardEventBrand=!0;const a=s;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=D(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let a=0;return this.ctrlKey&&(a|=y),this.altKey&&(a|=$),this.shiftKey&&(a|=b),this.metaKey&&(a|=k),a|=s,a}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new j.$mr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}e.$SQ=d}),define(me[20],$e([1,0,17,72,5]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=e.$NQ=void 0;class W{constructor(b,k){this.timestamp=Date.now(),this.browserEvent=k,this.leftButton=k.button===0,this.middleButton=k.button===1,this.rightButton=k.button===2,this.buttons=k.buttons,this.target=k.target,this.detail=k.detail||1,k.type==="dblclick"&&(this.detail=2),this.ctrlKey=k.ctrlKey,this.shiftKey=k.shiftKey,this.altKey=k.altKey,this.metaKey=k.metaKey,typeof k.pageX=="number"?(this.posx=k.pageX,this.posy=k.pageY):(this.posx=k.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=k.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const B=R.$LQ.getPositionOfChildWindowRelativeToAncestorWindow(b,k.view);this.posx-=B.left,this.posy-=B.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}e.$NQ=W;class D extends W{constructor(b,k){super(b,k),this.dataTransfer=k.dataTransfer}}e.$OQ=D;class y{constructor(b,k=0,B=0){this.browserEvent=b||null,this.target=b?b.target||b.targetNode||b.srcElement:null,this.deltaY=B,this.deltaX=k;let c=!1;if(i.$DQ){const d=navigator.userAgent.match(/Chrome\/(\d+)/);c=(d?parseInt(d[1]):123)<=122}if(b){const d=b,t=b,s=b.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")c?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof t.VERTICAL_AXIS<"u"&&t.axis===t.VERTICAL_AXIS)this.deltaY=-t.detail/3;else if(b.type==="wheel"){const a=b;a.deltaMode===a.DOM_DELTA_LINE?i.$BQ&&!j.$j?this.deltaY=-b.deltaY/3:this.deltaY=-b.deltaY:this.deltaY=-b.deltaY/40}if(typeof d.wheelDeltaX<"u")i.$EQ&&j.$i?this.deltaX=-(d.wheelDeltaX/120):c?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof t.HORIZONTAL_AXIS<"u"&&t.axis===t.HORIZONTAL_AXIS)this.deltaX=-b.detail/3;else if(b.type==="wheel"){const a=b;a.deltaMode===a.DOM_DELTA_LINE?i.$BQ&&!j.$j?this.deltaX=-b.deltaX/3:this.deltaX=-b.deltaX:this.deltaX=-b.deltaX/40}this.deltaY===0&&this.deltaX===0&&b.wheelDelta&&(c?this.deltaY=b.wheelDelta/(120*s):this.deltaY=b.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}e.$PQ=y}),define(me[119],$e([1,0,5]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const W=j.process;R={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(me[25],$e([1,0,119]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,j=97,W=90,D=122,y=46,$=47,b=92,k=58,B=63;class c extends Error{constructor(E,N,M){let P;typeof N=="string"&&N.indexOf("not ")===0?(P="must not be",N=N.replace(/^not /,"")):P="must be";const z=E.indexOf(".")!==-1?"property":"argument";let v=`The "${E}" ${z} ${P} of type ${N}`;v+=`. Received type ${typeof M}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,E){if(r===null||typeof r!="object")throw new c(E,"Object",r)}function t(r,E){if(typeof r!="string")throw new c(E,"string",r)}const s=i.$dc==="win32";function a(r){return r===$||r===b}function m(r){return r===$}function p(r){return r>=R&&r<=W||r>=j&&r<=D}function w(r,E,N,M){let P="",z=0,v=-1,H=0,V=0;for(let T=0;T<=r.length;++T){if(T<r.length)V=r.charCodeAt(T);else{if(M(V))break;V=$}if(M(V)){if(!(v===T-1||H===1))if(H===2){if(P.length<2||z!==2||P.charCodeAt(P.length-1)!==y||P.charCodeAt(P.length-2)!==y){if(P.length>2){const L=P.lastIndexOf(N);L===-1?(P="",z=0):(P=P.slice(0,L),z=P.length-1-P.lastIndexOf(N)),v=T,H=0;continue}else if(P.length!==0){P="",z=0,v=T,H=0;continue}}E&&(P+=P.length>0?`${N}..`:"..",z=2)}else P.length>0?P+=`${N}${r.slice(v+1,T)}`:P=r.slice(v+1,T),z=T-v-1;v=T,H=0}else V===y&&H!==-1?++H:H=-1}return P}function o(r,E){d(E,"pathObject");const N=E.dir||E.root,M=E.base||`${E.name||""}${E.ext||""}`;return N?N===E.root?`${N}${M}`:`${N}${r}${M}`:M}e.$fc={resolve(...r){let E="",N="",M=!1;for(let P=r.length-1;P>=-1;P--){let z;if(P>=0){if(z=r[P],t(z,"path"),z.length===0)continue}else E.length===0?z=i.cwd():(z=i.env[`=${E}`]||i.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==E.toLowerCase()&&z.charCodeAt(2)===b)&&(z=`${E}\\`));const v=z.length;let H=0,V="",T=!1;const L=z.charCodeAt(0);if(v===1)a(L)&&(H=1,T=!0);else if(a(L))if(T=!0,a(z.charCodeAt(1))){let I=2,X=I;for(;I<v&&!a(z.charCodeAt(I));)I++;if(I<v&&I!==X){const U=z.slice(X,I);for(X=I;I<v&&a(z.charCodeAt(I));)I++;if(I<v&&I!==X){for(X=I;I<v&&!a(z.charCodeAt(I));)I++;(I===v||I!==X)&&(V=`\\\\${U}\\${z.slice(X,I)}`,H=I)}}}else H=1;else p(L)&&z.charCodeAt(1)===k&&(V=z.slice(0,2),H=2,v>2&&a(z.charCodeAt(2))&&(T=!0,H=3));if(V.length>0)if(E.length>0){if(V.toLowerCase()!==E.toLowerCase())continue}else E=V;if(M){if(E.length>0)break}else if(N=`${z.slice(H)}\\${N}`,M=T,T&&E.length>0)break}return N=w(N,!M,"\\",a),M?`${E}\\${N}`:`${E}${N}`||"."},normalize(r){t(r,"path");const E=r.length;if(E===0)return".";let N=0,M,P=!1;const z=r.charCodeAt(0);if(E===1)return m(z)?"\\":r;if(a(z))if(P=!0,a(r.charCodeAt(1))){let H=2,V=H;for(;H<E&&!a(r.charCodeAt(H));)H++;if(H<E&&H!==V){const T=r.slice(V,H);for(V=H;H<E&&a(r.charCodeAt(H));)H++;if(H<E&&H!==V){for(V=H;H<E&&!a(r.charCodeAt(H));)H++;if(H===E)return`\\\\${T}\\${r.slice(V)}\\`;H!==V&&(M=`\\\\${T}\\${r.slice(V,H)}`,N=H)}}}else N=1;else p(z)&&r.charCodeAt(1)===k&&(M=r.slice(0,2),N=2,E>2&&a(r.charCodeAt(2))&&(P=!0,N=3));let v=N<E?w(r.slice(N),!P,"\\",a):"";return v.length===0&&!P&&(v="."),v.length>0&&a(r.charCodeAt(E-1))&&(v+="\\"),M===void 0?P?`\\${v}`:v:P?`${M}\\${v}`:`${M}${v}`},isAbsolute(r){t(r,"path");const E=r.length;if(E===0)return!1;const N=r.charCodeAt(0);return a(N)||E>2&&p(N)&&r.charCodeAt(1)===k&&a(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let E,N;for(let z=0;z<r.length;++z){const v=r[z];t(v,"path"),v.length>0&&(E===void 0?E=N=v:E+=`\\${v}`)}if(E===void 0)return".";let M=!0,P=0;if(typeof N=="string"&&a(N.charCodeAt(0))){++P;const z=N.length;z>1&&a(N.charCodeAt(1))&&(++P,z>2&&(a(N.charCodeAt(2))?++P:M=!1))}if(M){for(;P<E.length&&a(E.charCodeAt(P));)P++;P>=2&&(E=`\\${E.slice(P)}`)}return e.$fc.normalize(E)},relative(r,E){if(t(r,"from"),t(E,"to"),r===E)return"";const N=e.$fc.resolve(r),M=e.$fc.resolve(E);if(N===M||(r=N.toLowerCase(),E=M.toLowerCase(),r===E))return"";let P=0;for(;P<r.length&&r.charCodeAt(P)===b;)P++;let z=r.length;for(;z-1>P&&r.charCodeAt(z-1)===b;)z--;const v=z-P;let H=0;for(;H<E.length&&E.charCodeAt(H)===b;)H++;let V=E.length;for(;V-1>H&&E.charCodeAt(V-1)===b;)V--;const T=V-H,L=v<T?v:T;let I=-1,X=0;for(;X<L;X++){const de=r.charCodeAt(P+X);if(de!==E.charCodeAt(H+X))break;de===b&&(I=X)}if(X!==L){if(I===-1)return M}else{if(T>L){if(E.charCodeAt(H+X)===b)return M.slice(H+X+1);if(X===2)return M.slice(H+X)}v>L&&(r.charCodeAt(P+X)===b?I=X:X===2&&(I=3)),I===-1&&(I=0)}let U="";for(X=P+I+1;X<=z;++X)(X===z||r.charCodeAt(X)===b)&&(U+=U.length===0?"..":"\\..");return H+=I,U.length>0?`${U}${M.slice(H,V)}`:(M.charCodeAt(H)===b&&++H,M.slice(H,V))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const E=e.$fc.resolve(r);if(E.length<=2)return r;if(E.charCodeAt(0)===b){if(E.charCodeAt(1)===b){const N=E.charCodeAt(2);if(N!==B&&N!==y)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(p(E.charCodeAt(0))&&E.charCodeAt(1)===k&&E.charCodeAt(2)===b)return`\\\\?\\${E}`;return r},dirname(r){t(r,"path");const E=r.length;if(E===0)return".";let N=-1,M=0;const P=r.charCodeAt(0);if(E===1)return a(P)?r:".";if(a(P)){if(N=M=1,a(r.charCodeAt(1))){let H=2,V=H;for(;H<E&&!a(r.charCodeAt(H));)H++;if(H<E&&H!==V){for(V=H;H<E&&a(r.charCodeAt(H));)H++;if(H<E&&H!==V){for(V=H;H<E&&!a(r.charCodeAt(H));)H++;if(H===E)return r;H!==V&&(N=M=H+1)}}}}else p(P)&&r.charCodeAt(1)===k&&(N=E>2&&a(r.charCodeAt(2))?3:2,M=N);let z=-1,v=!0;for(let H=E-1;H>=M;--H)if(a(r.charCodeAt(H))){if(!v){z=H;break}}else v=!1;if(z===-1){if(N===-1)return".";z=N}return r.slice(0,z)},basename(r,E){E!==void 0&&t(E,"ext"),t(r,"path");let N=0,M=-1,P=!0,z;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===k&&(N=2),E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let v=E.length-1,H=-1;for(z=r.length-1;z>=N;--z){const V=r.charCodeAt(z);if(a(V)){if(!P){N=z+1;break}}else H===-1&&(P=!1,H=z+1),v>=0&&(V===E.charCodeAt(v)?--v===-1&&(M=z):(v=-1,M=H))}return N===M?M=H:M===-1&&(M=r.length),r.slice(N,M)}for(z=r.length-1;z>=N;--z)if(a(r.charCodeAt(z))){if(!P){N=z+1;break}}else M===-1&&(P=!1,M=z+1);return M===-1?"":r.slice(N,M)},extname(r){t(r,"path");let E=0,N=-1,M=0,P=-1,z=!0,v=0;r.length>=2&&r.charCodeAt(1)===k&&p(r.charCodeAt(0))&&(E=M=2);for(let H=r.length-1;H>=E;--H){const V=r.charCodeAt(H);if(a(V)){if(!z){M=H+1;break}continue}P===-1&&(z=!1,P=H+1),V===y?N===-1?N=H:v!==1&&(v=1):N!==-1&&(v=-1)}return N===-1||P===-1||v===0||v===1&&N===P-1&&N===M+1?"":r.slice(N,P)},format:o.bind(null,"\\"),parse(r){t(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const N=r.length;let M=0,P=r.charCodeAt(0);if(N===1)return a(P)?(E.root=E.dir=r,E):(E.base=E.name=r,E);if(a(P)){if(M=1,a(r.charCodeAt(1))){let I=2,X=I;for(;I<N&&!a(r.charCodeAt(I));)I++;if(I<N&&I!==X){for(X=I;I<N&&a(r.charCodeAt(I));)I++;if(I<N&&I!==X){for(X=I;I<N&&!a(r.charCodeAt(I));)I++;I===N?M=I:I!==X&&(M=I+1)}}}}else if(p(P)&&r.charCodeAt(1)===k){if(N<=2)return E.root=E.dir=r,E;if(M=2,a(r.charCodeAt(2))){if(N===3)return E.root=E.dir=r,E;M=3}}M>0&&(E.root=r.slice(0,M));let z=-1,v=M,H=-1,V=!0,T=r.length-1,L=0;for(;T>=M;--T){if(P=r.charCodeAt(T),a(P)){if(!V){v=T+1;break}continue}H===-1&&(V=!1,H=T+1),P===y?z===-1?z=T:L!==1&&(L=1):z!==-1&&(L=-1)}return H!==-1&&(z===-1||L===0||L===1&&z===H-1&&z===v+1?E.base=E.name=r.slice(v,H):(E.name=r.slice(v,z),E.base=r.slice(v,H),E.ext=r.slice(z,H))),v>0&&v!==M?E.dir=r.slice(0,v-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(s){const r=/\\/g;return()=>{const E=i.cwd().replace(r,"/");return E.slice(E.indexOf("/"))}}return()=>i.cwd()})();e.$gc={resolve(...r){let E="",N=!1;for(let M=r.length-1;M>=-1&&!N;M--){const P=M>=0?r[M]:g();t(P,"path"),P.length!==0&&(E=`${P}/${E}`,N=P.charCodeAt(0)===$)}return E=w(E,!N,"/",m),N?`/${E}`:E.length>0?E:"."},normalize(r){if(t(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===$,N=r.charCodeAt(r.length-1)===$;return r=w(r,!E,"/",m),r.length===0?E?"/":N?"./":".":(N&&(r+="/"),E?`/${r}`:r)},isAbsolute(r){return t(r,"path"),r.length>0&&r.charCodeAt(0)===$},join(...r){if(r.length===0)return".";let E;for(let N=0;N<r.length;++N){const M=r[N];t(M,"path"),M.length>0&&(E===void 0?E=M:E+=`/${M}`)}return E===void 0?".":e.$gc.normalize(E)},relative(r,E){if(t(r,"from"),t(E,"to"),r===E||(r=e.$gc.resolve(r),E=e.$gc.resolve(E),r===E))return"";const N=1,M=r.length,P=M-N,z=1,v=E.length-z,H=P<v?P:v;let V=-1,T=0;for(;T<H;T++){const I=r.charCodeAt(N+T);if(I!==E.charCodeAt(z+T))break;I===$&&(V=T)}if(T===H)if(v>H){if(E.charCodeAt(z+T)===$)return E.slice(z+T+1);if(T===0)return E.slice(z+T)}else P>H&&(r.charCodeAt(N+T)===$?V=T:T===0&&(V=0));let L="";for(T=N+V+1;T<=M;++T)(T===M||r.charCodeAt(T)===$)&&(L+=L.length===0?"..":"/..");return`${L}${E.slice(z+V)}`},toNamespacedPath(r){return r},dirname(r){if(t(r,"path"),r.length===0)return".";const E=r.charCodeAt(0)===$;let N=-1,M=!0;for(let P=r.length-1;P>=1;--P)if(r.charCodeAt(P)===$){if(!M){N=P;break}}else M=!1;return N===-1?E?"/":".":E&&N===1?"//":r.slice(0,N)},basename(r,E){E!==void 0&&t(E,"ext"),t(r,"path");let N=0,M=-1,P=!0,z;if(E!==void 0&&E.length>0&&E.length<=r.length){if(E===r)return"";let v=E.length-1,H=-1;for(z=r.length-1;z>=0;--z){const V=r.charCodeAt(z);if(V===$){if(!P){N=z+1;break}}else H===-1&&(P=!1,H=z+1),v>=0&&(V===E.charCodeAt(v)?--v===-1&&(M=z):(v=-1,M=H))}return N===M?M=H:M===-1&&(M=r.length),r.slice(N,M)}for(z=r.length-1;z>=0;--z)if(r.charCodeAt(z)===$){if(!P){N=z+1;break}}else M===-1&&(P=!1,M=z+1);return M===-1?"":r.slice(N,M)},extname(r){t(r,"path");let E=-1,N=0,M=-1,P=!0,z=0;for(let v=r.length-1;v>=0;--v){const H=r.charCodeAt(v);if(H===$){if(!P){N=v+1;break}continue}M===-1&&(P=!1,M=v+1),H===y?E===-1?E=v:z!==1&&(z=1):E!==-1&&(z=-1)}return E===-1||M===-1||z===0||z===1&&E===M-1&&E===N+1?"":r.slice(E,M)},format:o.bind(null,"/"),parse(r){t(r,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return E;const N=r.charCodeAt(0)===$;let M;N?(E.root="/",M=1):M=0;let P=-1,z=0,v=-1,H=!0,V=r.length-1,T=0;for(;V>=M;--V){const L=r.charCodeAt(V);if(L===$){if(!H){z=V+1;break}continue}v===-1&&(H=!1,v=V+1),L===y?P===-1?P=V:T!==1&&(T=1):P!==-1&&(T=-1)}if(v!==-1){const L=z===0&&N?1:z;P===-1||T===0||T===1&&P===v-1&&P===z+1?E.base=E.name=r.slice(L,v):(E.name=r.slice(L,P),E.base=r.slice(L,v),E.ext=r.slice(P,v))}return z>0?E.dir=r.slice(0,z-1):N&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=s?e.$fc.normalize:e.$gc.normalize,e.$ic=s?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=s?e.$fc.join:e.$gc.join,e.$kc=s?e.$fc.resolve:e.$gc.resolve,e.$lc=s?e.$fc.relative:e.$gc.relative,e.$mc=s?e.$fc.dirname:e.$gc.dirname,e.$nc=s?e.$fc.basename:e.$gc.basename,e.$oc=s?e.$fc.extname:e.$gc.extname,e.$pc=s?e.$fc.format:e.$gc.format,e.$qc=s?e.$fc.parse:e.$gc.parse,e.$rc=s?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=s?e.$fc.sep:e.$gc.sep,e.$tc=s?e.$fc.delimiter:e.$gc.delimiter}),define(me[120],$e([1,0,25,5,10,7]),function(re,e,i,R,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function D(z){return z===47||z===92}e.$_f=D;function y(z){return z.replace(/[\\/]/g,i.$gc.sep)}e.$ag=y;function $(z){return z.indexOf("/")===-1&&(z=y(z)),/^[a-zA-Z]:(\/|$)/.test(z)&&(z="/"+z),z}e.$bg=$;function b(z,v=i.$gc.sep){if(!z)return"";const H=z.length,V=z.charCodeAt(0);if(D(V)){if(D(z.charCodeAt(1))&&!D(z.charCodeAt(2))){let L=3;const I=L;for(;L<H&&!D(z.charCodeAt(L));L++);if(I!==L&&!D(z.charCodeAt(L+1))){for(L+=1;L<H;L++)if(D(z.charCodeAt(L)))return z.slice(0,L+1).replace(/[\\/]/g,v)}}return v}else if(m(V)&&z.charCodeAt(1)===58)return D(z.charCodeAt(2))?z.slice(0,2)+v:z.slice(0,2);let T=z.indexOf("://");if(T!==-1){for(T+=3;T<H;T++)if(D(z.charCodeAt(T)))return z.slice(0,T+1)}return""}e.$cg=b;function k(z){if(!R.$i||!z||z.length<5)return!1;let v=z.charCodeAt(0);if(v!==92||(v=z.charCodeAt(1),v!==92))return!1;let H=2;const V=H;for(;H<z.length&&(v=z.charCodeAt(H),v!==92);H++);return!(V===H||(v=z.charCodeAt(H+1),isNaN(v)||v===92))}e.$dg=k;const B=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(z,v=R.$i){const H=v?B:c;return!(!z||z.length===0||/^\s+$/.test(z)||(H.lastIndex=0,H.test(z))||v&&d.test(z)||z==="."||z===".."||v&&z[z.length-1]==="."||v&&z.length!==z.trim().length||z.length>255)}e.$eg=t;function s(z,v,H){const V=z===v;return!H||V?V:!z||!v?!1:(0,j.$kf)(z,v)}e.$fg=s;function a(z,v,H,V=i.sep){if(z===v)return!0;if(!z||!v||v.length>z.length)return!1;if(H){if(!(0,j.$lf)(z,v))return!1;if(v.length===z.length)return!0;let L=v.length;return v.charAt(v.length-1)===V&&L--,z.charAt(L)===V}return v.charAt(v.length-1)!==V&&(v+=V),z.indexOf(v)===0}e.$gg=a;function m(z){return z>=65&&z<=90||z>=97&&z<=122}e.$hg=m;function p(z,v){return R.$i&&z.endsWith(":")&&(z+=i.sep),(0,i.$ic)(z)||(z=(0,i.$jc)(v,z)),z=(0,i.$hc)(z),R.$i?(z=(0,j.$5e)(z,i.sep),z.endsWith(":")&&(z+=i.sep)):(z=(0,j.$5e)(z,i.sep),z||(z=i.sep)),z}e.$ig=p;function w(z){const v=(0,i.$hc)(z);return R.$i?z.length>3?!1:o(v)&&(z.length===2||v.charCodeAt(2)===92):v===i.$gc.sep}e.$jg=w;function o(z,v=R.$i){return v?m(z.charCodeAt(0))&&z.charCodeAt(1)===58:!1}e.$kg=o;function g(z,v=R.$i){return o(z,v)?z[0]:void 0}e.$lg=g;function r(z,v,H){return v.length>z.length?-1:z===v?0:(H&&(z=z.toLowerCase(),v=v.toLowerCase()),z.indexOf(v))}e.$mg=r;function E(z){const v=z.split(":");let H,V,T;for(const L of v){const I=Number(L);(0,W.$Xf)(I)?V===void 0?V=I:T===void 0&&(T=I):H=H?[H,L].join(":"):L}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:V!==void 0?V:void 0,column:T!==void 0?T:V!==void 0?1:void 0}}e.$ng=E;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function P(z,v,H=8){let V="";for(let L=0;L<H;L++){let I;L===0&&R.$i&&!v&&(H===3||H===4)?I=M:I=N,V+=I.charAt(Math.floor(Math.random()*I.length))}let T;return v?T=`${v}-${V}`:T=V,z?(0,i.$jc)(z,T):T}e.$og=P}),define(me[121],$e([1,0,25]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(k){const B=(0,i.$oc)(k),c=R[B.toLowerCase()];return c!==void 0?c:D(k)}e.$vs=W;function D(k){const B=(0,i.$oc)(k);return j[B.toLowerCase()]}e.$ws=D;function y(k){for(const B in j)if(j[B]===k)return B}e.$xs=y;const $=/^(.+)\/(.+?)(;.+)?$/;function b(k,B){const c=$.exec(k);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:B?void 0:k}e.$ys=b}),define(me[16],$e([1,0,25,5]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,W=/^\//,D=/^\/\//;function y(M,P){if(!M.scheme&&P)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${M.authority}", path: "${M.path}", query: "${M.query}", fragment: "${M.fragment}"}`);if(M.scheme&&!j.test(M.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(M.path){if(M.authority){if(!W.test(M.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(M.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(M,P){return!M&&!P?"file":M}function b(M,P){switch(M){case"https":case"http":case"file":P?P[0]!==B&&(P=B+P):P=B;break}return P}const k="",B="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(P){return P instanceof d?!0:P?typeof P.authority=="string"&&typeof P.fragment=="string"&&typeof P.path=="string"&&typeof P.query=="string"&&typeof P.scheme=="string"&&typeof P.fsPath=="string"&&typeof P.with=="function"&&typeof P.toString=="function":!1}constructor(P,z,v,H,V,T=!1){typeof P=="object"?(this.scheme=P.scheme||k,this.authority=P.authority||k,this.path=P.path||k,this.query=P.query||k,this.fragment=P.fragment||k):(this.scheme=$(P,T),this.authority=z||k,this.path=b(this.scheme,v||k),this.query=H||k,this.fragment=V||k,y(this,T))}get fsPath(){return o(this,!1)}with(P){if(!P)return this;let{scheme:z,authority:v,path:H,query:V,fragment:T}=P;return z===void 0?z=this.scheme:z===null&&(z=k),v===void 0?v=this.authority:v===null&&(v=k),H===void 0?H=this.path:H===null&&(H=k),V===void 0?V=this.query:V===null&&(V=k),T===void 0?T=this.fragment:T===null&&(T=k),z===this.scheme&&v===this.authority&&H===this.path&&V===this.query&&T===this.fragment?this:new a(z,v,H,V,T)}static parse(P,z=!1){const v=c.exec(P);return v?new a(v[2]||k,N(v[4]||k),N(v[5]||k),N(v[7]||k),N(v[9]||k),z):new a(k,k,k,k,k)}static file(P){let z=k;if(R.$i&&(P=P.replace(/\\/g,B)),P[0]===B&&P[1]===B){const v=P.indexOf(B,2);v===-1?(z=P.substring(2),P=B):(z=P.substring(2,v),P=P.substring(v)||B)}return new a("file",z,P,k,k)}static from(P,z){return new a(P.scheme,P.authority,P.path,P.query,P.fragment,z)}static joinPath(P,...z){if(!P.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return R.$i&&P.scheme==="file"?v=d.file(i.$fc.join(o(P,!0),...z)).path:v=i.$gc.join(P.path,...z),P.with({path:v})}toString(P=!1){return g(this,P)}toJSON(){return this}static revive(P){if(P){if(P instanceof d)return P;{const z=new a(P);return z._formatted=P.external??null,z._fsPath=P._sep===s?P.fsPath??null:null,z}}else return P}}e.URI=d;function t(M){return!M||typeof M!="object"?!1:typeof M.scheme=="string"&&(typeof M.authority=="string"||typeof M.authority>"u")&&(typeof M.path=="string"||typeof M.path>"u")&&(typeof M.query=="string"||typeof M.query>"u")&&(typeof M.fragment=="string"||typeof M.fragment>"u")}e.$vc=t;const s=R.$i?1:void 0;class a extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(P=!1){return P?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const P={$mid:1};return this._fsPath&&(P.fsPath=this._fsPath,P._sep=s),this._formatted&&(P.external=this._formatted),this.path&&(P.path=this.path),this.scheme&&(P.scheme=this.scheme),this.authority&&(P.authority=this.authority),this.query&&(P.query=this.query),this.fragment&&(P.fragment=this.fragment),P}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(M,P,z){let v,H=-1;for(let V=0;V<M.length;V++){const T=M.charCodeAt(V);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||P&&T===47||z&&T===91||z&&T===93||z&&T===58)H!==-1&&(v+=encodeURIComponent(M.substring(H,V)),H=-1),v!==void 0&&(v+=M.charAt(V));else{v===void 0&&(v=M.substr(0,V));const L=m[T];L!==void 0?(H!==-1&&(v+=encodeURIComponent(M.substring(H,V)),H=-1),v+=L):H===-1&&(H=V)}}return H!==-1&&(v+=encodeURIComponent(M.substring(H))),v!==void 0?v:M}function w(M){let P;for(let z=0;z<M.length;z++){const v=M.charCodeAt(z);v===35||v===63?(P===void 0&&(P=M.substr(0,z)),P+=m[v]):P!==void 0&&(P+=M[z])}return P!==void 0?P:M}function o(M,P){let z;return M.authority&&M.path.length>1&&M.scheme==="file"?z=`//${M.authority}${M.path}`:M.path.charCodeAt(0)===47&&(M.path.charCodeAt(1)>=65&&M.path.charCodeAt(1)<=90||M.path.charCodeAt(1)>=97&&M.path.charCodeAt(1)<=122)&&M.path.charCodeAt(2)===58?P?z=M.path.substr(1):z=M.path[1].toLowerCase()+M.path.substr(2):z=M.path,R.$i&&(z=z.replace(/\//g,"\\")),z}e.$wc=o;function g(M,P){const z=P?w:p;let v="",{scheme:H,authority:V,path:T,query:L,fragment:I}=M;if(H&&(v+=H,v+=":"),(V||H==="file")&&(v+=B,v+=B),V){let X=V.indexOf("@");if(X!==-1){const U=V.substr(0,X);V=V.substr(X+1),X=U.lastIndexOf(":"),X===-1?v+=z(U,!1,!1):(v+=z(U.substr(0,X),!1,!1),v+=":",v+=z(U.substr(X+1),!1,!0)),v+="@"}V=V.toLowerCase(),X=V.lastIndexOf(":"),X===-1?v+=z(V,!1,!0):(v+=z(V.substr(0,X),!1,!0),v+=V.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}v+=z(T,!0,!1)}return L&&(v+="?",v+=z(L,!1,!1)),I&&(v+="#",v+=P?I:p(I,!1,!1)),v}function r(M){try{return decodeURIComponent(M)}catch{return M.length>3?M.substr(0,3)+r(M.substr(3)):M}}const E=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(M){return M.match(E)?M.replace(E,P=>r(P)):M}}),define(me[56],$e([1,0,36,16]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function j($){return JSON.stringify($,D)}e.$Nh=j;function W($){let b=JSON.parse($);return b=y(b),b}e.$Oh=W;function D($,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function y($,b=0){if(!$||b>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return R.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof i.$te||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let k=0;k<$.length;++k)$[k]=y($[k],b+1);else for(const k in $)Object.hasOwnProperty.call($,k)&&($[k]=y($[k],b+1))}return $}e.$Ph=y}),define(me[32],$e([1,0,6,5,10,16,25]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var y;(function(t){t.inMemory="inmemory",t.vscode="vscode",t.internal="private",t.walkThrough="walkThrough",t.walkThroughSnippet="walkThroughSnippet",t.http="http",t.https="https",t.file="file",t.mailto="mailto",t.untitled="untitled",t.data="data",t.command="command",t.vscodeRemote="vscode-remote",t.vscodeRemoteResource="vscode-remote-resource",t.vscodeManagedRemoteResource="vscode-managed-remote-resource",t.vscodeUserData="vscode-userdata",t.vscodeCustomEditor="vscode-custom-editor",t.vscodeNotebookCell="vscode-notebook-cell",t.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",t.vscodeNotebookCellOutput="vscode-notebook-cell-output",t.vscodeInteractiveInput="vscode-interactive-input",t.vscodeSettings="vscode-settings",t.vscodeWorkspaceTrust="vscode-workspace-trust",t.vscodeTerminal="vscode-terminal",t.vscodeChatCodeBlock="vscode-chat-code-block",t.vscodeChatSesssion="vscode-chat-editor",t.webviewPanel="webview-panel",t.vscodeWebview="vscode-webview",t.extension="extension",t.vscodeFileResource="vscode-file",t.tmp="tmp",t.vsls="vsls",t.vscodeSourceControl="vscode-scm",t.codeSetting="code-setting"})(y||(e.Schemas=y={}));function $(t,s){return W.URI.isUri(t)?(0,j.$kf)(t.scheme,s):(0,j.$lf)(t,s+":")}e.$pg=$;function b(t,...s){return s.some(a=>$(t,a))}e.$qg=b,e.$rg="vscode-tkn",e.$sg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=B(s,a)}getServerRootPath(){return this.f}get g(){return D.$gc.join(this.f,y.vscodeRemoteResource)}set(s,a,m){this.a[s]=a,this.b[s]=m}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(g){return i.$1(g),s}const a=s.authority;let m=this.a[a];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[a],w=this.c[a];let o=`path=${encodeURIComponent(s.path)}`;return typeof w=="string"&&(o+=`&${e.$sg}=${encodeURIComponent(w)}`),W.URI.from({scheme:R.$o?this.d:y.vscodeRemoteResource,authority:`${m}:${p}`,path:this.g,query:o})}}e.$tg=new k;function B(t,s){return D.$gc.join(s??"/",`${t.quality??"oss"}-${t.commit??"dev"}`)}e.$ug=B,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class c{static{this.a=e.$zg}asBrowserUri(s){const a=this.b(s,re);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===y.vscodeRemote?e.$tg.rewrite(s):s.scheme===y.file&&(R.$m||R.$q===`${y.vscodeFileResource}://${c.a}`)?s.with({scheme:y.vscodeFileResource,authority:s.authority||c.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,re);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===y.vscodeFileResource?s.with({scheme:y.file,authority:s.authority!==c.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return W.URI.isUri(s)?s:W.URI.parse(a.toUrl(s))}}e.$Ag=new c;var d;(function(t){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);t.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function m(w){let o;typeof w=="string"?o=new URL(w).searchParams:w instanceof URL?o=w.searchParams:W.URI.isUri(w)&&(o=new URL(w.toString(!0)).searchParams);const g=o?.get(a);if(g)return s.get(g)}t.getHeadersFromQuery=m;function p(w,o,g){if(!globalThis.crossOriginIsolated)return;const r=o&&g?"3":g?"2":"1";w instanceof URLSearchParams?w.set(a,r):w[a]=r}t.addSearchParam=p})(d||(e.COI=d={}))}),define(me[41],$e([1,0,120,32,25,5,10,16]),function(re,e,i,R,j,W,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function $(d){return(0,y.$wc)(d,!0)}e.$Hg=$;class b{constructor(t){this.a=t}compare(t,s,a=!1){return t===s?0:(0,D.$df)(this.getComparisonKey(t,a),this.getComparisonKey(s,a))}isEqual(t,s,a=!1){return t===s?!0:!t||!s?!1:this.getComparisonKey(t,a)===this.getComparisonKey(s,a)}getComparisonKey(t,s=!1){return t.with({path:this.a(t)?t.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(t){return this.a(t)}isEqualOrParent(t,s,a=!1){if(t.scheme===s.scheme){if(t.scheme===R.Schemas.file)return i.$gg($(t),$(s),this.a(t))&&t.query===s.query&&(a||t.fragment===s.fragment);if((0,e.$Yg)(t.authority,s.authority))return i.$gg(t.path,s.path,this.a(t),"/")&&t.query===s.query&&(a||t.fragment===s.fragment)}return!1}joinPath(t,...s){return y.URI.joinPath(t,...s)}basenameOrAuthority(t){return(0,e.$Qg)(t)||t.authority}basename(t){return j.$gc.basename(t.path)}extname(t){return j.$gc.extname(t.path)}dirname(t){if(t.path.length===0)return t;let s;return t.scheme===R.Schemas.file?s=y.URI.file(j.$mc($(t))).path:(s=j.$gc.dirname(t.path),t.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),s="/")),t.with({path:s})}normalizePath(t){if(!t.path.length)return t;let s;return t.scheme===R.Schemas.file?s=y.URI.file(j.$hc($(t))).path:s=j.$gc.normalize(t.path),t.with({path:s})}relativePath(t,s){if(t.scheme!==s.scheme||!(0,e.$Yg)(t.authority,s.authority))return;if(t.scheme===R.Schemas.file){const p=j.$lc($(t),$(s));return W.$i?i.$ag(p):p}let a=t.path||"/";const m=s.path||"/";if(this.a(t)){let p=0;for(const w=Math.min(a.length,m.length);p<w&&!(a.charCodeAt(p)!==m.charCodeAt(p)&&a.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);a=m.substr(0,p)+a.substr(p)}return j.$gc.relative(a,m)}resolvePath(t,s){if(t.scheme===R.Schemas.file){const a=y.URI.file(j.$kc($(t),s));return t.with({authority:a.authority,path:a.path})}return s=i.$bg(s),t.with({path:j.$gc.resolve(t.path,s)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,s){return t===s||t!==void 0&&s!==void 0&&(0,D.$kf)(t,s)}hasTrailingPathSeparator(t,s=j.sep){if(t.scheme===R.Schemas.file){const a=$(t);return a.length>i.$cg(a).length&&a[a.length-1]===s}else{const a=t.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,s=j.sep){return(0,e.$Zg)(t,s)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,s=j.sep){let a=!1;if(t.scheme===R.Schemas.file){const m=$(t);a=m!==void 0&&m.length===i.$cg(m).length&&m[m.length-1]===s}else{s="/";const m=t.path;a=m.length===1&&m.charCodeAt(m.length-1)===47}return!a&&!(0,e.$Zg)(t,s)?t.with({path:t.path+"/"}):t}}e.$Ig=b,e.$Jg=new b(()=>!1),e.$Kg=new b(d=>d.scheme===R.Schemas.file?!W.$k:!0),e.$Lg=new b(d=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function k(d,t){const s=[];for(let a=0;a<d.length;a++){const m=t(d[a]);d.some((p,w)=>w===a?!1:(0,e.$Ng)(m,t(p)))||s.push(d[a])}return s}e.$3g=k;var B;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function t(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(w=>{const[o,g]=w.split(":");o&&g&&a.set(o,g)});const p=s.path.substring(0,s.path.indexOf(";"));return p&&a.set(d.META_DATA_MIME,p),a}d.parseMetaData=t})(B||(e.DataUri=B={}));function c(d,t,s){if(t){let a=d.path;return a&&a[0]!==j.$gc.sep&&(a=j.$gc.sep+a),d.with({scheme:s,authority:t,path:a})}return d.with({scheme:s})}e.$4g=c}),define(me[9],$e([1,0,30,6,4,3,41,5,53,23]),function(re,e,i,R,j,W,D,y,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function k(F){return!!F&&typeof F.then=="function"}e.$5g=k;function B(F){const l=new i.$de,u=F(l.token),n=new Promise((h,C)=>{const S=l.token.onCancellationRequested(()=>{S.dispose(),C(new R.$5)});Promise.resolve(u).then(O=>{S.dispose(),l.dispose(),h(O)},O=>{S.dispose(),l.dispose(),C(O)})});return new class{cancel(){l.cancel(),l.dispose()}then(h,C){return n.then(h,C)}catch(h){return this.then(void 0,h)}finally(h){return n.finally(h)}}}e.$6g=B;function c(F,l,u){return new Promise((n,h)=>{const C=l.onCancellationRequested(()=>{C.dispose(),n(u)});F.then(n,h).finally(()=>C.dispose())})}e.$7g=c;function d(F,l){return new Promise((u,n)=>{const h=l.onCancellationRequested(()=>{h.dispose(),n(new R.$5)});F.then(u,n).finally(()=>h.dispose())})}e.$8g=d;async function t(F){let l=-1;const u=F.map((n,h)=>n.then(C=>(l=h,C)));try{return await Promise.race(u)}finally{F.forEach((n,h)=>{h!==l&&n.cancel()})}}e.$9g=t;function s(F,l,u){let n;const h=setTimeout(()=>{n?.(void 0),u?.()},l);return Promise.race([F.finally(()=>clearTimeout(h)),new Promise(C=>n=C)])}e.$0g=s;function a(F){return new Promise((l,u)=>{const n=F();k(n)?n.then(l,u):l(n)})}e.$$g=a;function m(){let F,l;return{promise:new Promise((n,h)=>{F=n,l=h}),resolve:F,reject:l}}e.$_g=m;class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const u=()=>{if(this.b=null,this.f)return;const n=this.queue(this.d);return this.d=null,n};this.b=new Promise(n=>{this.a.then(u,u).then(n)})}return new Promise((u,n)=>{this.b.then(u,n)})}return this.a=l(),new Promise((u,n)=>{this.a.then(h=>{this.a=null,u(h)},h=>{this.a=null,n(h)})})}dispose(){this.f=!0}}e.$ah=p;class w{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}e.$bh=w;class o{constructor(){this.a=new Map}queue(l,u){const h=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(l)===h&&this.a.delete(l)});return this.a.set(l,h),h}}e.$ch=o;const g=(F,l)=>{let u=!0;const n=setTimeout(()=>{u=!1,l()},F);return{isTriggered:()=>u,dispose:()=>{clearTimeout(n),u=!1}}},r=F=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,F())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class E{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,u=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((h,C)=>{this.d=h,this.f=C}).then(()=>{if(this.b=null,this.d=null,this.g){const h=this.g;return this.g=null,h()}}));const n=()=>{this.a=null,this.d?.(null)};return this.a=u===$.$3d?r(n):g(u,n),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=E;class N{constructor(l){this.a=new E(l),this.b=new p}trigger(l,u){return this.a.trigger(()=>this.b.queue(l),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=N;class M{constructor(){this.a=!1,this.b=new Promise((l,u)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=M;class P extends M{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}e.$gh=P;function z(F,l){return l?new Promise((u,n)=>{const h=setTimeout(()=>{C.dispose(),u()},F),C=l.onCancellationRequested(()=>{clearTimeout(h),C.dispose(),n(new R.$5)})}):B(u=>z(F,u))}e.$hh=z;function v(F,l=0,u){const n=setTimeout(()=>{F(),u&&h.dispose()},l),h=(0,W.$Rc)(()=>{clearTimeout(n),u?.deleteAndLeak(h)});return u?.add(h),h}e.$ih=v;function H(F){const l=[];let u=0;const n=F.length;function h(){return u<n?F[u++]():null}function C(S){S!=null&&l.push(S);const O=h();return O?O.then(C):Promise.resolve(l)}return Promise.resolve(null).then(C)}e.$jh=H;function V(F,l=n=>!!n,u=null){let n=0;const h=F.length,C=()=>{if(n>=h)return Promise.resolve(u);const S=F[n++];return Promise.resolve(S()).then(q=>l(q)?Promise.resolve(q):C())};return C()}e.$kh=V;function T(F,l=n=>!!n,u=null){if(F.length===0)return Promise.resolve(u);let n=F.length;const h=()=>{n=-1;for(const C of F)C.cancel?.()};return new Promise((C,S)=>{for(const O of F)O.then(q=>{--n>=0&&l(q)?(h(),C(q)):n===0&&C(u)}).catch(q=>{--n>=0&&(h(),S(q))})})}e.$lh=T;class L{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new j.$6d}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((u,n)=>{this.g.push({factory:l,c:u,e:n}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const u=l.factory();u.then(l.c,l.e),u.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=L;class I extends L{constructor(){super(1)}}e.$nh=I;class X{constructor(){this.a=new ae,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}e.$oh=X;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new G;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,u=D.$Jg){const n=u.getComparisonKey(l);return this.a.get(n)?.size??0}queueFor(l,u,n=D.$Jg){const h=n.getComparisonKey(l);let C=this.a.get(h);if(!C){C=new I;const S=this.f++,O=j.Event.once(C.onDrained)(()=>{C?.dispose(),this.a.delete(h),this.h(),this.d?.deleteAndDispose(S),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$3c),this.d.set(S,O),this.a.set(h,C)}return C.queue(u)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=U;class de{constructor(l,u){this.a=-1,typeof l=="function"&&typeof u=="number"&&this.setIfNotSet(l,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},u)}setIfNotSet(l,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},u))}}e.$qh=de;class he{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,u,n=globalThis){this.cancel();const h=n.setInterval(()=>{l()},u);this.d=(0,W.$Rc)(()=>{n.clearInterval(h),this.d=void 0})}dispose(){this.cancel()}}e.$rh=he;class ne{constructor(l,u){this.b=-1,this.a=l,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=ne;class ge{constructor(l,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=l,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=ge;class Ce extends ne{constructor(l,u){super(l,u),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}e.$uh=Ce;class Re extends W.$Tc{constructor(l,u){super(),this.g=l,this.h=u,this.a=[],this.b=this.B(new W.$Uc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const u of l)this.a.push(u);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=Re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(F,l)=>{(0,y.$B)(()=>{if(u)return;const n=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,n-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:e.$xh=(F,l,u)=>{const n=F.requestIdleCallback(l,typeof u=="number"?{timeout:u}:void 0);let h=!1;return{dispose(){h||(h=!0,F.cancelIdleCallback(n))}}},e.$wh=F=>(0,e.$xh)(globalThis,F)}();class Be{constructor(l,u){this.g=!1,this.d=()=>{try{this.j=u()}catch(n){this.l=n}finally{this.g=!0}},this.f=(0,e.$xh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=Be;class le extends Be{constructor(l){super(globalThis,l)}}e.$zh=le;async function _(F,l,u){let n;for(let h=0;h<u;h++)try{return await F()}catch(C){n=C,await z(l)}throw n}e.$Ah=_;class ae{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,u,n){return this.a={taskId:l,cancel:()=>n?.(),promise:u},u.then(()=>this.d(l),()=>this.d(l)),u}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:u,resolve:n,reject:h}=m();this.b={run:l,promise:u,promiseResolve:n,promiseReject:h}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=ae;class oe{constructor(l,u=()=>Date.now()){this.d=l,this.f=u,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}e.$Ch=oe;var J;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(J||(J={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,u)=>{this.a=l,this.b=u})}complete(l){return new Promise(u=>{this.a(l),this.d={outcome:0,value:l},u()})}error(l){return new Promise(u=>{this.b(l),this.d={outcome:1,value:l},u()})}cancel(){return this.error(new R.$5)}}e.$Dh=G;var ie;(function(F){async function l(n){let h;const C=await Promise.all(n.map(S=>S.then(O=>O,O=>{h||(h=O)})));if(typeof h<"u")throw h;return C}F.settled=l;function u(n){return new Promise(async(h,C)=>{try{await n(h,C)}catch(S){C(S)}})}F.withAsyncBody=u})(ie||(e.Promises=ie={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(u=>(this.a=u,this.d=!0,u),u=>{throw this.b=u,this.d=!0,u})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=fe;class De{constructor(l){this.b=l,this.a=new b.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=De;var Fe;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Fe||(Fe={}));class ye{static fromArray(l){return new ye(u=>{u.emitMany(l)})}static fromPromise(l){return new ye(async u=>{u.emitMany(await l)})}static fromPromises(l){return new ye(async u=>{await Promise.all(l.map(async n=>u.emitOne(await n)))})}static merge(l){return new ye(async u=>{await Promise.all(l.map(async n=>{for await(const h of n)u.emitOne(h)}))})}static{this.EMPTY=ye.fromArray([])}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new j.$6d,queueMicrotask(async()=>{const u={emitOne:n=>this.g(n),emitMany:n=>this.h(n),reject:n=>this.k(n)};try{await Promise.resolve(l(u)),this.j()}catch(n){this.k(n)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(l,u){return new ye(async n=>{for await(const h of l)n.emitOne(u(h))})}map(l){return ye.map(this,l)}static filter(l,u){return new ye(async n=>{for await(const h of l)u(h)&&n.emitOne(h)})}filter(l){return ye.filter(this,l)}static coalesce(l){return ye.filter(l,u=>!!u)}coalesce(){return ye.coalesce(this)}static async toPromise(l){const u=[];for await(const n of l)u.push(n);return u}toPromise(){return ye.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}e.$Gh=ye;class K extends ye{constructor(l,u){super(u),this.l=l}cancel(){this.l.cancel()}}e.$Hh=K;function f(F){const l=new i.$de,u=F(l.token);return new K(l,async n=>{const h=l.token.onCancellationRequested(()=>{h.dispose(),l.dispose(),n.reject(new R.$5)});try{for await(const C of u){if(l.token.isCancellationRequested)return;n.emitOne(C)}h.dispose(),l.dispose()}catch(C){h.dispose(),l.dispose(),n.reject(C)}})}e.$Ih=f;class A{constructor(){this.a=new G,this.b=new ye(n=>{if(l){n.reject(l);return}return u&&n.emitMany(u),this.d=h=>n.reject(h),this.f=h=>n.emitOne(h),this.a.p});let l,u;this.f=n=>{u||(u=[]),u.push(n)},this.d=n=>{l||(l=n)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}e.$Jh=A}),define(me[2],$e([1,0,17,118,15,20,9,6,4,122,3,32,5,16,52,22]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=e.$oS=e.h=e.$mS=e.$lS=e.$kS=e.$jS=e.$iS=e.$hS=e.$gS=e.$fS=e.DetectedFullscreenMode=e.$eS=e.$dS=e.$cS=e.$bS=e.$aS=e.$_R=e.$$R=e.$0R=e.$9R=e.$8R=e.$7R=e.$6R=e.$5R=e.$4R=e.$3R=e.$2R=e.$1R=e.$=e.Namespace=e.$YR=e.$XR=e.$WR=e.$VR=e.$UR=e.$TR=e.$SR=e.$RR=e.$QR=e.$PR=e.$OR=e.$NR=e.$MR=e.$LR=e.$KR=e.$JR=e.$IR=e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=e.$CR=e.$BR=e.$AR=e.$zR=e.$yR=e.$xR=e.$wR=e.$vR=e.$uR=e.$tR=e.$sR=e.$rR=e.$qR=e.$pR=e.$oR=e.$nR=e.$mR=e.$lR=e.$kR=e.$jR=e.$iR=e.$hR=e.$gR=e.$fR=e.$eR=e.$dR=e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=e.$7Q=e.$6Q=e.$5Q=e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=e.$XQ=e.$WQ=e.$VQ=e.$UQ=e.onDidUnregisterWindow=e.onWillUnregisterWindow=e.onDidRegisterWindow=e.hasWindow=e.getWindowById=e.getWindowId=e.getWindowsCount=e.getWindows=e.getDocument=e.getWindow=e.registerWindow=void 0,a=function(){const Q=new Map;(0,s.$nQ)(s.$oQ,1);const x={window:s.$oQ,disposables:new k.$Sc};Q.set(s.$oQ.vscodeWindowId,x);const ee=new $.$6d,ce=new $.$6d,Se=new $.$6d;function He(Oe,Ve){return(typeof Oe=="number"?Q.get(Oe):void 0)??(Ve?x:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:ce.event,registerWindow(Oe){if(Q.has(Oe.vscodeWindowId))return k.$Tc.None;const Ve=new k.$Sc,Ke={window:Oe,disposables:Ve.add(new k.$Sc)};return Q.set(Oe.vscodeWindowId,Ke),Ve.add((0,k.$Rc)(()=>{Q.delete(Oe.vscodeWindowId),ce.fire(Oe)})),Ve.add(w(Oe,e.$PR.BEFORE_UNLOAD,()=>{Se.fire(Oe)})),ee.fire(Ke),Ve},getWindows(){return Q.values()},getWindowsCount(){return Q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return Q.has(Oe)},getWindowById:He,getWindow(Oe){const Ve=Oe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const Ke=Oe;return Ke?.view?Ke.view.window:s.$oQ},getDocument(Oe){const Ve=Oe;return(0,e.getWindow)(Ve).document}}}(),e.registerWindow=a.registerWindow,e.getWindow=a.getWindow,e.getDocument=a.getDocument,e.getWindows=a.getWindows,e.getWindowsCount=a.getWindowsCount,e.getWindowId=a.getWindowId,e.getWindowById=a.getWindowById,e.hasWindow=a.hasWindow,e.onDidRegisterWindow=a.onDidRegisterWindow,e.onWillUnregisterWindow=a.onWillUnregisterWindow,e.onDidUnregisterWindow=a.onDidUnregisterWindow;function m(Q){for(;Q.firstChild;)Q.firstChild.remove()}e.$UQ=m;class p{constructor(x,ee,ce,Se){this.f=x,this.g=ee,this.d=ce,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function w(Q,x,ee,ce){return new p(Q,x,ee,ce)}e.$VQ=w;function o(Q,x){return function(ee){return x(new W.$NQ(Q,ee))}}function g(Q){return function(x){return Q(new j.$SQ(x))}}const r=function(x,ee,ce,Se){let He=ce;return ee==="click"||ee==="mousedown"?He=o((0,e.getWindow)(x),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(He=g(ce)),w(x,ee,He,Se)};e.$WQ=r;const E=function(x,ee,ce){const Se=o((0,e.getWindow)(x),ee);return M(x,Se,ce)};e.$XQ=E;const N=function(x,ee,ce){const Se=o((0,e.getWindow)(x),ee);return z(x,Se,ce)};e.$YQ=N;function M(Q,x,ee){return w(Q,c.$r&&R.$KQ.pointerEvents?e.$PR.POINTER_DOWN:e.$PR.MOUSE_DOWN,x,ee)}e.$ZQ=M;function P(Q,x,ee){return w(Q,c.$r&&R.$KQ.pointerEvents?e.$PR.POINTER_MOVE:e.$PR.MOUSE_MOVE,x,ee)}e.$1Q=P;function z(Q,x,ee){return w(Q,c.$r&&R.$KQ.pointerEvents?e.$PR.POINTER_UP:e.$PR.MOUSE_UP,x,ee)}e.$2Q=z;function v(Q,x,ee){return(0,D.$xh)(Q,x,ee)}e.$3Q=v;class H extends D.$yh{constructor(x,ee){super(x,ee)}}e.$4Q=H;function V(Q,x,ee,ce){let Se=0;const He=Q.setInterval(()=>{Se++,(typeof ce=="number"&&Se>=ce||x()===!0)&&Oe.dispose()},ee),Oe=(0,k.$Rc)(()=>{Q.clearInterval(He)});return Oe}e.$7Q=V;class T extends D.$rh{constructor(x){super(),this.f=x&&(0,e.getWindow)(x)}cancelAndSet(x,ee,ce){return super.cancelAndSet(x,ee,ce??this.f)}}e.$8Q=T;class L{constructor(x,ee=0){this.d=x,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(x){(0,y.$1)(x)}}static sort(x,ee){return ee.priority-x.priority}}(function(){const Q=new Map,x=new Map,ee=new Map,ce=new Map,Se=He=>{ee.set(He,!1);const Oe=Q.get(He)??[];for(x.set(He,Oe),Q.set(He,[]),ce.set(He,!0);Oe.length>0;)Oe.sort(L.sort),Oe.shift().execute();ce.set(He,!1)};e.$6Q=(He,Oe,Ve=0)=>{const Ke=(0,e.getWindowId)(He),xe=new L(Oe,Ve);let at=Q.get(Ke);return at||(at=[],Q.set(Ke,at)),at.push(xe),ee.get(Ke)||(ee.set(Ke,!0),He.requestAnimationFrame(()=>Se(Ke))),xe},e.$5Q=(He,Oe,Ve)=>{const Ke=(0,e.getWindowId)(He);if(ce.get(Ke)){const xe=new L(Oe,Ve);let at=x.get(Ke);return at||(at=[],x.set(Ke,at)),at.push(xe),xe}else return(0,e.$6Q)(He,Oe,Ve)}})();function I(Q,x){return(0,e.$6Q)(Q,x,1e4)}e.$9Q=I;function X(Q,x){return(0,e.$6Q)(Q,x,-1e4)}e.$0Q=X;const U=8,de=function(Q,x){return x};class he extends k.$Tc{constructor(x,ee,ce,Se=de,He=U){super();let Oe=null,Ve=0;const Ke=this.B(new D.$qh),xe=()=>{Ve=new Date().getTime(),ce(Oe),Oe=null};this.B(w(x,ee,at=>{Oe=Se(Oe,at);const Ft=new Date().getTime()-Ve;Ft>=He?(Ke.cancel(),xe()):Ke.setIfNotSet(xe,He-Ft)}))}}function ne(Q,x,ee,ce,Se){return new he(Q,x,ee,ce,Se)}e.$$Q=ne;function ge(Q){return(0,e.getWindow)(Q).getComputedStyle(Q,null)}e.$_Q=ge;function Ce(Q,x){const ee=(0,e.getWindow)(Q),ce=ee.document;if(Q!==ce.body)return new Be(Q.clientWidth,Q.clientHeight);if(c.$r&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(x)return Ce(x);throw new Error("Unable to figure out browser width and height")}e.$aR=Ce;class Re{static d(x,ee){return parseFloat(ee)||0}static f(x,ee,ce){const Se=ge(x),He=Se?Se.getPropertyValue(ee):"0";return Re.d(x,He)}static getBorderLeftWidth(x){return Re.f(x,"border-left-width","borderLeftWidth")}static getBorderRightWidth(x){return Re.f(x,"border-right-width","borderRightWidth")}static getBorderTopWidth(x){return Re.f(x,"border-top-width","borderTopWidth")}static getBorderBottomWidth(x){return Re.f(x,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(x){return Re.f(x,"padding-left","paddingLeft")}static getPaddingRight(x){return Re.f(x,"padding-right","paddingRight")}static getPaddingTop(x){return Re.f(x,"padding-top","paddingTop")}static getPaddingBottom(x){return Re.f(x,"padding-bottom","paddingBottom")}static getMarginLeft(x){return Re.f(x,"margin-left","marginLeft")}static getMarginTop(x){return Re.f(x,"margin-top","marginTop")}static getMarginRight(x){return Re.f(x,"margin-right","marginRight")}static getMarginBottom(x){return Re.f(x,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(x,ee){this.width=x,this.height=ee}with(x=this.width,ee=this.height){return x!==this.width||ee!==this.height?new Be(x,ee):this}static is(x){return typeof x=="object"&&typeof x.height=="number"&&typeof x.width=="number"}static lift(x){return x instanceof Be?x:new Be(x.width,x.height)}static equals(x,ee){return x===ee?!0:!x||!ee?!1:x.width===ee.width&&x.height===ee.height}}e.$bR=Be;function le(Q){let x=Q.offsetParent,ee=Q.offsetTop,ce=Q.offsetLeft;for(;(Q=Q.parentNode)!==null&&Q!==Q.ownerDocument.body&&Q!==Q.ownerDocument.documentElement;){ee-=Q.scrollTop;const Se=C(Q)?null:ge(Q);Se&&(ce-=Se.direction!=="rtl"?Q.scrollLeft:-Q.scrollLeft),Q===x&&(ce+=Re.getBorderLeftWidth(Q),ee+=Re.getBorderTopWidth(Q),ee+=Q.offsetTop,ce+=Q.offsetLeft,x=Q.offsetParent)}return{left:ce,top:ee}}e.$cR=le;function _(Q,x,ee){typeof x=="number"&&(Q.style.width=`${x}px`),typeof ee=="number"&&(Q.style.height=`${ee}px`)}e.$dR=_;function ae(Q,x,ee,ce,Se,He="absolute"){typeof x=="number"&&(Q.style.top=`${x}px`),typeof ee=="number"&&(Q.style.right=`${ee}px`),typeof ce=="number"&&(Q.style.bottom=`${ce}px`),typeof Se=="number"&&(Q.style.left=`${Se}px`),Q.style.position=He}e.$eR=ae;function oe(Q){const x=Q.getBoundingClientRect(),ee=(0,e.getWindow)(Q);return{left:x.left+ee.scrollX,top:x.top+ee.scrollY,width:x.width,height:x.height}}e.$fR=oe;function J(Q){let x=Q,ee=1;do{const ce=ge(x).zoom;ce!=null&&ce!=="1"&&(ee*=ce),x=x.parentElement}while(x!==null&&x!==x.ownerDocument.documentElement);return ee}e.$gR=J;function G(Q){const x=Re.getMarginLeft(Q)+Re.getMarginRight(Q);return Q.offsetWidth+x}e.$hR=G;function ie(Q){const x=Re.getBorderLeftWidth(Q)+Re.getBorderRightWidth(Q),ee=Re.getPaddingLeft(Q)+Re.getPaddingRight(Q);return Q.offsetWidth-x-ee}e.$iR=ie;function fe(Q){const x=Re.getMarginLeft(Q)+Re.getMarginRight(Q);return Q.scrollWidth+x}e.$jR=fe;function De(Q){const x=Re.getBorderTopWidth(Q)+Re.getBorderBottomWidth(Q),ee=Re.getPaddingTop(Q)+Re.getPaddingBottom(Q);return Q.offsetHeight-x-ee}e.$kR=De;function Fe(Q){const x=Re.getMarginTop(Q)+Re.getMarginBottom(Q);return Q.offsetHeight+x}e.$lR=Fe;function ye(Q,x){if(Q===null)return 0;const ee=le(Q),ce=le(x);return ee.left-ce.left}function K(Q,x){const ee=x.map(Se=>Math.max(fe(Se),G(Se))+ye(Se,Q)||0);return Math.max(...ee)}e.$mR=K;function f(Q,x){return!!x?.contains(Q)}e.$nR=f;const A="parentFlowToElementId";function F(Q,x){Q.dataset[A]=x.id}e.$oR=F;function l(Q){const x=Q.dataset[A];return typeof x=="string"?Q.ownerDocument.getElementById(x):null}function u(Q,x){let ee=Q;for(;ee;){if(ee===x)return!0;if(ee instanceof HTMLElement){const ce=l(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}e.$pR=u;function n(Q,x,ee){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q.classList.contains(x))return Q;if(ee){if(typeof ee=="string"){if(Q.classList.contains(ee))return null}else if(Q===ee)return null}Q=Q.parentNode}return null}e.$qR=n;function h(Q,x,ee){return!!n(Q,x,ee)}e.$rR=h;function C(Q){return Q&&!!Q.host&&!!Q.mode}e.$sR=C;function S(Q){return!!O(Q)}e.$tR=S;function O(Q){for(;Q.parentNode;){if(Q===Q.ownerDocument?.body)return null;Q=Q.parentNode}return C(Q)?Q:null}e.$uR=O;function q(){let Q=we().activeElement;for(;Q?.shadowRoot;)Q=Q.shadowRoot.activeElement;return Q}e.$vR=q;function Z(Q){return q()===Q}e.$wR=Z;function te(Q){return f(q(),Q)}e.$xR=te;function be(Q){return Q.ownerDocument===we()}e.$yR=be;function we(){return(0,e.getWindowsCount)()<=1?s.$oQ.document:Array.from((0,e.getWindows)()).map(({window:x})=>x.document).find(x=>x.hasFocus())??s.$oQ.document}e.$zR=we;function ke(){return we().defaultView?.window??s.$oQ}e.$AR=ke;function Pe(Q,x){const ee=(0,e.getWindow)(Q);if(x?.force)ee.focus();else{const ce=ke();ce!==ee&&ce.document.hasFocus()&&ee.focus()}}e.$BR=Pe;const Ee=new Map;function Ae(Q){return Ee.has(Q)}e.$CR=Ae;function Ne(){return new Ie}e.$DR=Ne;class Ie{constructor(){this.d="",this.f=void 0}setStyle(x){x!==this.d&&(this.d=x,this.f?this.f.innerText=x:this.f=Ge(s.$oQ.document.head,ee=>ee.innerText=x))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ge(Q=s.$oQ.document.head,x,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",x?.(ce),Q.appendChild(ce),ee&&ee.add((0,k.$Rc)(()=>Q.removeChild(ce))),Q===s.$oQ.document.head){const Se=new Set;Ee.set(ce,Se);for(const{window:He,disposables:Oe}of(0,e.getWindows)()){if(He===s.$oQ)continue;const Ve=Oe.add(Ye(ce,Se,He));ee?.add(Ve)}}return ce}e.$ER=Ge;function nt(Q){const x=new k.$Sc;for(const[ee,ce]of Ee)x.add(Ye(ee,ce,Q));return x}e.$FR=nt;function Ye(Q,x,ee){const ce=new k.$Sc,Se=Q.cloneNode(!0);ee.document.head.appendChild(Se),ce.add((0,k.$Rc)(()=>ee.document.head.removeChild(Se)));for(const He of Le(Q))Se.sheet?.insertRule(He.cssText,Se.sheet?.cssRules.length);return ce.add(e.$GR.observe(Q,ce,{childList:!0})(()=>{Se.textContent=Q.textContent})),x.add(Se),ce.add((0,k.$Rc)(()=>x.delete(Se))),ce}e.$GR=new class{constructor(){this.mutationObservers=new Map}observe(Q,x,ee){let ce=this.mutationObservers.get(Q);ce||(ce=new Map,this.mutationObservers.set(Q,ce));const Se=(0,t.$7i)(ee);let He=ce.get(Se);if(He)He.users+=1;else{const Oe=new $.$6d,Ve=new MutationObserver(xe=>Oe.fire(xe));Ve.observe(Q,ee);const Ke=He={users:1,observer:Ve,onDidMutate:Oe.event};x.add((0,k.$Rc)(()=>{Ke.users-=1,Ke.users===0&&(Oe.dispose(),Ve.disconnect(),ce?.delete(Se),ce?.size===0&&this.mutationObservers.delete(Q))})),ce.set(Se,He)}return He.onDidMutate}};function Ue(Q=s.$oQ.document.head){return se("meta",Q)}e.$HR=Ue;function Y(Q=s.$oQ.document.head){return se("link",Q)}e.$IR=Y;function se(Q,x=s.$oQ.document.head){const ee=document.createElement(Q);return x.appendChild(ee),ee}let pe=null;function ve(){return pe||(pe=Ge()),pe}function Le(Q){return Q?.sheet?.rules?Q.sheet.rules:Q?.sheet?.cssRules?Q.sheet.cssRules:[]}function je(Q,x,ee=ve()){if(!(!ee||!x)){ee.sheet?.insertRule(`${Q} {${x}}`,0);for(const ce of Ee.get(ee)??[])je(Q,x,ce)}}e.$JR=je;function qe(Q,x=ve()){if(!x)return;const ee=Le(x),ce=[];for(let Se=0;Se<ee.length;Se++){const He=ee[Se];_e(He)&&He.selectorText.indexOf(Q)!==-1&&ce.push(Se)}for(let Se=ce.length-1;Se>=0;Se--)x.sheet?.deleteRule(ce[Se]);for(const Se of Ee.get(x)??[])qe(Q,Se)}e.$KR=qe;function _e(Q){return typeof Q.selectorText=="string"}function tt(Q){return Q instanceof MouseEvent||Q instanceof(0,e.getWindow)(Q).MouseEvent}e.$LR=tt;function st(Q){return Q instanceof KeyboardEvent||Q instanceof(0,e.getWindow)(Q).KeyboardEvent}e.$MR=st;function Ze(Q){return Q instanceof PointerEvent||Q instanceof(0,e.getWindow)(Q).PointerEvent}e.$NR=Ze;function rt(Q){return Q instanceof DragEvent||Q instanceof(0,e.getWindow)(Q).DragEvent}e.$OR=rt,e.$PR={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$CQ?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$CQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$CQ?"webkitAnimationIteration":"animationiteration"};function et(Q){const x=Q;return!!(x&&typeof x.preventDefault=="function"&&typeof x.stopPropagation=="function")}e.$QR=et,e.$RR={stop:(Q,x)=>(Q.preventDefault(),x&&Q.stopPropagation(),Q)};function gt(Q){const x=[];for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)x[ee]=Q.scrollTop,Q=Q.parentNode;return x}e.$SR=gt;function mt(Q,x){for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)Q.scrollTop!==x[ee]&&(Q.scrollTop=x[ee]),Q=Q.parentNode}e.$TR=mt;class $t extends k.$Tc{static m(x){if(x instanceof HTMLElement){const ee=O(x),ce=ee?ee.activeElement:x.ownerDocument.activeElement;return f(ce,x)}else{const ee=x;return f(ee.document.activeElement,ee.document)}}constructor(x){super(),this.f=this.B(new $.$6d),this.onDidFocus=this.f.event,this.g=this.B(new $.$6d),this.onDidBlur=this.g.event;let ee=$t.m(x),ce=!1;const Se=()=>{ce=!1,ee||(ee=!0,this.f.fire())},He=()=>{ee&&(ce=!0,(x instanceof HTMLElement?(0,e.getWindow)(x):x).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{$t.m(x)!==ee&&(ee?He():Se())},this.B(w(x,e.$PR.FOCUS,Se,!0)),this.B(w(x,e.$PR.BLUR,He,!0)),x instanceof HTMLElement&&(this.B(w(x,e.$PR.FOCUS_IN,()=>this.j())),this.B(w(x,e.$PR.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Tt(Q){return new $t(Q)}e.$UR=Tt;function Ot(Q,x){return Q.after(x),x}e.$VR=Ot;function ze(Q,...x){if(Q.append(...x),x.length===1&&typeof x[0]!="string")return x[0]}e.$WR=ze;function ue(Q,x){return Q.insertBefore(x,Q.firstChild),x}e.$XR=ue;function Te(Q,...x){Q.innerText="",ze(Q,...x)}e.$YR=Te;const Me=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Qe;(function(Q){Q.HTML="http://www.w3.org/1999/xhtml",Q.SVG="http://www.w3.org/2000/svg"})(Qe||(e.Namespace=Qe={}));function it(Q,x,ee,...ce){const Se=Me.exec(x);if(!Se)throw new Error("Bad use of emmet");const He=Se[1]||"div";let Oe;return Q!==Qe.HTML?Oe=document.createElementNS(Q,He):Oe=document.createElement(He),Se[3]&&(Oe.id=Se[3]),Se[4]&&(Oe.className=Se[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ve,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(Ve)?Oe[Ve]=Ke:Ve==="selected"?Ke&&Oe.setAttribute(Ve,"true"):Oe.setAttribute(Ve,Ke))}),Oe.append(...ce),Oe}function lt(Q,x,...ee){return it(Qe.HTML,Q,x,...ee)}e.$=lt,lt.SVG=function(Q,x,...ee){return it(Qe.SVG,Q,x,...ee)};function Xe(Q,x){const ee=[];return Q.forEach((ce,Se)=>{Se>0&&(x instanceof Node?ee.push(x.cloneNode()):ee.push(document.createTextNode(x))),ee.push(ce)}),ee}e.$1R=Xe;function ct(Q,...x){Q?pt(...x):Dt(...x)}e.$2R=ct;function pt(...Q){for(const x of Q)x.style.display="",x.removeAttribute("aria-hidden")}e.$3R=pt;function Dt(...Q){for(const x of Q)x.style.display="none",x.setAttribute("aria-hidden","true")}e.$4R=Dt;function Xt(Q,x){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q instanceof HTMLElement&&Q.hasAttribute(x))return Q;Q=Q.parentNode}return null}function Ei(Q){!Q||!Q.hasAttribute("tabIndex")||(Q.ownerDocument.activeElement===Q&&Xt(Q.parentElement,"tabIndex")?.focus(),Q.removeAttribute("tabindex"))}e.$5R=Ei;function Ai(Q){return x=>{x.preventDefault(),x.stopPropagation(),Q(x)}}e.$6R=Ai;function Si(Q){return new Promise(x=>{if(Q.document.readyState==="complete"||Q.document&&Q.document.body!==null)x(void 0);else{const ce=()=>{Q.window.removeEventListener("DOMContentLoaded",ce,!1),x()};Q.window.addEventListener("DOMContentLoaded",ce,!1)}})}e.$7R=Si;function Ti(Q,x){const ee=Q.devicePixelRatio*x;return Math.max(1,Math.floor(ee))/Q.devicePixelRatio}e.$8R=Ti;function Fi(Q){s.$oQ.open(Q,"_blank","noopener")}e.$9R=Fi;const Jt=780,Zt=640;function Ci(Q){const x=Math.floor(s.$oQ.screenLeft+s.$oQ.innerWidth/2-Jt/2),ee=Math.floor(s.$oQ.screenTop+s.$oQ.innerHeight/2-Zt/2);s.$oQ.open(Q,"_blank",`width=${Jt},height=${Zt},top=${ee},left=${x}`)}e.$0R=Ci;function Ri(Q,x=!0){const ee=s.$oQ.open();return ee?(x&&(ee.opener=null),ee.location.href=Q,!0):!1}e.$$R=Ri;function Ni(Q,x){const ee=()=>{x(),ce=(0,e.$6Q)(Q,ee)};let ce=(0,e.$6Q)(Q,ee);return(0,k.$Rc)(()=>ce.dispose())}e.$_R=Ni,B.$tg.setPreferredWebSchema(/^https:/.test(s.$oQ.location.href)?"https":"http");function Li(Q){return Q?`url('${B.$Ag.uriToBrowserUri(Q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}e.$aS=Li;function Ii(Q){return`'${Q.replace(/'/g,"%27")}'`}e.$bS=Ii;function Ut(Q,x){if(Q!==void 0){const ee=Q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(x=Ut(ce[1].trim(),x)),`var(${ce[0]}, ${x})`}return Q}return x}e.$cS=Ut;function Mi(Q,x){let ee;if(d.URI.isUri(Q))ee=Q.toString(!0);else{const He=new Blob([Q]);ee=URL.createObjectURL(He),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=ke(),Se=document.createElement("a");ce.document.body.appendChild(Se),Se.download=x,Se.href=ee,Se.click(),setTimeout(()=>ce.document.body.removeChild(Se))}e.$dS=Mi;function Pi(){return new Promise(Q=>{const x=ke(),ee=document.createElement("input");x.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,$.Event.once($.Event.fromDOMEventEmitter(ee,"input"))(()=>{Q(ee.files??void 0)}),ee.click(),setTimeout(()=>x.document.body.removeChild(ee))})}e.$eS=Pi;var yt;(function(Q){Q[Q.DOCUMENT=1]="DOCUMENT",Q[Q.BROWSER=2]="BROWSER"})(yt||(e.DetectedFullscreenMode=yt={}));function Oi(Q){return Q.document.fullscreenElement||Q.document.webkitFullscreenElement||Q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:Q.innerHeight===Q.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&Q.outerHeight===Q.screen.height&&Q.outerWidth===Q.screen.width?{mode:yt.BROWSER,guess:!0}:null}e.$fS=Oi;function _t(Q,x=!1){const ee=document.createElement("a");return b.addHook("afterSanitizeAttributes",ce=>{for(const Se of["href","src"])if(ce.hasAttribute(Se)){const He=ce.getAttribute(Se);if(Se==="href"&&He.startsWith("#"))continue;if(ee.href=He,!Q.includes(ee.protocol.replace(/:$/,""))){if(x&&Se==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(Se)}}}),(0,k.$Rc)(()=>{b.removeHook("afterSanitizeAttributes")})}e.$gS=_t;const Bi=[B.Schemas.http,B.Schemas.https,B.Schemas.command];e.$hS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Hi(Q,x){const ee=_t(Bi);try{const ce=b.sanitize(x,zi);Q.innerHTML=ce}finally{ee.dispose()}}e.$iS=Hi;function ji(Q){const x=new Uint16Array(Q.length);for(let Se=0;Se<x.length;Se++)x[Se]=Q.charCodeAt(Se);let ee="";const ce=new Uint8Array(x.buffer);for(let Se=0;Se<ce.length;Se++)ee+=String.fromCharCode(ce[Se]);return ee}function Wi(Q){return btoa(ji(Q))}e.$jS=Wi;class kt extends $.$6d{constructor(){super(),this.o=new k.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add($.Event.runAndSubscribe(e.onDidRegisterWindow,({window:x,disposables:ee})=>this.C(x,ee),{window:s.$oQ,disposables:this.o}))}C(x,ee){ee.add(w(x,"keydown",ce=>{if(ce.defaultPrevented)return;const Se=new j.$SQ(ce);if(!(Se.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),ee.add(w(x,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),ee.add(w(x.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(x.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(w(x.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(w(x,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return kt.B||(kt.B=new kt),kt.B}dispose(){super.dispose(),this.o.dispose()}}e.$kS=kt;function Vi(Q){const x=document.cookie.match("(^|[^;]+)\\s*"+Q+"\\s*=\\s*([^;]+)");return x?x.pop():void 0}e.$lS=Vi;class qi extends k.$Tc{constructor(x,ee){super(),this.j=x,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(w(this.j,e.$PR.DRAG_START,x=>{this.m.onDragStart?.(x)})),this.m.onDrag&&this.B(w(this.j,e.$PR.DRAG,x=>{this.m.onDrag?.(x)})),this.B(w(this.j,e.$PR.DRAG_ENTER,x=>{this.f++,this.g=x.timeStamp,this.m.onDragEnter?.(x)})),this.B(w(this.j,e.$PR.DRAG_OVER,x=>{x.preventDefault(),this.m.onDragOver?.(x,x.timeStamp-this.g)})),this.B(w(this.j,e.$PR.DRAG_LEAVE,x=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(x))})),this.B(w(this.j,e.$PR.DRAG_END,x=>{this.f=0,this.g=0,this.m.onDragEnd?.(x)})),this.B(w(this.j,e.$PR.DROP,x=>{this.f=0,this.g=0,this.m.onDrop?.(x)}))}}e.$mS=qi;const Qi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ki(Q,...x){let ee,ce;Array.isArray(x[0])?(ee={},ce=x[0]):(ee=x[0]||{},ce=x[1]);const Se=Qi.exec(Q);if(!Se||!Se.groups)throw new Error("Bad use of h");const He=Se.groups.tag||"div",Oe=document.createElement(He);Se.groups.id&&(Oe.id=Se.groups.id);const Ve=[];if(Se.groups.class)for(const xe of Se.groups.class.split("."))xe!==""&&Ve.push(xe);if(ee.className!==void 0)for(const xe of ee.className.split("."))xe!==""&&Ve.push(xe);Ve.length>0&&(Oe.className=Ve.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=Oe),ce)for(const xe of ce)xe instanceof HTMLElement?Oe.appendChild(xe):typeof xe=="string"?Oe.append(xe):"root"in xe&&(Object.assign(Ke,xe),Oe.appendChild(xe.root));for(const[xe,at]of Object.entries(ee))if(xe!=="className")if(xe==="style")for(const[Ft,Bt]of Object.entries(at))Oe.style.setProperty(ei(Ft),typeof Bt=="number"?Bt+"px":""+Bt);else xe==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(xe),at.toString());return Ke.root=Oe,Ke}e.h=Ki;function ei(Q){return Q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(Q,x,ee){for(const{name:ce,value:Se}of Q.attributes)(!ee||ee.includes(ce))&&x.setAttribute(ce,Se)}e.$oS=ti;function xi(Q,x,ee){const ce=Q.getAttribute(ee);ce?x.setAttribute(ee,ce):x.removeAttribute(ee)}function Gi(Q,x,ee){ti(Q,x,ee);const ce=new k.$Sc;return ce.add(e.$GR.observe(Q,ce,{attributes:!0,attributeFilter:ee})(Se=>{for(const He of Se)He.type==="attributes"&&He.attributeName&&xi(Q,x,He.attributeName)})),ce}e.$pS=Gi}),define(me[57],$e([1,0,2,3,121]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sS=e.$rS=e.$qS=void 0;class W extends R.$Tc{constructor($,b){super(),this.B((0,i.$VQ)($,"dragover",k=>{k.preventDefault(),this.a||(this.a=setTimeout(()=>{b(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(k=>{this.B((0,i.$VQ)($,k,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}e.$qS=W,e.$rS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:j.$us.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(y,$,b,k,B){const c=document.createElement("div");if(c.className=b,c.textContent=$,B&&(c.style.color=B),k&&(c.style.background=k),y.dataTransfer){const d=(0,i.getWindow)(y).document;d.body.appendChild(c),y.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>d.body.removeChild(c),0)}}e.$sS=D}),define(me[58],$e([1,0,2]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZS=e.$YS=e.$XS=void 0;function R(c,d={}){const t=W(d);return t.textContent=c,t}e.$XS=R;function j(c,d={}){const t=W(d);return $(t,b(c,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),t}e.$YS=j;function W(c){const d=c.inline?"span":"div",t=document.createElement(d);return c.className&&(t.className=c.className),t}e.$ZS=W;class D{constructor(d){this.b=d,this.c=0}eos(){return this.c>=this.b.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(y||(y={}));function $(c,d,t,s){let a;if(d.type===2)a=document.createTextNode(d.content||"");else if(d.type===3)a=document.createElement("b");else if(d.type===4)a=document.createElement("i");else if(d.type===7&&s)a=document.createElement("code");else if(d.type===5&&t){const m=document.createElement("a");t.disposables.add(i.$WQ(m,"click",p=>{t.callback(String(d.index),p)})),a=m}else d.type===8?a=document.createElement("br"):d.type===1&&(a=c);a&&c!==a&&c.appendChild(a),a&&Array.isArray(d.children)&&d.children.forEach(m=>{$(a,m,t,s)})}function b(c,d){const t={type:1,children:[]};let s=0,a=t;const m=[],p=new D(c);for(;!p.eos();){let w=p.next();const o=w==="\\"&&B(p.peek(),d)!==0;if(o&&(w=p.next()),!o&&k(w,d)&&w===p.peek()){p.advance(),a.type===2&&(a=m.pop());const g=B(w,d);if(a.type===g||a.type===5&&g===6)a=m.pop();else{const r={type:g,children:[]};g===5&&(r.index=s,s++),a.children.push(r),m.push(a),a=r}}else if(w===`
`)a.type===2&&(a=m.pop()),a.children.push({type:8});else if(a.type!==2){const g={type:2,content:w};a.children.push(g),m.push(a),a=g}else a.content+=w}return a.type===2&&(a=m.pop()),m.length,t}function k(c,d){return B(c,d)!==0}function B(c,d){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(me[59],$e([1,0,2,3]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wS=void 0;class j{constructor(){this.a=new R.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const $=this.c;this.c=null,D&&$&&$(y)}isMonitoring(){return!!this.b}startMonitoring(D,y,$,b,k){this.isMonitoring()&&this.stopMonitoring(!1),this.b=b,this.c=k;let B=D;try{D.setPointerCapture(y),this.a.add((0,R.$Rc)(()=>{try{D.releasePointerCapture(y)}catch{}}))}catch{B=i.getWindow(D)}this.a.add(i.$VQ(B,i.$PR.POINTER_MOVE,c=>{if(c.buttons!==$){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$VQ(B,i.$PR.POINTER_UP,c=>this.stopMonitoring(!0)))}}e.$wS=j});var Je=this&&this.__decorate||function(re,e,i,R){var j=arguments.length,W=j<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,i):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(re,e,i,R);else for(var y=re.length-1;y>=0;y--)(D=re[y])&&(W=(j<3?D(W):j>3?D(e,i,W):D(e,i))||W);return j>3&&W&&Object.defineProperty(e,i,W),W};define(me[26],$e([1,0,2,22,12,28,4,3,49]),function(re,e,i,R,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tS=e.EventType=void 0;var b;(function(B){B.Tap="-monaco-gesturetap",B.Change="-monaco-gesturechange",B.Start="-monaco-gesturestart",B.End="-monaco-gesturesend",B.Contextmenu="-monaco-gesturecontextmenu"})(b||(e.EventType=b={}));class k extends y.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new $.$4c,this.h=new $.$4c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:d})=>{d.add(i.$VQ(c.document,"touchstart",t=>this.s(t),{passive:!1})),d.add(i.$VQ(c.document,"touchend",t=>this.u(c,t))),d.add(i.$VQ(c.document,"touchmove",t=>this.D(t),{passive:!1}))},{window:R.$oQ,disposables:this.q}))}static addTarget(c){if(!k.isTouchDevice())return y.$Tc.None;k.b||(k.b=(0,y.$Mc)(new k));const d=k.b.g.push(c);return(0,y.$Rc)(d)}static ignoreTarget(c){if(!k.isTouchDevice())return y.$Tc.None;k.b||(k.b=(0,y.$Mc)(new k));const d=k.b.h.push(c);return(0,y.$Rc)(d)}static isTouchDevice(){return"ontouchstart"in R.$oQ||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(c){const d=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let t=0,s=c.targetTouches.length;t<s;t++){const a=c.targetTouches.item(t);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:d,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[d],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const m=this.w(b.Start,a.target);m.pageX=a.pageX,m.pageY=a.pageY,this.z(m)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}u(c,d){const t=Date.now(),s=Object.keys(this.m).length;for(let a=0,m=d.changedTouches.length;a<m;a++){const p=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(p.identifier))){console.warn("move of an UNKNOWN touch",p);continue}const w=this.m[p.identifier],o=Date.now()-w.initialTimeStamp;if(o<k.c&&Math.abs(w.initialPageX-j.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-j.$sb(w.rollingPageY))<30){const g=this.w(b.Tap,w.initialTarget);g.pageX=j.$sb(w.rollingPageX),g.pageY=j.$sb(w.rollingPageY),this.z(g)}else if(o>=k.c&&Math.abs(w.initialPageX-j.$sb(w.rollingPageX))<30&&Math.abs(w.initialPageY-j.$sb(w.rollingPageY))<30){const g=this.w(b.Contextmenu,w.initialTarget);g.pageX=j.$sb(w.rollingPageX),g.pageY=j.$sb(w.rollingPageY),this.z(g)}else if(s===1){const g=j.$sb(w.rollingPageX),r=j.$sb(w.rollingPageY),E=j.$sb(w.rollingTimestamps)-w.rollingTimestamps[0],N=g-w.rollingPageX[0],M=r-w.rollingPageY[0],P=[...this.g].filter(z=>w.initialTarget instanceof Node&&z.contains(w.initialTarget));this.C(c,P,t,Math.abs(N)/E,N>0?1:-1,g,Math.abs(M)/E,M>0?1:-1,r)}this.z(this.w(b.End,w.initialTarget)),delete this.m[p.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(c,d){const t=document.createEvent("CustomEvent");return t.initEvent(c,!1,!0),t.initialTarget=d,t.tapCount=0,t}z(c){if(c.type===b.Tap){const d=new Date().getTime();let t=0;d-this.n>k.r?t=1:t=2,this.n=d,c.tapCount=t}else(c.type===b.Change||c.type===b.Contextmenu)&&(this.n=0);if(c.initialTarget instanceof Node){for(const d of this.h)if(d.contains(c.initialTarget))return;for(const d of this.g)d.contains(c.initialTarget)&&(d.dispatchEvent(c),this.f=!0)}}C(c,d,t,s,a,m,p,w,o){this.j=i.$6Q(c,()=>{const g=Date.now(),r=g-t;let E=0,N=0,M=!0;s+=k.a*r,p+=k.a*r,s>0&&(M=!1,E=a*s*r),p>0&&(M=!1,N=w*p*r);const P=this.w(b.Change);P.translationX=E,P.translationY=N,d.forEach(z=>z.dispatchEvent(P)),M||this.C(c,d,g,s,a,m+E,p,w,o+N)})}D(c){const d=Date.now();for(let t=0,s=c.changedTouches.length;t<s;t++){const a=c.changedTouches.item(t);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const m=this.m[a.identifier],p=this.w(b.Change,m.initialTarget);p.translationX=a.pageX-j.$sb(m.rollingPageX),p.translationY=a.pageY-j.$sb(m.rollingPageY),p.pageX=a.pageX,p.pageY=a.pageY,this.z(p),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(a.pageX),m.rollingPageY.push(a.pageY),m.rollingTimestamps.push(d)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}e.$tS=k,Je([W.$Kh],k,"isTouchDevice",null)}),define(me[60],$e([1,0,2,96]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4S=e.$3S=e.$2S=void 0;const R=2e4;let j,W,D,y,$;function b(d){j=document.createElement("div"),j.className="monaco-aria-container";const t=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),j.appendChild(a),a};W=t(),D=t();const s=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),j.appendChild(a),a};y=s(),$=s(),d.appendChild(j)}e.$2S=b;function k(d){j&&(W.textContent!==d?(i.$UQ(D),c(W,d)):(i.$UQ(W),c(D,d)))}e.$3S=k;function B(d){j&&(y.textContent!==d?(i.$UQ($),c(y,d)):(i.$UQ(y),c($,d)))}e.$4S=B;function c(d,t){i.$UQ(d),t.length>R&&(t=t.substr(0,R)),d.textContent=t,d.style.visibility="hidden",d.style.visibility="visible"}}),define(me[123],$e([1,0,2,19]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=e.$uT=void 0;const j=new RegExp(`(\\\\)?\\$\\((${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(y){const $=new Array;let b,k=0,B=0;for(;(b=j.exec(y))!==null;){B=b.index||0,k<B&&$.push(y.substring(k,B)),k=(b.index||0)+b[0].length;const[,c,d]=b;$.push(c?`$(${d})`:D({id:d}))}return k<y.length&&$.push(y.substring(k)),$}e.$uT=W;function D(y){const $=i.$("span");return $.classList.add(...R.ThemeIcon.asClassNameArray(y)),$}e.$vT=D}),define(me[124],$e([1,0,2]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0S=void 0;function R(W){try{W.parentElement?.removeChild(W)}catch{}}class j{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let y=this.h(D).pop(),$=!1;if(y)$=this.b.has(y.domNode),$&&this.b.delete(y.domNode);else{const b=(0,i.$)(".monaco-list-row"),B=this.i(D).renderTemplate(b);y={domNode:b,templateId:D,templateData:B}}return{row:y,isReusingConnectedDomNode:$}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(D){const{domNode:y,templateId:$}=D;y&&(this.c?this.b.add(y):this.g(y)),this.h($).push(D)}g(D){D.classList.remove("scrolling"),R(D)}h(D){let y=this.a.get(D);return y||(y=[],this.a.set(D,y)),y}dispose(){this.a.forEach((D,y)=>{for(const $ of D)this.i(y).disposeTemplate($.templateData),$.templateData=null}),this.a.clear(),this.b.clear()}i(D){const y=this.d.get(D);if(!y)throw new Error(`No renderer found for ${D}`);return y}}e.$0S=j}),define(me[125],$e([1,0,9,3]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BS=void 0;class j extends R.$Tc{constructor(D,y,$){super(),this.a=D,this.b=y,this.c=$,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$qh)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}e.$BS=j}),define(me[126],$e([1,0,2,26,12,4,3,5]),function(re,e,i,R,j,W,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=void 0;class $ extends D.$Tc{constructor(k,B,c,d){super(),this.f=0,this.b=d||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$6d),this.h=c,this.j(),this.setOptions(k,B)}j(){this.B(R.$tS.addTarget(this.a)),[R.EventType.Tap].forEach(k=>{this.B(i.$VQ(this.a,k,B=>{this.a.focus()}))}),this.B(i.$WQ(this.a,"click",k=>{i.$RR.stop(k,!0)})),this.B(i.$WQ(this.a,"change",k=>{this.a.title=k.target.value,this.g.fire({index:k.target.selectedIndex,selected:k.target.value})})),this.B(i.$WQ(this.a,"keydown",k=>{let B=!1;y.$j?(k.keyCode===18||k.keyCode===16||k.keyCode===10)&&(B=!0):(k.keyCode===18&&k.altKey||k.keyCode===10||k.keyCode===3)&&(B=!0),B&&k.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(k,B){(!this.c||!j.$ub(this.c,k))&&(this.c=k,this.a.options.length=0,this.c.forEach((c,d)=>{this.a.add(this.m(c.text,d,c.isDisabled))})),B!==void 0&&this.select(B)}select(k){this.c.length===0?this.f=0:k>=0&&k<this.c.length?this.f=k:k>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(k){this.b.ariaLabel=k,this.a.setAttribute("aria-label",k)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(k){this.a.tabIndex=k?0:-1}render(k){k.classList.add("select-container"),k.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(k){this.h=k,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(k,B,c){const d=document.createElement("option");return d.value=k,d.text=k,d.disabled=!!c,d}}e.$CT=$}),define(me[61],$e([1,0,27,12,9,53,90,4,29]),function(re,e,i,R,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_U=e.$$U=e.$0U=void 0;function b(d){return typeof d=="object"&&"visibility"in d&&"data"in d}e.$0U=b;function k(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}e.$$U=k;function B(d){return typeof d.collapsible=="boolean"}class c{constructor(t,s,a,m={}){this.o=t,this.p=s,this.rootRef=[],this.d=new y.$be,this.f=new y.$6d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.$6d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.$6d,this.onDidSplice=this.l.event,this.m=new j.$dh(W.$3d),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:a,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,s,a=$.Iterable.empty(),m={}){if(t.length===0)throw new i.$8U(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,t,s,a,m):this.s(t,s,a,m)}q(t,s,a,m=$.Iterable.empty(),p,w=p.diffDepth??0){const{parentNode:o}=this.G(s);if(!o.lastDiffIds)return this.s(s,a,m,p);const g=[...m],r=s[s.length-1],E=new D.$dt({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,r),...g,...o.children.slice(r+a)].map(v=>t.getId(v.element).toString())}).ComputeDiff(!1);if(E.quitEarly)return o.lastDiffIds=void 0,this.s(s,a,g,p);const N=s.slice(0,-1),M=(v,H,V)=>{if(w>0)for(let T=0;T<V;T++)v--,H--,this.q(t,[...N,v,0],Number.MAX_SAFE_INTEGER,g[H].children,p,w-1)};let P=Math.min(o.children.length,r+a),z=g.length;for(const v of E.changes.sort((H,V)=>V.originalStart-H.originalStart))M(P,z,P-(v.originalStart+v.originalLength)),P=v.originalStart,z=v.modifiedStart-r,this.s([...N,P],v.originalLength,$.Iterable.slice(g,z,z+v.modifiedLength),p);M(P,z,P)}s(t,s,a=$.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:p,diffIdentityProvider:w}){const{parentNode:o,listIndex:g,revealed:r,visible:E}=this.G(t),N=[],M=$.Iterable.map(a,X=>this.w(X,o,o.visible?1:0,r,N,m)),P=t[t.length-1];let z=0;for(let X=P;X>=0&&X<o.children.length;X--){const U=o.children[X];if(U.visible){z=U.visibleChildIndex;break}}const v=[];let H=0,V=0;for(const X of M)v.push(X),V+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=z+H++);const T=(0,R.$6b)(o.children,P,s,v);w?o.lastDiffIds?(0,R.$6b)(o.lastDiffIds,P,s,v.map(X=>w.getId(X.element).toString())):o.lastDiffIds=o.children.map(X=>w.getId(X.element).toString()):o.lastDiffIds=void 0;let L=0;for(const X of T)X.visible&&L++;if(L!==0)for(let X=P+v.length;X<o.children.length;X++){const U=o.children[X];U.visible&&(U.visibleChildIndex-=L)}if(o.visibleChildrenCount+=H-L,r&&E){const X=T.reduce((U,de)=>U+(de.visible?de.renderNodeCount:0),0);this.B(o,V-X),this.p.splice(g,X,N)}if(T.length>0&&p){const X=U=>{p(U),U.children.forEach(X)};T.forEach(X)}this.l.fire({insertedNodes:v,deletedNodes:T});let I=o;for(;I;){if(I.visibility===2){this.m.trigger(()=>this.refilter());break}I=I.parent}}rerender(t){if(t.length===0)throw new i.$8U(this.o,"Invalid tree location");const{node:s,listIndex:a,revealed:m}=this.F(t);s.visible&&m&&this.p.splice(a,1,[s])}updateElementHeight(t,s){if(t.length===0)throw new i.$8U(this.o,"Invalid tree location");const{listIndex:a}=this.F(t);this.p.updateElementHeight(a,s)}has(t){return this.D(t)}getListIndex(t){const{listIndex:s,visible:a,revealed:m}=this.F(t);return a&&m?s:-1}getListRenderCount(t){return this.E(t).renderNodeCount}isCollapsible(t){return this.E(t).collapsible}setCollapsible(t,s){const a=this.E(t);typeof s>"u"&&(s=!a.collapsible);const m={collapsible:s};return this.d.bufferEvents(()=>this.t(t,m))}isCollapsed(t){return this.E(t).collapsed}setCollapsed(t,s,a){const m=this.E(t);typeof s>"u"&&(s=!m.collapsed);const p={collapsed:s,recursive:a||!1};return this.d.bufferEvents(()=>this.t(t,p))}t(t,s){const{node:a,listIndex:m,revealed:p}=this.F(t),w=this.u(a,m,p,s);if(a!==this.c&&this.k&&w&&!B(s)&&a.collapsible&&!a.collapsed&&!s.recursive){let o=-1;for(let g=0;g<a.children.length;g++)if(a.children[g].visible)if(o>-1){o=-1;break}else o=g;o>-1&&this.t([...t,o],s)}return w}u(t,s,a,m){const p=this.v(t,m,!1);if(!a||!t.visible||!p)return p;const w=t.renderNodeCount,o=this.x(t),g=w-(s===-1?0:1);return this.p.splice(s+1,g,o.slice(1)),p}v(t,s,a){let m;if(t===this.c?m=!1:(B(s)?(m=t.collapsible!==s.collapsible,t.collapsible=s.collapsible):t.collapsible?(m=t.collapsed!==s.collapsed,t.collapsed=s.collapsed):m=!1,m&&this.f.fire({node:t,deep:a})),!B(s)&&s.recursive)for(const p of t.children)m=this.v(p,s,!0)||m;return m}expandTo(t){this.d.bufferEvents(()=>{let s=this.E(t);for(;s.parent;)s=s.parent,t=t.slice(0,t.length-1),s.collapsed&&this.t(t,{collapsed:!1,recursive:!1})})}refilter(){const t=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,t,s),this.m.cancel()}w(t,s,a,m,p,w){const o={parent:s,element:t.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof t.collapsible=="boolean"?t.collapsible:typeof t.collapsed<"u",collapsed:typeof t.collapsed>"u"?this.h:t.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this.C(o,a);o.visibility=g,m&&p.push(o);const r=t.children||$.Iterable.empty(),E=m&&g!==0&&!o.collapsed;let N=0,M=1;for(const P of r){const z=this.w(P,o,g,E,p,w);o.children.push(z),M+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=N++)}return o.collapsible=o.collapsible||o.children.length>0,o.visibleChildrenCount=N,o.visible=g===2?N>0:g===1,o.visible?o.collapsed||(o.renderNodeCount=M):(o.renderNodeCount=0,m&&p.pop()),w?.(o),o}x(t){const s=t.renderNodeCount,a=[];return this.y(t,a),this.B(t.parent,a.length-s),a}y(t,s){if(t.visible===!1)return 0;if(s.push(t),t.renderNodeCount=1,!t.collapsed)for(const a of t.children)t.renderNodeCount+=this.y(a,s);return this.g.fire(t),t.renderNodeCount}z(t){const s=t.renderNodeCount,a=[];return this.A(t,t.visible?1:0,a),this.B(t.parent,a.length-s),a}A(t,s,a,m=!0){let p;if(t!==this.c){if(p=this.C(t,s),p===0)return t.visible=!1,t.renderNodeCount=0,!1;m&&a.push(t)}const w=a.length;t.renderNodeCount=t===this.c?0:1;let o=!1;if(!t.collapsed||p!==0){let g=0;for(const r of t.children)o=this.A(r,p,a,m&&!t.collapsed)||o,r.visible&&(r.visibleChildIndex=g++);t.visibleChildrenCount=g}else t.visibleChildrenCount=0;return t!==this.c&&(t.visible=p===2?o:p===1,t.visibility=p),t.visible?t.collapsed||(t.renderNodeCount+=a.length-w):(t.renderNodeCount=0,m&&a.pop()),this.g.fire(t),t.visible}B(t,s){if(s!==0)for(;t;)t.renderNodeCount+=s,this.g.fire(t),t=t.parent}C(t,s){const a=this.j?this.j.filter(t.element,s):1;return typeof a=="boolean"?(t.filterData=void 0,a?1:0):b(a)?(t.filterData=a.data,k(a.visibility)):(t.filterData=void 0,k(a))}D(t,s=this.c){if(!t||t.length===0)return!0;const[a,...m]=t;return a<0||a>s.children.length?!1:this.D(m,s.children[a])}E(t,s=this.c){if(!t||t.length===0)return s;const[a,...m]=t;if(a<0||a>s.children.length)throw new i.$8U(this.o,"Invalid tree location");return this.E(m,s.children[a])}F(t){if(t.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:a,revealed:m,visible:p}=this.G(t),w=t[t.length-1];if(w<0||w>s.children.length)throw new i.$8U(this.o,"Invalid tree location");const o=s.children[w];return{node:o,listIndex:a,revealed:m,visible:p&&o.visible}}G(t,s=this.c,a=0,m=!0,p=!0){const[w,...o]=t;if(w<0||w>s.children.length)throw new i.$8U(this.o,"Invalid tree location");for(let g=0;g<w;g++)a+=s.children[g].renderNodeCount;return m=m&&!s.collapsed,p=p&&s.visible,o.length===0?{parentNode:s,listIndex:a,revealed:m,visible:p}:this.G(o,s.children[w],a+1,m,p)}getNode(t=[]){return this.E(t)}getNodeLocation(t){const s=[];let a=t;for(;a.parent;)s.push(a.parent.children.indexOf(a)),a=a.parent;return s.reverse()}getParentNodeLocation(t){if(t.length!==0)return t.length===1?[]:(0,R.$tb)(t)[0]}getFirstElementChild(t){const s=this.E(t);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(t=[]){const s=this.E(t);if(s.children.length!==0)return this.H(s)}H(t){return t.children.length===0?t.element:this.H(t.children[t.children.length-1])}}e.$_U=c}),define(me[127],$e([1,0,61,27,29]),function(re,e,i,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gV=void 0;class W{get size(){return this.d.size}constructor(y,$,b={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$_U(y,$,null,b),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,b.sorter&&(this.j={compare(k,B){return b.sorter.compare(k.element,B.element)}}),this.h=b.identityProvider}setChildren(y,$=j.Iterable.empty(),b={}){const k=this.o(y);this.l(k,this.m($),b)}l(y,$=j.Iterable.empty(),b){const k=new Set,B=new Set,c=t=>{if(t.element===null)return;const s=t;if(k.add(s.element),this.d.set(s.element,s),this.h){const a=this.h.getId(s.element).toString();B.add(a),this.f.set(a,s)}b.onDidCreateNode?.(s)},d=t=>{if(t.element===null)return;const s=t;if(k.has(s.element)||this.d.delete(s.element),this.h){const a=this.h.getId(s.element).toString();B.has(a)||this.f.delete(a)}b.onDidDeleteNode?.(s)};this.c.splice([...y,0],Number.MAX_VALUE,$,{...b,onDidCreateNode:c,onDidDeleteNode:d})}m(y=j.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),j.Iterable.map(y,$=>{let b=this.d.get($.element);if(!b&&this.h){const c=this.h.getId($.element).toString();b=this.f.get(c)}if(!b){let c;return typeof $.collapsed>"u"?c=void 0:$.collapsed===R.ObjectTreeElementCollapseState.Collapsed||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:$.collapsed===R.ObjectTreeElementCollapseState.Expanded||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!$.collapsed,{...$,children:this.m($.children),collapsed:c}}const k=typeof $.collapsible=="boolean"?$.collapsible:b.collapsible;let B;return typeof $.collapsed>"u"||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrCollapsed||$.collapsed===R.ObjectTreeElementCollapseState.PreserveOrExpanded?B=b.collapsed:$.collapsed===R.ObjectTreeElementCollapseState.Collapsed?B=!0:$.collapsed===R.ObjectTreeElementCollapseState.Expanded?B=!1:B=!!$.collapsed,{...$,collapsible:k,collapsed:B,children:this.m($.children)}})}rerender(y){const $=this.o(y);this.c.rerender($)}updateElementHeight(y,$){const b=this.o(y);this.c.updateElementHeight(b,$)}resort(y=null,$=!0){if(!this.j)return;const b=this.o(y),k=this.c.getNode(b);this.l(b,this.n(k,$),{})}n(y,$,b=!0){let k=[...y.children];return($||b)&&(k=k.sort(this.j.compare.bind(this.j))),j.Iterable.map(k,B=>({element:B.element,collapsible:B.collapsible,collapsed:B.collapsed,children:this.n(B,$,!1)}))}getFirstElementChild(y=null){const $=this.o(y);return this.c.getFirstElementChild($)}getLastElementAncestor(y=null){const $=this.o(y);return this.c.getLastElementAncestor($)}has(y){return this.d.has(y)}getListIndex(y){const $=this.o(y);return this.c.getListIndex($)}getListRenderCount(y){const $=this.o(y);return this.c.getListRenderCount($)}isCollapsible(y){const $=this.o(y);return this.c.isCollapsible($)}setCollapsible(y,$){const b=this.o(y);return this.c.setCollapsible(b,$)}isCollapsed(y){const $=this.o(y);return this.c.isCollapsed($)}setCollapsed(y,$,b){const k=this.o(y);return this.c.setCollapsed(k,$,b)}expandTo(y){const $=this.o(y);this.c.expandTo($)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const $=this.d.get(y);if(!$)throw new R.$8U(this.k,`Tree element not found: ${y}`);return $}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new R.$8U(this.k,"Invalid getParentNodeLocation call");const $=this.d.get(y);if(!$)throw new R.$8U(this.k,`Tree element not found: ${y}`);const b=this.c.getNodeLocation($),k=this.c.getParentNodeLocation(b);return this.c.getNode(k).element}o(y){if(y===null)return[];const $=this.d.get(y);if(!$)throw new R.$8U(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation($)}}e.$gV=W}),define(me[21],$e([1,0,2,15,20,26,3]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=void 0;class y extends D.$Tc{f(b,k){this.B(i.$VQ(b,i.$PR.CLICK,B=>k(new j.$NQ(i.getWindow(b),B))))}j(b,k){this.B(i.$VQ(b,i.$PR.MOUSE_DOWN,B=>k(new j.$NQ(i.getWindow(b),B))))}m(b,k){this.B(i.$VQ(b,i.$PR.MOUSE_OVER,B=>k(new j.$NQ(i.getWindow(b),B))))}u(b,k){this.B(i.$VQ(b,i.$PR.MOUSE_LEAVE,B=>k(new j.$NQ(i.getWindow(b),B))))}z(b,k){this.B(i.$VQ(b,i.$PR.KEY_DOWN,B=>k(new R.$SQ(B))))}C(b,k){this.B(i.$VQ(b,i.$PR.KEY_UP,B=>k(new R.$SQ(B))))}D(b,k){this.B(i.$VQ(b,i.$PR.INPUT,k))}F(b,k){this.B(i.$VQ(b,i.$PR.BLUR,k))}G(b,k){this.B(i.$VQ(b,i.$PR.FOCUS,k))}H(b,k){this.B(i.$VQ(b,i.$PR.CHANGE,k))}I(b){return W.$tS.ignoreTarget(b)}}e.$xS=y}),define(me[42],$e([1,0,59,21,9,19,2]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zS=e.$yS=void 0,e.$yS=11;class y extends R.$xS{constructor(b){super(),this.a=b.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=b.bgWidth+"px",this.bgDomNode.style.height=b.bgHeight+"px",typeof b.top<"u"&&(this.bgDomNode.style.top="0px"),typeof b.left<"u"&&(this.bgDomNode.style.left="0px"),typeof b.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof b.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=b.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(b.icon)),this.domNode.style.position="absolute",this.domNode.style.width=e.$yS+"px",this.domNode.style.height=e.$yS+"px",typeof b.top<"u"&&(this.domNode.style.top=b.top+"px"),typeof b.left<"u"&&(this.domNode.style.left=b.left+"px"),typeof b.bottom<"u"&&(this.domNode.style.bottom=b.bottom+"px"),typeof b.right<"u"&&(this.domNode.style.right=b.right+"px"),this.g=this.B(new i.$wS),this.B(D.$WQ(this.bgDomNode,D.$PR.POINTER_DOWN,k=>this.h(k))),this.B(D.$WQ(this.domNode,D.$PR.POINTER_DOWN,k=>this.h(k))),this.b=this.B(new D.$8Q),this.c=this.B(new j.$qh)}h(b){if(!b.target||!(b.target instanceof Element))return;const k=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,D.getWindow(b))};this.a(),this.b.cancel(),this.c.cancelAndSet(k,200),this.g.startMonitoring(b.target,b.pointerId,b.buttons,B=>{},()=>{this.b.cancel(),this.c.cancel()}),b.preventDefault()}}e.$zS=y}),define(me[62],$e([1,0,2,45,59,42,125,21,5]),function(re,e,i,R,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CS=void 0;const b=140;class k extends y.$xS{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new D.$BS(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new j.$wS),this.s=!0,this.domNode=(0,R.$vS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$VQ(this.domNode.domNode,i.$PR.POINTER_DOWN,d=>this.M(d)))}t(c){const d=this.B(new W.$zS(c));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}w(c,d,t,s){this.slider=(0,R.$vS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(d),typeof t=="number"&&this.slider.setWidth(t),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$VQ(this.slider.domNode,i.$PR.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.O(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const d=this.domNode.domNode.getClientRects()[0].top,t=d+this.h.getSliderPosition(),s=d+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.U(c);t<=a&&a<=s?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let d,t;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")d=c.offsetX,t=c.offsetY;else{const a=i.$fR(this.domNode.domNode);d=c.pageX-a.left,t=c.pageY-a.top}const s=this.S(d,t);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const d=this.U(c),t=this.W(c),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,a=>{const m=this.W(a),p=Math.abs(m-t);if($.$i&&p>b){this.P(s.getScrollPosition());return}const o=this.U(a)-d;this.P(s.getDesiredScrollPositionFromDelta(o))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const d={};this.writeScrollPosition(d,c),this.b.setScrollPositionNow(d)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}e.$CS=k}),define(me[128],$e([1,0,20,62,42,46,18]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DS=void 0;class y extends R.$CS{constructor(b,k,B){const c=b.getScrollDimensions(),d=b.getCurrentScrollPosition();if(super({lazyRender:k.lazyRender,host:B,scrollbarState:new W.$AS(k.horizontalHasArrows?k.arrowSize:0,k.horizontal===2?0:k.horizontalScrollbarSize,k.vertical===2?0:k.verticalScrollbarSize,c.width,c.scrollWidth,d.scrollLeft),visibility:k.horizontal,extraScrollbarClassName:"horizontal",scrollable:b,scrollByPage:k.scrollByPage}),k.horizontalHasArrows){const t=(k.arrowSize-j.$yS)/2,s=(k.horizontalScrollbarSize-j.$yS)/2;this.t({className:"scra",icon:D.$pk.scrollbarButtonLeft,top:s,left:t,bottom:void 0,right:void 0,bgWidth:k.arrowSize,bgHeight:k.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$PQ(null,1,0))}),this.t({className:"scra",icon:D.$pk.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:t,bgWidth:k.arrowSize,bgHeight:k.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$PQ(null,-1,0))})}this.w(Math.floor((k.horizontalScrollbarSize-k.horizontalSliderSize)/2),0,void 0,k.horizontalSliderSize)}R(b,k){this.slider.setWidth(b),this.slider.setLeft(k)}Q(b,k){this.domNode.setWidth(b),this.domNode.setHeight(k),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(b){return this.s=this.J(b.scrollWidth)||this.s,this.s=this.L(b.scrollLeft)||this.s,this.s=this.y(b.width)||this.s,this.s}S(b,k){return b}U(b){return b.pageX}W(b){return b.pageY}X(b){this.slider.setHeight(b)}writeScrollPosition(b,k){b.scrollLeft=k}updateOptions(b){this.updateScrollbarSize(b.horizontal===2?0:b.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.n.setVisibility(b.horizontal),this.c=b.scrollByPage}}e.$DS=y}),define(me[129],$e([1,0,20,62,42,46,18]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ES=void 0;class y extends R.$CS{constructor(b,k,B){const c=b.getScrollDimensions(),d=b.getCurrentScrollPosition();if(super({lazyRender:k.lazyRender,host:B,scrollbarState:new W.$AS(k.verticalHasArrows?k.arrowSize:0,k.vertical===2?0:k.verticalScrollbarSize,0,c.height,c.scrollHeight,d.scrollTop),visibility:k.vertical,extraScrollbarClassName:"vertical",scrollable:b,scrollByPage:k.scrollByPage}),k.verticalHasArrows){const t=(k.arrowSize-j.$yS)/2,s=(k.verticalScrollbarSize-j.$yS)/2;this.t({className:"scra",icon:D.$pk.scrollbarButtonUp,top:t,left:s,bottom:void 0,right:void 0,bgWidth:k.verticalScrollbarSize,bgHeight:k.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$PQ(null,0,1))}),this.t({className:"scra",icon:D.$pk.scrollbarButtonDown,top:void 0,left:s,bottom:t,right:void 0,bgWidth:k.verticalScrollbarSize,bgHeight:k.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$PQ(null,0,-1))})}this.w(0,Math.floor((k.verticalScrollbarSize-k.verticalSliderSize)/2),k.verticalSliderSize,void 0)}R(b,k){this.slider.setHeight(b),this.slider.setTop(k)}Q(b,k){this.domNode.setWidth(k),this.domNode.setHeight(b),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(b){return this.s=this.J(b.scrollHeight)||this.s,this.s=this.L(b.scrollTop)||this.s,this.s=this.y(b.height)||this.s,this.s}S(b,k){return k}U(b){return b.pageY}W(b){return b.pageX}X(b){this.slider.setWidth(b)}writeScrollPosition(b,k){b.scrollTop=k}updateOptions(b){this.updateScrollbarSize(b.vertical===2?0:b.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(b.vertical),this.c=b.scrollByPage}}e.$ES=y}),define(me[63],$e([1,0,17,2,45,20,128,129,21,9,4,3,5,51,103]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JS=e.$IS=e.$HS=e.$GS=e.$FS=void 0;const t=500,s=50,a=!0;class m{constructor(M,P,z){this.timestamp=M,this.deltaX=P,this.deltaY=z,this.score=0}}class p{static{this.INSTANCE=new p}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let M=1,P=0,z=1,v=this.d;do{const H=v===this.c?M:Math.pow(2,-z);if(M-=H,P+=this.b[v].score*H,v===this.c)break;v=(this.a+v-1)%this.a,z++}while(!0);return P<=.5}acceptStandardWheelEvent(M){if(i.$DQ){const P=R.getWindow(M.browserEvent),z=(0,i.$wQ)(P);this.accept(Date.now(),M.deltaX*z,M.deltaY*z)}else this.accept(Date.now(),M.deltaX,M.deltaY)}accept(M,P,z){const v=new m(M,P,z);v.score=this.f(v),this.c===-1&&this.d===-1?(this.b[0]=v,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=v)}f(M){if(Math.abs(M.deltaX)>0&&Math.abs(M.deltaY)>0)return 1;let P=.5;const z=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(M.deltaX)||!this.g(M.deltaY))&&(P+=.25),Math.min(Math.max(P,0),1)}g(M){return Math.abs(Math.round(M)-M)<.01}}e.$FS=p;class w extends $.$xS{get options(){return this.a}constructor(M,P,z){super(),this.O=this.B(new k.$6d),this.onScroll=this.O.event,this.P=this.B(new k.$6d),this.onWillScroll=this.P.event,M.style.overflow="hidden",this.a=E(P),this.b=z,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const v={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new y.$ES(this.b,this.a,v)),this.g=this.B(new D.$DS(this.b,this.a,v)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(M),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,j.$vS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,j.$vS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,j.$vS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new b.$qh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,B.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(M){this.c.delegatePointerDown(M)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(M){this.b.setScrollDimensions(M,!1)}updateClassName(M){this.a.className=M,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(M){typeof M.handleMouseWheel<"u"&&(this.a.handleMouseWheel=M.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof M.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=M.mouseWheelScrollSensitivity),typeof M.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=M.fastScrollSensitivity),typeof M.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=M.scrollPredominantAxis),typeof M.horizontal<"u"&&(this.a.horizontal=M.horizontal),typeof M.vertical<"u"&&(this.a.vertical=M.vertical),typeof M.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=M.horizontalScrollbarSize),typeof M.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=M.verticalScrollbarSize),typeof M.scrollByPage<"u"&&(this.a.scrollByPage=M.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(M){this.N=M}delegateScrollFromMouseWheelEvent(M){this.R(new W.$PQ(M))}Q(M){if(this.w.length>0!==M&&(this.w=(0,B.$Oc)(this.w),M)){const z=v=>{this.R(new W.$PQ(v))};this.w.push(R.$VQ(this.t,R.$PR.MOUSE_WHEEL,z,{passive:!1}))}}R(M){if(M.browserEvent?.defaultPrevented)return;const P=p.INSTANCE;a&&P.acceptStandardWheelEvent(M);let z=!1;if(M.deltaY||M.deltaX){let H=M.deltaY*this.a.mouseWheelScrollSensitivity,V=M.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+H===0?V=H=0:Math.abs(H)>=Math.abs(V)?V=0:H=0),this.a.flipAxes&&([H,V]=[V,H]);const T=!c.$j&&M.browserEvent&&M.browserEvent.shiftKey;(this.a.scrollYToX||T)&&!V&&(V=H,H=0),M.browserEvent&&M.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let I={};if(H){const X=s*H,U=L.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(I,U)}if(V){const X=s*V,U=L.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(I,U)}I=this.b.validateScrollPosition(I),(L.scrollLeft!==I.scrollLeft||L.scrollTop!==I.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&P.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(I):this.b.setScrollPositionNow(I),z=!0)}let v=z;!v&&this.a.alwaysConsumeMouseWheel&&(v=!0),!v&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(v=!0),v&&(M.preventDefault(),M.stopPropagation())}S(M){this.M=this.g.onDidScroll(M)||this.M,this.M=this.c.onDidScroll(M)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const M=this.b.getCurrentScrollPosition(),P=M.scrollTop>0,z=M.scrollLeft>0,v=z?" left":"",H=P?" top":"",V=z||P?" top-left-corner":"";this.n.setClassName(`shadow${v}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${V}${H}${v}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(M){this.J=!1,this.ab()}Z(M){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),t)}}e.$GS=w;class o extends w{constructor(M,P){P=P||{},P.mouseWheelSmoothScroll=!1;const z=new d.$As({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>R.$6Q(R.getWindow(M),v)});super(M,P,z),this.B(z)}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$HS=o;class g extends w{constructor(M,P,z){super(M,P,z)}setScrollPosition(M){M.reuseAnimation?this.b.setScrollPositionSmooth(M,M.reuseAnimation):this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$IS=g;class r extends w{constructor(M,P){P=P||{},P.mouseWheelSmoothScroll=!1;const z=new d.$As({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>R.$6Q(R.getWindow(M),v)});super(M,P,z),this.B(z),this.cb=M,this.B(this.onScroll(v=>{v.scrollTopChanged&&(this.cb.scrollTop=v.scrollTop),v.scrollLeftChanged&&(this.cb.scrollLeft=v.scrollLeft)})),this.scanDomNode()}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}e.$JS=r;function E(N){const M={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return M.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:M.horizontalScrollbarSize,M.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:M.verticalScrollbarSize,c.$j&&(M.className+=" mac"),M}}),define(me[64],$e([1,0,57,2,24,26,63,12,9,28,4,3,50,51,86,124,6,35]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bT=e.$aT=e.$_S=e.$$S=e.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var w;(function(z){z[z.TOP=0]="TOP",z[z.CENTER_TOP=1]="CENTER_TOP",z[z.CENTER_BOTTOM=2]="CENTER_BOTTOM",z[z.BOTTOM=3]="BOTTOM"})(w||(e.ListViewTargetSector=w={}));const o={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(z){return[z]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}e.$$S=g;class r{constructor(v){this.elements=v}update(){}getData(){return this.elements}}e.$_S=r;class E{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let H=0;H<v.files.length;H++){const V=v.files.item(H);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}e.$aT=E;function N(z,v){return Array.isArray(z)&&Array.isArray(v)?(0,y.$ub)(z,v):z===v}class M{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(H,V,T)=>T,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(H,V)=>V+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=H=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=H=>{}}}class P{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const H of this.d)this.ab(H);this.X(),this.q.setScrollDimensions({width:(0,R.$iR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,H,V,T=o){if(this.R=H,this.domId=`list_id_${++P.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new $.$dh(50),this.v=!1,this.x=B.$Tc.None,this.y=0,this.G=!1,this.K=B.$Tc.None,this.L=B.$Tc.None,this.M=new B.$Sc,this.N=new k.$6d,this.O=new k.$6d,this.onDidChangeContentHeight=k.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=k.Event.latch(this.O.event,void 0,this.M),this.P=!1,T.horizontalScrolling&&T.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(T.paddingTop??0);for(const I of V)this.j.set(I.templateId,I);this.h=this.M.add(new s.$0S(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof T.mouseSupport=="boolean"?T.mouseSupport:!0),this.P=T.horizontalScrolling??o.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof T.paddingBottom>"u"?0:T.paddingBottom,this.D=new M(T.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(T.transformOptimization??o.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$tS.addTarget(this.o)),this.p=this.M.add(new d.$As({forceIntegerValues:!0,smoothScrollDuration:T.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,R.$6Q)((0,R.getWindow)(this.domNode),I)})),this.q=this.M.add(new D.$IS(this.o,{alwaysConsumeMouseWheel:T.alwaysConsumeMouseWheel??o.alwaysConsumeMouseWheel,horizontal:1,vertical:T.verticalScrollMode??o.verticalScrollMode,useShadows:T.useShadows??o.useShadows,mouseWheelScrollSensitivity:T.mouseWheelScrollSensitivity,fastScrollSensitivity:T.fastScrollSensitivity,scrollByPage:T.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,R.$VQ)(this.o,W.EventType.Change,I=>this.jb(I))),this.M.add((0,R.$VQ)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.M.add((0,R.$VQ)(this.domNode,"dragover",I=>this.lb(this.hb(I)))),this.M.add((0,R.$VQ)(this.domNode,"drop",I=>this.nb(this.hb(I)))),this.M.add((0,R.$VQ)(this.domNode,"dragleave",I=>this.mb(this.hb(I)))),this.M.add((0,R.$VQ)(this.domNode,"dragend",I=>this.ob(I))),this.z=T.setRowLineHeight??o.setRowLineHeight,this.A=T.setRowHeight??o.setRowHeight,this.B=T.supportDynamicHeights??o.supportDynamicHeights,this.F=T.dnd??this.M.add(o.dnd),this.layout(T.initialSize?.height,T.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let H;if(v.scrollByPage!==void 0&&(H={...H??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(H={...H??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(H={...H??{},fastScrollSensitivity:v.fastScrollSensitivity}),H&&this.q.updateOptions(H),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),T=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.Y(V,Math.max(0,this.k+T),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,H,V){if(v<0||v>=this.d.length)return;const T=this.d[v].size;if(typeof H>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,H=T+this.xb(v)}if(T===H)return;const L=this.vb(this.k,this.m);let I=0;v<L.start||V!==null&&V>v&&V<L.end?I=H-T:I=0,this.g.splice(v,1,[{size:H}]),this.d[v].size=H,this.Y(L,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(v){return new t.$9S(v)}splice(v,H,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(v,H,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(v,H,V=[]){const T=this.vb(this.k,this.m),L={start:v,end:v+H},I=c.Range.intersect(T,L),X=new Map;for(let G=I.end-1;G>=I.start;G--){const ie=this.d[G];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let fe=X.get(ie.templateId);fe||(fe=[],X.set(ie.templateId,fe));const De=this.j.get(ie.templateId);De&&De.disposeElement&&De.disposeElement(ie.element,G,ie.row.templateData,ie.size),fe.push(ie.row)}ie.row=null,ie.stale=!0}const U={start:v+H,end:this.d.length},de=c.Range.intersect(U,T),he=c.Range.relativeComplement(U,T),ne=V.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:B.$Tc.None,checkedDisposable:B.$Tc.None,stale:!1}));let ge;v===0&&H>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ne),ge=this.d,this.d=ne):(this.g.splice(v,H,ne),ge=this.d.splice(v,H,...ne));const Ce=V.length-H,Re=this.vb(this.k,this.m),Be=(0,t.$7S)(de,Ce),le=c.Range.intersect(Re,Be);for(let G=le.start;G<le.end;G++)this.bb(this.d[G],G);const _=c.Range.relativeComplement(Be,Re);for(const G of _)for(let ie=G.start;ie<G.end;ie++)this.db(ie);const ae=he.map(G=>(0,t.$7S)(G,Ce)),J=[{start:v,end:v+V.length},...ae].map(G=>c.Range.intersect(Re,G)).reverse();for(const G of J)for(let ie=G.end-1;ie>=G.start;ie--){const fe=this.d[ie],Fe=X.get(fe.templateId)?.pop();this.Z(ie,Fe)}for(const G of X.values())for(const ie of G)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(G=>G.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,R.$6Q)((0,R.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let v=0;for(const H of this.d)typeof H.width<"u"&&(v=Math.max(v,H.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const H=this.d[v];this.ab(H),typeof H.width<"u"&&H.width>this.E&&(this.E=H.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,H=this.g.positionAt(v),V=this.g.positionAt(v+1);return V!==-1&&(V-H)/2+H<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(H=>H.element===v)}domElement(v){const H=this.d[v].row;return H&&H.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,H){const V={height:typeof v=="number"?v:(0,R.$kR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof H<"u"&&(this.n=H,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof H=="number"?H:(0,R.$iR)(this.domNode)})}Y(v,H,V,T,L,I=!1){const X=this.vb(H,V),U=c.Range.relativeComplement(X,v).reverse(),de=c.Range.relativeComplement(v,X);if(I){const he=c.Range.intersect(v,X);for(let ne=he.start;ne<he.end;ne++)this.bb(this.d[ne],ne)}this.h.transact(()=>{for(const he of de)for(let ne=he.start;ne<he.end;ne++)this.db(ne);for(const he of U)for(let ne=he.end-1;ne>=he.start;ne--)this.Z(ne)}),T!==void 0&&(this.o.style.left=`-${T}px`),this.o.style.top=`-${H}px`,this.Q&&L!==void 0&&(this.o.style.width=`${Math.max(L,this.n)}px`),this.k=H,this.m=V}Z(v,H){const V=this.d[v];if(!V.row)if(H)V.row=H,V.stale=!0;else{const U=this.h.alloc(V.templateId);V.row=U.row,V.stale||=U.isReusingConnectedDomNode}const T=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",T);const L=this.D.isChecked(V.element);if(typeof L=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!L));else if(L){const U=de=>V.row.domNode.setAttribute("aria-checked",String(!!de));U(L.value),V.checkedDisposable=L.onDidChange(U)}if(V.stale||!V.row.domNode.parentElement){const U=this.d.at(v+1)?.row?.domNode??null;this.o.insertBefore(V.row.domNode,U),V.stale=!1}this.bb(V,v);const I=this.j.get(V.templateId);if(!I)throw new Error(`No renderer found for template id ${V.templateId}`);I?.renderElement(V.element,v,V.row.templateData,V.size);const X=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!X,X&&(V.dragStartDisposable=(0,R.$VQ)(V.row.domNode,"dragstart",U=>this.kb(V.element,X,U))),this.Q&&(this.ab(V),this.W())}ab(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,R.$iR)(v.row.domNode);const H=(0,R.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);H.paddingLeft&&(v.width+=parseFloat(H.paddingLeft)),H.paddingRight&&(v.width+=parseFloat(H.paddingRight)),v.row.domNode.style.width=""}bb(v,H){v.row.domNode.style.top=`${this.elementTop(H)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${H}`),v.row.domNode.setAttribute("data-last-element",H===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",H%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,H,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,H))),v.row.domNode.setAttribute("id",this.getElementDomId(H)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}db(v){const H=this.d[v];if(H.dragStartDisposable.dispose(),H.checkedDisposable.dispose(),H.row){const V=this.j.get(H.templateId);V&&V.disposeElement&&V.disposeElement(H.element,v,H.row.templateData,H.size),this.h.release(H.row),H.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,H){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:H})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"click")).event,v=>this.eb(v),this.M)}get onMouseDblClick(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"dblclick")).event,v=>this.eb(v),this.M)}get onMouseMiddleClick(){return k.Event.filter(k.Event.map(this.M.add(new j.$1S(this.domNode,"auxclick")).event,v=>this.eb(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"mouseup")).event,v=>this.eb(v),this.M)}get onMouseDown(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"mousedown")).event,v=>this.eb(v),this.M)}get onMouseOver(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"mouseover")).event,v=>this.eb(v),this.M)}get onMouseMove(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"mousemove")).event,v=>this.eb(v),this.M)}get onMouseOut(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"mouseout")).event,v=>this.eb(v),this.M)}get onContextMenu(){return k.Event.any(k.Event.map(this.M.add(new j.$1S(this.domNode,"contextmenu")).event,v=>this.eb(v),this.M),k.Event.map(this.M.add(new j.$1S(this.domNode,W.EventType.Contextmenu)).event,v=>this.gb(v),this.M))}get onTouchStart(){return k.Event.map(this.M.add(new j.$1S(this.domNode,"touchstart")).event,v=>this.fb(v),this.M)}get onTap(){return k.Event.map(this.M.add(new j.$1S(this.o,W.EventType.Tap)).event,v=>this.gb(v),this.M)}eb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],T=V&&V.element;return{browserEvent:v,index:H,element:T}}fb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],T=V&&V.element;return{browserEvent:v,index:H,element:T}}gb(v){const H=this.ub(v.initialTarget||null),V=typeof H>"u"?void 0:this.d[H],T=V&&V.element;return{browserEvent:v,index:H,element:T}}hb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],T=V&&V.element,L=this.tb(v,H);return{browserEvent:v,index:H,element:T,sector:L}}ib(v){try{const H=this.vb(this.k,this.m);this.Y(H,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.wb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(H){throw console.error("Got bad scroll event:",v),H}}jb(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}kb(v,H,V){if(!V.dataTransfer)return;const T=this.F.getDragElements(v);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.$rS.TEXT,H),V.dataTransfer.setDragImage){let L;this.F.getDragLabel&&(L=this.F.getDragLabel(T,V)),typeof L>"u"&&(L=String(T.length));const I=(0,R.$)(".monaco-drag-image");I.textContent=L;const U=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);U.appendChild(I),V.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>U.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new g(T),p.CurrentDragAndDropData=new r(T),this.F.onDragStart?.(this.H,V)}lb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new E}const H=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof H=="boolean"?H:H.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof H!="boolean"&&H.effect?.type===0?"copy":"move";let V;typeof H!="boolean"&&H.feedback?V=H.feedback:typeof v.index>"u"?V=[-1]:V=[v.index],V=(0,y.$Mb)(V).filter(L=>L>=-1&&L<this.length).sort((L,I)=>L-I),V=V[0]===-1?[-1]:V;let T=typeof H!="boolean"&&H.effect&&H.effect.position?H.effect.position:"drop-target";if(N(this.I,V)&&this.J===T)return!0;if(this.I=V,this.J=T,this.K.dispose(),V[0]===-1)this.domNode.classList.add(T),this.o.classList.add(T),this.K=(0,B.$Rc)(()=>{this.domNode.classList.remove(T),this.o.classList.remove(T)});else{if(V.length>1&&T!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");T==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,T="drop-target-before");for(const L of V){const I=this.d[L];I.dropTarget=!0,I.row?.domNode.classList.add(T)}this.K=(0,B.$Rc)(()=>{for(const L of V){const I=this.d[L];I.dropTarget=!1,I.row?.domNode.classList.remove(T)}})}return!0}mb(v){this.L.dispose(),this.L=(0,$.$ih)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}nb(v){if(!this.G)return;const H=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!H||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),H.update(v.browserEvent.dataTransfer),this.F.drop(H,v.element,v.index,v.sector,v.browserEvent))}ob(v){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=B.$Tc.None}qb(v){if(!this.w){const H=(0,R.$cR)(this.domNode).top;this.w=(0,R.$_R)((0,R.getWindow)(this.domNode),this.rb.bind(this,H))}this.x.dispose(),this.x=(0,$.$ih)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}rb(v){if(this.y===void 0)return;const H=this.y-v,V=this.renderHeight-35;H<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(H-35))):H>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(H-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(v,H){if(H===void 0)return;const V=v.offsetY/this.d[H].size,T=Math.floor(V/.25);return(0,m.$fm)(T,0,3)}ub(v){const H=this.q.getDomNode();let V=v;for(;V instanceof HTMLElement&&V!==this.o&&H.contains(V);){const T=V.getAttribute("data-index");if(T){const L=Number(T);if(!isNaN(L))return L}V=V.parentElement}}vb(v,H){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+H-1)}}wb(v,H,V){const T=this.vb(v,H);let L,I;v===this.elementTop(T.start)?(L=T.start,I=0):T.end-T.start>1&&(L=T.start+1,I=this.elementTop(L)-v);let X=0;for(;;){const U=this.vb(v,H);let de=!1;for(let he=U.start;he<U.end;he++){const ne=this.xb(he);ne!==0&&this.g.splice(he,1,[this.d[he]]),X+=ne,de=de||ne!==0}if(!de){X!==0&&this.V();const he=c.Range.relativeComplement(T,U);for(const ge of he)for(let Ce=ge.start;Ce<ge.end;Ce++)this.d[Ce].row&&this.db(Ce);const ne=c.Range.relativeComplement(U,T).reverse();for(const ge of ne)for(let Ce=ge.end-1;Ce>=ge.start;Ce--)this.Z(Ce);for(let ge=U.start;ge<U.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof L=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-v,Ce=this.elementTop(L)-I+ge;this.setScrollTop(Ce,V)}this.N.fire(this.contentHeight);return}}}xb(v){const H=this.d[v];if(this.R.getDynamicHeight){const I=this.R.getDynamicHeight(H.element);if(I!==null){const X=H.size;return H.size=I,H.lastDynamicHeightWidth=this.n,I-X}}if(!H.hasDynamicHeight||H.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(H.element))return 0;const V=H.size;if(H.row)return H.row.domNode.style.height="",H.size=H.row.domNode.offsetHeight,H.lastDynamicHeightWidth=this.n,H.size-V;const{row:T}=this.h.alloc(H.templateId);T.domNode.style.height="",this.o.appendChild(T.domNode);const L=this.j.get(H.templateId);if(!L)throw new a.$cb("Missing renderer for templateId: "+H.templateId);return L.renderElement(H.element,v,T.templateData,void 0),H.size=T.domNode.offsetHeight,L.disposeElement?.(H.element,v,T.templateData,void 0),this.R.setDynamicHeight?.(H.element,H.size),H.lastDynamicHeightWidth=this.n,this.o.removeChild(T.domNode),this.h.release(T),H.size-V}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const H=this.j.get(v.row.templateId);H&&(H.disposeElement?.(v.element,-1,v.row.templateData,void 0),H.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}e.$bT=P,Je([b.$Kh],P.prototype,"onMouseClick",null),Je([b.$Kh],P.prototype,"onMouseDblClick",null),Je([b.$Kh],P.prototype,"onMouseMiddleClick",null),Je([b.$Kh],P.prototype,"onMouseUp",null),Je([b.$Kh],P.prototype,"onMouseDown",null),Je([b.$Kh],P.prototype,"onMouseOver",null),Je([b.$Kh],P.prototype,"onMouseMove",null),Je([b.$Kh],P.prototype,"onMouseOut",null),Je([b.$Kh],P.prototype,"onContextMenu",null),Je([b.$Kh],P.prototype,"onTouchStart",null),Je([b.$Kh],P.prototype,"onTap",null)}),define(me[43],$e([1,0,2,24,15,26,60,74,12,9,77,28,4,37,3,35,5,7,73,64,20,102]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s,a,m,p,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=e.$sT=e.$rT=e.$qT=e.$pT=e.$oT=e.$nT=e.TypeNavigationMode=e.$mT=e.$lT=e.$kT=e.$jT=e.$iT=e.$hT=e.$gT=e.$fT=void 0;class g{constructor(f){this.d=f,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(f){return f}renderElement(f,A,F){const l=this.c.findIndex(u=>u.templateData===F);if(l>=0){const u=this.c[l];this.d.unrender(F),u.index=A}else{const u={index:A,templateData:F};this.c.push(u)}this.d.renderIndex(A,F)}splice(f,A,F){const l=[];for(const u of this.c)u.index<f?l.push(u):u.index>=f+A&&l.push({index:u.index+F-A,templateData:u.templateData});this.c=l}renderIndexes(f){for(const{index:A,templateData:F}of this.c)f.indexOf(A)>-1&&this.d.renderIndex(A,F)}disposeTemplate(f){const A=this.c.findIndex(F=>F.templateData===f);A<0||this.c.splice(A,1)}}class r{get name(){return this.g}get renderer(){return new g(this)}constructor(f){this.g=f,this.c=[],this.d=[],this.f=new c.$6d,this.onChange=this.f.event}splice(f,A,F){const l=F.length-A,u=f+A,n=[];let h=0;for(;h<this.d.length&&this.d[h]<f;)n.push(this.d[h++]);for(let C=0;C<F.length;C++)F[C]&&n.push(C+f);for(;h<this.d.length&&this.d[h]>=u;)n.push(this.d[h++]+l);this.renderer.splice(f,A,F.length),this.h(n,n)}renderIndex(f,A){A.classList.toggle(this.g,this.contains(f))}unrender(f){f.classList.remove(this.g)}set(f,A){return this.h(f,[...f].sort(ie),A)}h(f,A,F){const l=this.c,u=this.d;this.c=f,this.d=A;const n=J(u,f);return this.renderer.renderIndexes(n),this.f.fire({indexes:f,browserEvent:F}),l}get(){return this.c}contains(f){return(0,$.$wb)(this.d,f,ie)>=0}dispose(){(0,t.$Oc)(this.f)}}Je([B.$Kh],r.prototype,"renderer",null);class E extends r{constructor(f){super("selected"),this.k=f}renderIndex(f,A){super.renderIndex(f,A),this.k&&(this.contains(f)?A.setAttribute("aria-selected","true"):A.setAttribute("aria-selected","false"))}}class N{constructor(f,A,F){this.c=f,this.d=A,this.f=F}splice(f,A,F){if(!this.f)return this.c.splice(f,A,new Array(F.length).fill(!1));const l=this.c.get().map(h=>this.f.getId(this.d.element(h)).toString());if(l.length===0)return this.c.splice(f,A,new Array(F.length).fill(!1));const u=new Set(l),n=F.map(h=>u.has(this.f.getId(h).toString()));this.c.splice(f,A,n)}}function M(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}e.$fT=M;function P(K,f){return K.classList.contains(f)?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:P(K.parentElement,f)}function z(K){return P(K,"monaco-editor")}e.$gT=z;function v(K){return P(K,"monaco-custom-toggle")}e.$hT=v;function H(K){return P(K,"action-item")}e.$iT=H;function V(K){return P(K,"monaco-tl-twistie")}e.$jT=V;function T(K){return P(K,"monaco-tree-sticky-row")}e.$kT=T;function L(K){return K.classList.contains("monaco-tree-sticky-container")}e.$lT=L;function I(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:I(K.parentElement)}e.$mT=I;class X{get g(){return c.Event.chain(this.c.add(new R.$1S(this.k.domNode,"keydown")).event,f=>f.filter(A=>!M(A.target)).map(A=>new j.$SQ(A)))}constructor(f,A,F){this.h=f,this.k=A,this.c=new t.$Sc,this.d=new t.$Sc,this.f=F.multipleSelectionSupport,this.c.add(this.g(l=>{switch(l.keyCode){case 3:return this.l(l);case 16:return this.o(l);case 18:return this.p(l);case 11:return this.q(l);case 12:return this.s(l);case 9:return this.u(l);case 31:this.f&&(a.$j?l.metaKey:l.ctrlKey)&&this.t(l)}}))}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.f=f.multipleSelectionSupport)}l(f){f.preventDefault(),f.stopPropagation(),this.h.setSelection(this.h.getFocus(),f.browserEvent)}o(f){f.preventDefault(),f.stopPropagation(),this.h.focusPrevious(1,!1,f.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}p(f){f.preventDefault(),f.stopPropagation(),this.h.focusNext(1,!1,f.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}q(f){f.preventDefault(),f.stopPropagation(),this.h.focusPreviousPage(f.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}s(f){f.preventDefault(),f.stopPropagation(),this.h.focusNextPage(f.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}t(f){f.preventDefault(),f.stopPropagation(),this.h.setSelection((0,$.$Sb)(this.h.length),f.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(f){this.h.getSelection().length&&(f.preventDefault(),f.stopPropagation(),this.h.setSelection([],f.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([B.$Kh],X.prototype,"g",null);var U;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(U||(e.TypeNavigationMode=U={}));var de;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(de||(de={})),e.$nT=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class he{constructor(f,A,F,l,u){this.o=f,this.p=A,this.q=F,this.s=l,this.t=u,this.c=!1,this.d=de.Idle,this.f=U.Automatic,this.g=!1,this.h=-1,this.k=new t.$Sc,this.l=new t.$Sc,this.updateOptions(f.options)}updateOptions(f){f.typeNavigationEnabled??!0?this.u():this.v(),this.f=f.typeNavigationMode??U.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let f=!1;const A=c.Event.chain(this.k.add(new R.$1S(this.p.domNode,"keydown")).event,u=>u.filter(n=>!M(n.target)).filter(()=>this.f===U.Automatic||this.g).map(n=>new j.$SQ(n)).filter(n=>f||this.s(n)).filter(n=>this.t.mightProducePrintableCharacter(n)).forEach(n=>i.$RR.stop(n,!0)).map(n=>n.browserEvent.key)),F=c.Event.debounce(A,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(A,F),(u,n)=>n===null?null:(u||"")+n,void 0,this.k)(this.x,this,this.k),F(this.w,this,this.k),A(()=>f=!0,void 0,this.k),F(()=>f=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const f=this.o.getFocus();if(f.length>0&&f[0]===this.h){const A=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(f[0]));A&&(0,D.$3S)(A)}this.h=-1}x(f){if(!f){this.d=de.Idle,this.g=!1;return}const A=this.o.getFocus(),F=A.length>0?A[0]:0,l=this.d===de.Idle?1:0;this.d=de.Typing;for(let u=0;u<this.o.length;u++){const n=(F+u+l)%this.o.length,h=this.q.getKeyboardNavigationLabel(this.p.element(n)),C=h&&h.toString();if(this.o.options.typeNavigationEnabled){if(typeof C<"u"){if((0,d.$8j)(f,C)){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}const S=(0,d.$ck)(f,C);if(S&&S[0].end-S[0].start>1&&S.length===1){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}}}else if(typeof C>"u"||(0,d.$8j)(f,C)){this.h=F,this.o.setFocus([n]),this.o.reveal(n);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ne{constructor(f,A){this.d=f,this.f=A,this.c=new t.$Sc;const F=c.Event.chain(this.c.add(new R.$1S(A.domNode,"keydown")).event,u=>u.filter(n=>!M(n.target)).map(n=>new j.$SQ(n)));c.Event.chain(F,u=>u.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.g,this,this.c)}g(f){if(f.target!==this.f.domNode)return;const A=this.d.getFocus();if(A.length===0)return;const F=this.f.domElement(A[0]);if(!F)return;const l=F.querySelector("[tabIndex]");if(!l||!(l instanceof HTMLElement)||l.tabIndex===-1)return;const u=(0,i.getWindow)(l).getComputedStyle(l);u.visibility==="hidden"||u.display==="none"||(f.preventDefault(),f.stopPropagation(),l.focus())}dispose(){this.c.dispose()}}function ge(K){return a.$j?K.browserEvent.metaKey:K.browserEvent.ctrlKey}e.$oT=ge;function Ce(K){return K.browserEvent.shiftKey}e.$pT=Ce;function Re(K){return(0,i.$LR)(K)&&K.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Ce};class le{constructor(f){this.k=f,this.f=new t.$Sc,this.g=new c.$6d,this.onPointer=this.g.event,f.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof f.options.mouseSupport>"u"||!!f.options.mouseSupport,this.d&&(f.onMouseDown(this.s,this,this.f),f.onContextMenu(this.t,this,this.f),f.onMouseDblClick(this.v,this,this.f),f.onTouchStart(this.s,this,this.f),this.f.add(W.$tS.addTarget(f.getHTMLElement()))),c.Event.any(f.onMouseClick,f.onMouseMiddleClick,f.onTap)(this.u,this,this.f)}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.c=void 0,f.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(f){return this.c?this.c.isSelectionSingleChangeEvent(f):!1}p(f){return this.c?this.c.isSelectionRangeChangeEvent(f):!1}q(f){return this.o(f)||this.p(f)}s(f){z(f.browserEvent.target)||(0,i.$vR)()!==f.browserEvent.target&&this.k.domFocus()}t(f){if(M(f.browserEvent.target)||z(f.browserEvent.target))return;const A=typeof f.index>"u"?[]:[f.index];this.k.setFocus(A,f.browserEvent)}u(f){if(!this.d||M(f.browserEvent.target)||z(f.browserEvent.target)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const A=f.index;if(typeof A>"u"){this.k.setFocus([],f.browserEvent),this.k.setSelection([],f.browserEvent),this.k.setAnchor(void 0);return}if(this.q(f))return this.w(f);this.k.setFocus([A],f.browserEvent),this.k.setAnchor(A),Re(f.browserEvent)||this.k.setSelection([A],f.browserEvent),this.g.fire(f)}v(f){if(M(f.browserEvent.target)||z(f.browserEvent.target)||this.q(f)||f.browserEvent.isHandledByList)return;f.browserEvent.isHandledByList=!0;const A=this.k.getFocus();this.k.setSelection(A,f.browserEvent)}w(f){const A=f.index;let F=this.k.getAnchor();if(this.p(f)){typeof F>"u"&&(F=this.k.getFocus()[0]??A,this.k.setAnchor(F));const l=Math.min(F,A),u=Math.max(F,A),n=(0,$.$Sb)(l,u+1),h=this.k.getSelection(),C=oe(J(h,[F]),F);if(C.length===0)return;const S=J(n,G(h,C));this.k.setSelection(S,f.browserEvent),this.k.setFocus([A],f.browserEvent)}else if(this.o(f)){const l=this.k.getSelection(),u=l.filter(n=>n!==A);this.k.setFocus([A]),this.k.setAnchor(A),l.length===u.length?this.k.setSelection([...u,A],f.browserEvent):this.k.setSelection(u,f.browserEvent)}}dispose(){this.f.dispose()}}e.$qT=le;class _{constructor(f,A){this.c=f,this.d=A}style(f){const A=this.d&&`.${this.d}`,F=[];f.listBackground&&F.push(`.monaco-list${A} .monaco-list-rows { background: ${f.listBackground}; }`),f.listFocusBackground&&(F.push(`.monaco-list${A}:focus .monaco-list-row.focused { background-color: ${f.listFocusBackground}; }`),F.push(`.monaco-list${A}:focus .monaco-list-row.focused:hover { background-color: ${f.listFocusBackground}; }`)),f.listFocusForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.focused { color: ${f.listFocusForeground}; }`),f.listActiveSelectionBackground&&(F.push(`.monaco-list${A}:focus .monaco-list-row.selected { background-color: ${f.listActiveSelectionBackground}; }`),F.push(`.monaco-list${A}:focus .monaco-list-row.selected:hover { background-color: ${f.listActiveSelectionBackground}; }`)),f.listActiveSelectionForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.selected { color: ${f.listActiveSelectionForeground}; }`),f.listActiveSelectionIconForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.selected .codicon { color: ${f.listActiveSelectionIconForeground}; }`),f.listFocusAndSelectionBackground&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.selected.focused { background-color: ${f.listFocusAndSelectionBackground}; }
			`),f.listFocusAndSelectionForeground&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.selected.focused { color: ${f.listFocusAndSelectionForeground}; }
			`),f.listInactiveFocusForeground&&(F.push(`.monaco-list${A} .monaco-list-row.focused { color:  ${f.listInactiveFocusForeground}; }`),F.push(`.monaco-list${A} .monaco-list-row.focused:hover { color:  ${f.listInactiveFocusForeground}; }`)),f.listInactiveSelectionIconForeground&&F.push(`.monaco-list${A} .monaco-list-row.focused .codicon { color:  ${f.listInactiveSelectionIconForeground}; }`),f.listInactiveFocusBackground&&(F.push(`.monaco-list${A} .monaco-list-row.focused { background-color:  ${f.listInactiveFocusBackground}; }`),F.push(`.monaco-list${A} .monaco-list-row.focused:hover { background-color:  ${f.listInactiveFocusBackground}; }`)),f.listInactiveSelectionBackground&&(F.push(`.monaco-list${A} .monaco-list-row.selected { background-color:  ${f.listInactiveSelectionBackground}; }`),F.push(`.monaco-list${A} .monaco-list-row.selected:hover { background-color:  ${f.listInactiveSelectionBackground}; }`)),f.listInactiveSelectionForeground&&F.push(`.monaco-list${A} .monaco-list-row.selected { color: ${f.listInactiveSelectionForeground}; }`),f.listHoverBackground&&F.push(`.monaco-list${A}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${f.listHoverBackground}; }`),f.listHoverForeground&&F.push(`.monaco-list${A}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${f.listHoverForeground}; }`);const l=(0,i.$cS)(f.listFocusAndSelectionOutline,(0,i.$cS)(f.listSelectionOutline,f.listFocusOutline??""));l&&F.push(`.monaco-list${A}:focus .monaco-list-row.focused.selected { outline: 1px solid ${l}; outline-offset: -1px;}`),f.listFocusOutline&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${A}.last-focused .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
			`);const u=(0,i.$cS)(f.listSelectionOutline,f.listInactiveFocusOutline??"");u&&F.push(`.monaco-list${A} .monaco-list-row.focused.selected { outline: 1px dotted ${u}; outline-offset: -1px; }`),f.listSelectionOutline&&F.push(`.monaco-list${A} .monaco-list-row.selected { outline: 1px dotted ${f.listSelectionOutline}; outline-offset: -1px; }`),f.listInactiveFocusOutline&&F.push(`.monaco-list${A} .monaco-list-row.focused { outline: 1px dotted ${f.listInactiveFocusOutline}; outline-offset: -1px; }`),f.listHoverOutline&&F.push(`.monaco-list${A} .monaco-list-row:hover { outline: 1px dashed ${f.listHoverOutline}; outline-offset: -1px; }`),f.listDropOverBackground&&F.push(`
				.monaco-list${A}.drop-target,
				.monaco-list${A} .monaco-list-rows.drop-target,
				.monaco-list${A} .monaco-list-row.drop-target { background-color: ${f.listDropOverBackground} !important; color: inherit !important; }
			`),f.listDropBetweenBackground&&(F.push(`
			.monaco-list${A} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${A} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`),F.push(`
			.monaco-list${A} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${A} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${f.listDropBetweenBackground};
			}`)),f.tableColumnsBorder&&F.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${f.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),f.tableOddRowsBackgroundColor&&F.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${f.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=F.join(`
`)}}e.$rT=_,e.$sT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:k.$Bt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:k.$Bt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:k.$Bt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function oe(K,f){const A=K.indexOf(f);if(A===-1)return[];const F=[];let l=A-1;for(;l>=0&&K[l]===f-(A-l);)F.push(K[l--]);for(F.reverse(),l=A;l<K.length&&K[l]===f+(l-A);)F.push(K[l++]);return F}function J(K,f){const A=[];let F=0,l=0;for(;F<K.length||l<f.length;)if(F>=K.length)A.push(f[l++]);else if(l>=f.length)A.push(K[F++]);else if(K[F]===f[l]){A.push(K[F]),F++,l++;continue}else K[F]<f[l]?A.push(K[F++]):A.push(f[l++]);return A}function G(K,f){const A=[];let F=0,l=0;for(;F<K.length||l<f.length;)if(F>=K.length)A.push(f[l++]);else if(l>=f.length)A.push(K[F++]);else if(K[F]===f[l]){F++,l++;continue}else K[F]<f[l]?A.push(K[F++]):l++;return A}const ie=(K,f)=>K-f;class fe{constructor(f,A){this.c=f,this.d=A}get templateId(){return this.c}renderTemplate(f){return this.d.map(A=>A.renderTemplate(f))}renderElement(f,A,F,l){let u=0;for(const n of this.d)n.renderElement(f,A,F[u++],l)}disposeElement(f,A,F,l){let u=0;for(const n of this.d)n.disposeElement?.(f,A,F[u],l),u+=1}disposeTemplate(f){let A=0;for(const F of this.d)F.disposeTemplate(f[A++])}}class De{constructor(f){this.c=f,this.templateId="a18n"}renderTemplate(f){return f}renderElement(f,A,F){const l=this.c.getAriaLabel(f);l?F.setAttribute("aria-label",l):F.removeAttribute("aria-label");const u=this.c.getAriaLevel&&this.c.getAriaLevel(f);typeof u=="number"?F.setAttribute("aria-level",`${u}`):F.removeAttribute("aria-level")}disposeTemplate(f){}}class Fe{constructor(f,A){this.c=f,this.d=A}getDragElements(f){const A=this.c.getSelectedElements();return A.indexOf(f)>-1?A:[f]}getDragURI(f){return this.d.getDragURI(f)}getDragLabel(f,A){if(this.d.getDragLabel)return this.d.getDragLabel(f,A)}onDragStart(f,A){this.d.onDragStart?.(f,A)}onDragOver(f,A,F,l,u){return this.d.onDragOver(f,A,F,l,u)}onDragLeave(f,A,F,l){this.d.onDragLeave?.(f,A,F,l)}onDragEnd(f){this.d.onDragEnd?.(f)}drop(f,A,F,l,u){this.d.drop(f,A,F,l,u)}dispose(){this.d.dispose()}}class ye{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),f=>this.G(f),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),f=>this.G(f),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let f=!1;const A=c.Event.chain(this.y.add(new R.$1S(this.k.domNode,"keydown")).event,u=>u.map(n=>new j.$SQ(n)).filter(n=>f=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$RR.stop(n,!0)).filter(()=>!1)),F=c.Event.chain(this.y.add(new R.$1S(this.k.domNode,"keyup")).event,u=>u.forEach(()=>f=!1).map(n=>new j.$SQ(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$RR.stop(n,!0)).map(({browserEvent:n})=>{const h=this.getFocus(),C=h.length?h[0]:void 0,S=typeof C<"u"?this.k.element(C):void 0,O=typeof C<"u"?this.k.domElement(C):this.k.domNode;return{index:C,element:S,anchor:O,browserEvent:n}})),l=c.Event.chain(this.k.onContextMenu,u=>u.filter(n=>!f).map(({element:n,index:h,browserEvent:C})=>({element:n,index:h,anchor:new o.$NQ((0,i.getWindow)(this.k.domNode),C),browserEvent:C})));return c.Event.any(A,F,l)}get onKeyDown(){return this.y.add(new R.$1S(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new R.$1S(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new R.$1S(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new R.$1S(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new R.$1S(this.k.domNode,"blur",!0)).event)}constructor(f,A,F,l,u=ae){this.A=f,this.B=u,this.c=new r("focused"),this.f=new r("anchor"),this.g=new c.$be,this.x="",this.y=new t.$Sc,this.z=new c.$6d,this.onDidDispose=this.z.event;const n=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new E(n!=="listbox");const h=[this.c.renderer,this.d.renderer];this.u=u.accessibilityProvider,this.u&&(h.push(new De(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),l=l.map(S=>new fe(S.templateId,[...h,S]));const C={...u,dnd:u.dnd&&new Fe(this,u.dnd)};if(this.k=this.C(A,F,l,C),this.k.domNode.setAttribute("role",n),u.styleController)this.q=u.styleController(this.k.domId);else{const S=(0,i.$ER)(this.k.domNode);this.q=new _(S,this.k.domId)}if(this.o=new y.$5S([new N(this.c,this.k,u.identityProvider),new N(this.d,this.k,u.identityProvider),new N(this.f,this.k,u.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ne(this,this.k)),(typeof u.keyboardSupport!="boolean"||u.keyboardSupport)&&(this.v=new X(this,this.k,u),this.y.add(this.v)),u.keyboardNavigationLabelProvider){const S=u.keyboardNavigationDelegate||e.$nT;this.t=new he(this,this.k,u.keyboardNavigationLabelProvider,u.keyboardNavigationEventFilter??(()=>!0),S),this.y.add(this.t)}this.w=this.D(u),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(f,A,F,l){return new w.$bT(f,A,F,l)}D(f){return new le(this)}updateOptions(f={}){this.B={...this.B,...f},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(f),this.v?.updateOptions(f),this.k.updateOptions(f)}get options(){return this.B}splice(f,A,F=[]){if(f<0||f>this.k.length)throw new p.$dT(this.A,`Invalid start index: ${f}`);if(A<0)throw new p.$dT(this.A,`Invalid delete count: ${A}`);A===0&&F.length===0||this.g.bufferEvents(()=>this.o.splice(f,A,F))}updateWidth(f){this.k.updateWidth(f)}updateElementHeight(f,A){this.k.updateElementHeight(f,A,null)}rerender(){this.k.rerender()}element(f){return this.k.element(f)}indexOf(f){return this.k.indexOf(f)}indexAt(f){return this.k.indexAt(f)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(f){this.k.setScrollTop(f)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(f){this.k.setScrollLeft(f)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(f){this.x=f,this.k.domNode.setAttribute("aria-label",f)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(f,A){this.k.layout(f,A)}triggerTypeNavigation(){this.t?.trigger()}setSelection(f,A){for(const F of f)if(F<0||F>=this.length)throw new p.$dT(this.A,`Invalid index ${F}`);this.d.set(f,A)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(f=>this.k.element(f))}setAnchor(f){if(typeof f>"u"){this.f.set([]);return}if(f<0||f>=this.length)throw new p.$dT(this.A,`Invalid index ${f}`);this.f.set([f])}getAnchor(){return(0,$.$Ob)(this.f.get(),void 0)}getAnchorElement(){const f=this.getAnchor();return typeof f>"u"?void 0:this.element(f)}setFocus(f,A){for(const F of f)if(F<0||F>=this.length)throw new p.$dT(this.A,`Invalid index ${F}`);this.c.set(f,A)}focusNext(f=1,A=!1,F,l){if(this.length===0)return;const u=this.c.get(),n=this.E(u.length>0?u[0]+f:0,A,l);n>-1&&this.setFocus([n],F)}focusPrevious(f=1,A=!1,F,l){if(this.length===0)return;const u=this.c.get(),n=this.F(u.length>0?u[0]-f:0,A,l);n>-1&&this.setFocus([n],F)}async focusNextPage(f,A){let F=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);F=F===0?0:F-1;const l=this.getFocus()[0];if(l!==F&&(l===void 0||F>l)){const u=this.F(F,!1,A);u>-1&&l!==u?this.setFocus([u],f):this.setFocus([F],f)}else{const u=this.k.getScrollTop();let n=u+this.k.renderHeight;F>l&&(n-=this.k.elementHeight(F)),this.k.setScrollTop(n),this.k.getScrollTop()!==u&&(this.setFocus([]),await(0,b.$hh)(0),await this.focusNextPage(f,A))}}async focusPreviousPage(f,A,F=()=>0){let l;const u=F(),n=this.k.getScrollTop()+u;n===0?l=this.k.indexAt(n):l=this.k.indexAfter(n-1);const h=this.getFocus()[0];if(h!==l&&(h===void 0||h>=l)){const C=this.E(l,!1,A);C>-1&&h!==C?this.setFocus([C],f):this.setFocus([l],f)}else{const C=n;this.k.setScrollTop(n-this.k.renderHeight-u),this.k.getScrollTop()+F()!==C&&(this.setFocus([]),await(0,b.$hh)(0),await this.focusPreviousPage(f,A,F))}}focusLast(f,A){if(this.length===0)return;const F=this.F(this.length-1,!1,A);F>-1&&this.setFocus([F],f)}focusFirst(f,A){this.focusNth(0,f,A)}focusNth(f,A,F){if(this.length===0)return;const l=this.E(f,!1,F);l>-1&&this.setFocus([l],A)}E(f,A=!1,F){for(let l=0;l<this.length;l++){if(f>=this.length&&!A)return-1;if(f=f%this.length,!F||F(this.element(f)))return f;f++}return-1}F(f,A=!1,F){for(let l=0;l<this.length;l++){if(f<0&&!A)return-1;if(f=(this.length+f%this.length)%this.length,!F||F(this.element(f)))return f;f--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(f=>this.k.element(f))}reveal(f,A,F=0){if(f<0||f>=this.length)throw new p.$dT(this.A,`Invalid index ${f}`);const l=this.k.getScrollTop(),u=this.k.elementTop(f),n=this.k.elementHeight(f);if((0,m.$Xf)(A)){const h=n-this.k.renderHeight+F;this.k.setScrollTop(h*(0,s.$fm)(A,0,1)+u-F)}else{const h=u+n,C=l+this.k.renderHeight;u<l+F&&h>=C||(u<l+F||h>=C&&n>=this.k.renderHeight?this.k.setScrollTop(u-F):h>=C&&this.k.setScrollTop(h-this.k.renderHeight))}}getRelativeTop(f,A=0){if(f<0||f>=this.length)throw new p.$dT(this.A,`Invalid index ${f}`);const F=this.k.getScrollTop(),l=this.k.elementTop(f),u=this.k.elementHeight(f);if(l<F+A||l+u>F+this.k.renderHeight)return null;const n=u-this.k.renderHeight+A;return Math.abs((F+A-l)/n)}isDOMFocused(){return(0,i.$wR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(f){return this.k.getElementDomId(f)}getElementTop(f){return this.k.elementTop(f)}style(f){this.q.style(f)}G({indexes:f,browserEvent:A}){return{indexes:f,elements:f.map(F=>this.k.element(F)),browserEvent:A}}H(){const f=this.c.get();this.k.domNode.classList.toggle("element-focused",f.length>0),this.I()}I(){const f=this.c.get();if(f.length>0){let A;this.u?.getActiveDescendantId&&(A=this.u.getActiveDescendantId(this.k.element(f[0]))),this.k.domNode.setAttribute("aria-activedescendant",A||this.k.getElementDomId(f[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const f=this.d.get();this.k.domNode.classList.toggle("selection-none",f.length===0),this.k.domNode.classList.toggle("selection-single",f.length===1),this.k.domNode.classList.toggle("selection-multiple",f.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}e.$tT=ye,Je([B.$Kh],ye.prototype,"onDidChangeFocus",null),Je([B.$Kh],ye.prototype,"onDidChangeSelection",null),Je([B.$Kh],ye.prototype,"onContextMenu",null),Je([B.$Kh],ye.prototype,"onKeyDown",null),Je([B.$Kh],ye.prototype,"onKeyUp",null),Je([B.$Kh],ye.prototype,"onKeyPress",null),Je([B.$Kh],ye.prototype,"onDidFocus",null),Je([B.$Kh],ye.prototype,"onDidBlur",null)}),define(me[65],$e([1,0,6,39,41,10,16]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(y||(e.MarkdownStringTextNewlineStyle=y={}));class ${constructor(p="",w=!1){if(this.value=p,typeof this.value!="string")throw(0,i.$7)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(p,w=0){return this.value+=c(this.supportThemeIcons?(0,R.$rk)(p):p).replace(/([ \t]+)/g,(o,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,w){return this.value+=`
${d(w,p)}
`,this}appendLink(p,w,o){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(p),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(p,w){const o=new RegExp((0,W.$Ye)(w),"g");return p.replace(o,(g,r)=>p.charAt(r-1)!=="\\"?`\\${g}`:g)}}e.$xk=$;function b(m){return k(m)?!m.value:Array.isArray(m)?m.every(b):!0}e.$yk=b;function k(m){return m instanceof $?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.$zk=k;function B(m,p){return m===p?!0:!m||!p?!1:m.value===p.value&&m.isTrusted===p.isTrusted&&m.supportThemeIcons===p.supportThemeIcons&&m.supportHtml===p.supportHtml&&(m.baseUri===p.baseUri||!!m.baseUri&&!!p.baseUri&&(0,j.$Mg)(D.URI.from(m.baseUri),D.URI.from(p.baseUri)))}e.$Ak=B;function c(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Bk=c;function d(m,p){const w=m.match(/^`+/gm)?.reduce((g,r)=>g.length>r.length?g:r).length??0,o=w>=3?w+1:3;return[`${"`".repeat(o)}${p}`,m,`${"`".repeat(o)}`].join(`
`)}e.$Ck=d;function t(m){return m.replace(/"/g,"&quot;")}e.$Dk=t;function s(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Ek=s;function a(m){const p=[],w=m.split("|").map(g=>g.trim());m=w[0];const o=w[1];if(o){const g=/height=(\d+)/.exec(o),r=/width=(\d+)/.exec(o),E=g?g[1]:"",N=r?r[1]:"",M=isFinite(parseInt(N)),P=isFinite(parseInt(E));M&&p.push(`width="${N}"`),P&&p.push(`height="${E}"`)}return{href:m,dimensions:p}}e.$Fk=a}),define(me[130],$e([1,0,2,122,24,58,15,20,123,6,4,65,39,80,23,3,82,56,32,54,41,10,16]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s,a,m,p,w,o,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=e.$zT=e.$yT=e.$xT=e.$wT=void 0;const E=Object.freeze({image:(G,ie,fe)=>{let De=[],Fe=[];return G&&({href:G,dimensions:De}=(0,B.$Fk)(G),Fe.push(`src="${(0,B.$Dk)(G)}"`)),fe&&Fe.push(`alt="${(0,B.$Dk)(fe)}"`),ie&&Fe.push(`title="${(0,B.$Dk)(ie)}"`),De.length&&(Fe=Fe.concat(De)),"<img "+Fe.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,ie,fe)=>typeof G!="string"?"":(G===fe&&(fe=(0,B.$Ek)(fe)),ie=typeof ie=="string"?(0,B.$Dk)((0,B.$Ek)(ie)):"",G=(0,B.$Ek)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${ie||G}" draggable="false">${fe}</a>`)});function N(G,ie={},fe={}){const De=new s.$Sc;let Fe=!1;const ye=(0,W.$ZS)(ie),K=function(S){let O;try{O=(0,m.$Oh)(decodeURIComponent(S))}catch{}return O?(O=(0,w.$Nn)(O,q=>{if(G.uris&&G.uris[q])return r.URI.revive(G.uris[q])}),encodeURIComponent(JSON.stringify(O))):S},f=function(S,O){const q=G.uris&&G.uris[S];let Z=r.URI.revive(q);return O?S.startsWith(p.Schemas.data+":")?S:(Z||(Z=r.URI.parse(S)),p.$Ag.uriToBrowserUri(Z).toString(!0)):!Z||r.URI.parse(S).toString()===Z.toString()?S:(Z.query&&(Z=Z.with({query:K(Z.query)})),Z.toString())},A=new a.marked.Renderer;A.image=E.image,A.link=E.link,A.paragraph=E.paragraph;const F=[],l=[];if(ie.codeBlockRendererSync?A.code=(S,O)=>{const q=d.$xO.nextId(),Z=ie.codeBlockRendererSync(M(O),S);return l.push([q,Z]),`<div class="code" data-code="${q}">${(0,g.$Xe)(S)}</div>`}:ie.codeBlockRenderer&&(A.code=(S,O)=>{const q=d.$xO.nextId(),Z=ie.codeBlockRenderer(M(O),S);return F.push(Z.then(te=>[q,te])),`<div class="code" data-code="${q}">${(0,g.$Xe)(S)}</div>`}),ie.actionHandler){const S=function(Z){let te=Z.target;if(!(te.tagName!=="A"&&(te=te.parentElement,!te||te.tagName!=="A")))try{let be=te.dataset.href;be&&(G.baseUri&&(be=P(r.URI.from(G.baseUri),be)),ie.actionHandler.callback(be,Z))}catch(be){(0,b.$1)(be)}finally{Z.preventDefault()}},O=ie.actionHandler.disposables.add(new j.$1S(ye,"click")),q=ie.actionHandler.disposables.add(new j.$1S(ye,"auxclick"));ie.actionHandler.disposables.add(k.Event.any(O.event,q.event)(Z=>{const te=new y.$NQ(i.getWindow(ye),Z);!te.leftButton&&!te.middleButton||S(te)})),ie.actionHandler.disposables.add(i.$VQ(ye,"keydown",Z=>{const te=new D.$SQ(Z);!te.equals(10)&&!te.equals(3)||S(te)}))}G.supportHtml||(fe.sanitizer=S=>(G.isTrusted?S.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?S:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=A;let u=G.value??"";u.length>1e5&&(u=`${u.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(u=(0,c.$sk)(u));let n;if(ie.fillInIncompleteTokens){const S={...a.marked.defaults,...fe},O=a.marked.lexer(u,S),q=de(O);n=a.marked.parser(q,S)}else n=a.marked.parse(u,fe);G.supportThemeIcons&&(n=(0,$.$uT)(n).map(O=>typeof O=="string"?O:O.outerHTML).join(""));const C=new DOMParser().parseFromString(z(G,n),"text/html");if(C.body.querySelectorAll("img").forEach(S=>{const O=S.getAttribute("src");if(O){let q=O;try{G.baseUri&&(q=P(r.URI.from(G.baseUri),q))}catch{}S.src=f(q,!0)}}),C.body.querySelectorAll("a").forEach(S=>{const O=S.getAttribute("href");if(S.setAttribute("href",""),!O||/^data:|javascript:/i.test(O)||/^command:/i.test(O)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(O))S.replaceWith(...S.childNodes);else{let q=f(O,!1);G.baseUri&&(q=P(r.URI.from(G.baseUri),O)),S.dataset.href=q}}),ye.innerHTML=z(G,C.body.innerHTML),F.length>0)Promise.all(F).then(S=>{if(Fe)return;const O=new Map(S),q=ye.querySelectorAll("div[data-code]");for(const Z of q){const te=O.get(Z.dataset.code??"");te&&i.$YR(Z,te)}ie.asyncRenderCallback?.()});else if(l.length>0){const S=new Map(l),O=ye.querySelectorAll("div[data-code]");for(const q of O){const Z=S.get(q.dataset.code??"");Z&&i.$YR(q,Z)}}if(ie.asyncRenderCallback)for(const S of ye.getElementsByTagName("img")){const O=De.add(i.$VQ(S,"load",()=>{O.dispose(),ie.asyncRenderCallback()}))}return{element:ye,dispose:()=>{Fe=!0,De.dispose()}}}e.$wT=N;function M(G){if(!G)return"";const ie=G.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:G}function P(G,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:G.path.endsWith("/")?(0,o.$Wg)(G,ie).toString():(0,o.$Wg)((0,o.$Sg)(G),ie).toString()}function z(G,ie){const{config:fe,allowedSchemes:De}=v(G);R.addHook("uponSanitizeAttribute",(ye,K)=>{if(K.attrName==="style"||K.attrName==="class"){if(ye.tagName==="SPAN"){if(K.attrName==="style"){K.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(K.attrValue);return}else if(K.attrName==="class"){K.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(K.attrValue);return}}K.keepAttr=!1;return}else if(ye.tagName==="INPUT"&&ye.attributes.getNamedItem("type")?.value==="checkbox"){if(K.attrName==="type"&&K.attrValue==="checkbox"||K.attrName==="disabled"||K.attrName==="checked"){K.keepAttr=!0;return}K.keepAttr=!1}}),R.addHook("uponSanitizeElement",(ye,K)=>{K.tagName==="input"&&(ye.attributes.getNamedItem("type")?.value==="checkbox"?ye.setAttribute("disabled",""):ye.parentElement?.removeChild(ye))});const Fe=i.$gS(De);try{return R.sanitize(ie,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{R.removeHook("uponSanitizeAttribute"),Fe.dispose()}}e.$xT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function v(G){const ie=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return G.isTrusted&&ie.push(p.Schemas.command),{config:{ALLOWED_TAGS:[...i.$hS],ALLOWED_ATTR:e.$xT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function H(G){return typeof G=="string"?G:V(G)}e.$yT=H;function V(G){let ie=G.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const fe=a.marked.parse(ie,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,De=>T.get(De)??De);return z({isTrusted:!1},fe).toString()}e.$zT=V;const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new t.$V(()=>{const G=new a.marked.Renderer;return G.code=ie=>ie,G.blockquote=ie=>ie,G.html=ie=>"",G.heading=(ie,fe,De)=>ie+`
`,G.hr=()=>"",G.list=(ie,fe)=>ie,G.listitem=ie=>ie+`
`,G.paragraph=ie=>ie+`
`,G.table=(ie,fe)=>ie+fe+`
`,G.tablerow=ie=>ie,G.tablecell=(ie,fe)=>ie+" ",G.strong=ie=>ie,G.em=ie=>ie,G.codespan=ie=>ie,G.br=()=>`
`,G.del=ie=>ie,G.image=(ie,fe,De)=>"",G.text=ie=>ie,G.link=(ie,fe,De)=>De,G});function I(G){let ie="";return G.forEach(fe=>{ie+=fe.raw}),ie}function X(G){for(let ie=0;ie<G.tokens.length;ie++){const fe=G.tokens[ie];if(fe.type==="text"){const De=fe.raw.split(`
`),Fe=De[De.length-1];if(Fe.includes("`"))return ne(G);if(Fe.includes("**"))return _(G);if(Fe.match(/\*\w/))return ge(G);if(Fe.match(/(^|\s)__\w/))return ae(G);if(Fe.match(/(^|\s)_\w/))return Ce(G);if(Fe.match(/(^|\s)\[.*\]\(\w*/)){const ye=G.tokens.slice(ie+1);return ye[0]?.type==="link"&&ye[1]?.type==="text"&&ye[1].raw.match(/^ *"[^"]*$/)?Be(G):Re(G)}else{if(U(Fe))return Re(G);if(Fe.match(/(^|\s)\[\w/)&&!G.tokens.slice(ie+1).some(ye=>U(ye.raw)))return le(G)}}}}function U(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function de(G){let ie,fe;for(ie=0;ie<G.length;ie++){const De=G[ie];let Fe;if(De.type==="paragraph"&&(Fe=De.raw.match(/(\n|^)(````*)/))){const ye=Fe[2];fe=he(G.slice(ie),ye);break}if(De.type==="paragraph"&&De.raw.match(/(\n|^)\|/)){fe=J(G.slice(ie));break}if(ie===G.length-1&&De.type==="paragraph"){const ye=X(De);if(ye){fe=[ye];break}}}if(fe){const De=[...G.slice(0,ie),...fe];return De.links=G.links,De}return G}e.$AT=de;function he(G,ie){const fe=I(G);return a.marked.lexer(fe+`
${ie}`)}function ne(G){return oe(G,"`")}function ge(G){return oe(G,"*")}function Ce(G){return oe(G,"_")}function Re(G){return oe(G,")")}function Be(G){return oe(G,'")')}function le(G){return oe(G,"](about:blank)")}function _(G){return oe(G,"**")}function ae(G){return oe(G,"__")}function oe(G,ie){const fe=I(Array.isArray(G)?G:[G]);return a.marked.lexer(fe+ie)[0]}function J(G){const ie=I(G),fe=ie.split(`
`);let De,Fe=!1;for(let ye=0;ye<fe.length;ye++){const K=fe[ye].trim();if(typeof De>"u"&&K.match(/^\s*\|/)){const f=K.match(/(\|[^\|]+)(?=\||$)/g);f&&(De=f.length)}else if(typeof De=="number")if(K.match(/^\s*\|/)){if(ye!==fe.length-1)return;Fe=!0}else return}if(typeof De=="number"&&De>0){const ye=Fe?fe.slice(0,-1).join(`
`):ie,K=!!ye.match(/\|\s*$/),f=ye+(K?"":"|")+`
|${" --- |".repeat(De)}`;return a.marked.lexer(f)}}}),define(me[33],$e([1,0,2,9,30,65,39,3,7,112]),function(re,e,i,R,j,W,D,y,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OS=e.$NS=void 0;function k(t,s){(0,$.$Tf)(s)?t.title=(0,D.$tk)(s):s?.markdownNotSupportedFallback?t.title=s.markdownNotSupportedFallback:t.removeAttribute("title")}e.$NS=k;class B{constructor(s,a,m){this.c=s,this.d=a,this.f=m}async update(s,a,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let p;if(s===void 0||(0,$.$Tf)(s)||s instanceof HTMLElement)p=s;else if(!(0,$.$8f)(s.markdown))p=s.markdown??s.markdownNotSupportedFallback;else{this.a||this.g((0,b.localize)(0,null),a),this.b=new j.$de;const w=this.b.token;if(p=await s.markdown(w),p===void 0&&(p=s.markdownNotSupportedFallback),this.isDisposed||w.isCancellationRequested)return}this.g(p,a,m)}g(s,a,m){const p=this.a;if(this.h(s)){const w={content:s,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!p},position:{hoverPosition:2},...m};this.a=this.c.showHover(w,a)}p?.dispose()}h(s){return s?(0,W.$zk)(s)?!!s.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function c(t,s){for(s=s??i.getWindow(t).document.body;!t.hasAttribute("custom-hover")&&t!==s;)t=t.parentElement;return t}function d(t,s,a,m){s.setAttribute("custom-hover","true"),s.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",s.title),s.title="");let p,w;const o=(L,I)=>{const X=w!==void 0;L&&(w?.dispose(),w=void 0),I&&(p?.dispose(),p=void 0),X&&(t.onDidHideHover?.(),w=void 0)},g=(L,I,X)=>new R.$qh(async()=>{(!w||w.isDisposed)&&(w=new B(t,X||s,L>0),await w.update(typeof a=="function"?a():a,I,m))},L);let r=!1;const E=i.$VQ(s,i.$PR.MOUSE_DOWN,()=>{r=!0,o(!0,!0)},!0),N=i.$VQ(s,i.$PR.MOUSE_UP,()=>{r=!1},!0),M=i.$VQ(s,i.$PR.MOUSE_LEAVE,L=>{r=!1,o(!1,L.fromElement===s)},!0),P=L=>{if(p)return;const I=new y.$Sc,X={targetElements:[s],dispose:()=>{}};if(t.placement===void 0||t.placement==="mouse"){const U=de=>{X.x=de.x+10,de.target instanceof HTMLElement&&c(de.target,s)!==s&&o(!0,!0)};I.add(i.$VQ(s,i.$PR.MOUSE_MOVE,U,!0))}p=I,!(L.target instanceof HTMLElement&&c(L.target,s)!==s)&&I.add(g(t.delay,!1,X))},z=i.$VQ(s,i.$PR.MOUSE_OVER,P,!0),v=()=>{if(r||p)return;const L={targetElements:[s],dispose:()=>{}},I=new y.$Sc,X=()=>o(!0,!0);I.add(i.$VQ(s,i.$PR.BLUR,X,!0)),I.add(g(t.delay,!1,L)),p=I};let H;const V=s.tagName.toLowerCase();return V!=="input"&&V!=="textarea"&&(H=i.$VQ(s,i.$PR.FOCUS,v,!0)),{show:L=>{o(!1,!0),g(0,L)},hide:()=>{o(!0,!0)},update:async(L,I)=>{a=L,await w?.update(a,void 0,I)},dispose:()=>{z.dispose(),M.dispose(),E.dispose(),N.dispose(),H?.dispose(),o(!0,!0)}}}e.$OS=d}),define(me[131],$e([1,0,2,24,15,130,14,33,43,12,4,48,3,5,114,105]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BT=void 0;const s=i.$,a="selectOption.entry.template";class m{get templateId(){return a}renderTemplate(o){const g=Object.create(null);return g.root=o,g.text=i.$WR(o,s(".option-text")),g.detail=i.$WR(o,s(".option-detail")),g.decoratorRight=i.$WR(o,s(".option-decorator-right")),g}renderElement(o,g,r){const E=r,N=o.text,M=o.detail,P=o.decoratorRight,z=o.isDisabled;E.text.textContent=N,E.detail.textContent=M||"",E.decoratorRight.innerText=P||"",z?E.root.classList.add("option-disabled"):E.root.classList.remove("option-disabled")}disposeTemplate(o){}}class p extends c.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,g,r,E,N){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=E,this.g=N||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=p.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new k.$6d,this.B(this.r),this.Q(),this.P(r),this.n=g||0,o&&this.setOptions(o,g),this.S()}O(o){!this.M&&o?this.M=this.B((0,y.$OS)((0,D.$QS)("mouse"),this.h,o)):this.M&&this.M.update(o)}getHeight(){return 22}getTemplateId(){return a}P(o){this.u=o,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$WR(this.w,s(".select-box-details-pane"));const g=i.$WR(this.w,s(".select-box-dropdown-container-width-control")),r=i.$WR(g,s(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$WR(r,this.D),this.G=0,this.y=i.$ER(this.w),this.w.setAttribute("draggable","true"),this.B(i.$VQ(this.w,i.$PR.DRAG_START,E=>{i.$RR.stop(E,!0)}))}Q(){this.B(i.$WQ(this.h,"change",g=>{this.n=g.target.selectedIndex,this.r.fire({index:g.target.selectedIndex,selected:g.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$VQ(this.h,i.$PR.CLICK,g=>{i.$RR.stop(g),this.f?this.Z(!0):this.Y()})),this.B(i.$VQ(this.h,i.$PR.MOUSE_DOWN,g=>{i.$RR.stop(g)}));let o;this.B(i.$VQ(this.h,"touchstart",g=>{o=this.f})),this.B(i.$VQ(this.h,"touchend",g=>{i.$RR.stop(g),o?this.Z(!0):this.Y()})),this.B(i.$VQ(this.h,i.$PR.KEY_DOWN,g=>{const r=new j.$SQ(g);let E=!1;d.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(E=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(E=!0),E&&(this.Y(),i.$RR.stop(g,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,g){b.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,E)=>{this.h.add(this.X(r.text,E,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),g!==void 0&&(this.select(g),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.U()}S(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}U(){const o=this.s.selectBackground??"",g=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=g,this.h.style.borderColor=r}W(){const o=this.s.selectBackground??"",g=i.$cS(this.s.selectListBackground,o);this.C.style.backgroundColor=g,this.I.style.backgroundColor=g;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(o,g,r){const E=document.createElement("option");return E.value=o,E.text=o,E.disabled=!!r,E}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.ab(o),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}ab(o,g){return o.appendChild(this.w),this.cb(g),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}bb(){let o=0;return this.m.forEach((g,r)=>{this.jb(r),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}cb(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const g=i.getWindow(this.h),r=i.$fR(this.h),E=i.getWindow(this.h).getComputedStyle(this.h),N=parseFloat(E.getPropertyValue("--dropdown-padding-top"))+parseFloat(E.getPropertyValue("--dropdown-padding-bottom")),M=g.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),P=r.top-p.b,z=this.h.offsetWidth,v=this.db(this.D),H=Math.max(v,Math.round(z)).toString()+"px";this.w.style.width=H,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const T=this.H?this.L:0,L=V+N+T,I=Math.floor((M-N-T)/this.getHeight()),X=Math.floor((P-N-T)/this.getHeight());if(o)return r.top+r.height>g.innerHeight-22||r.top<p.b||I<1&&X<1?!1:(I<p.c&&X>I&&this.m.length>I?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>g.innerHeight-22||r.top<p.b||this.G===0&&I<1||this.G===1&&X<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&I+X<1)return this.Z(!0),!1;L>M&&(V=I*this.getHeight())}else L>P&&(V=X*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+N+"px",this.w.style.height=""):this.w.style.height=V+N+"px",this.jb(this.n),this.w.style.width=H,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(o){let g=0;if(o){let r=0,E=0;this.m.forEach((N,M)=>{const P=N.detail?N.detail.length:0,z=N.decoratorRight?N.decoratorRight.length:0,v=N.text.length+P+z;v>E&&(r=M,E=v)}),o.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),g=i.$hR(o)}return g}eb(o){if(this.z)return;this.C=i.$WR(o,s(".select-box-dropdown-list-container")),this.t=new m,this.z=new $.$tT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:E=>{let N=E.text;return E.detail&&(N+=`. ${E.detail}`),E.decoratorRight&&(N+=`. ${E.decoratorRight}`),E.description&&(N+=`. ${E.description}`),N},getWidgetAriaLabel:()=>(0,t.localize)(0,null),getRole:()=>d.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const g=this.B(new R.$1S(this.C,"keydown")),r=k.Event.chain(g.event,E=>E.filter(()=>this.z.length>0).map(N=>new j.$SQ(N)));this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===3))(this.lb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===2))(this.lb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===9))(this.kb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===16))(this.nb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===18))(this.mb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===12))(this.pb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===11))(this.ob,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===14))(this.qb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode===13))(this.rb,this)),this.B(k.Event.chain(r,E=>E.filter(N=>N.keyCode>=21&&N.keyCode<=56||N.keyCode>=85&&N.keyCode<=113))(this.sb,this)),this.B(i.$VQ(this.z.getHTMLElement(),i.$PR.POINTER_UP,E=>this.fb(E))),this.B(this.z.onMouseOver(E=>typeof E.index<"u"&&this.z.setFocus([E.index]))),this.B(this.z.onDidChangeFocus(E=>this.ib(E))),this.B(i.$VQ(this.w,i.$PR.FOCUS_OUT,E=>{!this.f||i.$nR(E.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(o){if(!this.z.length)return;i.$RR.stop(o);const g=o.target;if(!g||g.classList.contains("slider"))return;const r=g.closest(".monaco-list-row");if(!r)return;const E=Number(r.getAttribute("data-index")),N=r.classList.contains("option-disabled");E>=0&&E<this.m.length&&!N&&(this.n=E,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(o,g){const r=N=>{for(let M=0;M<N.childNodes.length;M++){const P=N.childNodes.item(M);(P.tagName&&P.tagName.toLowerCase())==="img"?N.removeChild(P):r(P)}},E=(0,W.$wT)({value:o,supportThemeIcons:!0},{actionHandler:g});return E.element.classList.add("select-box-description-markdown"),r(E.element),E.element}ib(o){!this.f||!this.H||this.jb(o.indexes[0])}jb(o){this.I.innerText="";const g=this.m[o],r=g?.description??"",E=g?.descriptionIsMarkdown??!1;if(r){if(E){const N=g.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,N))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(o){i.$RR.stop(o),this.select(this.F),this.Z(!0)}lb(o){i.$RR.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(o){if(this.n<this.m.length-1){i.$RR.stop(o,!0);const g=this.m[this.n+1].isDisabled;if(g&&this.m.length>this.n+2)this.n+=2;else{if(g)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(o){this.n>0&&(i.$RR.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(o){i.$RR.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(o){i.$RR.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(o){i.$RR.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(o){i.$RR.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(o){const g=B.KeyCodeUtils.toString(o.keyCode);let r=-1;for(let E=0;E<this.m.length-1;E++)if(r=(E+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===g&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$RR.stop(o);break}}dispose(){this.Z(!1),super.dispose()}}e.$BT=p}),define(me[132],$e([1,0,43,131,126,21,5,104]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ET=e.$DT=void 0,e.$DT={...i.$sT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends W.$xS{constructor(b,k,B,c,d){super(),D.$j&&!d?.useCustomDrawn?this.a=new j.$CT(b,k,c,d):this.a=new R.$BT(b,k,B,c,d),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(b,k){this.a.setOptions(b,k)}select(b){this.a.select(b)}setAriaLabel(b){this.a.setAriaLabel(b)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(b){this.a.setFocusable(b)}render(b){this.a.render(b)}}e.$ET=y}),define(me[66],$e([1,0,17,57,2,26,14,33,132,40,3,5,7,109,55]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MT=e.$LT=e.$KT=void 0;class t extends k.$Tc{get action(){return this._action}constructor(p,w,o={}){super(),this.m=o,this._context=p||this,this._action=w,w instanceof b.$Xi&&this.B(w.onDidChange(g=>{this.element&&this.t(g)}))}t(p){p.enabled!==void 0&&this.u(),p.checked!==void 0&&this.H(),p.class!==void 0&&this.G(),p.label!==void 0&&(this.w(),this.D()),p.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$Yi)),this.j}set actionRunner(p){this.j=p}isEnabled(){return this._action.enabled}setActionContext(p){this._context=p}render(p){const w=this.element=p;this.B(W.$tS.addTarget(p));const o=this.m&&this.m.draggable;o&&(p.draggable=!0,i.$BQ&&this.B((0,j.$VQ)(p,j.$PR.DRAG_START,g=>g.dataTransfer?.setData(R.$rS.TEXT,this._action.label)))),this.B((0,j.$VQ)(w,W.EventType.Tap,g=>this.onClick(g,!0))),this.B((0,j.$VQ)(w,j.$PR.MOUSE_DOWN,g=>{o||j.$RR.stop(g,!0),this._action.enabled&&g.button===0&&w.classList.add("active")})),B.$j&&this.B((0,j.$VQ)(w,j.$PR.CONTEXT_MENU,g=>{g.button===0&&g.ctrlKey===!0&&this.onClick(g)})),this.B((0,j.$VQ)(w,j.$PR.CLICK,g=>{j.$RR.stop(g,!0),this.m&&this.m.isMenu||this.onClick(g)})),this.B((0,j.$VQ)(w,j.$PR.DBLCLICK,g=>{j.$RR.stop(g,!0)})),[j.$PR.MOUSE_UP,j.$PR.MOUSE_OUT].forEach(g=>{this.B((0,j.$VQ)(w,g,r=>{j.$RR.stop(r),w.classList.remove("active")}))})}onClick(p,w=!1){j.$RR.stop(p,!0);const o=c.$3f(this._context)?this.m?.useEventAsContext?p:{preserveFocus:w}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(p){this.element&&(this.element.tabIndex=p?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const p=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=p;else if(!this.f&&p!==""){const w=this.m.hoverDelegate??(0,D.$QS)("element");this.f=this.q.add((0,y.$OS)(w,this.element,p))}else this.f&&this.f.update(p)}F(){if(this.element){const p=this.C()??"";this.element.setAttribute("aria-label",p)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}e.$KT=t;class s extends t{constructor(p,w,o){super(p,w,o),this.m=o,this.m.icon=o.icon!==void 0?o.icon:!1,this.m.label=o.label!==void 0?o.label:!0,this.L=""}render(p){super.render(p),c.$4f(this.element);const w=document.createElement("a");if(w.classList.add("action-label"),w.setAttribute("role",this.M()),this.I=w,this.element.appendChild(w),this.m.label&&this.m.keybinding){const o=document.createElement("span");o.classList.add("keybinding"),o.textContent=this.m.keybinding,this.element.appendChild(o)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$Zi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(p){this.I&&(this.I.tabIndex=p?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let p=null;return this.action.tooltip?p=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(p=this.action.label,this.m.keybinding&&(p=d.localize(0,null,p,this.m.keybinding))),p??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const p=this.C()??"";this.I.setAttribute("aria-label",p)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}e.$LT=s;class a extends t{constructor(p,w,o,g,r,E,N){super(p,w),this.b=new $.$ET(o,g,r,E,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(p,w){this.b.setOptions(p,w)}select(p){this.b.select(p)}g(){this.B(this.b.onDidSelect(p=>this.n(p.selected,p.index)))}n(p,w){this.actionRunner.run(this._action,this.r(p,w))}r(p,w){return p}setFocusable(p){this.b.setFocusable(p)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(p){this.b.render(p)}}e.$MT=a}),define(me[67],$e([1,0,2,15,66,14,40,4,3,7,55]),function(re,e,i,R,j,W,D,y,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=e.$SS=e.ActionsOrientation=void 0;var k;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(k||(e.ActionsOrientation=k={}));class B extends $.$Tc{constructor(t,s={}){super(),this.j=this.B(new $.$Sc),this.s=this.B(new $.$3c),this.y=!1,this.z=!0,this.D=this.B(new y.$6d),this.onDidBlur=this.D.event,this.F=this.B(new y.$6d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new y.$6d),this.onDidRun=this.H.event,this.I=this.B(new y.$6d),this.onWillRun=this.I.event,this.b=s,this.m=s.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=s.hoverDelegate??this.B((0,W.$RS)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new D.$Yi,this.j.add(this.g)),this.j.add(this.g.onDidRun(p=>this.H.fire(p))),this.j.add(this.g.onWillRun(p=>this.I.fire(p))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let a,m;switch(this.n){case 0:a=[15],m=[17];break;case 1:a=[16],m=[18],this.domNode.className+=" vertical";break}this.B(i.$VQ(this.domNode,i.$PR.KEY_DOWN,p=>{const w=new R.$SQ(p);let o=!0;const g=typeof this.u=="number"?this.viewItems[this.u]:void 0;a&&(w.equals(a[0])||w.equals(a[1]))?o=this.Q():m&&(w.equals(m[0])||w.equals(m[1]))?o=this.P():w.equals(9)&&this.G?this.F.fire():w.equals(14)?o=this.N():w.equals(13)?o=this.O():w.equals(2)&&g instanceof j.$KT&&g.trapsArrowNavigation?o=this.P():this.L(w)?this.r.keyDown?this.S(w):this.y=!0:o=!1,o&&(w.preventDefault(),w.stopPropagation())})),this.B(i.$VQ(this.domNode,i.$PR.KEY_UP,p=>{const w=new R.$SQ(p);this.L(w)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(w)),w.preventDefault(),w.stopPropagation()):(w.equals(2)||w.equals(1026)||w.equals(16)||w.equals(18)||w.equals(15)||w.equals(17))&&this.M()})),this.w=this.B(i.$UR(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$vR()===this.domNode||!i.$nR(i.$vR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),t.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(t){t?this.C.setAttribute("aria-label",t):this.C.removeAttribute("aria-label")}setFocusable(t){if(this.z=t,this.z){const s=this.viewItems.find(a=>a instanceof j.$KT&&a.isEnabled());s instanceof j.$KT&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof j.$KT&&s.setFocusable(!1)})}L(t){let s=!1;return this.r.keys.forEach(a=>{s=s||t.equals(a)}),s}M(){for(let t=0;t<this.C.children.length;t++){const s=this.C.children[t];if(i.$nR(i.$vR(),s)){this.u=t,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(t){this.m=t,this.viewItems.forEach(s=>s.setActionContext(t))}get actionRunner(){return this.g}set actionRunner(t){this.g=t,this.j.clear(),this.j.add(this.g.onDidRun(s=>this.H.fire(s))),this.j.add(this.g.onWillRun(s=>this.I.fire(s))),this.viewItems.forEach(s=>s.actionRunner=t)}getContainer(){return this.domNode}hasAction(t){return this.viewItems.findIndex(s=>s.action.id===t.id)!==-1}getAction(t){if(typeof t=="number")return this.viewItems[t]?.action;if(t instanceof HTMLElement){for(;t.parentElement!==this.C;){if(!t.parentElement)return;t=t.parentElement}for(let s=0;s<this.C.childNodes.length;s++)if(this.C.childNodes[s]===t)return this.viewItems[s].action}}push(t,s={}){const a=Array.isArray(t)?t:[t];let m=b.$Xf(s.index)?s.index:null;a.forEach(p=>{const w=document.createElement("li");w.className="action-item",w.setAttribute("role","presentation");let o;const g={hoverDelegate:this.f,...s};this.b.actionViewItemProvider&&(o=this.b.actionViewItemProvider(p,g)),o||(o=new j.$LT(this.context,p,g)),this.b.allowContextMenu||this.s.set(o,i.$VQ(w,i.$PR.CONTEXT_MENU,r=>{i.$RR.stop(r,!0)})),o.actionRunner=this.g,o.setActionContext(this.context),o.render(w),this.z&&o instanceof j.$KT&&this.viewItems.length===0&&o.setFocusable(!0),m===null||m<0||m>=this.C.children.length?(this.C.appendChild(w),this.viewItems.push(o)):(this.C.insertBefore(w,this.C.children[m]),this.viewItems.splice(m,0,o),m++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientWidth}return 0}getHeight(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientHeight}return 0}pull(t){t>=0&&t<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[t]),this.s.deleteAndDispose(this.viewItems[t]),(0,$.$Oc)(this.viewItems.splice(t,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,$.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),i.$UQ(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(t){let s=!1,a;if(t===void 0?s=!0:typeof t=="number"?a=t:typeof t=="boolean"&&(s=t),s&&typeof this.u>"u"){const m=this.viewItems.findIndex(p=>p.isEnabled());this.u=m===-1?void 0:m,this.R(void 0,void 0,!0)}else a!==void 0&&(this.u=a),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(t){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(!t&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=s,!1;this.u=(this.u+1)%this.viewItems.length,a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===D.$Zi.ID));return this.R(),!0}Q(t){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(this.u=this.u-1,this.u<0){if(!t&&this.b.preventLoopNavigation)return this.u=s,!1;this.u=this.viewItems.length-1}a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===D.$Zi.ID));return this.R(!0),!0}R(t,s,a=!1){typeof this.u>"u"&&this.C.focus({preventScroll:s}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const m=this.u!==void 0?this.viewItems[this.u]:void 0;if(m){let p=!0;b.$8f(m.focus)||(p=!1),this.b.focusOnlyEnabledItems&&b.$8f(m.isEnabled)&&!m.isEnabled()&&(p=!1),m.action.id===D.$Zi.ID&&(p=!1),p?(a||this.t!==this.u)&&(m.focus(t),this.t=this.u):(this.C.focus({preventScroll:s}),this.t=void 0),p&&m.showHover?.()}}S(t){if(typeof this.u>"u")return;const s=this.viewItems[this.u];if(s instanceof j.$KT){const a=s._context===null||s._context===void 0?t:s._context;this.run(s._action,a)}}async run(t,s){await this.g.run(t,s)}dispose(){this.m=void 0,this.viewItems=(0,$.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}e.$SS=B;function c(d){if(!d.length)return d;let t=-1;for(let a=0;a<d.length;a++)if(d[a].id!==D.$Zi.ID){t=a;break}if(t===-1)return[];d=d.slice(t);for(let a=d.length-1;a>=0&&d[a].id===D.$Zi.ID;a--)d.splice(a,1);let s=!1;for(let a=d.length-1;a>=0;a--){const m=d[a].id===D.$Zi.ID;m&&!s?d.splice(a,1):m?m&&(s=!1):s=!0}return d}e.$TS=c}),define(me[68],$e([1,0,2,24,58,67,60,14,33,63,21,4,85,54,113,101]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sU=e.$rU=e.$qU=e.MessageType=void 0;const s=i.$;var a;(function(w){w[w.INFO=1]="INFO",w[w.WARNING=2]="WARNING",w[w.ERROR=3]="ERROR"})(a||(e.MessageType=a={})),e.$qU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class m extends k.$xS{constructor(o,g,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new B.$6d),this.onDidChange=this.P.event,this.Q=this.B(new B.$6d),this.onDidHeightChange=this.Q.event,this.a=g,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$WR(o,s(".monaco-inputbox.idle"));const E=this.g.flexibleHeight?"textarea":"input",N=i.$WR(this.element,s(".ibwrapper"));if(this.b=i.$WR(N,s(E+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$WR(N,s("div.mirror")),this.y.innerText="\xA0",this.N=new b.$HS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$WR(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(z=>this.b.scrollTop=z.scrollTop));const M=this.B(new R.$1S(o.ownerDocument,"selectionchange")),P=B.Event.filter(M.event,()=>o.ownerDocument.getSelection()?.anchorNode===N);this.B(P(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new W.$SS(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.O?this.O.update(o):this.O=this.B((0,$.$OS)((0,y.$QS)("mouse"),this.b,o))}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Z())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:i.$lR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$wR(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(o){o?this.enable():this.disable()}get width(){return i.$hR(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,E=parseFloat(this.y.style.paddingRight||"")||0;g=r+E}this.b.style.width=o-g+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,g=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:g}),this.N.setScrollPosition({scrollTop:r})}showMessage(o,g){if(this.w==="open"&&(0,d.$Pn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(o.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$cS(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const g=this.g.inputBoxStyles;switch(o){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}W(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let o;const g=()=>o.style.width=i.$hR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:E=>{if(!this.h)return null;o=i.$WR(E,s(".monaco-inputbox-container")),g();const N={inline:!0,className:"monaco-inputbox-message"},M=this.h.formatContent?(0,j.$YS)(this.h.content,N):(0,j.$XS)(this.h.content,N);M.classList.add(this.W(this.h.type));const P=this.stylesForType(this.h.type);return M.style.backgroundColor=P.background??"",M.style.color=P.foreground??"",M.style.border=P.border?`1px solid ${P.border}`:"",i.$WR(o,M),null},onHide:()=>{this.w="closed"},layout:g});let r;this.h.type===3?r=t.localize(0,null,this.h.content):this.h.type===2?r=t.localize(1,null,this.h.content):r=t.localize(2,null,this.h.content),D.$3S(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const o=this.value,r=o.charCodeAt(o.length-1)===10?" ":"";(o+r).replace(/\u000c/g,"")?this.y.textContent=o+r:this.y.innerText="\xA0",this.layout()}bb(){const o=this.g.inputBoxStyles,g=o.inputBackground??"",r=o.inputForeground??"",E=o.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$cS(E,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=i.$lR(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(o){const g=this.inputElement,r=g.selectionStart,E=g.selectionEnd,N=g.value;r!==null&&E!==null&&(this.value=N.substr(0,r)+o+N.substr(E),g.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}e.$rU=m;class p extends m{constructor(o,g,r){const E=t.localize(3,null,"\u21C5"),N=t.localize(4,null,"\u21C5");super(o,g,r),this.eb=this.B(new B.$6d),this.onDidFocus=this.eb.event,this.fb=this.B(new B.$6d),this.onDidBlur=this.fb.event,this.cb=new c.$oU(r.history,100);const M=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(E)&&!this.n.endsWith(N)&&this.cb.getHistory().length){const P=this.n.endsWith(")")?E:N,z=this.n+P;r.showPlaceholderOnFocus&&!i.$wR(this.b)?this.n=z:this.setPlaceHolder(z)}};this.db=new MutationObserver((P,z)=>{P.forEach(v=>{v.target.textContent||M()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>M()),this.F(this.b,()=>{const P=z=>{if(this.n.endsWith(z)){const v=this.n.slice(0,this.n.length-z.length);return r.showPlaceholderOnFocus?this.n=v:this.setPlaceHolder(v),!0}else return!1};P(N)||P(E)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(o){this.value&&(o||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(o){const g=this.getHistory();this.clearHistory(),o.forEach(r=>{this.cb.add(r)}),g.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let o=this.kb();o&&(o=o===this.value?this.kb():o),this.value=o??"",D.$4S(this.value?this.value:t.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),o&&(this.value=o,D.$4S(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let o=this.cb.current();return o||(o=this.cb.last(),this.cb.next()),o}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}e.$sU=p}),define(me[69],$e([1,0,66,21,18,19,4,2,33,14,106]),function(re,e,i,R,j,W,D,y,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JT=e.$IT=e.$HT=e.$GT=e.$FT=void 0,e.$FT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class k extends i.$KT{constructor(s,a,m){super(s,a,m),this.a=this.B(new B({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:m.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:m.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:m.toggleStyles?.inputActiveOptionForeground,hoverDelegate:m.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$GT=k;class B extends R.$xS{constructor(s){super(),this.a=this.B(new D.$6d),this.onChange=this.a.event,this.b=this.B(new D.$6d),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,$.$OS)(s.hoverDelegate??(0,b.$QS)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,m=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),m.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,m=>{if(m.keyCode===10||m.keyCode===3){this.checked=!this.s,this.a.fire(!0),m.preventDefault(),m.stopPropagation();return}this.b.fire(m)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(s){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.t.update(s),this.domNode.setAttribute("aria-label",s)}}e.$HT=B;class c extends R.$xS{constructor(s,a,m){super(),this.g=s,this.h=a,this.a=this.B(new D.$6d),this.onChange=this.a.event,this.b=new B({title:this.g,isChecked:this.h,icon:j.$pk.check,actionClassName:"monaco-checkbox",...e.$FT}),this.domNode=this.b.domNode,this.c=m,this.n(),this.B(this.b.onChange(p=>{this.n(),this.a.fire(p)}))}get checked(){return this.b.checked}set checked(s){this.b.checked=s,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$wR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}e.$IT=c;class d extends i.$KT{constructor(s,a,m){super(s,a,m),this.a=this.B(new c(this._action.label,!!this._action.checked,m.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const a=this.element.appendChild((0,y.$)("span.checkbox-label",void 0,this._action.label));this.B((0,y.$VQ)(a,y.$PR.CLICK,m=>{this.a.checked=!this.a.checked,m.stopPropagation(),m.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$JT=d}),define(me[133],$e([1,0,14,69,18,111]),function(re,e,i,R,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FU=e.$EU=e.$DU=void 0;const D=W.localize(0,null),y=W.localize(1,null),$=W.localize(2,null);class b extends R.$HT{constructor(d){super({icon:j.$pk.caseSensitive,title:D+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$QS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$DU=b;class k extends R.$HT{constructor(d){super({icon:j.$pk.wholeWord,title:y+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$QS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$EU=k;class B extends R.$HT{constructor(d){super({icon:j.$pk.regex,title:$+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$QS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$FU=B}),define(me[134],$e([1,0,2,133,68,21,4,110,3,14,100]),function(re,e,i,R,j,W,D,y,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GU=void 0;const k=y.localize(0,null);class B extends W.$xS{static{this.OPTION_CHANGE="optionChange"}constructor(d,t,s){super(),this.n=!0,this.s=!1,this.w=this.B(new $.$Uc),this.N=[],this.O=this.B(new D.$6d),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$6d),this.onKeyDown=this.P.event,this.Q=this.B(new D.$6d),this.onMouseDown=this.Q.event,this.R=this.B(new D.$6d),this.onInput=this.R.event,this.S=this.B(new D.$6d),this.onKeyUp=this.S.event,this.U=this.B(new D.$6d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$6d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=s.placeholder||"",this.b=s.validation,this.c=s.label||k,this.h=!!s.showCommonFindToggles;const a=s.appendCaseSensitiveLabel||"",m=s.appendWholeWordsLabel||"",p=s.appendRegexLabel||"",w=s.history||[],o=!!s.flexibleHeight,g=!!s.flexibleWidth,r=s.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new j.$sU(this.domNode,t,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:w,showHistoryHint:s.showHistoryHint,flexibleHeight:o,flexibleWidth:g,flexibleMaxHeight:r,inputBoxStyles:s.inputBoxStyles}));const E=this.B((0,b.$RS)());if(this.h){this.J=this.B(new R.$FU({appendTitle:p,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.J.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(M=>{this.W.fire(M)})),this.L=this.B(new R.$EU({appendTitle:m,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.L.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new R.$DU({appendTitle:a,isChecked:!1,hoverDelegate:E,...s.toggleStyles})),this.B(this.M.onChange(M=>{this.O.fire(M),!M&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(M=>{this.U.fire(M)}));const N=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,M=>{if(M.equals(15)||M.equals(17)||M.equals(9)){const P=N.indexOf(this.domNode.ownerDocument.activeElement);if(P>=0){let z=-1;M.equals(17)?z=(P+1)%N.length:M.equals(15)&&(P===0?z=N.length-1:z=P-1),M.equals(9)?(N[P].blur(),this.inputBox.focus()):z>=0&&N[z].focus(),i.$RR.stop(M,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(s?.additionalToggles),this.y&&this.domNode.appendChild(this.y),d?.appendChild(this.domNode),this.B(i.$VQ(this.inputBox.inputElement,"compositionstart",N=>{this.s=!0})),this.B(i.$VQ(this.inputBox.inputElement,"compositionend",N=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,N=>this.P.fire(N)),this.C(this.inputBox.inputElement,N=>this.S.fire(N)),this.D(this.inputBox.inputElement,N=>this.R.fire()),this.j(this.inputBox.inputElement,N=>this.Q.fire(N))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(d){this.inputBox.layout(),this.X(d.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const d of this.N)d.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const d of this.N)d.disable()}setFocusInputOnOptionClick(d){this.n=d}setEnabled(d){d?this.enable():this.disable()}setAdditionalToggles(d){for(const t of this.N)t.domNode.remove();this.N=[],this.w.value=new $.$Sc;for(const t of d??[])this.w.value.add(t),this.y.appendChild(t.domNode),this.w.value.add(t.onChange(s=>{this.O.fire(s),!s&&this.n&&this.inputBox.focus()})),this.N.push(t);this.N.length>0&&(this.y.style.display=""),this.X()}X(d=!1){d?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((t,s)=>t+s.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(d){this.inputBox.value!==d&&(this.inputBox.value=d)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(d){this.M&&(this.M.checked=d)}getWholeWords(){return this.L?.checked??!1}setWholeWords(d){this.L&&(this.L.checked=d)}getRegex(){return this.J?.checked??!1}setRegex(d){this.J&&(this.J.checked=d,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(d){this.inputBox.showMessage(d)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}e.$GU=B}),define(me[135],$e([1,0,2,24,15,67,134,68,64,43,69,61,27,40,12,9,18,19,34,4,37,3,35,7,115,14,107]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s,a,m,p,w,o,g,r,E,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fV=e.AbstractTreePart=e.TreeFindMatchType=e.TreeFindMode=e.$eV=e.$dV=e.$cV=e.RenderIndentGuides=e.$bV=e.$aV=void 0;class P extends $.$$S{set context(n){this.c.context=n}get context(){return this.c.context}constructor(n){super(n.elements.map(h=>h.element)),this.c=n}}function z(u){return u instanceof $.$$S?new P(u):u}class v{constructor(n,h){this.d=n,this.f=h,this.b=g.$Tc.None,this.c=new g.$Sc}getDragURI(n){return this.f.getDragURI(n.element)}getDragLabel(n,h){if(this.f.getDragLabel)return this.f.getDragLabel(n.map(C=>C.element),h)}onDragStart(n,h){this.f.onDragStart?.(z(n),h)}onDragOver(n,h,C,S,O,q=!0){const Z=this.f.onDragOver(z(n),h&&h.element,C,S,O),te=this.a!==h;if(te&&(this.b.dispose(),this.a=h),typeof h>"u")return Z;if(te&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,s.$ih)(()=>{const Ee=this.d(),Ae=Ee.getNodeLocation(h);Ee.isCollapsed(Ae)&&Ee.setCollapsed(Ae,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!q){const Ee=typeof Z=="boolean"?Z:Z.accept,Ae=typeof Z=="boolean"?void 0:Z.effect;return{accept:Ee,effect:Ae,feedback:[C]}}return Z}if(Z.bubble===1){const Ee=this.d(),Ae=Ee.getNodeLocation(h),Ne=Ee.getParentNodeLocation(Ae),Ie=Ee.getNode(Ne),Ge=Ne&&Ee.getListIndex(Ne);return this.onDragOver(n,Ie,Ge,S,O,!1)}const be=this.d(),we=be.getNodeLocation(h),ke=be.getListIndex(we),Pe=be.getListRenderCount(we);return{...Z,feedback:(0,t.$Sb)(ke,ke+Pe)}}drop(n,h,C,S,O){this.b.dispose(),this.a=void 0,this.f.drop(z(n),h&&h.element,C,S,O)}onDragEnd(n){this.f.onDragEnd?.(n)}dispose(){this.c.dispose(),this.f.dispose()}}function H(u,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(h){return n.identityProvider.getId(h.element)}},dnd:n.dnd&&new v(u,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(h){return n.multipleSelectionController.isSelectionSingleChangeEvent({...h,element:h.element})},isSelectionRangeChangeEvent(h){return n.multipleSelectionController.isSelectionRangeChangeEvent({...h,element:h.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(h){const C=u(),S=C.getNodeLocation(h),O=C.getParentNodeLocation(S);return C.getNode(O).visibleChildrenCount},getPosInSet(h){return h.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?h=>n.accessibilityProvider.isChecked(h.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?h=>n.accessibilityProvider.getRole(h.element):()=>"treeitem",getAriaLabel(h){return n.accessibilityProvider.getAriaLabel(h.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?h=>n.accessibilityProvider.getAriaLevel(h.element):h=>h.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(h=>n.accessibilityProvider.getActiveDescendantId(h.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(h){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(h.element)}}}}class V{constructor(n){this.a=n}getHeight(n){return this.a.getHeight(n.element)}getTemplateId(n){return this.a.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(n.element)}setDynamicHeight(n,h){this.a.setDynamicHeight?.(n.element,h)}}e.$aV=V;class T{static lift(n){return n instanceof T?n:new T(n)}static empty(n=0){return new T({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const h of n.expanded)this.expanded[h]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}e.$bV=T;var L;(function(u){u.None="none",u.OnHover="onHover",u.Always="always"})(L||(e.RenderIndentGuides=L={}));class I{get elements(){return this.b}constructor(n,h=[]){this.b=h,this.a=new g.$Sc,this.onDidChange=w.Event.forEach(n,C=>this.b=C,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(n,h,C,S,O,q={}){this.o=n,this.p=h,this.q=S,this.s=O,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=g.$Tc.None,this.m=new g.$Sc,this.templateId=n.templateId,this.updateOptions(q),w.Event.map(C,Z=>Z.node)(this.u,this,this.m),n.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(n={}){if(typeof n.indent<"u"){const h=(0,r.$fm)(n.indent,0,40);if(h!==this.d){this.d=h;for(const[C,S]of this.c)this.v(C,S)}}if(typeof n.renderIndentGuides<"u"){const h=n.renderIndentGuides!==L.None;if(h!==this.g){this.g=h;for(const[C,S]of this.c)this.w(C,S);if(this.k.dispose(),h){const C=new g.$Sc;this.q.onDidChange(this.x,this,C),this.k=C,this.x(this.q.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.f=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const h=(0,i.$WR)(n,(0,i.$)(".monaco-tl-row")),C=(0,i.$WR)(h,(0,i.$)(".monaco-tl-indent")),S=(0,i.$WR)(h,(0,i.$)(".monaco-tl-twistie")),O=(0,i.$WR)(h,(0,i.$)(".monaco-tl-contents")),q=this.o.renderTemplate(O);return{container:n,indent:C,twistie:S,indentGuidesDisposable:g.$Tc.None,templateData:q}}renderElement(n,h,C,S){this.c.set(n,C),this.b.set(n.element,n),this.v(n,C),this.o.renderElement(n,h,C.templateData,S)}disposeElement(n,h,C,S){C.indentGuidesDisposable.dispose(),this.o.disposeElement?.(n,h,C.templateData,S),typeof S=="number"&&(this.c.delete(n),this.b.delete(n.element))}disposeTemplate(n){this.o.disposeTemplate(n.templateData)}t(n){const h=this.b.get(n);h&&this.u(h)}u(n){const h=this.c.get(n);h&&(this.x(this.q.elements),this.v(n,h))}v(n,h){const C=X.a+(n.depth-1)*this.d;h.twistie.style.paddingLeft=`${C}px`,h.indent.style.width=`${C+this.d-16}px`,n.collapsible?h.container.setAttribute("aria-expanded",String(!n.collapsed)):h.container.removeAttribute("aria-expanded"),h.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(a.$pk.treeItemExpanded));let S=!1;this.o.renderTwistie&&(S=this.o.renderTwistie(n.element,h.twistie)),n.collapsible&&(!this.f||n.visibleChildrenCount>0)?(S||h.twistie.classList.add(...m.ThemeIcon.asClassNameArray(a.$pk.treeItemExpanded)),h.twistie.classList.add("collapsible"),h.twistie.classList.toggle("collapsed",n.collapsed)):h.twistie.classList.remove("collapsible","collapsed"),this.w(n,h)}w(n,h){if((0,i.$UQ)(h.indent),h.indentGuidesDisposable.dispose(),!this.g)return;const C=new g.$Sc,S=this.p();for(;;){const O=S.getNodeLocation(n),q=S.getParentNodeLocation(O);if(!q)break;const Z=S.getNode(q),te=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&te.classList.add("active"),h.indent.childElementCount===0?h.indent.appendChild(te):h.indent.insertBefore(te,h.indent.firstElementChild),this.s.add(Z,te),C.add((0,g.$Rc)(()=>this.s.delete(Z,te))),n=Z}h.indentGuidesDisposable=C}x(n){if(!this.g)return;const h=new Set,C=this.p();n.forEach(S=>{const O=C.getNodeLocation(S);try{const q=C.getParentNodeLocation(O);S.collapsible&&S.children.length>0&&!S.collapsed?h.add(S):q&&h.add(C.getNode(q))}catch{}}),this.j.forEach(S=>{h.has(S)||this.s.forEach(S,O=>O.classList.remove("active"))}),h.forEach(S=>{this.j.has(S)||this.s.forEach(S,O=>O.classList.add("active"))}),this.j=h}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,g.$Oc)(this.m)}}e.$cV=X;class U{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(n){this.c=n,this.d=n.toLowerCase()}constructor(n,h,C){this.g=n,this.j=h,this.k=C,this.a=0,this.b=0,this.c="",this.d="",this.f=new g.$Sc,n.onWillRefilter(this.m,this,this.f)}filter(n,h){let C=1;if(this.k){const q=this.k.filter(n,h);if(typeof q=="boolean"?C=q?1:0:(0,B.$0U)(q)?C=(0,B.$$U)(q.visibility):C=q,C===0)return!1}if(this.a++,!this.c)return this.b++,{data:o.FuzzyScore.Default,visibility:C};const S=this.j.getKeyboardNavigationLabel(n),O=Array.isArray(S)?S:[S];for(const q of O){const Z=q&&q.toString();if(typeof Z>"u")return{data:o.FuzzyScore.Default,visibility:C};let te;if(this.g.findMatchType===Ce.Contiguous){const be=Z.toLowerCase().indexOf(this.d);if(be>-1){te=[Number.MAX_SAFE_INTEGER,0];for(let we=this.d.length;we>0;we--)te.push(be+we-1)}}else te=(0,o.$hk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(te)return this.b++,O.length===1?{data:te,visibility:C}:{data:{label:Z,score:te},visibility:C}}return this.g.findMode===ge.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(n):2:{data:o.FuzzyScore.Default,visibility:C}}m(){this.a=0,this.b=0}dispose(){(0,g.$Oc)(this.f)}}class de extends k.$HT{constructor(n){super({icon:a.$pk.listFilter,title:(0,N.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,M.$QS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}e.$dV=de;class he extends k.$HT{constructor(n){super({icon:a.$pk.searchFuzzy,title:(0,N.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,M.$QS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}e.$eV=he;const ne={inputBoxStyles:y.$qU,toggleStyles:k.$FT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ge;(function(u){u[u.Highlight=0]="Highlight",u[u.Filter=1]="Filter"})(ge||(e.TreeFindMode=ge={}));var Ce;(function(u){u[u.Fuzzy=0]="Fuzzy",u[u.Contiguous=1]="Contiguous"})(Ce||(e.TreeFindMatchType=Ce={}));class Re extends g.$Tc{set mode(n){this.b.checked=n===ge.Filter,this.f.inputBox.setPlaceHolder(n===ge.Filter?(0,N.localize)(2,null):(0,N.localize)(3,null))}set matchType(n){this.c.checked=n===Ce.Fuzzy}get value(){return this.f.inputBox.value}set value(n){this.f.inputBox.value=n}constructor(n,h,C,S,O,q){super(),this.t=h,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new w.$6d,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.a.root),this.B((0,g.$Rc)(()=>n.removeChild(this.a.root)));const Z=q?.styles??ne;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const te=this.B((0,M.$RS)());this.b=this.B(new de({...Z.toggleStyles,isChecked:S===ge.Filter,hoverDelegate:te})),this.c=this.B(new he({...Z.toggleStyles,isChecked:O===Ce.Fuzzy,hoverDelegate:te})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?ge.Filter:ge.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?Ce.Fuzzy:Ce.Contiguous,this.q),this.f=this.B(new D.$GU(this.a.findInput,C,{label:(0,N.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:q?.history})),this.g=this.B(new W.$SS(this.a.actionbar)),this.mode=S;const be=this.B(new R.$1S(this.f.inputBox.inputElement,"keydown")),we=w.Event.chain(be.event,Ae=>Ae.map(Ne=>new j.$SQ(Ne)));this.B(we(Ae=>{if(Ae.equals(3)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ae.equals(18)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ae.equals(16)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ke=this.B(new d.$Xi("close",(0,N.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ke,{icon:!0,label:!1});const Pe=this.B(new R.$1S(this.a.grab,"mousedown"));this.B(Pe.event(Ae=>{const Ne=new g.$Sc,Ie=Ne.add(new R.$1S((0,i.getWindow)(Ae),"mousemove")),Ge=Ne.add(new R.$1S((0,i.getWindow)(Ae),"mouseup")),nt=this.m,Ye=Ae.pageX,Ue=this.s,Y=Ae.pageY;this.a.grab.classList.add("grabbing");const se=this.a.root.style.transition;this.a.root.style.transition="unset";const pe=ve=>{const Le=ve.pageX-Ye;this.m=nt-Le;const je=ve.pageY-Y;this.s=Ue+je,this.layout()};Ne.add(Ie.event(pe)),Ne.add(Ge.event(ve=>{pe(ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=se,Ne.dispose()}))}));const Ee=w.Event.chain(this.B(new R.$1S(this.a.grab,"keydown")).event,Ae=>Ae.map(Ne=>new j.$SQ(Ne)));this.B(Ee(Ae=>{let Ne,Ie;if(Ae.keyCode===15?Ne=Number.POSITIVE_INFINITY:Ae.keyCode===17?Ne=0:Ae.keyCode===10&&(Ne=this.m===0?Number.POSITIVE_INFINITY:0),Ae.keyCode===16?Ie=0:Ae.keyCode===18&&(Ie=Number.POSITIVE_INFINITY),Ne!==void 0&&(Ae.preventDefault(),Ae.stopPropagation(),this.m=Ne,this.layout()),Ie!==void 0){Ae.preventDefault(),Ae.stopPropagation(),this.s=Ie;const Ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(n=this.j){this.j=n,this.m=(0,r.$fm)(this.m,0,Math.max(0,n-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$fm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(n){this.f.showMessage(n)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$hh)(300),super.dispose()}}class Be{get pattern(){return this.b}get mode(){return this.d}set mode(n){n!==this.d&&(this.d=n,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(n))}get matchType(){return this.f}set matchType(n){n!==this.f&&(this.f=n,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(n))}constructor(n,h,C,S,O,q={}){this.t=n,this.u=C,this.v=S,this.w=O,this.x=q,this.b="",this.c="",this.j=0,this.k=new w.$6d,this.onDidChangeMode=this.k.event,this.m=new w.$6d,this.onDidChangeMatchType=this.m.event,this.o=new w.$6d,this.onDidChangePattern=this.o.event,this.p=new w.$6d,this.onDidChangeOpenState=this.p.event,this.q=new g.$Sc,this.s=new g.$Sc,this.d=n.options.defaultFindMode??ge.Highlight,this.f=n.options.defaultFindMatchType??Ce.Fuzzy,h.onDidSplice(this.z,this,this.s)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Re(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(n=>this.mode=n,void 0,this.q),this.g.onDidChangeMatchType(n=>this.matchType=n,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(n){this.b=n,this.o.fire(n),this.v.pattern=n,this.t.refilter(),n&&this.t.focusNext(0,!0,void 0,C=>!o.FuzzyScore.isDefault(C.filterData));const h=this.t.getFocus();if(h.length>0){const C=h[0];this.t.getRelativeTop(C)===null&&this.t.reveal(C,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const n=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&n?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,N.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(n){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!o.FuzzyScore.isDefault(n.filterData)}layout(n){this.j=n,this.g?.layout(n)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function le(u,n){return u.position===n.position&&_(u,n)}function _(u,n){return u.node.element===n.node.element&&u.startIndex===n.startIndex&&u.height===n.height&&u.endIndex===n.endIndex}class ae{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,t.$ub)(this.stickyNodes,n.stickyNodes,le)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const h=this.stickyNodes[this.count-2];return h.position+h.height!==n.position}animationStateChanged(n){if(!(0,t.$ub)(this.stickyNodes,n.stickyNodes,_)||this.count===0)return!1;const h=this.stickyNodes[this.count-1],C=n.stickyNodes[n.count-1];return h.position!==C.position}}class oe{constrainStickyScrollNodes(n,h,C){for(let S=0;S<n.length;S++){const O=n[S];if(O.position+O.height>C||S>=h)return n.slice(0,S)}return n}}class J extends g.$Tc{constructor(n,h,C,S,O,q={}){super(),this.g=n,this.j=h,this.m=C,this.s=O,this.c=.4;const Z=this.validateStickySettings(q);this.b=Z.stickyScrollMaxItemCount,this.a=q.stickyScrollDelegate??new oe,this.f=this.B(new G(C.getScrollableElement(),C,n,S,O,q.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(C.onDidScroll(()=>this.u())),this.B(C.onDidChangeContentHeight(()=>this.u())),this.B(n.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(n){return this.f.getNode(n)}t(n){let h;if(n===0?h=this.m.firstVisibleIndex:h=this.m.indexAt(n+this.m.scrollTop),!(h<0||h>=this.m.length))return this.m.element(h)}u(){const n=this.t(0);if(!n||this.g.scrollTop===0){this.f.setState(void 0);return}const h=this.w(n);this.f.setState(h)}w(n){const h=[];let C=n,S=0,O=this.z(C,void 0,S);for(;O&&(h.push(O),S+=O.height,!(h.length<=this.b&&(C=this.y(O),!C)));)O=this.z(C,O.node,S);const q=this.H(h);return q.length?new ae(q):void 0}y(n){return this.t(n.position+n.height)}z(n,h,C){const S=this.F(n,h);if(S&&!(S===n&&(!this.J(n)||this.C(n,C))))return this.D(S,C)}C(n,h){const C=this.L(n),S=this.m.getElementTop(C),O=h;return this.m.scrollTop===S-O}D(n,h){const C=this.s.getHeight(n),{startIndex:S,endIndex:O}=this.M(n),q=this.G(O,h,C);return{node:n,position:q,height:C,startIndex:S,endIndex:O}}F(n,h=void 0){let C=n,S=this.I(C);for(;S;){if(S===h)return C;C=S,S=this.I(C)}if(h===void 0)return C}G(n,h,C){let S=this.m.getRelativeTop(n);if(S===null&&this.m.firstVisibleIndex===n&&n+1<this.m.length){const be=this.s.getHeight(this.m.element(n)),we=this.m.getRelativeTop(n+1);S=we?we-be/this.m.renderHeight:null}if(S===null)return h;const O=this.m.element(n),q=this.s.getHeight(O),te=S*this.m.renderHeight+q;return h+C>te&&h<=te?te-C:h}H(n){if(n.length===0)return[];const h=this.m.renderHeight*this.c,C=n[n.length-1];if(n.length<=this.b&&C.position+C.height<=h)return n;const S=this.a.constrainStickyScrollNodes(n,this.b,h);if(!S.length)return[];const O=S[S.length-1];if(S.length>this.b||O.position+O.height>h)throw new Error("stickyScrollDelegate violates constraints");return S}I(n){const h=this.j.getNodeLocation(n),C=this.j.getParentNodeLocation(h);return C?this.j.getNode(C):void 0}J(n){const h=this.j.getNodeLocation(n);return this.j.getListRenderCount(h)>1}L(n){const h=this.j.getNodeLocation(n);return this.j.getListIndex(h)}M(n){const h=this.j.getNodeLocation(n),C=this.j.getListIndex(h);if(C<0)throw new Error("Node not found in tree");const S=this.j.getListRenderCount(h),O=C+S-1;return{startIndex:C,endIndex:O}}nodePositionTopBelowWidget(n){const h=[];let C=this.I(n);for(;C;)h.push(C),C=this.I(C);let S=0;for(let O=0;O<h.length&&O<this.b;O++)S+=this.s.getHeight(h[O]);return S}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const h=this.validateStickySettings(n);this.b!==h.stickyScrollMaxItemCount&&(this.b=h.stickyScrollMaxItemCount,this.u())}validateStickySettings(n){let h=7;return typeof n.stickyScrollMaxItemCount=="number"&&(h=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:h}}}class G{constructor(n,h,C,S,O,q){this.g=h,this.j=C,this.k=S,this.m=O,this.o=q,this.c=[],this.d=new g.$Sc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this.a);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new ie(this.a,h),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const n=this.b.stickyNodes[this.b.count-1];return n.position+n.height}get count(){return this.b?.count??0}getNode(n){return this.b?.stickyNodes.find(h=>h.node===n)}setState(n){const h=!!this.b&&this.b.count>0,C=!!n&&n.count>0;if(!h&&!C||h&&C&&this.b.equal(n))return;if(h!==C&&this.s(C),!C){this.b=void 0,this.c=[],this.d.clear();return}const S=n.stickyNodes[n.count-1];if(this.b&&n.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${S.position}px`;else{this.d.clear();const O=Array(n.count);for(let q=n.count-1;q>=0;q--){const Z=n.stickyNodes[q],{element:te,disposable:be}=this.p(Z,q,n.count);O[q]=te,this.a.appendChild(te),this.d.add(be)}this.f.updateElements(O,n),this.c=O}this.b=n,this.a.style.height=`${S.position+S.height}px`}p(n,h,C){const S=n.startIndex,O=document.createElement("div");O.style.top=`${n.position}px`,O.style.height=`${n.height}px`,O.style.lineHeight=`${n.height}px`,O.classList.add("monaco-tree-sticky-row"),O.classList.add("monaco-list-row"),O.setAttribute("data-index",`${S}`),O.setAttribute("data-parity",S%2===0?"even":"odd"),O.setAttribute("id",this.g.getElementID(S)),this.q(O,n.node.element,h,C);const q=this.m.getTemplateId(n.node),Z=this.k.find(ke=>ke.templateId===q);if(!Z)throw new Error(`No renderer found for template id ${q}`);let te=n.node;te===this.j.getNode(this.j.getNodeLocation(n.node))&&(te=new Proxy(n.node,{}));const be=Z.renderTemplate(O);Z.renderElement(te,n.startIndex,be,n.height);const we=(0,g.$Rc)(()=>{Z.disposeElement(te,n.startIndex,be,n.height),Z.disposeTemplate(be),O.remove()});return{element:O,disposable:we}}q(n,h,C,S){if(!this.o)return;this.o.getSetSize&&n.setAttribute("aria-setsize",String(this.o.getSetSize(h,C,S))),this.o.getPosInSet&&n.setAttribute("aria-posinset",String(this.o.getPosInSet(h,C))),this.o.getRole&&n.setAttribute("role",this.o.getRole(h)??"treeitem");const O=this.o.getAriaLabel(h);O&&n.setAttribute("aria-label",O);const q=this.o.getAriaLevel&&this.o.getAriaLevel(h);typeof q=="number"&&n.setAttribute("aria-level",`${q}`),n.setAttribute("aria-selected",String(!1))}s(n){this.a.classList.toggle("empty",!n),n||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ie extends g.$Tc{get m(){return this.j}set m(n){n!==this.j&&(this.f.fire(n),this.j=n)}constructor(n,h){super(),this.s=n,this.t=h,this.a=-1,this.b=[],this.f=new w.$6d,this.onDidChangeHasFocus=this.f.event,this.g=new w.$6d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(C=>this.w(C))),this.B(this.t.onMouseDown(C=>this.y(C))),this.B(this.t.onContextMenu(C=>this.u(C)))}u(n){const h=n.browserEvent.target;if(!(0,b.$lT)(h)&&!(0,b.$kT)(h)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$MR)(n.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const q=this.c.stickyNodes.findIndex(Z=>Z.node.element===n.element?.element);if(q===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(q);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const S=this.c.stickyNodes[this.a].node.element,O=this.b[this.a];this.g.fire({element:S,anchor:O,browserEvent:n.browserEvent,isStickyScroll:!0})}w(n){if(this.m&&this.c){if(n.key==="ArrowUp")this.z(Math.max(0,this.a-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.a>=this.c.count-1){const h=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([h]),this.C(h,this.c)}else this.z(this.a+1);n.preventDefault(),n.stopPropagation()}}}y(n){const h=n.browserEvent.target;!(0,b.$lT)(h)&&!(0,b.$kT)(h)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,h){if(h&&h.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(h&&h.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const C=this.a;if(this.D(),this.b=n,this.c=h,h){const S=(0,r.$fm)(C,0,h.count-1);this.F(S)}else this.m&&this.t.domFocus();this.s.tabIndex=h?0:-1}z(n){const h=this.c;if(!h)throw new Error("Cannot set focus when state is undefined");if(this.F(n),!(n<h.count-1)&&h.lastNodePartiallyVisible()){const C=h.stickyNodes[n];this.C(C.endIndex+1,h)}}C(n,h){const C=h.stickyNodes[h.count-1],S=h.count>1?h.stickyNodes[h.count-2]:void 0,O=this.t.getElementTop(n),q=S?S.position+S.height+C.height:C.height;this.t.scrollTop=O-q}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.c&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&n>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const h=this.a;h>=0&&this.G(this.b[h],!1),n>=0&&this.G(this.b[n],!0),this.a=n}G(n,h){n.classList.toggle("focused",h)}H(n){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function fe(u){let n=c.TreeMouseEventTarget.Unknown;return(0,i.$rR)(u.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=c.TreeMouseEventTarget.Twistie:(0,i.$rR)(u.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=c.TreeMouseEventTarget.Element:(0,i.$rR)(u.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=c.TreeMouseEventTarget.Filter),{browserEvent:u.browserEvent,element:u.element?u.element.element:null,target:n}}function De(u){const n=(0,b.$lT)(u.browserEvent.target);return{element:u.element?u.element.element:null,browserEvent:u.browserEvent,anchor:u.anchor,isStickyScroll:n}}function Fe(u,n){n(u),u.children.forEach(h=>Fe(h,n))}class ye{get f(){return this.d||(this.d=this.m()),this.d}constructor(n,h){this.g=n,this.j=h,this.a=[],this.c=new w.$6d,this.onDidChange=this.c.event}set(n,h){!h?.__forceEvent&&(0,t.$ub)(this.a,n)||this.k(n,!1,h)}k(n,h,C){if(this.a=[...n],this.b=void 0,this.d=void 0,!h){const S=this;this.c.fire({get elements(){return S.get()},browserEvent:C})}}get(){return this.b||(this.b=this.a.map(n=>n.element)),[...this.b]}getNodes(){return this.a}has(n){return this.f.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:h}){if(!this.j){const te=this.m(),be=we=>te.delete(we);h.forEach(we=>Fe(we,be)),this.set([...te.values()]);return}const C=new Set,S=te=>C.add(this.j.getId(te.element).toString());h.forEach(te=>Fe(te,S));const O=new Map,q=te=>O.set(this.j.getId(te.element).toString(),te);n.forEach(te=>Fe(te,q));const Z=[];for(const te of this.a){const be=this.j.getId(te.element).toString();if(!C.has(be))Z.push(te);else{const ke=O.get(be);ke&&ke.visible&&Z.push(ke)}}if(this.a.length>0&&Z.length===0){const te=this.g();te&&Z.push(te)}this.k(Z,!0)}m(){const n=new Set;for(const h of this.a)n.add(h);return n}}class K extends b.$qT{constructor(n,h,C){super(n),this.x=h,this.y=C}u(n){if((0,b.$mT)(n.browserEvent.target)||(0,b.$fT)(n.browserEvent.target)||(0,b.$gT)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const h=n.element;if(!h)return super.u(n);if(this.p(n)||this.o(n))return super.u(n);const C=n.browserEvent.target,S=C.classList.contains("monaco-tl-twistie")||C.classList.contains("monaco-icon-label")&&C.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,O=(0,b.$kT)(n.browserEvent.target);let q=!1;if(O?q=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?q=this.x.expandOnlyOnTwistieClick(h.element):q=!!this.x.expandOnlyOnTwistieClick,O)this.A(n,h);else{if(q&&!S&&n.browserEvent.detail!==2)return super.u(n);if(!this.x.expandOnDoubleClick&&n.browserEvent.detail===2)return super.u(n)}if(h.collapsible&&(!O||S)){const Z=this.x.getNodeLocation(h),te=n.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,te),q&&S){n.browserEvent.isHandledByList=!0;return}}O||super.u(n)}A(n,h){if((0,b.$hT)(n.browserEvent.target)||(0,b.$iT)(n.browserEvent.target))return;const C=this.y();if(!C)throw new Error("Sticky scroll controller not found");const S=this.k.indexOf(h),O=this.k.getElementTop(S),q=C.nodePositionTopBelowWidget(h);this.x.scrollTop=O-q,this.k.domFocus(),this.k.setFocus([S]),this.k.setSelection([S])}v(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||n.browserEvent.isHandledByList||super.v(n)}s(n){const h=n.browserEvent.target;if(!(0,b.$lT)(h)&&!(0,b.$kT)(h)){super.s(n);return}}t(n){const h=n.browserEvent.target;if(!(0,b.$lT)(h)&&!(0,b.$kT)(h)){super.t(n);return}}}class f extends b.$tT{constructor(n,h,C,S,O,q,Z,te){super(n,h,C,S,te),this.p=O,this.s=q,this.K=Z}D(n){return new K(this,n.tree,n.stickyScrollProvider)}splice(n,h,C=[]){if(super.splice(n,h,C),C.length===0)return;const S=[],O=[];let q;C.forEach((Z,te)=>{this.p.has(Z)&&S.push(n+te),this.s.has(Z)&&O.push(n+te),this.K.has(Z)&&(q=n+te)}),S.length>0&&super.setFocus((0,t.$Mb)([...super.getFocus(),...S])),O.length>0&&super.setSelection((0,t.$Mb)([...super.getSelection(),...O])),typeof q=="number"&&super.setAnchor(q)}setFocus(n,h,C=!1){super.setFocus(n,h),C||this.p.set(n.map(S=>this.element(S)),h)}setSelection(n,h,C=!1){super.setSelection(n,h),C||this.s.set(n.map(S=>this.element(S)),h)}setAnchor(n,h=!1){super.setAnchor(n),h||(typeof n>"u"?this.K.set([]):this.K.set([this.element(n)]))}}var A;(function(u){u[u.Tree=0]="Tree",u[u.StickyScroll=1]="StickyScroll"})(A||(e.AbstractTreePart=A={}));class F{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,fe)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,fe),n=>n.target!==c.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.any(w.Event.filter(w.Event.map(this.j.onContextMenu,De),n=>!n.isStickyScroll),this.B?.onContextMenu??w.Event.None)}get onTap(){return w.Event.map(this.j.onTap,fe)}get onPointer(){return w.Event.map(this.j.onPointer,fe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ge.Highlight}set findMode(n){this.z&&(this.z.mode=n)}get findMatchType(){return this.z?.matchType??Ce.Fuzzy}set findMatchType(n){this.z&&(this.z.matchType=n)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(n,h,C,S,O={}){this.G=n,this.H=O,this.y=new w.$be,this.onDidChangeFindOpenState=w.Event.None,this.onDidChangeStickyScrollFocused=w.Event.None,this.D=new g.$Sc,this.E=new w.$6d,this.onWillRefilter=this.E.event,this.F=new w.$6d,this.onDidUpdateOptions=this.F.event,this.p=new V(C);const q=new w.$ce,Z=new w.$ce,te=this.D.add(new I(Z.event)),be=new p.$Gc;this.k=S.map(Ae=>new X(Ae,()=>this.o,q.event,te,be,O));for(const Ae of this.k)this.D.add(Ae);let we;O.keyboardNavigationLabelProvider&&(we=new U(this,O.keyboardNavigationLabelProvider,O.filter),O={...O,filter:we},this.D.add(we)),this.q=new ye(()=>this.j.getFocusedElements()[0],O.identityProvider),this.w=new ye(()=>this.j.getSelectedElements()[0],O.identityProvider),this.x=new ye(()=>this.j.getAnchorElement(),O.identityProvider),this.j=new f(n,h,this.p,this.k,this.q,this.w,this.x,{...H(()=>this.o,O),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(n,this.j,O),q.input=this.o.onDidChangeCollapseState;const ke=w.Event.forEach(this.o.onDidSplice,Ae=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ae),this.w.onDidModelSplice(Ae)})},this.D);ke(()=>null,null,this.D);const Pe=this.D.add(new w.$6d),Ee=this.D.add(new s.$dh(0));if(this.D.add(w.Event.any(ke,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const Ae=new Set;for(const Ne of this.q.getNodes())Ae.add(Ne);for(const Ne of this.w.getNodes())Ae.add(Ne);Pe.fire([...Ae.values()])})})),Z.input=Pe.event,O.keyboardSupport!==!1){const Ae=w.Event.chain(this.j.onKeyDown,Ne=>Ne.filter(Ie=>!(0,b.$fT)(Ie.target)).map(Ie=>new j.$SQ(Ie)));w.Event.chain(Ae,Ne=>Ne.filter(Ie=>Ie.keyCode===15))(this.J,this,this.D),w.Event.chain(Ae,Ne=>Ne.filter(Ie=>Ie.keyCode===17))(this.K,this,this.D),w.Event.chain(Ae,Ne=>Ne.filter(Ie=>Ie.keyCode===10))(this.L,this,this.D)}if((O.findWidgetEnabled??!0)&&O.keyboardNavigationLabelProvider&&O.contextViewProvider){const Ae=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Be(this,this.o,this.j,we,O.contextViewProvider,Ae),this.A=Ne=>this.z.shouldAllowFocus(Ne),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;O.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,O),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$ER)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}updateOptions(n={}){this.H={...this.H,...n};for(const h of this.k)h.updateOptions(n);this.j.updateOptions(this.H),this.z?.updateOptions(n),this.I(n),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}get options(){return this.H}I(n){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=w.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(n)}updateWidth(n){const h=this.o.getListIndex(n);h!==-1&&this.j.updateWidth(h)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(n){this.j.scrollTop=n}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(n){this.j.scrollLeft=n}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let n=this.j.firstVisibleIndex;return this.B&&(n+=this.B.count),n<0||n>=this.j.length?void 0:this.j.element(n).element}get lastVisibleElement(){const n=this.j.lastVisibleIndex;return this.j.element(n).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(n){this.j.ariaLabel=n}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$wR)(this.getHTMLElement())}layout(n,h){this.j.layout(n,h),(0,E.$Xf)(h)&&this.z?.layout(h)}style(n){const h=`.${this.j.domId}`,C=[];n.treeIndentGuidesStroke&&(C.push(`.monaco-list${h}:hover .monaco-tl-indent > .indent-guide, .monaco-list${h}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),C.push(`.monaco-list${h} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),n.listBackground&&(C.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${n.listBackground}; }`),C.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${n.listBackground}; }`)),n.listFocusForeground&&(C.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),C.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const S=(0,i.$cS)(n.listFocusAndSelectionOutline,(0,i.$cS)(n.listSelectionOutline,n.listFocusOutline??""));S&&(C.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${S}; outline-offset: -1px;}`),C.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(C.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),C.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),C.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),C.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=C.join(`
`),this.j.style(n)}getParentElement(n){const h=this.o.getParentNodeLocation(n);return this.o.getNode(h).element}getFirstElementChild(n){return this.o.getFirstElementChild(n)}getNode(n){return this.o.getNode(n)}getNodeLocation(n){return this.o.getNodeLocation(n)}collapse(n,h=!1){return this.o.setCollapsed(n,!0,h)}expand(n,h=!1){return this.o.setCollapsed(n,!1,h)}toggleCollapsed(n,h=!1){return this.o.setCollapsed(n,void 0,h)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(n){return this.o.isCollapsible(n)}setCollapsible(n,h){return this.o.setCollapsible(n,h)}isCollapsed(n){return this.o.isCollapsed(n)}expandTo(n){this.o.expandTo(n)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(n){if(typeof n>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const h=this.o.getNode(n);this.x.set([h]);const C=this.o.getListIndex(n);C>-1&&this.j.setAnchor(C,!0)})}getAnchor(){return(0,t.$Ob)(this.x.get(),void 0)}setSelection(n,h){this.y.bufferEvents(()=>{const C=n.map(O=>this.o.getNode(O));this.w.set(C,h);const S=n.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setSelection(S,h,!0)})}getSelection(){return this.w.get()}setFocus(n,h){this.y.bufferEvents(()=>{const C=n.map(O=>this.o.getNode(O));this.q.set(C,h);const S=n.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setFocus(S,h,!0)})}focusNext(n=1,h=!1,C,S=(0,i.$MR)(C)&&C.altKey?void 0:this.A){this.j.focusNext(n,h,C,S)}focusPrevious(n=1,h=!1,C,S=(0,i.$MR)(C)&&C.altKey?void 0:this.A){this.j.focusPrevious(n,h,C,S)}focusNextPage(n,h=(0,i.$MR)(n)&&n.altKey?void 0:this.A){return this.j.focusNextPage(n,h)}focusPreviousPage(n,h=(0,i.$MR)(n)&&n.altKey?void 0:this.A){return this.j.focusPreviousPage(n,h,()=>this.B?.height??0)}focusLast(n,h=(0,i.$MR)(n)&&n.altKey?void 0:this.A){this.j.focusLast(n,h)}focusFirst(n,h=(0,i.$MR)(n)&&n.altKey?void 0:this.A){this.j.focusFirst(n,h)}getFocus(){return this.q.get()}getStickyScrollFocus(){const n=this.B?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(n,h){this.o.expandTo(n);const C=this.o.getListIndex(n);if(C!==-1)if(!this.B)this.j.reveal(C,h);else{const S=this.B.nodePositionTopBelowWidget(this.getNode(n));this.j.reveal(C,h,S)}}getRelativeTop(n){const h=this.o.getListIndex(n);if(h===-1)return null;const C=this.B?.getNode(this.getNode(n));return this.j.getRelativeTop(h,C?.position??this.B?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new c.$8U(this.G,"Can't get tree view state without an identity provider");const h=q=>n.getId(q).toString(),C=T.empty(this.scrollTop);for(const q of this.getFocus())C.focus.add(h(q));for(const q of this.getSelection())C.selection.add(h(q));const S=this.o.getNode(),O=[S];for(;O.length>0;){const q=O.shift();q!==S&&q.collapsible&&(C.expanded[h(q.element)]=q.collapsed?0:1),O.push(...q.children)}return C}J(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const C=h[0],S=this.o.getNodeLocation(C);if(!this.o.setCollapsed(S,!0)){const q=this.o.getParentNodeLocation(S);if(!q)return;const Z=this.o.getListIndex(q);this.j.reveal(Z),this.j.setFocus([Z])}}K(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const C=h[0],S=this.o.getNodeLocation(C);if(!this.o.setCollapsed(S,!1)){if(!C.children.some(te=>te.visible))return;const[q]=this.j.getFocus(),Z=q+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const C=h[0],S=this.o.getNodeLocation(C),O=n.browserEvent.altKey;this.o.setCollapsed(S,void 0,O)}navigate(n){return new l(this.j,this.o,n)}dispose(){(0,g.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}e.$fV=F;class l{constructor(n,h,C){this.b=n,this.c=h,C?this.a=this.c.getListIndex(C):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[136],$e([1,0,135,127,27,29]),function(re,e,i,R,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qV=void 0;class D extends i.$fV{constructor($,b,k,B,c,d={}){super($,b,k,B,d),this.f=$,this.g=c,this.d=new Map,this.c=d.identityProvider}getInput(){return this.b}setInput($,b){if(b&&!this.c)throw new j.$8U(this.f,"Can't restore tree view state without an identity provider");if(this.b=$,!$){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!b){this.m($);return}const k=[],B=[],c=t=>{const s=this.c.getId(t).toString();return!b.expanded[s]},d=t=>{const s=this.c.getId(t.element).toString();b.focus.has(s)&&k.push(t.element),b.selection.has(s)&&B.push(t.element)};this.m($,c,d),this.setFocus(k),this.setSelection(B),b&&typeof b.scrollTop=="number"&&(this.scrollTop=b.scrollTop)}updateChildren($=this.b){if(typeof this.b>"u")throw new j.$8U(this.f,"Tree input not set");let b;this.c&&(b=k=>{const B=this.c.getId(k).toString(),c=this.d.get(B);if(c)return c.collapsed}),this.m($,b)}resort($=this.b,b=!0){this.o.resort($===this.b?null:$,b)}refresh($){if($===void 0){this.j.rerender();return}this.o.rerender($)}m($,b,k){let B;if(this.c){const c=new Set,d=k;k=t=>{const s=this.c.getId(t.element).toString();c.add(s),this.d.set(s,t),d?.(t)},B=t=>{const s=this.c.getId(t.element).toString();c.has(s)||this.d.delete(s)}}this.o.setChildren($===this.b?null:$,this.s($,b).elements,{onDidCreateNode:k,onDidDeleteNode:B})}s($,b){const k=[...this.g.getChildren($)];return{elements:W.Iterable.map(k,c=>{const{elements:d,size:t}=this.s(c,b),s=this.g.hasChildren?this.g.hasChildren(c):void 0,a=t===0?void 0:b&&b(c);return{element:c,children:d,collapsible:s,collapsed:a}}),size:k.length}}M($,b,k){return new R.$gV($,b,k)}}e.$qV=D}),define(me[70],$e([1,0,12,9,36,30,28,6,4,3,56,10,7]),function(re,e,i,R,j,W,D,y,$,b,k,B,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var d;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(d||(d={}));function t(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function a(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(m||(m={}));function p(le){let _=0;for(let ae=0;;ae+=7){const oe=le.read(1);if(_|=(oe.buffer[0]&127)<<ae,!(oe.buffer[0]&128))return _}}const w=N(0);function o(le,_){if(_===0){le.write(w);return}let ae=0;for(let J=_;J!==0;J=J>>>7)ae++;const oe=j.$te.alloc(ae);for(let J=0;_!==0;J++)oe.buffer[J]=_&127,_=_>>>7,_>0&&(oe.buffer[J]|=128);le.write(oe)}class g{constructor(_){this.b=_,this.a=0}read(_){const ae=this.b.slice(this.a,this.a+_);return this.a+=ae.byteLength,ae}}e.$Qh=g;class r{constructor(){this.a=[]}get buffer(){return j.$te.concat(this.a)}write(_){this.a.push(_)}}e.$Rh=r;var E;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(E||(E={}));function N(le){const _=j.$te.alloc(1);return _.writeUInt8(le,0),_}const M={Undefined:N(E.Undefined),String:N(E.String),Buffer:N(E.Buffer),VSBuffer:N(E.VSBuffer),Array:N(E.Array),Object:N(E.Object),Uint:N(E.Int)},P=typeof Buffer<"u";function z(le,_){if(typeof _>"u")le.write(M.Undefined);else if(typeof _=="string"){const ae=j.$te.fromString(_);le.write(M.String),o(le,ae.byteLength),le.write(ae)}else if(P&&Buffer.isBuffer(_)){const ae=j.$te.wrap(_);le.write(M.Buffer),o(le,ae.byteLength),le.write(ae)}else if(_ instanceof j.$te)le.write(M.VSBuffer),o(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(M.Array),o(le,_.length);for(const ae of _)z(le,ae)}else if(typeof _=="number"&&(_|0)===_)le.write(M.Uint),o(le,_);else{const ae=j.$te.fromString(JSON.stringify(_));le.write(M.Object),o(le,ae.byteLength),le.write(ae)}}e.$Sh=z;function v(le){switch(le.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return le.read(p(le)).toString();case E.Buffer:return le.read(p(le)).buffer;case E.VSBuffer:return le.read(p(le));case E.Array:{const ae=p(le),oe=[];for(let J=0;J<ae;J++)oe.push(v(le));return oe}case E.Object:return JSON.parse(le.read(p(le)).toString());case E.Int:return p(le)}}e.$Th=v;class H{constructor(_,ae,oe=null,J=1e3){this.h=_,this.j=ae,this.k=oe,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(_,ae){this.b.set(_,ae),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ae=this.o([_.type]);this.k?.logOutgoing(ae,0,1,a(_.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ae,_.id,1,a(_.type),_.data);return}}}o(_,ae=void 0){const oe=new r;return z(oe,_),z(oe,ae),this.p(oe.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ae=new g(_),oe=v(ae),J=v(ae),G=oe[0];switch(G){case 100:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}: ${oe[2]}.${oe[3]}`,J),this.s({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}: ${oe[2]}.${oe[3]}`,J),this.t({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}`),this.u({type:G,id:oe[1]});case 103:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}`),this.u({type:G,id:oe[1]})}}s(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=new W.$de;let J;try{J=ae.call(this.j,_.name,_.arg,oe.token)}catch(fe){J=Promise.reject(fe)}const G=_.id;J.then(fe=>{this.m({id:G,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:G,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:G,data:fe,type:203})}).finally(()=>{ie.dispose(),this.d.delete(_.id)});const ie=(0,b.$Rc)(()=>oe.cancel());this.d.set(_.id,ie)}t(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=_.id,G=ae.listen(this.j,_.name,_.arg)(ie=>this.m({id:oe,data:ie,type:204}));this.d.set(_.id,G)}u(_){const ae=this.d.get(_.id);ae&&(ae.dispose(),this.d.delete(_.id))}v(_){let ae=this.g.get(_.channelName);ae||(ae=[],this.g.set(_.channelName,ae));const oe=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:_,timeoutTimer:oe})}w(_){const ae=this.g.get(_);if(ae){for(const oe of ae)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=H;var V;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(V||(e.RequestInitiator=V={}));class T{constructor(_,ae=null){this.l=_,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ae}getChannel(_){const ae=this;return{call(oe,J,G){return ae.a?Promise.reject(new y.$5):ae.m(_,oe,J,G)},listen(oe,J){return ae.a?$.Event.None:ae.o(_,oe,J)}}}m(_,ae,oe,J=W.CancellationToken.None){const G=this.g++,fe={id:G,type:100,channelName:_,name:ae,arg:oe};if(J.isCancellationRequested)return Promise.reject(new y.$5);let De;return new Promise((ye,K)=>{if(J.isCancellationRequested)return K(new y.$5);const f=()=>{const u=n=>{switch(n.type){case 201:this.f.delete(G),ye(n.data);break;case 202:{this.f.delete(G);const h=new Error(n.data.message);h.stack=Array.isArray(n.data.stack)?n.data.stack.join(`
`):n.data.stack,h.name=n.data.name,K(h);break}case 203:this.f.delete(G),K(n.data);break}};this.f.set(G,u),this.p(fe)};let A=null;this.b===m.Idle?f():(A=(0,R.$6g)(u=>this.u()),A.then(()=>{A=null,f()}));const F=()=>{A?(A.cancel(),A=null):this.p({id:G,type:101}),K(new y.$5)},l=J.onCancellationRequested(F);De=(0,b.$Qc)((0,b.$Rc)(F),l),this.d.add(De)}).finally(()=>{De.dispose(),this.d.delete(De)})}o(_,ae,oe){const J=this.g++,ie={id:J,type:102,channelName:_,name:ae,arg:oe};let fe=null;const De=new $.$6d({onWillAddFirstListener:()=>{fe=(0,R.$6g)(ye=>this.u()),fe.then(()=>{fe=null,this.d.add(De),this.p(ie)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(De),this.p({id:J,type:103}))}}),Fe=ye=>De.fire(ye.data);return this.f.set(J,Fe),De.event}p(_){switch(_.type){case 100:case 102:{const ae=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ae,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ae=this.q([_.type,_.id]);this.j?.logOutgoing(ae,_.id,0,t(_.type));return}}}q(_,ae=void 0){const oe=new r;return z(oe,_),z(oe,ae),this.r(oe.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ae=new g(_),oe=v(ae),J=v(ae),G=oe[0];switch(G){case 200:return this.j?.logIncoming(_.byteLength,0,0,a(G)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,oe[1],0,a(G),J),this.t({type:oe[0],id:oe[1],data:J})}}t(_){if(_.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=T,Je([D.$Kh],T.prototype,"onDidInitializePromise",null);class L{get connections(){const _=[];return this.f.forEach(ae=>_.push(ae)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new $.$6d,this.onDidAddConnection=this.g.event,this.h=new $.$6d,this.onDidRemoveConnection=this.h.event,this.j=new b.$Sc,this.j.add(_(({protocol:ae,onDidClientDisconnect:oe})=>{const J=$.Event.once(ae.onMessage);this.j.add(J(G=>{const ie=new g(G),fe=v(ie),De=new H(ae,fe),Fe=new T(ae);this.a.forEach((K,f)=>De.registerChannel(f,K));const ye={channelServer:De,channelClient:Fe,ctx:fe};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{De.dispose(),Fe.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(_,ae){const oe=this;return{call(J,G,ie){let fe;if((0,c.$8f)(ae)){const Fe=(0,i.$4b)(oe.connections.filter(ae));fe=Fe?Promise.resolve(Fe):$.Event.toPromise($.Event.filter(oe.onDidAddConnection,ae))}else fe=ae.routeCall(oe,J,G);const De=fe.then(Fe=>Fe.channelClient.getChannel(_));return X(De).call(J,G,ie)},listen(J,G){if((0,c.$8f)(ae))return oe.k(_,ae,J,G);const ie=ae.routeEvent(oe,J,G).then(fe=>fe.channelClient.getChannel(_));return X(ie).listen(J,G)}}}k(_,ae,oe,J){const G=this;let ie;const fe=new $.$6d({onWillAddFirstListener:()=>{ie=new b.$Sc;const De=new $.$_d,Fe=new Map,ye=f=>{const F=f.channelClient.getChannel(_).listen(oe,J),l=De.add(F);Fe.set(f,l)},K=f=>{const A=Fe.get(f);A&&(A.dispose(),Fe.delete(f))};G.connections.filter(ae).forEach(ye),$.Event.filter(G.onDidAddConnection,ae)(ye,void 0,ie),G.onDidRemoveConnection(K,void 0,ie),De.event(fe.fire,fe,ie),ie.add(De)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return fe.event}registerChannel(_,ae){this.a.set(_,ae);for(const oe of this.f)oe.channelServer.registerChannel(_,ae)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=L;class I{constructor(_,ae,oe=null){const J=new r;z(J,ae),_.send(J.buffer),this.a=new T(_,oe),this.d=new H(_,ae,oe)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ae){this.d.registerChannel(_,ae)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=I;function X(le){return{call(_,ae,oe){return le.then(J=>J.call(_,ae,oe))},listen(_,ae){const oe=new $.$ce;return le.then(J=>oe.input=J.listen(_,ae)),oe.event}}}e.$Yh=X;function U(le){let _=!1;return{call(ae,oe,J){return _?le.call(ae,oe,J):(0,R.$hh)(0).then(()=>_=!0).then(()=>le.call(ae,oe,J))},listen(ae,oe){if(_)return le.listen(ae,oe);const J=new $.$ce;return(0,R.$hh)(0).then(()=>_=!0).then(()=>J.input=le.listen(ae,oe)),J.event}}}e.$Zh=U;class de{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ae of _.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await $.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.$1h=de;var he;(function(le){function _(G,ie,fe){const De=G,Fe=fe&&fe.disableMarshalling,ye=new Map;for(const K in De)oe(K)&&ye.set(K,$.Event.buffer(De[K],!0,void 0,ie));return new class{listen(K,f,A){const F=ye.get(f);if(F)return F;const l=De[f];if(typeof l=="function"){if(J(f))return l.call(De,A);if(oe(f))return ye.set(f,$.Event.buffer(De[f],!0,void 0,ie)),ye.get(f)}throw new y.$bb(`Event not found: ${f}`)}call(K,f,A){const F=De[f];if(typeof F=="function"){if(!Fe&&Array.isArray(A))for(let u=0;u<A.length;u++)A[u]=(0,k.$Ph)(A[u]);let l=F.apply(De,A);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new y.$bb(`Method not found: ${f}`)}}}le.fromService=_;function ae(G,ie){const fe=ie&&ie.disableMarshalling;return new Proxy({},{get(De,Fe){if(typeof Fe=="string")return ie?.properties?.has(Fe)?ie.properties.get(Fe):J(Fe)?function(ye){return G.listen(Fe,ye)}:oe(Fe)?G.listen(Fe):async function(...ye){let K;ie&&!(0,c.$3f)(ie.context)?K=[ie.context,...ye]:K=ye;const f=await G.call(Fe,K);return fe?f:(0,k.$Ph)(f)};throw new y.$bb(`Property not found: ${String(Fe)}`)}})}le.toService=ae;function oe(G){return G[0]==="o"&&G[1]==="n"&&B.$jf(G.charCodeAt(2))}function J(G){return/^onDynamic/.test(G)&&B.$jf(G.charCodeAt(9))}})(he||(e.ProxyChannel=he={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function Ce(le){return Array.isArray(le)?le.map(ge):ge(le)}function Re(le,_,ae,oe,J,G,ie){ie=Ce(ie);const fe=ne[J],De=fe[oe%fe.length];let Fe=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(G)?(Fe=Fe.concat(ie),Fe.push(")")):Fe.push(ie),console.log.apply(console,Fe)}class Be{constructor(_,ae){this.d=_,this.f=ae,this.a=0,this.b=0}logOutgoing(_,ae,oe,J,G){this.b+=_,Re(this.d,this.b,_,ae,oe,J,G)}logIncoming(_,ae,oe,J,G){this.a+=_,Re(this.f,this.a,_,ae,oe,J,G)}}e.$2h=Be}),define(me[137],$e([1,0,36,4,70,94,31]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2V=void 0;class y extends j.$Xh{static f(){const b=R.Event.fromNodeEventEmitter(D.$O,"vscode:message",(k,B)=>i.$te.wrap(B));return D.$O.send("vscode:hello"),new W.$XV(D.$O,b)}constructor(b){const k=y.f();super(k,b),this.b=k}dispose(){this.b.disconnect(),super.dispose()}}e.$2V=y}),define(me[138],$e([13,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(me[139],$e([13,11]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(me[44],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var i;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y($){return $[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(i||(e._util=i={})),e.$fi=j("instantiationService");function R(D,y,$){y[i.DI_TARGET]===y?y[i.DI_DEPENDENCIES].push({id:D,index:$}):(y[i.DI_DEPENDENCIES]=[{id:D,index:$}],y[i.DI_TARGET]=y)}function j(D){if(i.serviceIds.has(D))return i.serviceIds.get(D);const y=function($,b,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,$,k)};return y.toString=()=>D,i.serviceIds.set(D,y),y}e.$gi=j;function W(D){return D}e.$hi=W}),define(me[140],$e([1,0,44]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.ID=void 0,e.ID="diagnosticsService",e.$Ym=(0,i.$gi)(e.ID);function R(W){return!!W.hostName&&!!W.errorMessage}e.$Zm=R;class j{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$1m=j}),define(me[141],$e([1,0,91,25,10,7,16,138,44,5,32,23]),function(re,e,i,R,j,W,D,y,$,b,k,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,$.$gi)("fileService");function c(J){return J.create===!0}e.$Hk=c;var d;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var t;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(t||(e.FilePermission=t={}));function s(J){const G=J;return!!G&&typeof G.onDidChange=="function"}e.$Ik=s;var a;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function m(J){return!!(J.capabilities&2)}e.$Jk=m;function p(J){return!!(J.capabilities&8)}e.$Kk=p;function w(J){return!!(J.capabilities&131072)}e.$Lk=w;function o(J){return!!(J.capabilities&4)}e.$Mk=o;function g(J){return!!(J.capabilities&16)}e.$Nk=g;function r(J){return m(J)?!!(J.capabilities&16384):!1}e.$Ok=r;function E(J){return m(J)?!!(J.capabilities&32768):!1}e.$Pk=E;function N(J){return!!(J.capabilities&65536)}e.$Qk=N;function M(J){return!!(J.capabilities&2048)}e.$Rk=M;var P;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(P||(e.FileSystemProviderErrorCode=P={}));class z extends Error{static create(G,ie){const fe=new z(G.toString(),ie);return V(fe,ie),fe}constructor(G,ie){super(G),this.code=ie}}e.$Sk=z;function v(J,G){return z.create(J,G)}e.$Tk=v;function H(J){return J||v((0,y.localize)(0,null),P.Unknown)}e.$Uk=H;function V(J,G){return J.name=G?`${G} (FileSystemError)`:"FileSystemError",J}e.$Vk=V;function T(J){if(!J)return P.Unknown;if(J instanceof z)return J.code;const G=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!G)return P.Unknown;switch(G[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.$Wk=T;function L(J){if(J instanceof ne)return J.fileOperationResult;switch(T(J)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 9;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileTooLarge:return 7;default:return 10}}e.$Xk=L;var I;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class X{constructor(G,ie,fe){this.resource=G,this.operation=ie,this.target=fe}isOperation(G){return this.operation===G}}e.$Yk=X;var U;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class de{static{this.a=null}constructor(G,ie){this.c=ie,this.b=void 0,this.d=new B.$V(()=>{const fe=i.$mi.forUris(()=>this.c);return fe.fill(this.rawAdded.map(De=>[De,!0])),fe}),this.f=new B.$V(()=>{const fe=i.$mi.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(De=>[De,!0])),fe}),this.g=new B.$V(()=>{const fe=i.$mi.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(De=>[De,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of G){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==de.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(G,...ie){return this.h(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.h(G,{includeChildren:!0},...ie)}h(G,ie,...fe){if(!G)return!1;const De=fe.length>0;return!!((!De||fe.includes(1))&&(this.d.value.get(G)||ie.includeChildren&&this.d.value.findSuperstr(G))||(!De||fe.includes(0))&&(this.f.value.get(G)||ie.includeChildren&&this.f.value.findSuperstr(G))||(!De||fe.includes(2))&&(this.g.value.findSubstr(G)||ie.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=de;function he(J,G,ie){return!J||!G||J===G||G.length>J.length?!1:(G.charAt(G.length-1)!==R.sep&&(G+=R.sep),ie?(0,j.$lf)(J,G):J.indexOf(G)===0)}e.$1k=he;class ne extends Error{constructor(G,ie,fe){super(G),this.fileOperationResult=ie,this.options=fe}}e.$2k=ne;class ge extends ne{constructor(G,ie,fe,De){super(G,ie,De),this.fileOperationResult=ie,this.size=fe}}e.$3k=ge;class Ce extends ne{constructor(G,ie,fe){super(G,2,fe),this.stat=ie}}e.$4k=Ce;var Re;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Re||(e.FileOperationResult=Re={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var Be;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(e.FileKind=Be={})),e.$_k="";function le(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.$al=le;async function _(J,G){if(!G.hasProvider(D.URI.from({scheme:J.scheme})))return new Promise(ie=>{const fe=G.onDidChangeFileSystemProviderRegistrations(De=>{De.scheme===J.scheme&&De.added&&(fe.dispose(),ie())})})}e.$bl=_;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(G){return(0,W.$Xf)(G)||(G=0),G<ae.KB?(0,y.localize)(1,null,G.toFixed(0)):G<ae.MB?(0,y.localize)(2,null,(G/ae.KB).toFixed(2)):G<ae.GB?(0,y.localize)(3,null,(G/ae.MB).toFixed(2)):G<ae.TB?(0,y.localize)(4,null,(G/ae.GB).toFixed(2)):(0,y.localize)(5,null,(G/ae.TB).toFixed(2))}}e.$cl=ae;function oe(J){const G=typeof J=="string"||J?.scheme===k.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===k.Schemas.file?1024*ae.MB:G?10*ae.MB:b.$o?50*ae.MB:1024*ae.MB}e.$dl=oe}),define(me[142],$e([1,0,44]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ac=e.$3ac=void 0,e.$3ac=(0,i.$gi)("mainProcessService");class R{constructor(W,D){this.a=W,this.b=D}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,D){this.a.registerChannel(W,D)}}e.$4ac=R}),define(me[143],$e([1,0,3,137]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class j extends i.$Tc{constructor(D){super(),this.a=this.B(new R.$2V(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,y){this.a.registerChannel(D,y)}}e.$5ac=j});var yi=this&&this.__param||function(re,e){return function(i,R){e(i,R,re)}};define(me[144],$e([1,0,70,142]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;let j=class{constructor(D,y){return this.windowId=D,i.ProxyChannel.toService(y.getChannel("nativeHost"),{context:D,properties:(()=>{const $=new Map;return $.set("windowId",D),$})()})}};e.$9ac=j,e.$9ac=j=Je([yi(1,R.$3ac)],j)}),define(me[71],$e([1,0,79,7]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class j{constructor(){this.a=new Map}add(D,y){i.ok(R.$Tf(D)),i.ok(R.$Vf(y)),i.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,y)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Xn=new j}),define(me[145],$e([1,0,4,71]),function(re,e,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function j(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class W{constructor(){this.b=new i.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,b){this.a[j($)]=b,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const D=new W;R.$Xn.add(e.$Yn.JSONContribution,D)}),define(me[146],$e([1,0,9,18,38,19,4,7,16,139,145,71]),function(re,e,i,R,j,W,D,y,$,b,k,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.IconFontDefinition=e.IconContribution=e.$Mw=void 0,e.$Mw={IconContribution:"base.contributions.icons"};var c;(function(g){function r(E,N){let M=E.defaults;for(;W.ThemeIcon.isThemeIcon(M);){const P=s.getIcon(M.id);if(!P)return;M=P.defaults}return M}g.getDefinition=r})(c||(e.IconContribution=c={}));var d;(function(g){function r(N){return{weight:N.weight,style:N.style,src:N.src.map(M=>({format:M.format,location:M.location.toString()}))}}g.toJSONObject=r;function E(N){const M=P=>(0,y.$Tf)(P)?P:void 0;if(N&&Array.isArray(N.src)&&N.src.every(P=>(0,y.$Tf)(P.format)&&(0,y.$Tf)(P.location)))return{weight:M(N.weight),style:M(N.style),src:N.src.map(P=>({format:P.format,location:$.URI.parse(P.location)}))}}g.fromJSONObject=E})(d||(e.IconFontDefinition=d={}));class t{constructor(){this.a=new D.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${W.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,E,N,M){const P=this.b[r];if(P){if(N&&!P.description){P.description=N,this.d.properties[r].markdownDescription=`${N} $(${r})`;const H=this.e.enum.indexOf(r);H!==-1&&(this.e.enumDescriptions[H]=N),this.a.fire()}return P}const z={id:r,description:N,defaults:E,deprecationMessage:M};this.b[r]=z;const v={$ref:"#/definitions/icons"};return M&&(v.deprecationMessage=M),N&&(v.markdownDescription=`${N}: $(${r})`),this.d.properties[r]=v,this.e.enum.push(r),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const E=this.e.enum.indexOf(r);E!==-1&&(this.e.enum.splice(E,1),this.e.enumDescriptions.splice(E,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,E){const N=this.f[r];return N||(this.f[r]=E,this.a.fire(),E)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(P,z)=>P.id.localeCompare(z.id),E=P=>{for(;W.ThemeIcon.isThemeIcon(P.defaults);)P=this.b[P.defaults.id];return`codicon codicon-${P?P.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const M=Object.keys(this.b).map(P=>this.b[P]);for(const P of M.filter(z=>!!z.description).sort(r))N.push(`|<i class="${E(P)}"></i>|${P.id}|${W.ThemeIcon.isThemeIcon(P.defaults)?P.defaults.id:P.id}|${P.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const P of M.filter(z=>!W.ThemeIcon.isThemeIcon(z.defaults)).sort(r))N.push(`|<i class="${E(P)}"></i>|${P.id}|`);return N.join(`
`)}}const s=new t;B.$Xn.add(e.$Mw.IconContribution,s);function a(g,r,E,N){return s.registerIcon(g,r,E,N)}e.$Nw=a;function m(){return s}e.$Ow=m;function p(){const g=(0,j.$lk)();for(const r in g){const E="\\"+g[r].toString(16);s.registerIcon(r,{fontCharacter:E})}}p(),e.$Pw="vscode://schemas/icons";const w=B.$Xn.as(k.$Yn.JSONContribution);w.registerSchema(e.$Pw,s.getIconSchema());const o=new i.$sh(()=>w.notifySchemaChanged(e.$Pw),200);s.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Qw=a("widget-close",R.$pk.close,(0,b.localize)(2,null)),e.$Rw=a("goto-previous-location",R.$pk.arrowUp,(0,b.localize)(3,null)),e.$Sw=a("goto-next-location",R.$pk.arrowDown,(0,b.localize)(4,null)),e.$Tw=W.ThemeIcon.modify(R.$pk.sync,"spin"),e.$Uw=W.ThemeIcon.modify(R.$pk.loading,"spin")}),define(me[147],$e([1,0,2,4,3,19,146]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dHb=e.$cHb=void 0;function y(b){const k=new j.$Sc,B=k.add(new R.$6d),c=(0,D.$Ow)();return k.add(c.onDidChange(()=>B.fire())),b&&k.add(b.onDidProductIconThemeChange(()=>B.fire())),{dispose:()=>k.dispose(),onDidChange:B.event,getCSS(){const d=b?b.getProductIconTheme():new $,t={},s=m=>{const p=d.getIcon(m);if(!p)return;const w=p.font;return w?(t[w.id]=w.definition,`.codicon-${m.id}:before { content: '${p.fontCharacter}'; font-family: ${(0,i.$bS)(w.id)}; }`):`.codicon-${m.id}:before { content: '${p.fontCharacter}'; }`},a=[];for(const m of c.getIcons()){const p=s(m);p&&a.push(p)}for(const m in t){const p=t[m],w=p.weight?`font-weight: ${p.weight};`:"",o=p.style?`font-style: ${p.style};`:"",g=p.src.map(r=>`${(0,i.$aS)(r.location)} format('${r.format}')`).join(", ");a.push(`@font-face { src: ${g}; font-family: ${(0,i.$bS)(m)};${w}${o} font-display: block; }`)}return a.join(`
`)}}}e.$cHb=y;class ${getIcon(k){const B=(0,D.$Ow)();let c=k.defaults;for(;W.ThemeIcon.isThemeIcon(c);){const d=B.getIcon(c.id);if(!d)return;c=d.defaults}return c}}e.$dHb=$}),define(me[148],$e([1,0,5]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=void 0,e.$4C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(m){return typeof m.parentId=="number"}e.$5C=R;function j(m){return!!m.workspaceUri}e.$6C=j;function W(m){return!!m.folderUri}e.$7C=W;function D(m){return!!m.fileUri}e.$8C=D;function y(m){const p=c(m),w=m.getValue("window.menuBarVisibility");return w==="default"||p&&w==="compact"||i.$j&&i.$m?"classic":w}e.$9C=y;var $;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})($||(e.TitleBarSetting=$={}));var b;(function(m){m.NATIVE="native",m.CUSTOM="custom"})(b||(e.TitlebarStyle=b={}));var k;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(k||(e.CustomTitleBarVisibility=k={}));function B(m,p){return!0}e.$0C=B;function c(m,p){return p||(p=d(m)),p==="native"}e.$$C=c;function d(m){if(i.$o)return"custom";const p=m.getValue("window");if(p){if(i.$j&&p.nativeTabs===!0||i.$j&&p.nativeFullScreen===!1)return"native";const g=p.titleBarStyle;if(g==="native"||g==="custom")return g}return i.$k?"native":"custom"}e.$_C=d;function t(m){return!(!i.$i||i.$o||c(m))}e.$aD=t;function s(m){const p=m.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}e.$bD=s;function a(m=0){return Math.pow(1.2,m)}e.$cD=a}),define(me[149],$e([1,0,17,2,22,31,148]),function(re,e,i,R,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=e.$abc=e.$_ac=e.$$ac=e.ApplyZoomTarget=void 0;var y;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(y||(e.ApplyZoomTarget=y={})),e.$$ac=8,e.$_ac=-8;function $(c,d){c=Math.min(Math.max(c,e.$_ac),e.$$ac);const t=[];d===y.ACTIVE_WINDOW?t.push((0,R.$AR)()):d===y.ALL_WINDOWS?t.push(...Array.from((0,R.getWindows)()).map(({window:s})=>s)):t.push(d);for(const s of t)b(s)?.webFrame?.setZoomLevel(c),(0,i.$xQ)((0,D.$cD)(c),s),(0,i.$tQ)(c,s)}e.$abc=$;function b(c){if(c===j.$oQ)return{ipcRenderer:W.$O,webFrame:W.$Q};{const d=c;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function k(c){$((0,i.$uQ)(typeof c=="number"?(0,R.$AR)():c)+1,c)}e.$bbc=k;function B(c){$((0,i.$uQ)(typeof c=="number"?(0,R.$AR)():c)-1,c)}e.$cbc=B}),define(me[150],$e([1,0,11,2,136,9,95,31,140,141,143,144,147,149,15,22,108,99]),function(re,e,i,R,j,W,D,y,$,b,k,B,c,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(T){return 22}getTemplateId(T){return P(T)?"process":N(T)?"machine":(0,$.$Zm)(T)?"error":M(T)?"header":""}}class w{hasChildren(T){return(0,$.$Zm)(T)?!1:P(T)?!!T.children?.length:!0}getChildren(T){return P(T)?T.children?T.children:[]:(0,$.$Zm)(T)?[]:M(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:N(T)?[T.rootProcess]:[T.processes]}}class o{constructor(){this.templateId="header"}renderTemplate(T){const L=(0,R.$WR)(T,(0,R.$)(".row")),I=(0,R.$WR)(L,(0,R.$)(".nameLabel")),X=(0,R.$WR)(L,(0,R.$)(".cpu")),U=(0,R.$WR)(L,(0,R.$)(".memory")),de=(0,R.$WR)(L,(0,R.$)(".pid"));return{name:I,CPU:X,memory:U,PID:de}}renderElement(T,L,I,X){I.name.textContent=(0,i.localize)(0,null),I.CPU.textContent=(0,i.localize)(1,null),I.PID.textContent=(0,i.localize)(2,null),I.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(T){}}class g{constructor(){this.templateId="machine"}renderTemplate(T){const L=Object.create(null),I=(0,R.$WR)(T,(0,R.$)(".row"));return L.name=(0,R.$WR)(I,(0,R.$)(".nameLabel")),L}renderElement(T,L,I,X){I.name.textContent=T.element.name}disposeTemplate(T){}}class r{constructor(){this.templateId="error"}renderTemplate(T){const L=Object.create(null),I=(0,R.$WR)(T,(0,R.$)(".row"));return L.name=(0,R.$WR)(I,(0,R.$)(".nameLabel")),L}renderElement(T,L,I,X){I.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class E{constructor(T,L,I){this.a=T,this.b=L,this.c=I,this.templateId="process"}renderTemplate(T){const L=(0,R.$WR)(T,(0,R.$)(".row")),I=(0,R.$WR)(L,(0,R.$)(".nameLabel")),X=(0,R.$WR)(L,(0,R.$)(".cpu")),U=(0,R.$WR)(L,(0,R.$)(".memory")),de=(0,R.$WR)(L,(0,R.$)(".pid"));return{name:I,CPU:X,PID:de,memory:U}}renderElement(T,L,I,X){const{element:U}=T,de=U.pid.toFixed(0);let he=U.name;this.c.has(U.pid)&&(he=this.c.get(U.pid)),I.name.textContent=he,I.name.title=U.cmd,I.CPU.textContent=U.load.toFixed(0),I.PID.textContent=de,I.PID.parentElement.id=`pid-${de}`;const ne=this.a==="win32"?U.mem:this.b*(U.mem/100);I.memory.textContent=(ne/b.$cl.MB).toFixed(0)}disposeTemplate(T){}}function N(V){return!!V.name&&!!V.rootProcess}function M(V){return!!V.processRoots}function P(V){return!!V.pid}class z{constructor(T,L){this.f=L,this.b=new Map;const I=new k.$5ac(T);this.c=new B.$9ac(T,I),this.k(L.styles),this.g(L),y.$O.on("vscode:pidToNameResponse",(X,U)=>{this.b.clear();for(const[de,he]of U)this.b.set(de,he)}),y.$O.on("vscode:listProcessesResponse",async(X,U)=>{U.forEach((de,he)=>{P(de.rootProcess)&&(de.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:U}}),this.d.layout(s.$oQ.innerHeight,s.$oQ.innerWidth)):await this.h(U),this.m(0)}),this.a=Date.now(),y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")}g(T){s.$oQ.document.onkeydown=L=>{const I=T.platform==="darwin"?L.metaKey:L.ctrlKey;I&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),y.$O.send("vscode:closeProcessExplorer")),I&&L.keyCode===187&&(0,d.$bbc)(s.$oQ),I&&L.keyCode===189&&(0,d.$cbc)(s.$oQ)}}async h(T){const L=s.$oQ.document.getElementById("process-list");if(!L)return;const{totalmem:I}=await this.c.getOSStatistics(),X=[new E(this.f.platform,I,this.b),new o,new g,new r];this.d=new j.$qV("processExplorer",L,new p,X,new w,{identityProvider:{getId:U=>P(U)?U.pid.toString():(0,$.$Zm)(U)?U.hostName:M(U)?"processes":N(U)?U.name:"header"}}),this.d.setInput({processes:{processRoots:T}}),this.d.layout(s.$oQ.innerHeight,s.$oQ.innerWidth),this.d.onKeyDown(U=>{const de=new t.$SQ(U);if(de.keyCode===35&&de.altKey){const he=this.n();Promise.all(he.map(ne=>this.c.killProcess(ne,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(U=>{P(U.element)&&this.l(U.element,!0)}),L.style.height=`${s.$oQ.innerHeight}px`,s.$oQ.addEventListener("resize",()=>{L.style.height=`${s.$oQ.innerHeight}px`,this.d?.layout(s.$oQ.innerHeight,s.$oQ.innerWidth)})}i(T){const L=a.exec(T);return L&&L.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}j(T){const L={type:"node",request:"attach",name:`process ${T.pid}`};let I=a.exec(T.cmd);I?L.port=Number(I.groups.port):L.processId=String(T.pid),I=m.exec(T.cmd),I&&(L.port=Number(I.groups.port)),y.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(T){const L=(0,R.$ER)(),I=[];T.listFocusBackground&&(I.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&I.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(I.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&I.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&I.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&I.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&I.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=I.join(`
`),T.color&&(s.$oQ.document.body.style.color=T.color)}l(T,L){const I=[],X=Number(T.pid);L&&(I.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),I.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),I.push({type:"separator"})),I.push({label:(0,i.localize)(6,null),click:()=>{const U=this.n();U?.includes(X)||(U.length=0,U.push(X));const de=U?.map(he=>s.$oQ.document.getElementById(`pid-${he}`)).filter(he=>!!he);if(de){const he=de.map(ne=>ne.innerText).filter(ne=>!!ne);this.c.writeClipboardText(he.join(`
`))}}}),I.push({label:(0,i.localize)(7,null),click:()=>{const U=s.$oQ.document.getElementById("process-list");U&&this.c.writeClipboardText(U.innerText)}}),T&&L&&this.i(T.cmd)&&(I.push({type:"separator"}),I.push({label:(0,i.localize)(8,null),click:()=>{this.j(T)}})),(0,D.$TV)(I)}m(T){setTimeout(()=>{const L=Date.now(),I=T+L-this.a;this.a=L,I>1e3?(y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")):this.m(I)},200)}n(){return this.d?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function v(){const V=(0,R.$ER)();V.id="codiconStyles";const T=(0,c.$cHb)(void 0);function L(){V.textContent=T.getCSS()}const I=new W.$sh(L,0);T.onDidChange(()=>I.schedule()),I.schedule()}function H(V){const T=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";s.$oQ.document.body.classList.add(T),v(),(0,d.$abc)(V.data.zoomLevel,s.$oQ),new z(V.windowId,V.data)}e.startup=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ea142b5ccdcb797b1de6b1a46fecbf25dea2e229/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
